/*
 *  Translated to D by Pavel "EvilOne" Minayev
 ***********************************************/

module pavel.win32; /* (slightly adapted by Helmut Leitner, April 2003) */

/*
    This file is part of the Free Pascal run time library.
    This unit contains base definition for the Win32 API
    Copyright (c) 1999-2000 by Florian Klaempfl,
    member of the Free Pascal development team.

    See the file COPYING, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************/

/*
  Base.h

  Base definitions

  Copyright (C) 1996, 1997 Free Software Foundation, Inc.

  Author: Scott Christley <scottc@net-community.com>

  This file is part of the Windows32 API Library.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  If you are interested in a warranty or support for this source code,
  contact Scott Christley <scottc@net-community.com> for more information.

  You should have received a copy of the GNU Library General Public
  License along with this library; see the file COPYING.LIB.
  If not, write to the Free Software Foundation,
  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

const int NULL = 0;

alias int SCODE;
alias void* POINTER;
alias ushort ATOM;
alias int BOOL;
alias uint CALTYPE;
alias uint CALID;
alias char CHAR;
alias char CCHAR;
alias char* PCHAR;
alias uint COLORREF;
alias uint TCOLORREF;
alias int SHORT;
alias int INT;
alias int WINT;
alias int LONG;
alias uint DWORD;
alias int* PINTEGER;
alias double LONGLONG;
alias LONGLONG* PLONGLONG;
alias double DWORDLONG;
alias DWORDLONG* PDWORDLONG;
alias double FLOAT;
alias int HANDLE;
alias HANDLE HACCEL;
alias HANDLE HBITMAP;
alias HANDLE HBRUSH;
alias HANDLE HCOLORSPACE;
alias HANDLE HCONV;
alias HANDLE HCONVLIST;
alias HANDLE HCURSOR;
alias HANDLE HDBC;
alias HANDLE HDC;
alias HANDLE HDDEDATA;
alias HANDLE HDESK;
alias HANDLE HDROP;
alias HANDLE HDWP;
alias HANDLE HENHMETAFILE;
alias HANDLE HENV;
alias HANDLE HFILE;
alias HANDLE HFONT;
alias HANDLE HGDIOBJ;
alias HANDLE HGLOBAL;
alias HANDLE HGLRC;
alias HANDLE HHOOK;
alias HANDLE HICON;
alias HANDLE HIMAGELIST;
alias HANDLE HINST;
alias HINST HINSTANCE;
alias HANDLE HKEY;
alias HANDLE HKL;
alias HANDLE HLOCAL;
alias HANDLE HMENU;
alias HANDLE HMETAFILE;
alias HANDLE HMODULE;
alias HANDLE HPALETTE;
alias HANDLE HPEN;
alias HANDLE HRASCONN;
alias int HRESULT;
alias HANDLE HRGN;
alias HANDLE HRSRC;
alias HANDLE HSTMT;
alias HANDLE HSZ;
alias HANDLE HWINSTA;
alias HANDLE HWND;
alias ushort LANGID;
alias DWORD LCID;
alias DWORD LCTYPE;
alias int LPARAM;
alias ushort* LP;
alias BOOL* LPBOOL;
alias ubyte* LPBYTE;
alias PCHAR LPCCH;
alias PCHAR LPCH;
alias COLORREF* LPCOLORREF;
alias PCHAR LPCSTR;
alias PCHAR LPCTSTR;
alias wchar* LPCWCH;
alias wchar* LPCWSTR;
alias DWORD* LPDWORD;
alias HANDLE* LPHANDLE;
alias int* LPINT;
alias int* LPLONG;
alias PCHAR LPSTR;
alias PCHAR LPTCH;
alias PCHAR LPTSTR;
alias int LRESULT;
alias POINTER LPVOID;
alias POINTER LPCVOID;
alias wchar* LPWCH;
alias wchar* LPWORD;
alias wchar* LPWSTR;
alias wchar* NWPSTR;
alias BOOL* PWINBOOL;
alias ubyte* PBOOLEAN;
alias ubyte* PBYTE;
alias PCHAR PCCH;
alias PCHAR PCH;
alias PCHAR PCSTR;
alias wchar* PCWCH;
alias wchar* PCWSTR;
alias DWORD* PDWORD;
alias double* PFLOAT;
alias HANDLE* PHANDLE;
alias HKEY* PHKEY;
alias int* PINT;
alias int* PLONG;
alias int* PSHORT;
alias PCHAR PSTR;
alias PCHAR PSZ;
alias ubyte* PTBYTE;
alias PCHAR PTCH;
alias PCHAR PTCHAR;
alias PCHAR PTSTR;
alias ubyte* PUCHAR;
alias wchar* PWCH;
alias wchar* PWCHAR;
alias ushort* PWORD;
alias uint* PUINT;
alias uint* PULONG;
alias ushort* PUSHORT;
alias POINTER PVOID;
alias int RETCODE;
alias HANDLE SC_HANDLE;
alias LPVOID SC_LOCK;
alias SC_HANDLE* LPSC_HANDLE;
alias DWORD SERVICE_STATUS_HANDLE;
alias ubyte TBYTE;
alias char TCHAR;
alias ubyte BCHAR;
alias ubyte UCHAR;
alias wchar WCHAR;
alias uint UINT;
alias uint ULONG;
alias ushort USHORT;
alias uint WPARAM;
alias int ACL_INFORMATION_CLASS;
enum { AclRevisionInformation = 1, AclSizeInformation,  };
alias ACL_INFORMATION_CLASS _ACL_INFORMATION_CLASS;
alias int MEDIA_TYPE;
enum { Unknown, F5_1Pt2_512, F3_1Pt44_512, F3_2Pt88_512, F3_20Pt8_512, F3_720_512, F5_360_512, F5_320_512, F5_320_1024, F5_180_512, F5_160_512, RemovableMedia, FixedMedia,  };
alias MEDIA_TYPE _MEDIA_TYPE;
const int RASCS_DONE = (0x2000);
const int RASCS_PAUSED = (0x1000);
alias int RASCONNSTATE;
enum { RASCS_OpenPort = 0, RASCS_PortOpened, RASCS_ConnectDevice, RASCS_DeviceConnected, RASCS_AllDevicesConnected, RASCS_Authenticate, RASCS_AuthNotify, RASCS_AuthRetry, RASCS_AuthCallback, RASCS_AuthChangePassword, RASCS_AuthProject, RASCS_AuthLinkSpeed, RASCS_AuthAck, RASCS_ReAuthenticate, RASCS_Authenticated, RASCS_PrepareForCallback, RASCS_WaitForModemReset, RASCS_WaitForCallback, RASCS_Projected, RASCS_StartAuthentication, RASCS_CallbackComplete, RASCS_LogonNetwork, RASCS_Interactive = RASCS_PAUSED, RASCS_RetryAuthentication, RASCS_CallbackSetByCaller, RASCS_PasswordExpired, RASCS_Connected = RASCS_DONE, RASCS_Disconnected,  };
alias RASCONNSTATE _RASCONNSTATE;
alias int RASPROJECTION;
enum { RASP_Amb = 0x10000, RASP_PppNbf = 0x803F, RASP_PppIpx = 0x802B, RASP_PppIp = 0x8021,  };
alias RASPROJECTION _RASPROJECTION;
alias int SECURITY_IMPERSONATION_LEVEL;
enum { SecurityAnonymous, SecurityIdentification, SecurityImpersonation, SecurityDelegation,  };
alias SECURITY_IMPERSONATION_LEVEL _SECURITY_IMPERSONATION_LEVEL;
alias int SID_NAME_USE;
enum { SidTypeUser = 1, SidTypeGroup, SidTypeDomain, SidTypeAlias, SidTypeWellKnownGroup, SidTypeDeletedAccount, SidTypeInvalid, SidTypeUnknown,  };
alias SID_NAME_USE* PSID_NAME_USE;
alias SID_NAME_USE _SID_NAME_USE;
alias int TOKEN_INFORMATION_CLASS;
enum { TokenUser = 1, TokenGroups, TokenPrivileges, TokenOwner, TokenPrimaryGroup, TokenDefaultDacl, TokenSource, TokenType, TokenImpersonationLevel, TokenStatistics,  };
alias TOKEN_INFORMATION_CLASS _TOKEN_INFORMATION_CLASS;
alias int TOKEN_TYPE;
enum { TokenPrimary = 1, TokenImpersonation,  };
alias TOKEN_TYPE TAGTOKEN_TYPE;
extern(Windows) alias int (*BFFCALLBACK)(HWND, UINT, LPARAM, LPARAM);
extern(Windows) alias UINT (*LPCCHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias UINT (*LPCFHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
alias POINTER PTHREAD_START_ROUTINE;
alias PTHREAD_START_ROUTINE LPTHREAD_START_ROUTINE;
extern(Windows) alias DWORD (*EDITSTREAMCALLBACK)(DWORD, LPBYTE, LONG, LONG);
extern(Windows) alias UINT (*LPFRHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias UINT (*LPOFNHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias UINT (*LPPRINTHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias UINT (*LPSETUPHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias LRESULT (*DLGPROC)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias int (*PFNPROPSHEETCALLBACK)(HWND, UINT, LPARAM);
extern(Windows) alias void (*LPSERVICE_MAIN_FUNCTION)(DWORD);
extern(Windows) alias int (*PFNTVCOMPARE)(LPARAM, LPARAM, LPARAM);
extern(Windows) alias LRESULT (*WNDPROC)(HWND, UINT, WPARAM, LPARAM);
alias POINTER FARPROC;
alias FARPROC PROC;
extern(Windows) alias BOOL (*ENUMRESTYPEPROC)(HANDLE, LPTSTR, LONG);
extern(Windows) alias BOOL (*ENUMRESNAMEPROC)(HANDLE, LPCTSTR, LPTSTR, LONG);
extern(Windows) alias BOOL (*ENUMRESLANGPROC)(HANDLE, LPCTSTR, LPCTSTR, ushort, LONG);
alias FARPROC DESKTOPENUMPROC;
extern(Windows) alias BOOL (*ENUMWINDOWSPROC)(HWND, LPARAM);
extern(Windows) alias BOOL (*ENUMWINDOWSTATIONPROC)(LPTSTR, LPARAM);
extern(Windows) alias void (*SENDASYNCPROC)(HWND, UINT, DWORD);
extern(Windows) alias void (*TIMERPROC)(HWND, UINT, UINT);
alias FARPROC GRAYSTRINGPROC;
extern(Windows) alias BOOL (*DRAWSTATEPROC)(HDC, LPARAM, WPARAM, int, int);
extern(Windows) alias BOOL (*PROPENUMPROCEX)(HWND, LPCTSTR, HANDLE, DWORD);
extern(Windows) alias BOOL (*PROPENUMPROC)(HWND, LPCTSTR, HANDLE);
extern(Windows) alias LRESULT (*HOOKPROC)(int, WPARAM, LPARAM);
extern(Windows) alias void (*ENUMOBJECTSPROC)(LPVOID);
extern(Windows) alias void (*LINEDDAPROC)(int, int);
extern(Windows) alias BOOL (*TABORTPROC)(HDC, int);
extern(Windows) alias UINT (*LPPAGEPAINTHOOK)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias UINT (*LPPAGESETUPHOOK)(HWND, UINT, WPARAM, LPARAM);
extern(Windows) alias int (*ICMENUMPROC)(LPTSTR, LPARAM);
extern(Windows) alias LONG (*EDITWORDBREAKPROCEX)(PCHAR, LONG, ubyte, INT);
extern(Windows) alias int (*PFNLVCOMPARE)(LPARAM, LPARAM, LPARAM);
extern(Windows) alias BOOL (*LOCALE_ENUMPROC)(LPTSTR);
extern(Windows) alias BOOL (*CODEPAGE_ENUMPROC)(LPTSTR);
extern(Windows) alias BOOL (*DATEFMT_ENUMPROC)(LPTSTR);
extern(Windows) alias BOOL (*TIMEFMT_ENUMPROC)(LPTSTR);
extern(Windows) alias BOOL (*CALINFO_ENUMPROC)(LPTSTR);
extern(Windows) alias BOOL (*PHANDLER_ROUTINE)(DWORD);
extern(Windows) alias BOOL (*LPHANDLER_FUNCTION)(DWORD);
extern(Windows) alias UINT (*PFNGETPROFILEPATH)(LPCTSTR, LPSTR, UINT);
extern(Windows) alias UINT (*PFNRECONCILEPROFILE)(LPCTSTR, LPCTSTR, DWORD);
extern(Windows) alias BOOL (*PFNPROCESSPOLICIES)(HWND, LPCTSTR, LPCTSTR, LPCTSTR, DWORD);
const char* SE_CREATE_TOKEN_NAME = ("SeCreateTokenPrivilege");
const char* SE_ASSIGNPRIMARYTOKEN_NAME = ("SeAssignPrimaryTokenPrivilege");
const char* SE_LOCK_MEMORY_NAME = ("SeLockMemoryPrivilege");
const char* SE_INCREASE_QUOTA_NAME = ("SeIncreaseQuotaPrivilege");
const char* SE_UNSOLICITED_INPUT_NAME = ("SeUnsolicitedInputPrivilege");
const char* SE_MACHINE_ACCOUNT_NAME = ("SeMachineAccountPrivilege");
const char* SE_TCB_NAME = ("SeTcbPrivilege");
const char* SE_SECURITY_NAME = ("SeSecurityPrivilege");
const char* SE_TAKE_OWNERSHIP_NAME = ("SeTakeOwnershipPrivilege");
const char* SE_LOAD_DRIVER_NAME = ("SeLoadDriverPrivilege");
const char* SE_SYSTEM_PROFILE_NAME = ("SeSystemProfilePrivilege");
const char* SE_SYSTEMTIME_NAME = ("SeSystemtimePrivilege");
const char* SE_PROF_SINGLE_PROCESS_NAME = ("SeProfileSingleProcessPrivilege");
const char* SE_INC_BASE_PRIORITY_NAME = ("SeIncreaseBasePriorityPrivilege");
const char* SE_CREATE_PAGEFILE_NAME = ("SeCreatePagefilePrivilege");
const char* SE_CREATE_PERMANENT_NAME = ("SeCreatePermanentPrivilege");
const char* SE_BACKUP_NAME = ("SeBackupPrivilege");
const char* SE_RESTORE_NAME = ("SeRestorePrivilege");
const char* SE_SHUTDOWN_NAME = ("SeShutdownPrivilege");
const char* SE_DEBUG_NAME = ("SeDebugPrivilege");
const char* SE_AUDIT_NAME = ("SeAuditPrivilege");
const char* SE_SYSTEM_ENVIRONMENT_NAME = ("SeSystemEnvironmentPrivilege");
const char* SE_CHANGE_NOTIFY_NAME = ("SeChangeNotifyPrivilege");
const char* SE_REMOTE_SHUTDOWN_NAME = ("SeRemoteShutdownPrivilege");
const char* SERVICES_ACTIVE_DATABASEA = ("ServicesActive");
const char* SERVICES_FAILED_DATABASEA = ("ServicesFailed");
const char* SC_GROUP_IDENTIFIERA = ("+");
const char* SERVICES_ACTIVE_DATABASE = (SERVICES_ACTIVE_DATABASEA);
const char* SERVICES_FAILED_DATABASE = (SERVICES_FAILED_DATABASEA);
const char* SC_GROUP_IDENTIFIER = (SC_GROUP_IDENTIFIERA);
extern(Windows) alias HDDEDATA (*PFNCALLBACK)(UINT, UINT, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);
alias PFNCALLBACK CALLB;
alias BOOL SECURITY_CONTEXT_TRACKING_MODE;
alias FARPROC WNDENUMPROC;
alias FARPROC ENHMFENUMPROC;
alias DWORD CCSTYLE;
alias CCSTYLE* PCCSTYLE;
alias CCSTYLE* LPCCSTYLE;
alias DWORD CCSTYLEFLAGA;
alias CCSTYLEFLAGA* PCCSTYLEFLAGA;
alias CCSTYLEFLAGA* LPCCSTYLEFLAGA;
const int LZERROR_UNKNOWNALG = -((8));
const int LZERROR_BADVALUE = -((7));
const int LZERROR_GLOBLOCK = -((6));
const int LZERROR_GLOBALLOC = -((5));
const int LZERROR_WRITE = -((4));
const int LZERROR_READ = -((3));
const int LZERROR_BADOUTHANDLE = -((2));
const int LZERROR_BADINHANDLE = -((1));
const int NO_ERROR = (0);
const int ERROR_SUCCESS = (0);
const int ERROR_INVALID_FUNCTION = (1);
const int ERROR_FILE_NOT_FOUND = (2);
const int ERROR_PATH_NOT_FOUND = (3);
const int ERROR_TOO_MANY_OPEN_FILES = (4);
const int ERROR_ACCESS_DENIED = (5);
const int ERROR_INVALID_HANDLE = (6);
const int ERROR_ARENA_TRASHED = (7);
const int ERROR_NOT_ENOUGH_MEMORY = (8);
const int ERROR_INVALID_BLOCK = (9);
const int ERROR_BAD_ENVIRONMENT = (10);
const int ERROR_BAD_FORMAT = (11);
const int ERROR_INVALID_ACCESS = (12);
const int ERROR_INVALID_DATA = (13);
const int ERROR_OUTOFMEMORY = (14);
const int ERROR_INVALID_DRIVE = (15);
const int ERROR_CURRENT_DIRECTORY = (16);
const int ERROR_NOT_SAME_DEVICE = (17);
const int ERROR_NO_MORE_FILES = (18);
const int ERROR_WRITE_PROTECT = (19);
const int ERROR_BAD_UNIT = (20);
const int ERROR_NOT_READY = (21);
const int ERROR_BAD_COMMAND = (22);
const int ERROR_CRC = (23);
const int ERROR_BAD_LENGTH = (24);
const int ERROR_SEEK = (25);
const int ERROR_NOT_DOS_DISK = (26);
const int ERROR_SECTOR_NOT_FOUND = (27);
const int ERROR_OUT_OF_PAPER = (28);
const int ERROR_WRITE_FAULT = (29);
const int ERROR_READ_FAULT = (30);
const int ERROR_GEN_FAILURE = (31);
const int ERROR_SHARING_VIOLATION = (32);
const int ERROR_LOCK_VIOLATION = (33);
const int ERROR_WRONG_DISK = (34);
const int ERROR_SHARING_BUFFER_EXCEEDED = (36);
const int ERROR_HANDLE_EOF = (38);
const int ERROR_HANDLE_DISK_FULL = (39);
const int ERROR_NOT_SUPPORTED = (50);
const int ERROR_REM_NOT_LIST = (51);
const int ERROR_DUP_NAME = (52);
const int ERROR_BAD_NETPATH = (53);
const int ERROR_NETWORK_BUSY = (54);
const int ERROR_DEV_NOT_EXIST = (55);
const int ERROR_TOO_MANY_CMDS = (56);
const int ERROR_ADAP_HDW_ERR = (57);
const int ERROR_BAD_NET_RESP = (58);
const int ERROR_UNEXP_NET_ERR = (59);
const int ERROR_BAD_REM_ADAP = (60);
const int ERROR_PRINTQ_FULL = (61);
const int ERROR_NO_SPOOL_SPACE = (62);
const int ERROR_PRINT_CANCELLED = (63);
const int ERROR_NETNAME_DELETED = (64);
const int ERROR_NETWORK_ACCESS_DENIED = (65);
const int ERROR_BAD_DEV_TYPE = (66);
const int ERROR_BAD_NET_NAME = (67);
const int ERROR_TOO_MANY_NAMES = (68);
const int ERROR_TOO_MANY_SESS = (69);
const int ERROR_SHARING_PAUSED = (70);
const int ERROR_REQ_NOT_ACCEP = (71);
const int ERROR_REDIR_PAUSED = (72);
const int ERROR_FILE_EXISTS = (80);
const int ERROR_CANNOT_MAKE = (82);
const int ERROR_FAIL_I24 = (83);
const int ERROR_OUT_OF_STRUCTURES = (84);
const int ERROR_ALREADY_ASSIGNED = (85);
const int ERROR_INVALID_PASSWORD = (86);
const int ERROR_INVALID_PARAMETER = (87);
const int ERROR_NET_WRITE_FAULT = (88);
const int ERROR_NO_PROC_SLOTS = (89);
const int ERROR_TOO_MANY_SEMAPHORES = (100);
const int ERROR_EXCL_SEM_ALREADY_OWNED = (101);
const int ERROR_SEM_IS_SET = (102);
const int ERROR_TOO_MANY_SEM_REQUESTS = (103);
const int ERROR_INVALID_AT_INTERRUPT_TIME = (104);
const int ERROR_SEM_OWNER_DIED = (105);
const int ERROR_SEM_USER_LIMIT = (106);
const int ERROR_DISK_CHANGE = (107);
const int ERROR_DRIVE_LOCKED = (108);
const int ERROR_BROKEN_PIPE = (109);
const int ERROR_OPEN_FAILED = (110);
const int ERROR_BUFFER_OVERFLOW = (111);
const int ERROR_DISK_FULL = (112);
const int ERROR_NO_MORE_SEARCH_HANDLES = (113);
const int ERROR_INVALID_TARGET_HANDLE = (114);
const int ERROR_INVALID_CATEGORY = (117);
const int ERROR_INVALID_VERIFY_SWITCH = (118);
const int ERROR_BAD_DRIVER_LEVEL = (119);
const int ERROR_CALL_NOT_IMPLEMENTED = (120);
const int ERROR_SEM_TIMEOUT = (121);
const int ERROR_INSUFFICIENT_BUFFER = (122);
const int ERROR_INVALID_NAME = (123);
const int ERROR_INVALID_LEVEL = (124);
const int ERROR_NO_VOLUME_LABEL = (125);
const int ERROR_MOD_NOT_FOUND = (126);
const int ERROR_PROC_NOT_FOUND = (127);
const int ERROR_WAIT_NO_CHILDREN = (128);
const int ERROR_CHILD_NOT_COMPLETE = (129);
const int ERROR_DIRECT_ACCESS_HANDLE = (130);
const int ERROR_NEGATIVE_SEEK = (131);
const int ERROR_SEEK_ON_DEVICE = (132);
const int ERROR_IS_JOIN_TARGET = (133);
const int ERROR_IS_JOINED = (134);
const int ERROR_IS_SUBSTED = (135);
const int ERROR_NOT_JOINED = (136);
const int ERROR_NOT_SUBSTED = (137);
const int ERROR_JOIN_TO_JOIN = (138);
const int ERROR_SUBST_TO_SUBST = (139);
const int ERROR_JOIN_TO_SUBST = (140);
const int ERROR_SUBST_TO_JOIN = (141);
const int ERROR_BUSY_DRIVE = (142);
const int ERROR_SAME_DRIVE = (143);
const int ERROR_DIR_NOT_ROOT = (144);
const int ERROR_DIR_NOT_EMPTY = (145);
const int ERROR_IS_SUBST_PATH = (146);
const int ERROR_IS_JOIN_PATH = (147);
const int ERROR_PATH_BUSY = (148);
const int ERROR_IS_SUBST_TARGET = (149);
const int ERROR_SYSTEM_TRACE = (150);
const int ERROR_INVALID_EVENT_COUNT = (151);
const int ERROR_TOO_MANY_MUXWAITERS = (152);
const int ERROR_INVALID_LIST_FORMAT = (153);
const int ERROR_LABEL_TOO_LONG = (154);
const int ERROR_TOO_MANY_TCBS = (155);
const int ERROR_SIGNAL_REFUSED = (156);
const int ERROR_DISCARDED = (157);
const int ERROR_NOT_LOCKED = (158);
const int ERROR_BAD_THREADID_ADDR = (159);
const int ERROR_BAD_ARGUMENTS = (160);
const int ERROR_BAD_PATHNAME = (161);
const int ERROR_SIGNAL_PENDING = (162);
const int ERROR_MAX_THRDS_REACHED = (164);
const int ERROR_LOCK_FAILED = (167);
const int ERROR_BUSY = (170);
const int ERROR_CANCEL_VIOLATION = (173);
const int ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = (174);
const int ERROR_INVALID_SEGMENT_NUMBER = (180);
const int ERROR_INVALID_ORDINAL = (182);
const int ERROR_ALREADY_EXISTS = (183);
const int ERROR_INVALID_FLAG_NUMBER = (186);
const int ERROR_SEM_NOT_FOUND = (187);
const int ERROR_INVALID_STARTING_CODESEG = (188);
const int ERROR_INVALID_STACKSEG = (189);
const int ERROR_INVALID_MODULETYPE = (190);
const int ERROR_INVALID_EXE_SIGNATURE = (191);
const int ERROR_EXE_MARKED_INVALID = (192);
const int ERROR_BAD_EXE_FORMAT = (193);
const int ERROR_ITERATED_DATA_EXCEEDS_64k = (194);
const int ERROR_INVALID_MINALLOCSIZE = (195);
const int ERROR_DYNLINK_FROM_INVALID_RING = (196);
const int ERROR_IOPL_NOT_ENABLED = (197);
const int ERROR_INVALID_SEGDPL = (198);
const int ERROR_AUTODATASEG_EXCEEDS_64k = (199);
const int ERROR_RING2SEG_MUST_BE_MOVABLE = (200);
const int ERROR_RELOC_CHAIN_XEEDS_SEGLIM = (201);
const int ERROR_INFLOOP_IN_RELOC_CHAIN = (202);
const int ERROR_ENVVAR_NOT_FOUND = (203);
const int ERROR_NO_SIGNAL_SENT = (205);
const int ERROR_FILENAME_EXCED_RANGE = (206);
const int ERROR_RING2_STACK_IN_USE = (207);
const int ERROR_META_EXPANSION_TOO_LONG = (208);
const int ERROR_INVALID_SIGNAL_NUMBER = (209);
const int ERROR_THREAD_1_INACTIVE = (210);
const int ERROR_LOCKED = (212);
const int ERROR_TOO_MANY_MODULES = (214);
const int ERROR_NESTING_NOT_ALLOWED = (215);
const int ERROR_BAD_PIPE = (230);
const int ERROR_PIPE_BUSY = (231);
const int ERROR_NO_DATA = (232);
const int ERROR_PIPE_NOT_CONNECTED = (233);
const int ERROR_MORE_DATA = (234);
const int ERROR_VC_DISCONNECTED = (240);
const int ERROR_INVALID_EA_NAME = (254);
const int ERROR_EA_LIST_INCONSISTENT = (255);
const int ERROR_NO_MORE_ITEMS = (259);
const int ERROR_CANNOT_COPY = (266);
const int ERROR_DIRECTORY = (267);
const int ERROR_EAS_DIDNT_FIT = (275);
const int ERROR_EA_FILE_CORRUPT = (276);
const int ERROR_EA_TABLE_FULL = (277);
const int ERROR_INVALID_EA_HANDLE = (278);
const int ERROR_EAS_NOT_SUPPORTED = (282);
const int ERROR_NOT_OWNER = (288);
const int ERROR_TOO_MANY_POSTS = (298);
const int ERROR_PARTIAL_COPY = (299);
const int ERROR_MR_MID_NOT_FOUND = (317);
const int ERROR_INVALID_ADDRESS = (487);
const int ERROR_ARITHMETIC_OVERFLOW = (534);
const int ERROR_PIPE_CONNECTED = (535);
const int ERROR_PIPE_LISTENING = (536);
const int ERROR_EA_ACCESS_DENIED = (994);
const int ERROR_OPERATION_ABORTED = (995);
const int ERROR_IO_INCOMPLETE = (996);
const int ERROR_IO_PENDING = (997);
const int ERROR_NOACCESS = (998);
const int ERROR_SWAPERROR = (999);
const int ERROR_STACK_OVERFLOW = (1001);
const int ERROR_INVALID_MESSAGE = (1002);
const int ERROR_CAN_NOT_COMPLETE = (1003);
const int ERROR_INVALID_FLAGS = (1004);
const int ERROR_UNRECOGNIZED_VOLUME = (1005);
const int ERROR_FILE_INVALID = (1006);
const int ERROR_FULLSCREEN_MODE = (1007);
const int ERROR_NO_TOKEN = (1008);
const int ERROR_BADDB = (1009);
const int ERROR_BADKEY = (1010);
const int ERROR_CANTOPEN = (1011);
const int ERROR_CANTREAD = (1012);
const int ERROR_CANTWRITE = (1013);
const int ERROR_REGISTRY_RECOVERED = (1014);
const int ERROR_REGISTRY_CORRUPT = (1015);
const int ERROR_REGISTRY_IO_FAILED = (1016);
const int ERROR_NOT_REGISTRY_FILE = (1017);
const int ERROR_KEY_DELETED = (1018);
const int ERROR_NO_LOG_SPACE = (1019);
const int ERROR_KEY_HAS_CHILDREN = (1020);
const int ERROR_CHILD_MUST_BE_VOLATILE = (1021);
const int ERROR_NOTIFY_ENUM_DIR = (1022);
const int ERROR_DEPENDENT_SERVICES_RUNNING = (1051);
const int ERROR_INVALID_SERVICE_CONTROL = (1052);
const int ERROR_SERVICE_REQUEST_TIMEOUT = (1053);
const int ERROR_SERVICE_NO_THREAD = (1054);
const int ERROR_SERVICE_DATABASE_LOCKED = (1055);
const int ERROR_SERVICE_ALREADY_RUNNING = (1056);
const int ERROR_INVALID_SERVICE_ACCOUNT = (1057);
const int ERROR_SERVICE_DISABLED = (1058);
const int ERROR_CIRCULAR_DEPENDENCY = (1059);
const int ERROR_SERVICE_DOES_NOT_EXIST = (1060);
const int ERROR_SERVICE_CANNOT_ACCEPT_CTRL = (1061);
const int ERROR_SERVICE_NOT_ACTIVE = (1062);
const int ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = (1063);
const int ERROR_EXCEPTION_IN_SERVICE = (1064);
const int ERROR_DATABASE_DOES_NOT_EXIST = (1065);
const int ERROR_SERVICE_SPECIFIC_ERROR = (1066);
const int ERROR_PROCESS_ABORTED = (1067);
const int ERROR_SERVICE_DEPENDENCY_FAIL = (1068);
const int ERROR_SERVICE_LOGON_FAILED = (1069);
const int ERROR_SERVICE_START_HANG = (1070);
const int ERROR_INVALID_SERVICE_LOCK = (1071);
const int ERROR_SERVICE_MARKED_FOR_DELETE = (1072);
const int ERROR_SERVICE_EXISTS = (1073);
const int ERROR_ALREADY_RUNNING_LKG = (1074);
const int ERROR_SERVICE_DEPENDENCY_DELETED = (1075);
const int ERROR_BOOT_ALREADY_ACCEPTED = (1076);
const int ERROR_SERVICE_NEVER_STARTED = (1077);
const int ERROR_DUPLICATE_SERVICE_NAME = (1078);
const int ERROR_END_OF_MEDIA = (1100);
const int ERROR_FILEMARK_DETECTED = (1101);
const int ERROR_BEGINNING_OF_MEDIA = (1102);
const int ERROR_SETMARK_DETECTED = (1103);
const int ERROR_NO_DATA_DETECTED = (1104);
const int ERROR_PARTITION_FAILURE = (1105);
const int ERROR_INVALID_BLOCK_LENGTH = (1106);
const int ERROR_DEVICE_NOT_PARTITIONED = (1107);
const int ERROR_UNABLE_TO_LOCK_MEDIA = (1108);
const int ERROR_UNABLE_TO_UNLOAD_MEDIA = (1109);
const int ERROR_MEDIA_CHANGED = (1110);
const int ERROR_BUS_RESET = (1111);
const int ERROR_NO_MEDIA_IN_DRIVE = (1112);
const int ERROR_NO_UNICODE_TRANSLATION = (1113);
const int ERROR_DLL_INIT_FAILED = (1114);
const int ERROR_SHUTDOWN_IN_PROGRESS = (1115);
const int ERROR_NO_SHUTDOWN_IN_PROGRESS = (1116);
const int ERROR_IO_DEVICE = (1117);
const int ERROR_SERIAL_NO_DEVICE = (1118);
const int ERROR_IRQ_BUSY = (1119);
const int ERROR_MORE_WRITES = (1120);
const int ERROR_COUNTER_TIMEOUT = (1121);
const int ERROR_FLOPPY_ID_MARK_NOT_FOUND = (1122);
const int ERROR_FLOPPY_WRONG_CYLINDER = (1123);
const int ERROR_FLOPPY_UNKNOWN_ERROR = (1124);
const int ERROR_FLOPPY_BAD_REGISTERS = (1125);
const int ERROR_DISK_RECALIBRATE_FAILED = (1126);
const int ERROR_DISK_OPERATION_FAILED = (1127);
const int ERROR_DISK_RESET_FAILED = (1128);
const int ERROR_EOM_OVERFLOW = (1129);
const int ERROR_NOT_ENOUGH_SERVER_MEMORY = (1130);
const int ERROR_POSSIBLE_DEADLOCK = (1131);
const int ERROR_MAPPED_ALIGNMENT = (1132);
const int ERROR_SET_POWER_STATE_VETOED = (1140);
const int ERROR_SET_POWER_STATE_FAILED = (1141);
const int ERROR_OLD_WIN_VERSION = (1150);
const int ERROR_APP_WRONG_OS = (1151);
const int ERROR_SINGLE_INSTANCE_APP = (1152);
const int ERROR_RMODE_APP = (1153);
const int ERROR_INVALID_DLL = (1154);
const int ERROR_NO_ASSOCIATION = (1155);
const int ERROR_DDE_FAIL = (1156);
const int ERROR_DLL_NOT_FOUND = (1157);
const int ERROR_BAD_USERNAME = (2202);
const int ERROR_NOT_CONNECTED = (2250);
const int ERROR_OPEN_FILES = (2401);
const int ERROR_ACTIVE_CONNECTIONS = (2402);
const int ERROR_DEVICE_IN_USE = (2404);
const int ERROR_BAD_DEVICE = (1200);
const int ERROR_CONNECTION_UNAVAIL = (1201);
const int ERROR_DEVICE_ALREADY_REMEMBERED = (1202);
const int ERROR_NO_NET_OR_BAD_PATH = (1203);
const int ERROR_BAD_PROVIDER = (1204);
const int ERROR_CANNOT_OPEN_PROFILE = (1205);
const int ERROR_BAD_PROFILE = (1206);
const int ERROR_NOT_CONTAINER = (1207);
const int ERROR_EXTENDED_ERROR = (1208);
const int ERROR_INVALID_GROUPNAME = (1209);
const int ERROR_INVALID_COMPUTERNAME = (1210);
const int ERROR_INVALID_EVENTNAME = (1211);
const int ERROR_INVALID_DOMAINNAME = (1212);
const int ERROR_INVALID_SERVICENAME = (1213);
const int ERROR_INVALID_NETNAME = (1214);
const int ERROR_INVALID_SHARENAME = (1215);
const int ERROR_INVALID_PASSWORDNAME = (1216);
const int ERROR_INVALID_MESSAGENAME = (1217);
const int ERROR_INVALID_MESSAGEDEST = (1218);
const int ERROR_SESSION_CREDENTIAL_CONFLICT = (1219);
const int ERROR_REMOTE_SESSION_LIMIT_EXCEEDED = (1220);
const int ERROR_DUP_DOMAINNAME = (1221);
const int ERROR_NO_NETWORK = (1222);
const int ERROR_CANCELLED = (1223);
const int ERROR_USER_MAPPED_FILE = (1224);
const int ERROR_CONNECTION_REFUSED = (1225);
const int ERROR_GRACEFUL_DISCONNECT = (1226);
const int ERROR_ADDRESS_ALREADY_ASSOCIATED = (1227);
const int ERROR_ADDRESS_NOT_ASSOCIATED = (1228);
const int ERROR_CONNECTION_INVALID = (1229);
const int ERROR_CONNECTION_ACTIVE = (1230);
const int ERROR_NETWORK_UNREACHABLE = (1231);
const int ERROR_HOST_UNREACHABLE = (1232);
const int ERROR_PROTOCOL_UNREACHABLE = (1233);
const int ERROR_PORT_UNREACHABLE = (1234);
const int ERROR_REQUEST_ABORTED = (1235);
const int ERROR_CONNECTION_ABORTED = (1236);
const int ERROR_RETRY = (1237);
const int ERROR_CONNECTION_COUNT_LIMIT = (1238);
const int ERROR_LOGIN_TIME_RESTRICTION = (1239);
const int ERROR_LOGIN_WKSTA_RESTRICTION = (1240);
const int ERROR_INCORRECT_ADDRESS = (1241);
const int ERROR_ALREADY_REGISTERED = (1242);
const int ERROR_SERVICE_NOT_FOUND = (1243);
const int ERROR_NOT_AUTHENTICATED = (1244);
const int ERROR_NOT_LOGGED_ON = (1245);
const int ERROR_CONTINUE = (1246);
const int ERROR_ALREADY_INITIALIZED = (1247);
const int ERROR_NO_MORE_DEVICES = (1248);
const int ERROR_NOT_ALL_ASSIGNED = (1300);
const int ERROR_SOME_NOT_MAPPED = (1301);
const int ERROR_NO_QUOTAS_FOR_ACCOUNT = (1302);
const int ERROR_LOCAL_USER_SESSION_KEY = (1303);
const int ERROR_NULL_LM_PASSWORD = (1304);
const int ERROR_UNKNOWN_REVISION = (1305);
const int ERROR_REVISION_MISMATCH = (1306);
const int ERROR_INVALID_OWNER = (1307);
const int ERROR_INVALID_PRIMARY_GROUP = (1308);
const int ERROR_NO_IMPERSONATION_TOKEN = (1309);
const int ERROR_CANT_DISABLE_MANDATORY = (1310);
const int ERROR_NO_LOGON_SERVERS = (1311);
const int ERROR_NO_SUCH_LOGON_SESSION = (1312);
const int ERROR_NO_SUCH_PRIVILEGE = (1313);
const int ERROR_PRIVILEGE_NOT_HELD = (1314);
const int ERROR_INVALID_ACCOUNT_NAME = (1315);
const int ERROR_USER_EXISTS = (1316);
const int ERROR_NO_SUCH_USER = (1317);
const int ERROR_GROUP_EXISTS = (1318);
const int ERROR_NO_SUCH_GROUP = (1319);
const int ERROR_MEMBER_IN_GROUP = (1320);
const int ERROR_MEMBER_NOT_IN_GROUP = (1321);
const int ERROR_LAST_ADMIN = (1322);
const int ERROR_WRONG_PASSWORD = (1323);
const int ERROR_ILL_FORMED_PASSWORD = (1324);
const int ERROR_PASSWORD_RESTRICTION = (1325);
const int ERROR_LOGON_FAILURE = (1326);
const int ERROR_ACCOUNT_RESTRICTION = (1327);
const int ERROR_INVALID_LOGON_HOURS = (1328);
const int ERROR_INVALID_WORKSTATION = (1329);
const int ERROR_PASSWORD_EXPIRED = (1330);
const int ERROR_ACCOUNT_DISABLED = (1331);
const int ERROR_NONE_MAPPED = (1332);
const int ERROR_TOO_MANY_LUIDS_REQUESTED = (1333);
const int ERROR_LUIDS_EXHAUSTED = (1334);
const int ERROR_INVALID_SUB_AUTHORITY = (1335);
const int ERROR_INVALID_ACL = (1336);
const int ERROR_INVALID_SID = (1337);
const int ERROR_INVALID_SECURITY_DESCR = (1338);
const int ERROR_BAD_INHERITANCE_ACL = (1340);
const int ERROR_SERVER_DISABLED = (1341);
const int ERROR_SERVER_NOT_DISABLED = (1342);
const int ERROR_INVALID_ID_AUTHORITY = (1343);
const int ERROR_ALLOTTED_SPACE_EXCEEDED = (1344);
const int ERROR_INVALID_GROUP_ATTRIBUTES = (1345);
const int ERROR_BAD_IMPERSONATION_LEVEL = (1346);
const int ERROR_CANT_OPEN_ANONYMOUS = (1347);
const int ERROR_BAD_VALIDATION_CLASS = (1348);
const int ERROR_BAD_TOKEN_TYPE = (1349);
const int ERROR_NO_SECURITY_ON_OBJECT = (1350);
const int ERROR_CANT_ACCESS_DOMAIN_INFO = (1351);
const int ERROR_INVALID_SERVER_STATE = (1352);
const int ERROR_INVALID_DOMAIN_STATE = (1353);
const int ERROR_INVALID_DOMAIN_ROLE = (1354);
const int ERROR_NO_SUCH_DOMAIN = (1355);
const int ERROR_DOMAIN_EXISTS = (1356);
const int ERROR_DOMAIN_LIMIT_EXCEEDED = (1357);
const int ERROR_INTERNAL_DB_CORRUPTION = (1358);
const int ERROR_INTERNAL_ERROR = (1359);
const int ERROR_GENERIC_NOT_MAPPED = (1360);
const int ERROR_BAD_DESCRIPTOR_FORMAT = (1361);
const int ERROR_NOT_LOGON_PROCESS = (1362);
const int ERROR_LOGON_SESSION_EXISTS = (1363);
const int ERROR_NO_SUCH_PACKAGE = (1364);
const int ERROR_BAD_LOGON_SESSION_STATE = (1365);
const int ERROR_LOGON_SESSION_COLLISION = (1366);
const int ERROR_INVALID_LOGON_TYPE = (1367);
const int ERROR_CANNOT_IMPERSONATE = (1368);
const int ERROR_RXACT_INVALID_STATE = (1369);
const int ERROR_RXACT_COMMIT_FAILURE = (1370);
const int ERROR_SPECIAL_ACCOUNT = (1371);
const int ERROR_SPECIAL_GROUP = (1372);
const int ERROR_SPECIAL_USER = (1373);
const int ERROR_MEMBERS_PRIMARY_GROUP = (1374);
const int ERROR_TOKEN_ALREADY_IN_USE = (1375);
const int ERROR_NO_SUCH_ALIAS = (1376);
const int ERROR_MEMBER_NOT_IN_ALIAS = (1377);
const int ERROR_MEMBER_IN_ALIAS = (1378);
const int ERROR_ALIAS_EXISTS = (1379);
const int ERROR_LOGON_NOT_GRANTED = (1380);
const int ERROR_TOO_MANY_SECRETS = (1381);
const int ERROR_SECRET_TOO_LONG = (1382);
const int ERROR_INTERNAL_DB_ERROR = (1383);
const int ERROR_TOO_MANY_CONTEXT_IDS = (1384);
const int ERROR_LOGON_TYPE_NOT_GRANTED = (1385);
const int ERROR_NT_CROSS_ENCRYPTION_REQUIRED = (1386);
const int ERROR_NO_SUCH_MEMBER = (1387);
const int ERROR_INVALID_MEMBER = (1388);
const int ERROR_TOO_MANY_SIDS = (1389);
const int ERROR_LM_CROSS_ENCRYPTION_REQUIRED = (1390);
const int ERROR_NO_INHERITANCE = (1391);
const int ERROR_FILE_CORRUPT = (1392);
const int ERROR_DISK_CORRUPT = (1393);
const int ERROR_NO_USER_SESSION_KEY = (1394);
const int ERROR_LICENSE_QUOTA_EXCEEDED = (1395);
const int ERROR_INVALID_WINDOW_HANDLE = (1400);
const int ERROR_INVALID_MENU_HANDLE = (1401);
const int ERROR_INVALID_CURSOR_HANDLE = (1402);
const int ERROR_INVALID_ACCEL_HANDLE = (1403);
const int ERROR_INVALID_HOOK_HANDLE = (1404);
const int ERROR_INVALID_DWP_HANDLE = (1405);
const int ERROR_TLW_WITH_WSCHILD = (1406);
const int ERROR_CANNOT_FIND_WND_CLASS = (1407);
const int ERROR_WINDOW_OF_OTHER_THREAD = (1408);
const int ERROR_HOTKEY_ALREADY_REGISTERED = (1409);
const int ERROR_CLASS_ALREADY_EXISTS = (1410);
const int ERROR_CLASS_DOES_NOT_EXIST = (1411);
const int ERROR_CLASS_HAS_WINDOWS = (1412);
const int ERROR_INVALID_INDEX = (1413);
const int ERROR_INVALID_ICON_HANDLE = (1414);
const int ERROR_PRIVATE_DIALOG_INDEX = (1415);
const int ERROR_LISTBOX_ID_NOT_FOUND = (1416);
const int ERROR_NO_WILDCARD_CHARACTERS = (1417);
const int ERROR_CLIPBOARD_NOT_OPEN = (1418);
const int ERROR_HOTKEY_NOT_REGISTERED = (1419);
const int ERROR_WINDOW_NOT_DIALOG = (1420);
const int ERROR_CONTROL_ID_NOT_FOUND = (1421);
const int ERROR_INVALID_COMBOBOX_MESSAGE = (1422);
const int ERROR_WINDOW_NOT_COMBOBOX = (1423);
const int ERROR_INVALID_EDIT_HEIGHT = (1424);
const int ERROR_DC_NOT_FOUND = (1425);
const int ERROR_INVALID_HOOK_FILTER = (1426);
const int ERROR_INVALID_FILTER_PROC = (1427);
const int ERROR_HOOK_NEEDS_HMOD = (1428);
const int ERROR_GLOBAL_ONLY_HOOK = (1429);
const int ERROR_JOURNAL_HOOK_SET = (1430);
const int ERROR_HOOK_NOT_INSTALLED = (1431);
const int ERROR_INVALID_LB_MESSAGE = (1432);
const int ERROR_SETCOUNT_ON_BAD_LB = (1433);
const int ERROR_LB_WITHOUT_TABSTOPS = (1434);
const int ERROR_DESTROY_OBJECT_OF_OTHER_THREAD = (1435);
const int ERROR_CHILD_WINDOW_MENU = (1436);
const int ERROR_NO_SYSTEM_MENU = (1437);
const int ERROR_INVALID_MSGBOX_STYLE = (1438);
const int ERROR_INVALID_SPI_VALUE = (1439);
const int ERROR_SCREEN_ALREADY_LOCKED = (1440);
const int ERROR_HWNDS_HAVE_DIFF_PARENT = (1441);
const int ERROR_NOT_CHILD_WINDOW = (1442);
const int ERROR_INVALID_GW_COMMAND = (1443);
const int ERROR_INVALID_THREAD_ID = (1444);
const int ERROR_NON_MDICHILD_WINDOW = (1445);
const int ERROR_POPUP_ALREADY_ACTIVE = (1446);
const int ERROR_NO_SCROLLBARS = (1447);
const int ERROR_INVALID_SCROLLBAR_RANGE = (1448);
const int ERROR_INVALID_SHOWWIN_COMMAND = (1449);
const int ERROR_NO_SYSTEM_RESOURCES = (1450);
const int ERROR_NONPAGED_SYSTEM_RESOURCES = (1451);
const int ERROR_PAGED_SYSTEM_RESOURCES = (1452);
const int ERROR_WORKING_SET_QUOTA = (1453);
const int ERROR_PAGEFILE_QUOTA = (1454);
const int ERROR_COMMITMENT_LIMIT = (1455);
const int ERROR_MENU_ITEM_NOT_FOUND = (1456);
const int ERROR_EVENTLOG_FILE_CORRUPT = (1500);
const int ERROR_EVENTLOG_CANT_START = (1501);
const int ERROR_LOG_FILE_FULL = (1502);
const int ERROR_EVENTLOG_FILE_CHANGED = (1503);
const int RPC_S_INVALID_STRING_BINDING = (1700);
const int RPC_S_WRONG_KIND_OF_BINDING = (1701);
const int RPC_S_INVALID_BINDING = (1702);
const int RPC_S_PROTSEQ_NOT_SUPPORTED = (1703);
const int RPC_S_INVALID_RPC_PROTSEQ = (1704);
const int RPC_S_INVALID_STRING_UUID = (1705);
const int RPC_S_INVALID_ENDPOINT_FORMAT = (1706);
const int RPC_S_INVALID_NET_ADDR = (1707);
const int RPC_S_NO_ENDPOINT_FOUND = (1708);
const int RPC_S_INVALID_TIMEOUT = (1709);
const int RPC_S_OBJECT_NOT_FOUND = (1710);
const int RPC_S_ALREADY_REGISTERED = (1711);
const int RPC_S_TYPE_ALREADY_REGISTERED = (1712);
const int RPC_S_ALREADY_LISTENING = (1713);
const int RPC_S_NO_PROTSEQS_REGISTERED = (1714);
const int RPC_S_NOT_LISTENING = (1715);
const int RPC_S_UNKNOWN_MGR_TYPE = (1716);
const int RPC_S_UNKNOWN_IF = (1717);
const int RPC_S_NO_BINDINGS = (1718);
const int RPC_S_NO_PROTSEQS = (1719);
const int RPC_S_CANT_CREATE_ENDPOINT = (1720);
const int RPC_S_OUT_OF_RESOURCES = (1721);
const int RPC_S_SERVER_UNAVAILABLE = (1722);
const int RPC_S_SERVER_TOO_BUSY = (1723);
const int RPC_S_INVALID_NETWORK_OPTIONS = (1724);
const int RPC_S_NO_CALL_ACTIVE = (1725);
const int RPC_S_CALL_FAILED = (1726);
const int RPC_S_CALL_FAILED_DNE = (1727);
const int RPC_S_PROTOCOL_ERROR = (1728);
const int RPC_S_UNSUPPORTED_TRANS_SYN = (1730);
const int RPC_S_UNSUPPORTED_TYPE = (1732);
const int RPC_S_INVALID_TAG = (1733);
const int RPC_S_INVALID_BOUND = (1734);
const int RPC_S_NO_ENTRY_NAME = (1735);
const int RPC_S_INVALID_NAME_SYNTAX = (1736);
const int RPC_S_UNSUPPORTED_NAME_SYNTAX = (1737);
const int RPC_S_UUID_NO_ADDRESS = (1739);
const int RPC_S_DUPLICATE_ENDPOINT = (1740);
const int RPC_S_UNKNOWN_AUTHN_TYPE = (1741);
const int RPC_S_MAX_CALLS_TOO_SMALL = (1742);
const int RPC_S_STRING_TOO_LONG = (1743);
const int RPC_S_PROTSEQ_NOT_FOUND = (1744);
const int RPC_S_PROCNUM_OUT_OF_RANGE = (1745);
const int RPC_S_BINDING_HAS_NO_AUTH = (1746);
const int RPC_S_UNKNOWN_AUTHN_SERVICE = (1747);
const int RPC_S_UNKNOWN_AUTHN_LEVEL = (1748);
const int RPC_S_INVALID_AUTH_IDENTITY = (1749);
const int RPC_S_UNKNOWN_AUTHZ_SERVICE = (1750);
const int EPT_S_INVALID_ENTRY = (1751);
const int EPT_S_CANT_PERFORM_OP = (1752);
const int EPT_S_NOT_REGISTERED = (1753);
const int RPC_S_NOTHING_TO_EXPORT = (1754);
const int RPC_S_INCOMPLETE_NAME = (1755);
const int RPC_S_INVALID_VERS_OPTION = (1756);
const int RPC_S_NO_MORE_MEMBERS = (1757);
const int RPC_S_NOT_ALL_OBJS_UNEXPORTED = (1758);
const int RPC_S_INTERFACE_NOT_FOUND = (1759);
const int RPC_S_ENTRY_ALREADY_EXISTS = (1760);
const int RPC_S_ENTRY_NOT_FOUND = (1761);
const int RPC_S_NAME_SERVICE_UNAVAILABLE = (1762);
const int RPC_S_INVALID_NAF_ID = (1763);
const int RPC_S_CANNOT_SUPPORT = (1764);
const int RPC_S_NO_CONTEXT_AVAILABLE = (1765);
const int RPC_S_INTERNAL_ERROR = (1766);
const int RPC_S_ZERO_DIVIDE = (1767);
const int RPC_S_ADDRESS_ERROR = (1768);
const int RPC_S_FP_DIV_ZERO = (1769);
const int RPC_S_FP_UNDERFLOW = (1770);
const int RPC_S_FP_OVERFLOW = (1771);
const int RPC_X_NO_MORE_ENTRIES = (1772);
const int RPC_X_SS_CHAR_TRANS_OPEN_FAIL = (1773);
const int RPC_X_SS_CHAR_TRANS_SHORT_FILE = (1774);
const int RPC_X_SS_IN_NULL_CONTEXT = (1775);
const int RPC_X_SS_CONTEXT_DAMAGED = (1777);
const int RPC_X_SS_HANDLES_MISMATCH = (1778);
const int RPC_X_SS_CANNOT_GET_CALL_HANDLE = (1779);
const int RPC_X_NULL_REF_POINTER = (1780);
const int RPC_X_ENUM_VALUE_OUT_OF_RANGE = (1781);
const int RPC_X_BYTE_COUNT_TOO_SMALL = (1782);
const int RPC_X_BAD_STUB_DATA = (1783);
const int ERROR_INVALID_USER_BUFFER = (1784);
const int ERROR_UNRECOGNIZED_MEDIA = (1785);
const int ERROR_NO_TRUST_LSA_SECRET = (1786);
const int ERROR_NO_TRUST_SAM_ACCOUNT = (1787);
const int ERROR_TRUSTED_DOMAIN_FAILURE = (1788);
const int ERROR_TRUSTED_RELATIONSHIP_FAILURE = (1789);
const int ERROR_TRUST_FAILURE = (1790);
const int RPC_S_CALL_IN_PROGRESS = (1791);
const int ERROR_NETLOGON_NOT_STARTED = (1792);
const int ERROR_ACCOUNT_EXPIRED = (1793);
const int ERROR_REDIRECTOR_HAS_OPEN_HANDLES = (1794);
const int ERROR_PRINTER_DRIVER_ALREADY_INSTALLED = (1795);
const int ERROR_UNKNOWN_PORT = (1796);
const int ERROR_UNKNOWN_PRINTER_DRIVER = (1797);
const int ERROR_UNKNOWN_PRINTPROCESSOR = (1798);
const int ERROR_INVALID_SEPARATOR_FILE = (1799);
const int ERROR_INVALID_PRIORITY = (1800);
const int ERROR_INVALID_PRINTER_NAME = (1801);
const int ERROR_PRINTER_ALREADY_EXISTS = (1802);
const int ERROR_INVALID_PRINTER_COMMAND = (1803);
const int ERROR_INVALID_DATATYPE = (1804);
const int ERROR_INVALID_ENVIRONMENT = (1805);
const int RPC_S_NO_MORE_BINDINGS = (1806);
const int ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT = (1807);
const int ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT = (1808);
const int ERROR_NOLOGON_SERVER_TRUST_ACCOUNT = (1809);
const int ERROR_DOMAIN_TRUST_INCONSISTENT = (1810);
const int ERROR_SERVER_HAS_OPEN_HANDLES = (1811);
const int ERROR_RESOURCE_DATA_NOT_FOUND = (1812);
const int ERROR_RESOURCE_TYPE_NOT_FOUND = (1813);
const int ERROR_RESOURCE_NAME_NOT_FOUND = (1814);
const int ERROR_RESOURCE_LANG_NOT_FOUND = (1815);
const int ERROR_NOT_ENOUGH_QUOTA = (1816);
const int RPC_S_NO_INTERFACES = (1817);
const int RPC_S_CALL_CANCELLED = (1818);
const int RPC_S_BINDING_INCOMPLETE = (1819);
const int RPC_S_COMM_FAILURE = (1820);
const int RPC_S_UNSUPPORTED_AUTHN_LEVEL = (1821);
const int RPC_S_NO_PRINC_NAME = (1822);
const int RPC_S_NOT_RPC_ERROR = (1823);
const int RPC_S_UUID_LOCAL_ONLY = (1824);
const int RPC_S_SEC_PKG_ERROR = (1825);
const int RPC_S_NOT_CANCELLED = (1826);
const int RPC_X_INVALID_ES_ACTION = (1827);
const int RPC_X_WRONG_ES_VERSION = (1828);
const int RPC_X_WRONG_STUB_VERSION = (1829);
const int RPC_S_GROUP_MEMBER_NOT_FOUND = (1898);
const int EPT_S_CANT_CREATE = (1899);
const int RPC_S_INVALID_OBJECT = (1900);
const int ERROR_INVALID_TIME = (1901);
const int ERROR_INVALID_FORM_NAME = (1902);
const int ERROR_INVALID_FORM_SIZE = (1903);
const int ERROR_ALREADY_WAITING = (1904);
const int ERROR_PRINTER_DELETED = (1905);
const int ERROR_INVALID_PRINTER_STATE = (1906);
const int ERROR_PASSWORD_MUST_CHANGE = (1907);
const int ERROR_DOMAIN_CONTROLLER_NOT_FOUND = (1908);
const int ERROR_ACCOUNT_LOCKED_OUT = (1909);
const int ERROR_NO_BROWSER_SERVERS_FOUND = (6118);
const int ERROR_INVALID_PIXEL_FORMAT = (2000);
const int ERROR_BAD_DRIVER = (2001);
const int ERROR_INVALID_WINDOW_STYLE = (2002);
const int ERROR_METAFILE_NOT_SUPPORTED = (2003);
const int ERROR_TRANSFORM_NOT_SUPPORTED = (2004);
const int ERROR_CLIPPING_NOT_SUPPORTED = (2005);
const int ERROR_UNKNOWN_PRINT_MONITOR = (3000);
const int ERROR_PRINTER_DRIVER_IN_USE = (3001);
const int ERROR_SPOOL_FILE_NOT_FOUND = (3002);
const int ERROR_SPL_NO_STARTDOC = (3003);
const int ERROR_SPL_NO_ADDJOB = (3004);
const int ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED = (3005);
const int ERROR_PRINT_MONITOR_ALREADY_INSTALLED = (3006);
const int ERROR_WINS_INTERNAL = (4000);
const int ERROR_CAN_NOT_DEL_LOCAL_WINS = (4001);
const int ERROR_STATIC_INIT = (4002);
const int ERROR_INC_BACKUP = (4003);
const int ERROR_FULL_BACKUP = (4004);
const int ERROR_REC_NON_EXISTENT = (4005);
const int ERROR_RPL_NOT_ALLOWED = (4006);
const int MAX_PATH = (260);
const int LF_FACESIZE = (32);
const int LF_FULLFACESIZE = (64);
const int ELF_VENDOR_SIZE = (4);
const int SECURITY_STATIC_TRACKING = (0);
const int SECURITY_DYNAMIC_TRACKING = (1);
const int MAX_DEFAULTCHAR = (2);
const int MAX_LEADBYTES = (12);
const int EXCEPTION_MAXIMUM_PARAMETERS = (15);
const int CCHDEVICENAME = (32);
const int CCHFORMNAME = (32);
const int MENU_TEXT_LEN = (40);
const int MAX_LANA = (254);
const int NCBNAMSZ = (16);
const int NETBIOS_NAME_LEN = (16);
const int OFS_MAXPATHNAME = (128);
const int MAX_TAB_STOPS = (32);
const int ANYSIZE_ARRAY = (1);
const int RAS_MaxCallbackNumber = (128);
const int RAS_MaxDeviceName = (128);
const int RAS_MaxDeviceType = (16);
const int RAS_MaxEntryName = (256);
const int RAS_MaxIpAddress = (15);
const int RAS_MaxIpxAddress = (21);
const int RAS_MaxPhoneNumber = (128);
const int UNLEN = (256);
const int PWLEN = (256);
const int CNLEN = (15);
const int DNLEN = (15);
const int MAXDWORD = (int)(0xFFFFFFFF);
const int MAXWORD = (0xFFFF);
const int MAXBYTE = (0xFF);
const int MINCHAR = (0x80);
const int MAXCHAR = (0x7F);
const int MINSHORT = (0x8000);
const int MAXSHORT = (0x7FFF);
const int MINLONG = (int)(0x80000000);
const int MAXLONG = (int)(0x7FFFFFFF);
const int FILE_BEGIN = (0);
const int FILE_CURRENT = (1);
const int FILE_END = (2);
const int OF_READ = (0);
const int OF_READWRITE = (2);
const int OF_WRITE = (1);
const int OF_SHARE_COMPAT = (0);
const int OF_SHARE_DENY_NONE = (64);
const int OF_SHARE_DENY_READ = (48);
const int OF_SHARE_DENY_WRITE = (32);
const int OF_SHARE_EXCLUSIVE = (16);
const int OF_CANCEL = (2048);
const int OF_CREATE = (4096);
const int OF_DELETE = (512);
const int OF_EXIST = (16384);
const int OF_PARSE = (256);
const int OF_PROMPT = (8192);
const int OF_REOPEN = (32768);
const int OF_VERIFY = (1024);
const int HKL_NEXT = (1);
const int HKL_PREV = (0);
const int KLF_REORDER = (8);
const int KLF_UNLOADPREVIOUS = (4);
const int KLF_ACTIVATE = (1);
const int KLF_NOTELLSHELL = (128);
const int KLF_REPLACELANG = (16);
const int KLF_SUBSTITUTE_OK = (2);
const int MF_BITMAP = (0x4);
const int MF_DISABLED = (0x2);
const int MF_ENABLED = (0);
const int MF_GRAYED = (0x1);
const int MF_HELP = (0x4000);
const int MF_MENUBARBREAK = (0x20);
const int MF_MENUBREAK = (0x40);
const int MF_MOUSESELECT = (0x8000);
const int MF_OWNERDRAW = (0x100);
const int MF_POPUP = (0x10);
const int MF_SEPARATOR = (0x800);
const int MF_STRING = (0);
const int MF_SYSMENU = (0x2000);
const int MF_USECHECKBITMAPS = (0x200);
const int BLACKNESS = (0x00000042);
const int NOTSRCERASE = (0x001100A6);
const int NOTSRCCOPY = (0x00330008);
const int SRCERASE = (0x00440328);
const int DSTINVERT = (0x00550009);
const int PATINVERT = (0x005A0049);
const int SRCINVERT = (0x00660046);
const int SRCAND = (0x008800C6);
const int MERGEPAINT = (0x00BB0226);
const int MERGECOPY = (0x00C000CA);
const int SRCCOPY = (0x00CC0020);
const int SRCPAINT = (0x00EE0086);
const int PATCOPY = (0x00F00021);
const int PATPAINT = (0x00FB0A09);
const int WHITENESS = (0x00FF0062);
const int R2_BLACK = (1);
const int R2_COPYPEN = (13);
const int R2_MASKNOTPEN = (3);
const int R2_MASKPEN = (9);
const int R2_MASKPENNOT = (5);
const int R2_MERGENOTPEN = (12);
const int R2_MERGEPEN = (15);
const int R2_MERGEPENNOT = (14);
const int R2_NOP = (11);
const int R2_NOT = (6);
const int R2_NOTCOPYPEN = (4);
const int R2_NOTMASKPEN = (8);
const int R2_NOTMERGEPEN = (2);
const int R2_NOTXORPEN = (10);
const int R2_WHITE = (16);
const int R2_XORPEN = (7);
const int BSF_FLUSHDISK = (4);
const int BSF_FORCEIFHUNG = (32);
const int BSF_IGNORECURRENTTASK = (2);
const int BSF_NOHANG = (8);
const int BSF_POSTMESSAGE = (16);
const int BSF_QUERY = (1);
const int BSM_ALLCOMPONENTS = (0);
const int BSM_APPLICATIONS = (8);
const int BSM_INSTALLABLEDRIVERS = (4);
const int BSM_NETDRIVER = (2);
const int BSM_VXDS = (1);
const int BROADCAST_QUERY_DENY = (1112363332);
const int NMPWAIT_NOWAIT = (1);
const int NMPWAIT_WAIT_FOREVER = -((1));
const int NMPWAIT_USE_DEFAULT_WAIT = (0);
const int MDITILE_SKIPDISABLED = (2);
const int MDITILE_HORIZONTAL = (1);
const int MDITILE_VERTICAL = (0);
const int HCBT_ACTIVATE = (5);
const int HCBT_CLICKSKIPPED = (6);
const int HCBT_CREATEWND = (3);
const int HCBT_DESTROYWND = (4);
const int HCBT_KEYSKIPPED = (7);
const int HCBT_MINMAX = (1);
const int HCBT_MOVESIZE = (0);
const int HCBT_QS = (2);
const int HCBT_SETFOCUS = (9);
const int HCBT_SYSCOMMAND = (8);
const int DM_BITSPERPEL = (0x40000);
const int DM_PELSWIDTH = (0x80000);
const int DM_PELSHEIGHT = (0x100000);
const int DM_DISPLAYFLAGS = (0x200000);
const int DM_DISPLAYFREQUENCY = (0x400000);
const int CDS_UPDATEREGISTRY = (1);
const int CDS_TEST = (2);
const int DISP_CHANGE_SUCCESSFUL = (0);
const int DISP_CHANGE_RESTART = (1);
const int DISP_CHANGE_BADFLAGS = -((4));
const int DISP_CHANGE_FAILED = -((1));
const int DISP_CHANGE_BADMODE = -((2));
const int DISP_CHANGE_NOTUPDATED = -((3));
const int SERVICE_NO_CHANGE = -((1));
const int SERVICE_WIN32_OWN_PROCESS = (16);
const int SERVICE_WIN32_SHARE_PROCESS = (32);
const int SERVICE_KERNEL_DRIVER = (1);
const int SERVICE_FILE_SYSTEM_DRIVER = (2);
const int SERVICE_INTERACTIVE_PROCESS = (256);
const int SERVICE_BOOT_START = (0);
const int SERVICE_SYSTEM_START = (1);
const int SERVICE_AUTO_START = (2);
const int SERVICE_DEMAND_START = (3);
const int SERVICE_DISABLED = (4);
const int SERVICE_STOPPED = (1);
const int SERVICE_START_PENDING = (2);
const int SERVICE_STOP_PENDING = (3);
const int SERVICE_RUNNING = (4);
const int SERVICE_CONTINUE_PENDING = (5);
const int SERVICE_PAUSE_PENDING = (6);
const int SERVICE_PAUSED = (7);
const int SERVICE_ACCEPT_STOP = (1);
const int SERVICE_ACCEPT_PAUSE_CONTINUE = (2);
const int SERVICE_ACCEPT_SHUTDOWN = (4);
const int BST_CHECKED = (1);
const int BST_INDETERMINATE = (2);
const int BST_UNCHECKED = (0);
const int BST_FOCUS = (8);
const int BST_PUSHED = (4);
const int MF_BYCOMMAND = (0);
const int MF_BYPOSITION = (0x400);
const int MF_CHECKED = (0x8);
const int MF_UNCHECKED = (0);
const int MF_HILITE = (0x80);
const int MF_UNHILITE = (0);
const int CWP_ALL = (0);
const int CWP_SKIPINVISIBLE = (1);
const int CWP_SKIPDISABLED = (2);
const int CWP_SKIPTRANSPARENT = (4);
const int CE_BREAK = (16);
const int CE_DNS = (2048);
const int CE_FRAME = (8);
const int CE_IOE = (1024);
const int CE_MODE = (32768);
const int CE_OOP = (4096);
const int CE_OVERRUN = (2);
const int CE_PTO = (512);
const int CE_RXOVER = (1);
const int CE_RXPARITY = (4);
const int CE_TXFULL = (256);
const int RGN_AND = (1);
const int RGN_COPY = (5);
const int RGN_DIFF = (4);
const int RGN_OR = (2);
const int RGN_XOR = (3);
const int NULLREGION = (1);
const int SIMPLEREGION = (2);
const int COMPLEXREGION = (3);
const int ERROR = (0);
const int CDERR_DIALOGFAILURE = (0xffff);
const int CDERR_FINDRESFAILURE = (6);
const int CDERR_INITIALIZATION = (2);
const int CDERR_LOADRESFAILURE = (7);
const int CDERR_LOADSTRFAILURE = (5);
const int CDERR_LOCKRESFAILURE = (8);
const int CDERR_MEMALLOCFAILURE = (9);
const int CDERR_MEMLOCKFAILURE = (10);
const int CDERR_NOHINSTANCE = (4);
const int CDERR_NOHOOK = (11);
const int CDERR_NOTEMPLATE = (3);
const int CDERR_REGISTERMSGFAIL = (12);
const int CDERR_STRUCTSIZE = (1);
const int PDERR_CREATEICFAILURE = (0x1000)+(10);
const int PDERR_DEFAULTDIFFERENT = (0x1000)+(12);
const int PDERR_DNDMMISMATCH = (0x1000)+(9);
const int PDERR_GETDEVMODEFAIL = (0x1000)+(5);
const int PDERR_INITFAILURE = (0x1000)+(6);
const int PDERR_LOADDRVFAILURE = (0x1000)+(4);
const int PDERR_NODEFAULTPRN = (0x1000)+(8);
const int PDERR_NODEVICES = (0x1000)+(7);
const int PDERR_PARSEFAILURE = (0x1000)+(2);
const int PDERR_PRINTERNOTFOUND = (0x1000)+(11);
const int PDERR_RETDEFFAILURE = (0x1000)+(3);
const int PDERR_SETUPFAILURE = (0x1000)+(1);
const int CFERR_MAXLESSTHANMIN = (0x2000)+(2);
const int CFERR_NOFONTS = (0x2000)+(1);
const int FNERR_BUFFERTOOSMALL = (0x3000)+(3);
const int FNERR_INVALIDFILENAME = (0x3000)+(2);
const int FNERR_SUBCLASSFAILURE = (0x3000)+(1);
const int FRERR_BUFFERLENGTHZERO = (0x4000)+(1);
const int LOCALE_SYSTEM_DEFAULT = (0x800);
const int LOCALE_USER_DEFAULT = (0x400);
const int NORM_IGNORECASE = (1);
const int NORM_IGNOREKANATYPE = (65536);
const int NORM_IGNORENONSPACE = (2);
const int NORM_IGNORESYMBOLS = (4);
const int NORM_IGNOREWIDTH = (131072);
const int SORT_STRINGSORT = (4096);
const int LCMAP_BYTEREV = (2048);
const int LCMAP_FULLWIDTH = (8388608);
const int LCMAP_HALFWIDTH = (4194304);
const int LCMAP_HIRAGANA = (1048576);
const int LCMAP_KATAKANA = (2097152);
const int LCMAP_LOWERCASE = (256);
const int LCMAP_SORTKEY = (1024);
const int LCMAP_UPPERCASE = (512);
const int DBG_CONTINUE = (0x10002);
const int DBG_CONTROL_BREAK = (0x40010008);
const int DBG_CONTROL_C = (0x40010005);
const int DBG_EXCEPTION_NOT_HANDLED = (int)(0x80010001);
const int DBG_TERMINATE_THREAD = (0x40010003);
const int DBG_TERMINATE_PROCESS = (0x40010004);
const int SERVICE_CONTROL_STOP = (1);
const int SERVICE_CONTROL_PAUSE = (2);
const int SERVICE_CONTROL_CONTINUE = (3);
const int SERVICE_CONTROL_INTERROGATE = (4);
const int SERVICE_CONTROL_SHUTDOWN = (5);
const int IMAGE_BITMAP = (0);
const int IMAGE_CURSOR = (2);
const int IMAGE_ENHMETAFILE = (1);
const int IMAGE_ICON = (1);
const int LR_COPYDELETEORG = (8);
const int LR_COPYRETURNORG = (4);
const int LR_MONOCHROME = (1);
const int LR_CREATEDIBSECTION = (8192);
const int LR_DEFAULTSIZE = (64);
const int DF_ALLOWOTHERACCOUNTHOOK = (0x1);
const int DESKTOP_CREATEMENU = (0x4);
const int DESKTOP_CREATEWINDOW = (0x2);
const int DESKTOP_ENUMERATE = (0x40);
const int DESKTOP_HOOKCONTROL = (0x8);
const int DESKTOP_JOURNALPLAYBACK = (0x20);
const int DESKTOP_JOURNALRECORD = (0x10);
const int DESKTOP_READOBJECTS = (0x1);
const int DESKTOP_SWITCHDESKTOP = (0x100);
const int DESKTOP_WRITEOBJECTS = (0x80);
const int WSF_VISIBLE = (0x1);
const int CBM_INIT = (0x4);
const int DIB_PAL_COLORS = (1);
const int DIB_RGB_COLORS = (0);
const int GENERIC_READ = (int)(0x80000000);
const int GENERIC_WRITE = (0x40000000);
const int FILE_READ_DATA = (0x0001);
const int FILE_LIST_DIRECTORY = (0x0001);
const int FILE_WRITE_DATA = (0x0002);
const int FILE_ADD_FILE = (0x0002);
const int FILE_APPEND_DATA = (0x0004);
const int FILE_ADD_SUBDIRECTORY = (0x0004);
const int FILE_CREATE_PIPE_INSTANCE = (0x0004);
const int FILE_READ_EA = (0x0008);
const int FILE_READ_PROPERTIES = (FILE_READ_EA);
const int FILE_WRITE_EA = (0x0010);
const int FILE_WRITE_PROPERTIES = (FILE_WRITE_EA);
const int FILE_EXECUTE = (0x0020);
const int FILE_TRAVERSE = (0x0020);
const int FILE_DELETE_CHILD = (0x0040);
const int FILE_READ_ATTRIBUTES = (0x0080);
const int FILE_WRITE_ATTRIBUTES = (0x0100);
const int FILE_SHARE_DELETE = (4);
const int FILE_SHARE_READ = (1);
const int FILE_SHARE_WRITE = (2);
const int CONSOLE_TEXTMODE_BUFFER = (1);
const int CREATE_NEW = (1);
const int CREATE_ALWAYS = (2);
const int OPEN_EXISTING = (3);
const int OPEN_ALWAYS = (4);
const int TRUNCATE_EXISTING = (5);
const int FILE_ATTRIBUTE_ARCHIVE = (32);
const int FILE_ATTRIBUTE_COMPRESSED = (2048);
const int FILE_ATTRIBUTE_NORMAL = (128);
const int FILE_ATTRIBUTE_DIRECTORY = (16);
const int FILE_ATTRIBUTE_HIDDEN = (2);
const int FILE_ATTRIBUTE_READONLY = (1);
const int FILE_ATTRIBUTE_SYSTEM = (4);
const int FILE_ATTRIBUTE_TEMPORARY = (256);
const int FILE_FLAG_WRITE_THROUGH = (int)(2147483648);
const int FILE_FLAG_OVERLAPPED = (1073741824);
const int FILE_FLAG_NO_BUFFERING = (536870912);
const int FILE_FLAG_RANDOM_ACCESS = (268435456);
const int FILE_FLAG_SEQUENTIAL_SCAN = (134217728);
const int FILE_FLAG_DELETE_ON_CLOSE = (67108864);
const int FILE_FLAG_BACKUP_SEMANTICS = (33554432);
const int FILE_FLAG_POSIX_SEMANTICS = (16777216);
const int SECURITY_ANONYMOUS = (0);
const int SECURITY_IDENTIFICATION = (65536);
const int SECURITY_IMPERSONATION = (131072);
const int SECURITY_DELEGATION = (196608);
const int SECURITY_CONTEXT_TRACKING = (262144);
const int SECURITY_EFFECTIVE_ONLY = (524288);
const int SECURITY_SQOS_PRESENT = (1048576);
const int SEC_COMMIT = (134217728);
const int SEC_IMAGE = (16777216);
const int SEC_NOCACHE = (268435456);
const int SEC_RESERVE = (67108864);
const int PAGE_READONLY = (2);
const int PAGE_READWRITE = (4);
const int PAGE_WRITECOPY = (8);
const int PAGE_EXECUTE = (16);
const int PAGE_EXECUTE_READ = (32);
const int PAGE_EXECUTE_READWRITE = (64);
const int PAGE_EXECUTE_WRITECOPY = (128);
const int PAGE_GUARD = (256);
const int PAGE_NOACCESS = (1);
const int PAGE_NOCACHE = (512);
const int MEM_COMMIT = (4096);
const int MEM_FREE = (65536);
const int MEM_RESERVE = (8192);
const int MEM_IMAGE = (16777216);
const int MEM_MAPPED = (262144);
const int MEM_PRIVATE = (131072);
const int MEM_DECOMMIT = (16384);
const int MEM_RELEASE = (32768);
const int MEM_TOP_DOWN = (1048576);
const int EXCEPTION_GUARD_PAGE = (int)(0x80000001);
const int SECTION_EXTEND_SIZE = (0x10);
const int SECTION_MAP_READ = (0x4);
const int SECTION_MAP_WRITE = (0x2);
const int SECTION_QUERY = (0x1);
const int SECTION_ALL_ACCESS = (0xf001f);
const int FW_DONTCARE = (0);
const int FW_THIN = (100);
const int FW_EXTRALIGHT = (200);
const int FW_LIGHT = (300);
const int FW_NORMAL = (400);
const int FW_REGULAR = (FW_NORMAL);
const int FW_MEDIUM = (500);
const int FW_SEMIBOLD = (600);
const int FW_BOLD = (700);
const int FW_EXTRABOLD = (800);
const int FW_HEAVY = (900);
const int ANSI_CHARSET = (0);
const int DEFAULT_CHARSET = (1);
const int SYMBOL_CHARSET = (2);
const int SHIFTJIS_CHARSET = (128);
const int HANGEUL_CHARSET = (129);
const int GB2312_CHARSET = (134);
const int CHINESEBIG5_CHARSET = (136);
const int GREEK_CHARSET = (161);
const int TURKISH_CHARSET = (162);
const int HEBREW_CHARSET = (177);
const int ARABIC_CHARSET = (178);
const int BALTIC_CHARSET = (186);
const int RUSSIAN_CHARSET = (204);
const int THAI_CHARSET = (222);
const int EASTEUROPE_CHARSET = (238);
const int OEM_CHARSET = (255);
const int OUT_DEFAULT_PRECIS = (0);
const int OUT_STRING_PRECIS = (1);
const int OUT_CHARACTER_PRECIS = (2);
const int OUT_STROKE_PRECIS = (3);
const int OUT_TT_PRECIS = (4);
const int OUT_DEVICE_PRECIS = (5);
const int OUT_RASTER_PRECIS = (6);
const int OUT_TT_ONLY_PRECIS = (7);
const int OUT_OUTLINE_PRECIS = (8);
const int CLIP_DEFAULT_PRECIS = (0);
const int CLIP_CHARACTER_PRECIS = (1);
const int CLIP_STROKE_PRECIS = (2);
const int CLIP_MASK = (15);
const int CLIP_LH_ANGLES = (16);
const int CLIP_TT_ALWAYS = (32);
const int CLIP_EMBEDDED = (128);
const int DEFAULT_QUALITY = (0);
const int DRAFT_QUALITY = (1);
const int PROOF_QUALITY = (2);
const int DEFAULT_PITCH = (0);
const int FIXED_PITCH = (1);
const int VARIABLE_PITCH = (2);
const int FF_DECORATIVE = (80);
const int FF_DONTCARE = (0);
const int FF_MODERN = (48);
const int FF_ROMAN = (16);
const int FF_SCRIPT = (64);
const int FF_SWISS = (32);
const int HS_BDIAGONAL = (3);
const int HS_CROSS = (4);
const int HS_DIAGCROSS = (5);
const int HS_FDIAGONAL = (2);
const int HS_HORIZONTAL = (0);
const int HS_VERTICAL = (1);
const int LR_DEFAULTCOLOR = (0);
const int LR_LOADREALSIZE = (128);
const int MAILSLOT_WAIT_FOREVER = (int)(0xffffffff);
const int MAILSLOT_NO_MESSAGE = (int)(0xffffffff);
const int CMB_MASKED = (2);
const int PIPE_ACCESS_DUPLEX = (3);
const int PIPE_ACCESS_INBOUND = (1);
const int PIPE_ACCESS_OUTBOUND = (2);
const int WRITE_DAC = (0x40000);
const int WRITE_OWNER = (0x80000);
const int ACCESS_SYSTEM_SECURITY = (0x1000000);
const int PIPE_TYPE_BYTE = (0);
const int PIPE_TYPE_MESSAGE = (4);
const int PIPE_READMODE_BYTE = (0);
const int PIPE_READMODE_MESSAGE = (2);
const int PIPE_WAIT = (0);
const int PIPE_NOWAIT = (1);
const int PS_GEOMETRIC = (65536);
const int PS_COSMETIC = (0);
const int PS_ALTERNATE = (8);
const int PS_SOLID = (0);
const int PS_DASH = (1);
const int PS_DOT = (2);
const int PS_DASHDOT = (3);
const int PS_DASHDOTDOT = (4);
const int PS_NULL = (5);
const int PS_USERSTYLE = (7);
const int PS_INSIDEFRAME = (6);
const int PS_ENDCAP_ROUND = (0);
const int PS_ENDCAP_SQUARE = (256);
const int PS_ENDCAP_FLAT = (512);
const int PS_JOIN_BEVEL = (4096);
const int PS_JOIN_MITER = (8192);
const int PS_JOIN_ROUND = (0);
const int PS_STYLE_MASK = (15);
const int PS_ENDCAP_MASK = (3840);
const int PS_TYPE_MASK = (983040);
const int ALTERNATE = (1);
const int WINDING = (2);
const int CREATE_DEFAULT_ERROR_MODE = (67108864);
const int CREATE_NEW_CONSOLE = (16);
const int CREATE_NEW_PROCESS_GROUP = (512);
const int CREATE_SEPARATE_WOW_VDM = (2048);
const int CREATE_SUSPENDED = (4);
const int CREATE_UNICODE_ENVIRONMENT = (1024);
const int DEBUG_PROCESS = (1);
const int DEBUG_ONLY_THIS_PROCESS = (2);
const int DETACHED_PROCESS = (8);
const int HIGH_PRIORITY_CLASS = (128);
const int IDLE_PRIORITY_CLASS = (64);
const int NORMAL_PRIORITY_CLASS = (32);
const int REALTIME_PRIORITY_CLASS = (256);
const int SERVICE_ALL_ACCESS = (0xf01ff);
const int SERVICE_CHANGE_CONFIG = (2);
const int SERVICE_ENUMERATE_DEPENDENTS = (8);
const int SERVICE_INTERROGATE = (128);
const int SERVICE_PAUSE_CONTINUE = (64);
const int SERVICE_QUERY_CONFIG = (1);
const int SERVICE_QUERY_STATUS = (4);
const int SERVICE_START = (16);
const int SERVICE_STOP = (32);
const int SERVICE_USER_DEFINED_CONTROL = (256);
const int SERVICE_DELETE = (0x10000);
const int SERVICE_READ_CONTROL = (0x20000);
const int SERVICE_GENERIC_EXECUTE = (0x20000000);
const int SERVICE_ERROR_IGNORE = (0);
const int SERVICE_ERROR_NORMAL = (1);
const int SERVICE_ERROR_SEVERE = (2);
const int SERVICE_ERROR_CRITICAL = (3);
const int TAPE_FIXED_PARTITIONS = (0);
const int TAPE_INITIATOR_PARTITIONS = (0x2);
const int TAPE_SELECT_PARTITIONS = (0x1);
const int TAPE_FILEMARKS = (0x1);
const int TAPE_LONG_FILEMARKS = (0x3);
const int TAPE_SETMARKS = (0);
const int TAPE_SHORT_FILEMARKS = (0x2);
const int CW_USEDEFAULT = (int)(0x80000000);
const int WS_BORDER = (0x800000);
const int WS_CAPTION = (0xc00000);
const int WS_CHILD = (0x40000000);
const int WS_CHILDWINDOW = (0x40000000);
const int WS_CLIPCHILDREN = (0x2000000);
const int WS_CLIPSIBLINGS = (0x4000000);
const int WS_DISABLED = (0x8000000);
const int WS_DLGFRAME = (0x400000);
const int WS_GROUP = (0x20000);
const int WS_HSCROLL = (0x100000);
const int WS_ICONIC = (0x20000000);
const int WS_MAXIMIZE = (0x1000000);
const int WS_MAXIMIZEBOX = (0x10000);
const int WS_MINIMIZE = (0x20000000);
const int WS_MINIMIZEBOX = (0x20000);
const int WS_OVERLAPPED = (0);
const int WS_OVERLAPPEDWINDOW = (0xcf0000);
const int WS_POPUP = (int)(0x80000000);
const int WS_POPUPWINDOW = (int)(0x80880000);
const int WS_SIZEBOX = (0x40000);
const int WS_SYSMENU = (0x80000);
const int WS_TABSTOP = (0x10000);
const int WS_THICKFRAME = (0x40000);
const int WS_TILED = (0);
const int WS_TILEDWINDOW = (0xcf0000);
const int WS_VISIBLE = (0x10000000);
const int WS_VSCROLL = (0x200000);
const int MDIS_ALLCHILDSTYLES = (0x1);
const int BS_3STATE = (0x5);
const int BS_AUTO3STATE = (0x6);
const int BS_AUTOCHECKBOX = (0x3);
const int BS_AUTORADIOBUTTON = (0x9);
const int BS_BITMAP = (0x80);
const int BS_BOTTOM = (0x800);
const int BS_CENTER = (0x300);
const int BS_CHECKBOX = (0x2);
const int BS_DEFPUSHBUTTON = (0x1);
const int BS_GROUPBOX = (0x7);
const int BS_ICON = (0x40);
const int BS_LEFT = (0x100);
const int BS_LEFTTEXT = (0x20);
const int BS_MULTILINE = (0x2000);
const int BS_NOTIFY = (0x4000);
const int BS_OWNERDRAW = (0xb);
const int BS_PUSHBUTTON = (0);
const int BS_PUSHLIKE = (0x1000);
const int BS_RADIOBUTTON = (0x4);
const int BS_RIGHT = (0x200);
const int BS_RIGHTBUTTON = (0x20);
const int BS_TEXT = (0);
const int BS_TOP = (0x400);
const int BS_USERBUTTON = (0x8);
const int BS_VCENTER = (0xc00);
const int CBS_AUTOHSCROLL = (0x40);
const int CBS_DISABLENOSCROLL = (0x800);
const int CBS_DROPDOWN = (0x2);
const int CBS_DROPDOWNLIST = (0x3);
const int CBS_HASSTRINGS = (0x200);
const int CBS_LOWERCASE = (0x4000);
const int CBS_NOINTEGRALHEIGHT = (0x400);
const int CBS_OEMCONVERT = (0x80);
const int CBS_OWNERDRAWFIXED = (0x10);
const int CBS_OWNERDRAWVARIABLE = (0x20);
const int CBS_SIMPLE = (0x1);
const int CBS_SORT = (0x100);
const int CBS_UPPERCASE = (0x2000);
const int ES_AUTOHSCROLL = (0x80);
const int ES_AUTOVSCROLL = (0x40);
const int ES_CENTER = (0x1);
const int ES_LEFT = (0);
const int ES_LOWERCASE = (0x10);
const int ES_MULTILINE = (0x4);
const int ES_NOHIDESEL = (0x100);
const int ES_NUMBER = (0x2000);
const int ES_OEMCONVERT = (0x400);
const int ES_PASSWORD = (0x20);
const int ES_READONLY = (0x800);
const int ES_RIGHT = (0x2);
const int ES_UPPERCASE = (0x8);
const int ES_WANTRETURN = (0x1000);
const int LBS_DISABLENOSCROLL = (0x1000);
const int LBS_EXTENDEDSEL = (0x800);
const int LBS_HASSTRINGS = (0x40);
const int LBS_MULTICOLUMN = (0x200);
const int LBS_MULTIPLESEL = (0x8);
const int LBS_NODATA = (0x2000);
const int LBS_NOINTEGRALHEIGHT = (0x100);
const int LBS_NOREDRAW = (0x4);
const int LBS_NOSEL = (0x4000);
const int LBS_NOTIFY = (0x1);
const int LBS_OWNERDRAWFIXED = (0x10);
const int LBS_OWNERDRAWVARIABLE = (0x20);
const int LBS_SORT = (0x2);
const int LBS_STANDARD = (0xa00003);
const int LBS_USETABSTOPS = (0x80);
const int LBS_WANTKEYBOARDINPUT = (0x400);
const int SBS_BOTTOMALIGN = (0x4);
const int SBS_HORZ = (0);
const int SBS_LEFTALIGN = (0x2);
const int SBS_RIGHTALIGN = (0x4);
const int SBS_SIZEBOX = (0x8);
const int SBS_SIZEBOXBOTTOMRIGHTALIGN = (0x4);
const int SBS_SIZEBOXTOPLEFTALIGN = (0x2);
const int SBS_SIZEGRIP = (0x10);
const int SBS_TOPALIGN = (0x2);
const int SBS_VERT = (0x1);
const int SS_BITMAP = (0xe);
const int SS_BLACKFRAME = (0x7);
const int SS_BLACKRECT = (0x4);
const int SS_CENTER = (0x1);
const int SS_CENTERIMAGE = (0x200);
const int SS_ENHMETAFILE = (0xf);
const int SS_ETCHEDFRAME = (0x12);
const int SS_ETCHEDHORZ = (0x10);
const int SS_ETCHEDVERT = (0x11);
const int SS_GRAYFRAME = (0x8);
const int SS_GRAYRECT = (0x5);
const int SS_ICON = (0x3);
const int SS_LEFT = (0);
const int SS_LEFTNOWORDWRAP = (0xc);
const int SS_NOPREFIX = (0x80);
const int SS_NOTIFY = (0x100);
const int SS_OWNERDRAW = (0xd);
const int SS_REALSIZEIMAGE = (0x800);
const int SS_RIGHT = (0x2);
const int SS_RIGHTJUST = (0x400);
const int SS_SIMPLE = (0xb);
const int SS_SUNKEN = (0x1000);
const int SS_USERITEM = (0xa);
const int SS_WHITEFRAME = (0x9);
const int SS_WHITERECT = (0x6);
const int DS_3DLOOK = (0x4);
const int DS_ABSALIGN = (0x1);
const int DS_CENTER = (0x800);
const int DS_CENTERMOUSE = (0x1000);
const int DS_CONTEXTHELP = (0x2000);
const int DS_CONTROL = (0x400);
const int DS_FIXEDSYS = (0x8);
const int DS_LOCALEDIT = (0x20);
const int DS_MODALFRAME = (0x80);
const int DS_NOFAILCREATE = (0x10);
const int DS_NOIDLEMSG = (0x100);
const int DS_SETFONT = (0x40);
const int DS_SETFOREGROUND = (0x200);
const int DS_SYSMODAL = (0x2);
const int WS_EX_ACCEPTFILES = (0x10);
const int WS_EX_APPWINDOW = (0x40000);
const int WS_EX_CLIENTEDGE = (0x200);
const int WS_EX_CONTEXTHELP = (0x400);
const int WS_EX_CONTROLPARENT = (0x10000);
const int WS_EX_DLGMODALFRAME = (0x1);
const int WS_EX_LEFT = (0);
const int WS_EX_LEFTSCROLLBAR = (0x4000);
const int WS_EX_LTRREADING = (0);
const int WS_EX_MDICHILD = (0x40);
const int WS_EX_NOPARENTNOTIFY = (0x4);
const int WS_EX_OVERLAPPEDWINDOW = (0x300);
const int WS_EX_PALETTEWINDOW = (0x188);
const int WS_EX_RIGHT = (0x1000);
const int WS_EX_RIGHTSCROLLBAR = (0);
const int WS_EX_RTLREADING = (0x2000);
const int WS_EX_STATICEDGE = (0x20000);
const int WS_EX_TOOLWINDOW = (0x80);
const int WS_EX_TOPMOST = (0x8);
const int WS_EX_TRANSPARENT = (0x20);
const int WS_EX_WINDOWEDGE = (0x100);
const int WINSTA_ACCESSCLIPBOARD = (0x4);
const int WINSTA_ACCESSGLOBALATOMS = (0x20);
const int WINSTA_CREATEDESKTOP = (0x8);
const int WINSTA_ENUMDESKTOPS = (0x1);
const int WINSTA_ENUMERATE = (0x100);
const int WINSTA_EXITWINDOWS = (0x40);
const int WINSTA_READATTRIBUTES = (0x2);
const int WINSTA_READSCREEN = (0x200);
const int WINSTA_WRITEATTRIBUTES = (0x10);
const int WH_CALLWNDPROC = (4);
const int WH_CALLWNDPROCRET = (12);
const int WH_CBT = (5);
const int WH_DEBUG = (9);
const int WH_GETMESSAGE = (3);
const int WH_JOURNALPLAYBACK = (1);
const int WH_JOURNALRECORD = (0);
const int WH_KEYBOARD = (2);
const int WH_MOUSE = (7);
const int WH_MSGFILTER = -((1));
const int WH_SHELL = (10);
const int WH_SYSMSGFILTER = (6);
const int WH_FOREGROUNDIDLE = (11);
const int DDD_RAW_TARGET_PATH = (1);
const int DDD_REMOVE_DEFINITION = (2);
const int DDD_EXACT_MATCH_ON_REMOVE = (4);
const int DC_BINNAMES = (12);
const int DC_BINS = (6);
const int DC_COPIES = (18);
const int DC_DRIVER = (11);
const int DC_DATATYPE_PRODUCED = (21);
const int DC_DUPLEX = (7);
const int DC_EMF_COMPLIANT = (20);
const int DC_ENUMRESOLUTIONS = (13);
const int DC_EXTRA = (9);
const int DC_FIELDS = (1);
const int DC_FILEDEPENDENCIES = (14);
const int DC_MAXEXTENT = (5);
const int DC_MINEXTENT = (4);
const int DC_ORIENTATION = (17);
const int DC_PAPERNAMES = (16);
const int DC_PAPERS = (2);
const int DC_PAPERSIZE = (3);
const int DC_SIZE = (8);
const int DC_TRUETYPE = (15);
const int DCTT_BITMAP = (0x1);
const int DCTT_DOWNLOAD = (0x2);
const int DCTT_SUBDEV = (0x4);
const int DC_VERSION = (10);
const int DC_BINADJUST = (19);
const int DDL_ARCHIVE = (32);
const int DDL_DIRECTORY = (16);
const int DDL_DRIVES = (16384);
const int DDL_EXCLUSIVE = (32768);
const int DDL_HIDDEN = (2);
const int DDL_READONLY = (1);
const int DDL_READWRITE = (0);
const int DDL_SYSTEM = (4);
const int DDL_POSTMSGS = (8192);
const int DLL_PROCESS_ATTACH = (1);
const int DLL_THREAD_ATTACH = (2);
const int DLL_PROCESS_DETACH = (0);
const int DLL_THREAD_DETACH = (3);
const int DM_IN_BUFFER = (8);
const int DM_MODIFY = (8);
const int DM_IN_PROMPT = (4);
const int DM_PROMPT = (4);
const int DM_OUT_BUFFER = (2);
const int DM_COPY = (2);
const int DM_UPDATE = (1);
const int IDANI_OPEN = (1);
const int IDANI_CLOSE = (2);
const int DC_ACTIVE = (1);
const int DC_SMALLCAP = (2);
const int BDR_RAISEDINNER = (4);
const int BDR_SUNKENINNER = (8);
const int BDR_RAISEDOUTER = (1);
const int BDR_SUNKENOUTER = (1);
const int EDGE_BUMP = (9);
const int EDGE_ETCHED = (6);
const int EDGE_RAISED = (5);
const int EDGE_SUNKEN = (10);
const int BF_ADJUST = (8192);
const int BF_BOTTOM = (8);
const int BF_BOTTOMLEFT = (9);
const int BF_BOTTOMRIGHT = (12);
const int BF_DIAGONAL = (16);
const int BF_DIAGONAL_ENDBOTTOMLEFT = (25);
const int BF_DIAGONAL_ENDBOTTOMRIGHT = (28);
const int BF_DIAGONAL_ENDTOPLEFT = (19);
const int BF_DIAGONAL_ENDTOPRIGHT = (22);
const int BF_FLAT = (16384);
const int BF_LEFT = (1);
const int BF_MIDDLE = (2048);
const int BF_MONO = (32768);
const int BF_RECT = (15);
const int BF_RIGHT = (4);
const int BF_SOFT = (4096);
const int BF_TOP = (2);
const int BF_TOPLEFT = (3);
const int BF_TOPRIGHT = (6);
const int DFC_BUTTON = (4);
const int DFC_CAPTION = (1);
const int DFC_MENU = (2);
const int DFC_SCROLL = (3);
const int DFCS_BUTTON3STATE = (8);
const int DFCS_BUTTONCHECK = (0);
const int DFCS_BUTTONPUSH = (16);
const int DFCS_BUTTONRADIO = (4);
const int DFCS_BUTTONRADIOIMAGE = (1);
const int DFCS_BUTTONRADIOMASK = (2);
const int DFCS_CAPTIONCLOSE = (0);
const int DFCS_CAPTIONHELP = (4);
const int DFCS_CAPTIONMAX = (2);
const int DFCS_CAPTIONMIN = (1);
const int DFCS_CAPTIONRESTORE = (3);
const int DFCS_MENUARROW = (0);
const int DFCS_MENUBULLET = (2);
const int DFCS_MENUCHECK = (1);
const int DFCS_SCROLLCOMBOBOX = (5);
const int DFCS_SCROLLDOWN = (1);
const int DFCS_SCROLLLEFT = (2);
const int DFCS_SCROLLRIGHT = (3);
const int DFCS_SCROLLSIZEGRIP = (8);
const int DFCS_SCROLLUP = (0);
const int DFCS_ADJUSTRECT = (8192);
const int DFCS_CHECKED = (1024);
const int DFCS_FLAT = (16384);
const int DFCS_INACTIVE = (256);
const int DFCS_MONO = (32768);
const int DFCS_PUSHED = (512);
const int DI_COMPAT = (4);
const int DI_DEFAULTSIZE = (8);
const int DI_IMAGE = (2);
const int DI_MASK = (1);
const int DI_NORMAL = (3);
const int DST_BITMAP = (4);
const int DST_COMPLEX = (0);
const int DST_ICON = (3);
const int DST_PREFIXTEXT = (2);
const int DST_TEXT = (1);
const int DSS_NORMAL = (0);
const int DSS_UNION = (16);
const int DSS_DISABLED = (32);
const int DSS_MONO = (128);
const int SBT_NOBORDERS = (256);
const int SBT_OWNERDRAW = (4096);
const int SBT_POPOUT = (512);
const int SBT_RTLREADING = (1024);
const int DT_BOTTOM = (8);
const int DT_CALCRECT = (1024);
const int DT_CENTER = (1);
const int DT_EDITCONTROL = (8192);
const int DT_END_ELLIPSIS = (32768);
const int DT_PATH_ELLIPSIS = (16384);
const int DT_EXPANDTABS = (64);
const int DT_EXTERNALLEADING = (512);
const int DT_LEFT = (0);
const int DT_MODIFYSTRING = (65536);
const int DT_NOCLIP = (256);
const int DT_NOPREFIX = (2048);
const int DT_RIGHT = (2);
const int DT_RTLREADING = (131072);
const int DT_SINGLELINE = (32);
const int DT_TABSTOP = (128);
const int DT_TOP = (0);
const int DT_VCENTER = (4);
const int DT_WORDBREAK = (16);
const int DT_INTERNAL = (4096);
const int DUPLICATE_CLOSE_SOURCE = (1);
const int DUPLICATE_SAME_ACCESS = (2);
const int FILE_MAP_ALL_ACCESS = (0xf001f);
const int FILE_MAP_READ = (4);
const int FILE_MAP_WRITE = (2);
const int FILE_MAP_COPY = (1);
const int MUTEX_ALL_ACCESS = (0x1f0001);
const int MUTEX_MODIFY_STATE = (1);
const int SYNCHRONIZE = (0x100000);
const int SEMAPHORE_ALL_ACCESS = (0x1f0003);
const int SEMAPHORE_MODIFY_STATE = (2);
const int EVENT_ALL_ACCESS = (0x1f0003);
const int EVENT_MODIFY_STATE = (2);
const int KEY_ALL_ACCESS = (0xf003f);
const int KEY_CREATE_LINK = (32);
const int KEY_CREATE_SUB_KEY = (4);
const int KEY_ENUMERATE_SUB_KEYS = (8);
const int KEY_EXECUTE = (0x20019);
const int KEY_NOTIFY = (16);
const int KEY_QUERY_VALUE = (1);
const int KEY_READ = (0x20019);
const int KEY_SET_VALUE = (2);
const int KEY_WRITE = (0x20006);
const int PROCESS_ALL_ACCESS = (0x1f0fff);
const int PROCESS_CREATE_PROCESS = (128);
const int PROCESS_CREATE_THREAD = (2);
const int PROCESS_DUP_HANDLE = (64);
const int PROCESS_QUERY_INFORMATION = (1024);
const int PROCESS_SET_INFORMATION = (512);
const int PROCESS_TERMINATE = (1);
const int PROCESS_VM_OPERATION = (8);
const int PROCESS_VM_READ = (16);
const int PROCESS_VM_WRITE = (32);
const int THREAD_ALL_ACCESS = (0x1f03ff);
const int THREAD_DIRECT_IMPERSONATION = (512);
const int THREAD_GET_CONTEXT = (8);
const int THREAD_IMPERSONATE = (256);
const int THREAD_QUERY_INFORMATION = (64);
const int THREAD_SET_CONTEXT = (16);
const int THREAD_SET_INFORMATION = (32);
const int THREAD_SET_THREAD_TOKEN = (128);
const int THREAD_SUSPEND_RESUME = (2);
const int THREAD_TERMINATE = (1);
const int WB_ISDELIMITER = (2);
const int WB_LEFT = (0);
const int WB_RIGHT = (1);
const int SB_BOTH = (3);
const int SB_CTL = (2);
const int SB_HORZ = (0);
const int SB_VERT = (1);
const int ESB_DISABLE_BOTH = (3);
const int ESB_DISABLE_DOWN = (2);
const int ESB_DISABLE_LEFT = (1);
const int ESB_DISABLE_LTUP = (1);
const int ESB_DISABLE_RIGHT = (2);
const int ESB_DISABLE_RTDN = (2);
const int ESB_DISABLE_UP = (1);
const int ESB_ENABLE_BOTH = (0);
const int SB_LINEUP = (0);
const int SB_LINEDOWN = (1);
const int SB_LINELEFT = (0);
const int SB_LINERIGHT = (1);
const int SB_PAGEUP = (2);
const int SB_PAGEDOWN = (3);
const int SB_PAGELEFT = (2);
const int SB_PAGERIGHT = (3);
const int SB_THUMBPOSITION = (4);
const int SB_THUMBTRACK = (5);
const int SB_ENDSCROLL = (8);
const int SB_LEFT = (6);
const int SB_RIGHT = (7);
const int SB_BOTTOM = (7);
const int SB_TOP = (6);
const int ENUM_ALL_CALENDARS = -((1));
const int DATE_SHORTDATE = (1);
const int DATE_LONGDATE = (2);
const int SERVICE_ACTIVE = (1);
const int SERVICE_INACTIVE = (2);
const int DEVICE_FONTTYPE = (2);
const int RASTER_FONTTYPE = (1);
const int TRUETYPE_FONTTYPE = (4);
const int OBJ_BRUSH = (2);
const int OBJ_PEN = (1);
const int OBJ_PAL = (5);
const int OBJ_FONT = (6);
const int OBJ_BITMAP = (7);
const int OBJ_EXTPEN = (11);
const int OBJ_REGION = (8);
const int OBJ_DC = (3);
const int OBJ_MEMDC = (10);
const int OBJ_METAFILE = (9);
const int OBJ_METADC = (4);
const int OBJ_ENHMETAFILE = (13);
const int OBJ_ENHMETADC = (12);
const int SERVICE_WIN32 = (48);
const int SERVICE_DRIVER = (11);
const int CP_INSTALLED = (1);
const int CP_SUPPORTED = (2);
const int LCID_INSTALLED = (1);
const int LCID_SUPPORTED = (2);
const int TAPE_ERASE_LONG = (0x1);
const int TAPE_ERASE_SHORT = (0);
const int SP_ERROR = -((1));
const int SP_OUTOFDISK = -((4));
const int SP_OUTOFMEMORY = -((5));
const int SP_USERABORT = -((3));
const int PHYSICALWIDTH = (110);
const int PHYSICALHEIGHT = (111);
const int PHYSICALOFFSETX = (112);
const int PHYSICALOFFSETY = (113);
const int SCALINGFACTORX = (114);
const int SCALINGFACTORY = (115);
const int QUERYESCSUPPORT = (8);
const int cABORTDOC = (2);
const int cENDDOC = (11);
const int GETPHYSPAGESIZE = (12);
const int GETPRINTINGOFFSET = (13);
const int GETSCALINGFACTOR = (14);
const int NEWFRAME = (1);
const int NEXTBAND = (3);
const int PASSTHROUGH = (19);
const int cSETABORTPROC = (9);
const int cSTARTDOC = (10);
const int CLRDTR = (6);
const int CLRRTS = (4);
const int SETDTR = (5);
const int SETRTS = (3);
const int SETXOFF = (1);
const int SETXON = (2);
const int SETBREAK = (8);
const int CLRBREAK = (9);
const int EWX_FORCE = (4);
const int EWX_LOGOFF = (0);
const int EWX_POWEROFF = (8);
const int EWX_REBOOT = (2);
const int EWX_SHUTDOWN = (1);
const int FLOODFILLBORDER = (0);
const int FLOODFILLSURFACE = (1);
const int ETO_CLIPPED = (4);
const int ETO_GLYPH_INDEX = (16);
const int ETO_OPAQUE = (2);
const int ETO_RTLREADING = (128);
const int FOREGROUND_BLUE = (1);
const int FOREGROUND_GREEN = (2);
const int FOREGROUND_RED = (4);
const int FOREGROUND_INTENSITY = (8);
const int BACKGROUND_BLUE = (16);
const int BACKGROUND_GREEN = (32);
const int BACKGROUND_RED = (64);
const int BACKGROUND_INTENSITY = (128);
const int FILE_NOTIFY_CHANGE_FILE_NAME = (1);
const int FILE_NOTIFY_CHANGE_DIR_NAME = (2);
const int FILE_NOTIFY_CHANGE_ATTRIBUTES = (4);
const int FILE_NOTIFY_CHANGE_SIZE = (8);
const int FILE_NOTIFY_CHANGE_LAST_WRITE = (16);
const int FILE_NOTIFY_CHANGE_SECURITY = (256);
const int MAP_FOLDCZONE = (16);
const int MAP_FOLDDIGITS = (128);
const int MAP_PRECOMPOSED = (32);
const int MAP_COMPOSITE = (64);
const int HC_ACTION = (0);
const int FORMAT_MESSAGE_ALLOCATE_BUFFER = (256);
const int FORMAT_MESSAGE_IGNORE_INSERTS = (512);
const int FORMAT_MESSAGE_FROM_STRING = (1024);
const int FORMAT_MESSAGE_FROM_HMODULE = (2048);
const int FORMAT_MESSAGE_FROM_SYSTEM = (4096);
const int FORMAT_MESSAGE_ARGUMENT_ARRAY = (8192);
const int FORMAT_MESSAGE_MAX_WIDTH_MASK = (255);
const int GDICOMMENT_WINDOWS_METAFILE = -((2147483647));
const int GDICOMMENT_BEGINGROUP = (2);
const int GDICOMMENT_ENDGROUP = (3);
const int GDICOMMENT_MULTIFORMATS = (1073741828);
const int GDICOMMENT_IDENTIFIER = (1128875079);
const int CTRL_C_EVENT = (0);
const int CTRL_BREAK_EVENT = (1);
const int CTRL_CLOSE_EVENT = (2);
const int CTRL_LOGOFF_EVENT = (5);
const int CTRL_SHUTDOWN_EVENT = (6);
const int AD_COUNTERCLOCKWISE = (1);
const int AD_CLOCKWISE = (2);
const int SCS_32BIT_BINARY = (0);
const int SCS_DOS_BINARY = (1);
const int SCS_OS216_BINARY = (5);
const int SCS_PIF_BINARY = (3);
const int SCS_POSIX_BINARY = (4);
const int SCS_WOW_BINARY = (2);
const int DCB_DISABLE = (8);
const int DCB_ENABLE = (4);
const int DCB_RESET = (1);
const int DCB_SET = (3);
const int DCB_ACCUMULATE = (2);
const int GCP_DBCS = (1);
const int GCP_ERROR = (0x8000);
const int GCP_CLASSIN = (0x80000);
const int GCP_DIACRITIC = (256);
const int GCP_DISPLAYZWG = (0x400000);
const int GCP_GLYPHSHAPE = (16);
const int GCP_JUSTIFY = (0x10000);
const int GCP_JUSTIFYIN = (0x200000);
const int GCP_KASHIDA = (1024);
const int GCP_LIGATE = (32);
const int GCP_MAXEXTENT = (0x100000);
const int GCP_NEUTRALOVERRIDE = (0x2000000);
const int GCP_NUMERICOVERRIDE = (0x1000000);
const int GCP_NUMERICSLATIN = (0x4000000);
const int GCP_NUMERICSLOCAL = (0x8000000);
const int GCP_REORDER = (2);
const int GCP_SYMSWAPOFF = (0x800000);
const int GCP_USEKERNING = (8);
const int FLI_GLYPHS = (0x40000);
const int FLI_MASK = (0x103b);
const int GCW_ATOM = -((32));
const int GCL_CBCLSEXTRA = -((20));
const int GCL_CBWNDEXTRA = -((18));
const int GCL_HBRBACKGROUND = -((10));
const int GCL_HCURSOR = -((12));
const int GCL_HICON = -((14));
const int GCL_HICONSM = -((34));
const int GCL_HMODULE = -((16));
const int GCL_MENUNAME = -((8));
const int GCL_STYLE = -((26));
const int GCL_WNDPROC = -((24));
const int CF_BITMAP = (2);
const int CF_DIB = (8);
const int CF_PALETTE = (9);
const int CF_ENHMETAFILE = (14);
const int CF_METAFILEPICT = (3);
const int CF_OEMTEXT = (7);
const int CF_TEXT = (1);
const int CF_UNICODETEXT = (13);
const int CF_DIF = (5);
const int CF_DSPBITMAP = (130);
const int CF_DSPENHMETAFILE = (142);
const int CF_DSPMETAFILEPICT = (131);
const int CF_DSPTEXT = (129);
const int CF_GDIOBJFIRST = (768);
const int CF_GDIOBJLAST = (1023);
const int CF_HDROP = (15);
const int CF_LOCALE = (16);
const int CF_OWNERDISPLAY = (128);
const int CF_PENDATA = (10);
const int CF_PRIVATEFIRST = (512);
const int CF_PRIVATELAST = (767);
const int CF_RIFF = (11);
const int CF_SYLK = (4);
const int CF_WAVE = (12);
const int CF_TIFF = (6);
const int EV_BREAK = (64);
const int EV_CTS = (8);
const int EV_DSR = (16);
const int EV_ERR = (128);
const int EV_EVENT1 = (2048);
const int EV_EVENT2 = (4096);
const int EV_PERR = (512);
const int EV_RING = (256);
const int EV_RLSD = (32);
const int EV_RX80FULL = (1024);
const int EV_RXCHAR = (1);
const int EV_RXFLAG = (2);
const int EV_TXEMPTY = (4);
const int MS_CTS_ON = (0x10);
const int MS_DSR_ON = (0x20);
const int MS_RING_ON = (0x40);
const int MS_RLSD_ON = (0x80);
const int MAX_COMPUTERNAME_LENGTH = (15);
const int ENABLE_LINE_INPUT = (2);
const int ENABLE_ECHO_INPUT = (4);
const int ENABLE_PROCESSED_INPUT = (1);
const int ENABLE_WINDOW_INPUT = (8);
const int ENABLE_MOUSE_INPUT = (16);
const int ENABLE_PROCESSED_OUTPUT = (1);
const int ENABLE_WRAP_AT_EOL_OUTPUT = (2);
const int CP_ACP = (0);
const int CP_MACCP = (2);
const int CP_OEMCP = (1);
const int DATE_USE_ALT_CALENDAR = (4);
const int DCX_WINDOW = (0x1);
const int DCX_CACHE = (0x2);
const int DCX_PARENTCLIP = (0x20);
const int DCX_CLIPSIBLINGS = (0x10);
const int DCX_CLIPCHILDREN = (0x8);
const int DCX_NORESETATTRS = (0x4);
const int DCX_LOCKWINDOWUPDATE = (0x400);
const int DCX_EXCLUDERGN = (0x40);
const int DCX_INTERSECTRGN = (0x80);
const int DCX_VALIDATE = (0x200000);
const int DRIVERVERSION = (0);
const int TECHNOLOGY = (2);
const int DT_PLOTTER = (0);
const int DT_RASDISPLAY = (1);
const int DT_RASPRINTER = (2);
const int DT_RASCAMERA = (3);
const int DT_CHARSTREAM = (4);
const int DT_METAFILE = (5);
const int DT_DISPFILE = (6);
const int HORZSIZE = (4);
const int VERTSIZE = (6);
const int HORZRES = (8);
const int VERTRES = (10);
const int LOGPIXELSX = (88);
const int LOGPIXELSY = (90);
const int BITSPIXEL = (12);
const int PLANES = (14);
const int NUMBRUSHES = (16);
const int NUMPENS = (18);
const int NUMFONTS = (22);
const int NUMCOLORS = (24);
const int ASPECTX = (40);
const int ASPECTY = (42);
const int ASPECTXY = (44);
const int PDEVICESIZE = (26);
const int CLIPCAPS = (36);
const int SIZEPALETTE = (104);
const int NUMRESERVED = (106);
const int COLORRES = (108);
const int VREFRESH = (116);
const int DESKTOPHORZRES = (118);
const int DESKTOPVERTRES = (117);
const int BLTALIGNMENT = (119);
const int RASTERCAPS = (38);
const int RC_BANDING = (2);
const int RC_BITBLT = (1);
const int RC_BITMAP64 = (8);
const int RC_DI_BITMAP = (128);
const int RC_DIBTODEV = (512);
const int RC_FLOODFILL = (4096);
const int RC_GDI20_OUTPUT = (16);
const int RC_PALETTE = (256);
const int RC_SCALING = (4);
const int RC_STRETCHBLT = (2048);
const int RC_STRETCHDIB = (8192);
const int CURVECAPS = (28);
const int CC_NONE = (0);
const int CC_CIRCLES = (1);
const int CC_PIE = (2);
const int CC_CHORD = (4);
const int CC_ELLIPSES = (8);
const int CC_WIDE = (16);
const int CC_STYLED = (32);
const int CC_WIDESTYLED = (64);
const int CC_INTERIORS = (128);
const int CC_ROUNDRECT = (256);
const int LINECAPS = (30);
const int LC_NONE = (0);
const int LC_POLYLINE = (2);
const int LC_MARKER = (4);
const int LC_POLYMARKER = (8);
const int LC_WIDE = (16);
const int LC_STYLED = (32);
const int LC_WIDESTYLED = (64);
const int LC_INTERIORS = (128);
const int POLYGONALCAPS = (32);
const int PC_NONE = (0);
const int PC_POLYGON = (1);
const int PC_RECTANGLE = (2);
const int PC_WINDPOLYGON = (4);
const int PC_SCANLINE = (8);
const int PC_WIDE = (16);
const int PC_STYLED = (32);
const int PC_WIDESTYLED = (64);
const int PC_INTERIORS = (128);
const int TEXTCAPS = (34);
const int TC_OP_CHARACTER = (1);
const int TC_OP_STROKE = (2);
const int TC_CP_STROKE = (4);
const int TC_CR_90 = (8);
const int TC_CR_ANY = (16);
const int TC_SF_X_YINDEP = (32);
const int TC_SA_DOUBLE = (64);
const int TC_SA_INTEGER = (128);
const int TC_SA_CONTIN = (256);
const int TC_EA_DOUBLE = (512);
const int TC_IA_ABLE = (1024);
const int TC_UA_ABLE = (2048);
const int TC_SO_ABLE = (4096);
const int TC_RA_ABLE = (8192);
const int TC_VA_ABLE = (16384);
const int TC_RESERVED = (32768);
const int TC_SCROLLBLT = (65536);
const int PC_PATHS = (512);
const int DRIVE_REMOVABLE = (2);
const int DRIVE_FIXED = (3);
const int DRIVE_REMOTE = (4);
const int DRIVE_CDROM = (5);
const int DRIVE_RAMDISK = (6);
const int DRIVE_UNKNOWN = (0);
const int DRIVE_NO_ROOT_DIR = (1);
const int EXCEPTION_ACCESS_VIOLATION = (int)(0xc0000005);
const int EXCEPTION_BREAKPOINT = (int)(0x80000003);
const int EXCEPTION_DATATYPE_MISALIGNMENT = (int)(0x80000002);
const int EXCEPTION_SINGLE_STEP = (int)(0x80000004);
const int EXCEPTION_ARRAY_BOUNDS_EXCEEDED = (int)(0xc000008c);
const int EXCEPTION_FLT_DENORMAL_OPERAND = (int)(0xc000008d);
const int EXCEPTION_FLT_DIVIDE_BY_ZERO = (int)(0xc000008e);
const int EXCEPTION_FLT_INEXACT_RESULT = (int)(0xc000008f);
const int EXCEPTION_FLT_INVALID_OPERATION = (int)(0xc0000090);
const int EXCEPTION_FLT_OVERFLOW = (int)(0xc0000091);
const int EXCEPTION_FLT_STACK_CHECK = (int)(0xc0000092);
const int EXCEPTION_FLT_UNDERFLOW = (int)(0xc0000093);
const int EXCEPTION_INT_DIVIDE_BY_ZERO = (int)(0xc0000094);
const int EXCEPTION_INT_OVERFLOW = (int)(0xc0000095);
const int EXCEPTION_INVALID_HANDLE = (int)(0xc0000008);
const int EXCEPTION_PRIV_INSTRUCTION = (int)(0xc0000096);
const int EXCEPTION_NONCONTINUABLE_EXCEPTION = (int)(0xc0000025);
const int EXCEPTION_NONCONTINUABLE = (0x1);
const int EXCEPTION_STACK_OVERFLOW = (int)(0xc00000fd);
const int EXCEPTION_INVALID_DISPOSITION = (int)(0xc0000026);
const int FILE_TYPE_UNKNOWN = (0);
const int FILE_TYPE_DISK = (1);
const int FILE_TYPE_CHAR = (2);
const int FILE_TYPE_PIPE = (3);
const int GGO_BITMAP = (1);
const int GGO_NATIVE = (2);
const int GGO_METRICS = (0);
const int GGO_GRAY2_BITMAP = (4);
const int GGO_GRAY4_BITMAP = (5);
const int GGO_GRAY8_BITMAP = (6);
const int GDI_ERROR = (int)(0xffffffff);
const int GM_COMPATIBLE = (1);
const int GM_ADVANCED = (2);
const int HANDLE_FLAG_INHERIT = (1);
const int HANDLE_FLAG_PROTECT_FROM_CLOSE = (2);
const char* RT_ACCELERATOR = cast(char*) ((9));
const char* RT_BITMAP = cast(char*) ((2));
const char* RT_DIALOG = cast(char*) ((5));
const char* RT_FONT = cast(char*) ((8));
const char* RT_FONTDIR = cast(char*) ((7));
const char* RT_MENU = cast(char*) ((4));
const char* RT_RCDATA = cast(char*) ((10));
const char* RT_STRING = cast(char*) ((6));
const char* RT_MESSAGETABLE = cast(char*) ((11));
const char* RT_CURSOR = cast(char*) ((1));
const char* RT_GROUP_CURSOR = cast(char*) ((12));
const char* RT_ICON = cast(char*) ((3));
const char* RT_GROUP_ICON = cast(char*) ((13));
const char* RT_VERSION = cast(char*) ((16));
const char* IDC_ARROW = cast(char*) ((32512));
const char* IDC_IBEAM = cast(char*) ((32513));
const char* IDC_WAIT = cast(char*) ((32514));
const char* IDC_CROSS = cast(char*) ((32515));
const char* IDC_UPARROW = cast(char*) ((32516));
const char* IDC_SIZENWSE = cast(char*) ((32642));
const char* IDC_SIZENESW = cast(char*) ((32643));
const char* IDC_SIZEWE = cast(char*) ((32644));
const char* IDC_SIZENS = cast(char*) ((32645));
const char* IDC_SIZEALL = cast(char*) ((32646));
const char* IDC_NO = cast(char*) ((32648));
const char* IDC_APPSTARTING = cast(char*) ((32650));
const char* IDC_HELP = cast(char*) ((32651));
const char* IDI_APPLICATION = cast(char*) ((32512));
const char* IDI_HAND = cast(char*) ((32513));
const char* IDI_QUESTION = cast(char*) ((32514));
const char* IDI_EXCLAMATION = cast(char*) ((32515));
const char* IDI_ASTERISK = cast(char*) ((32516));
const char* IDI_WINLOGO = cast(char*) ((32517));
const char* IDC_SIZE = cast(char*) ((32640));
const char* IDC_ICON = cast(char*) ((32641));
const int MM_ANISOTROPIC = (8);
const int MM_HIENGLISH = (5);
const int MM_HIMETRIC = (3);
const int MM_ISOTROPIC = (7);
const int MM_LOENGLISH = (4);
const int MM_LOMETRIC = (2);
const int MM_TEXT = (1);
const int MM_TWIPS = (6);
const int GMDI_GOINTOPOPUPS = (0x2);
const int GMDI_USEDISABLED = (0x1);
const int PM_NOREMOVE = (0);
const int PM_REMOVE = (1);
const int PM_NOYIELD = (2);
const int PIPE_CLIENT_END = (0);
const int PIPE_SERVER_END = (1);
const int GW_HWNDNEXT = (2);
const int GW_HWNDPREV = (3);
const int GW_CHILD = (5);
const int GW_HWNDFIRST = (0);
const int GW_HWNDLAST = (1);
const int GW_OWNER = (4);
const int PT_MOVETO = (6);
const int PT_LINETO = (2);
const int PT_BEZIERTO = (4);
const int PT_CLOSEFIGURE = (1);
const int SHUTDOWN_NORETRY = (1);
const int QS_ALLEVENTS = (191);
const int QS_ALLINPUT = (255);
const int QS_HOTKEY = (128);
const int QS_INPUT = (7);
const int QS_KEY = (1);
const int QS_MOUSE = (6);
const int QS_MOUSEBUTTON = (4);
const int QS_MOUSEMOVE = (2);
const int QS_PAINT = (32);
const int QS_POSTMESSAGE = (8);
const int QS_SENDMESSAGE = (64);
const int QS_TIMER = (16);
const int SIF_ALL = (23);
const int SIF_PAGE = (2);
const int SIF_POS = (4);
const int SIF_RANGE = (1);
const int SIF_DISABLENOSCROLL = (8);
const int STD_INPUT_HANDLE = -(10);
const int STD_OUTPUT_HANDLE = -(11);
const int STD_ERROR_HANDLE = -(12);
const int INVALID_HANDLE_VALUE = -(1);
const int BLACK_BRUSH = (4);
const int DKGRAY_BRUSH = (3);
const int GRAY_BRUSH = (2);
const int HOLLOW_BRUSH = (5);
const int LTGRAY_BRUSH = (1);
const int NULL_BRUSH = (5);
const int WHITE_BRUSH = (0);
const int BLACK_PEN = (7);
const int NULL_PEN = (8);
const int WHITE_PEN = (6);
const int ANSI_FIXED_FONT = (11);
const int ANSI_VAR_FONT = (12);
const int DEVICE_DEFAULT_FONT = (14);
const int DEFAULT_GUI_FONT = (17);
const int OEM_FIXED_FONT = (10);
const int SYSTEM_FONT = (13);
const int SYSTEM_FIXED_FONT = (16);
const int DEFAULT_PALETTE = (15);
const int CT_CTYPE1 = (1);
const int CT_CTYPE2 = (2);
const int CT_CTYPE3 = (4);
const int C1_UPPER = (1);
const int C1_LOWER = (2);
const int C1_DIGIT = (4);
const int C1_SPACE = (8);
const int C1_PUNCT = (16);
const int C1_CNTRL = (32);
const int C1_BLANK = (64);
const int C1_XDIGIT = (128);
const int C1_ALPHA = (256);
const int C2_LEFTTORIGHT = (1);
const int C2_RIGHTTOLEFT = (2);
const int C2_EUROPENUMBER = (3);
const int C2_EUROPESEPARATOR = (4);
const int C2_EUROPETERMINATOR = (5);
const int C2_ARABICNUMBER = (6);
const int C2_COMMONSEPARATOR = (7);
const int C2_BLOCKSEPARATOR = (8);
const int C2_SEGMENTSEPARATOR = (9);
const int C2_WHITESPACE = (10);
const int C2_OTHERNEUTRAL = (11);
const int C2_NOTAPPLICABLE = (0);
const int C3_NONSPACING = (1);
const int C3_DIACRITIC = (2);
const int C3_VOWELMARK = (4);
const int C3_SYMBOL = (8);
const int C3_KATAKANA = (16);
const int C3_HIRAGANA = (32);
const int C3_HALFWIDTH = (64);
const int C3_FULLWIDTH = (128);
const int C3_IDEOGRAPH = (256);
const int C3_KASHIDA = (512);
const int C3_ALPHA = (32768);
const int C3_NOTAPPLICABLE = (0);
const int COLOR_3DDKSHADOW = (21);
const int COLOR_3DFACE = (15);
const int COLOR_3DHILIGHT = (20);
const int COLOR_3DLIGHT = (22);
const int COLOR_BTNHILIGHT = (20);
const int COLOR_3DSHADOW = (16);
const int COLOR_ACTIVEBORDER = (10);
const int COLOR_ACTIVECAPTION = (2);
const int COLOR_APPWORKSPACE = (12);
const int COLOR_BACKGROUND = (1);
const int COLOR_DESKTOP = (1);
const int COLOR_BTNFACE = (15);
const int COLOR_BTNHIGHLIGHT = (20);
const int COLOR_BTNSHADOW = (16);
const int COLOR_BTNTEXT = (18);
const int COLOR_CAPTIONTEXT = (9);
const int COLOR_GRAYTEXT = (17);
const int COLOR_HIGHLIGHT = (13);
const int COLOR_HIGHLIGHTTEXT = (14);
const int COLOR_INACTIVEBORDER = (11);
const int COLOR_INACTIVECAPTION = (3);
const int COLOR_INACTIVECAPTIONTEXT = (19);
const int COLOR_INFOBK = (24);
const int COLOR_INFOTEXT = (23);
const int COLOR_MENU = (4);
const int COLOR_MENUTEXT = (7);
const int COLOR_SCROLLBAR = (0);
const int COLOR_WINDOW = (5);
const int COLOR_WINDOWFRAME = (6);
const int COLOR_WINDOWTEXT = (8);
const int SM_CYMIN = (29);
const int SM_CXMIN = (28);
const int SM_ARRANGE = (56);
const int SM_CLEANBOOT = (67);
const int SM_CMETRICS = (76);
const int SM_CMOUSEBUTTONS = (43);
const int SM_CXBORDER = (5);
const int SM_CYBORDER = (6);
const int SM_CXCURSOR = (13);
const int SM_CYCURSOR = (14);
const int SM_CXDLGFRAME = (7);
const int SM_CYDLGFRAME = (8);
const int SM_CXDOUBLECLK = (36);
const int SM_CYDOUBLECLK = (37);
const int SM_CXDRAG = (68);
const int SM_CYDRAG = (69);
const int SM_CXEDGE = (45);
const int SM_CYEDGE = (46);
const int SM_CXFIXEDFRAME = (7);
const int SM_CYFIXEDFRAME = (8);
const int SM_CXFRAME = (32);
const int SM_CYFRAME = (33);
const int SM_CXFULLSCREEN = (16);
const int SM_CYFULLSCREEN = (17);
const int SM_CXHSCROLL = (21);
const int SM_CYHSCROLL = (3);
const int SM_CXHTHUMB = (10);
const int SM_CXICON = (11);
const int SM_CYICON = (12);
const int SM_CXICONSPACING = (38);
const int SM_CYICONSPACING = (39);
const int SM_CXMAXIMIZED = (61);
const int SM_CYMAXIMIZED = (62);
const int SM_CXMAXTRACK = (59);
const int SM_CYMAXTRACK = (60);
const int SM_CXMENUCHECK = (71);
const int SM_CYMENUCHECK = (72);
const int SM_CXMENUSIZE = (54);
const int SM_CYMENUSIZE = (55);
const int SM_CXMINIMIZED = (57);
const int SM_CYMINIMIZED = (58);
const int SM_CXMINSPACING = (47);
const int SM_CYMINSPACING = (48);
const int SM_CXMINTRACK = (34);
const int SM_CYMINTRACK = (35);
const int SM_CXSCREEN = (0);
const int SM_CYSCREEN = (1);
const int SM_CXSIZE = (30);
const int SM_CYSIZE = (31);
const int SM_CXSIZEFRAME = (32);
const int SM_CYSIZEFRAME = (33);
const int SM_CXSMICON = (49);
const int SM_CYSMICON = (50);
const int SM_CXSMSIZE = (52);
const int SM_CYSMSIZE = (53);
const int SM_CXVSCROLL = (2);
const int SM_CYVSCROLL = (20);
const int SM_CYVTHUMB = (9);
const int SM_CYCAPTION = (4);
const int SM_CYKANJIWINDOW = (18);
const int SM_CYMENU = (15);
const int SM_CYSMCAPTION = (51);
const int SM_DBCSENABLED = (42);
const int SM_DEBUG = (22);
const int SM_MENUDROPALIGNMENT = (40);
const int SM_MIDEASTENABLED = (74);
const int SM_MOUSEPRESENT = (19);
const int SM_MOUSEWHEELPRESENT = (75);
const int SM_NETWORK = (63);
const int SM_PENWINDOWS = (41);
const int SM_SECURE = (44);
const int SM_SHOWSOUNDS = (70);
const int SM_SLOWMACHINE = (73);
const int SM_SWAPBUTTON = (23);
const int ARW_BOTTOMLEFT = (0);
const int ARW_BOTTOMRIGHT = (0x1);
const int ARW_HIDE = (0x8);
const int ARW_TOPLEFT = (0x2);
const int ARW_TOPRIGHT = (0x3);
const int ARW_DOWN = (0x4);
const int ARW_LEFT = (0);
const int ARW_RIGHT = (0);
const int ARW_UP = (0x4);
const int SYSPAL_NOSTATIC = (2);
const int SYSPAL_STATIC = (1);
const int SYSPAL_ERROR = (0);
const int GET_TAPE_MEDIA_INFORMATION = (0);
const int GET_TAPE_DRIVE_INFORMATION = (1);
const int SET_TAPE_MEDIA_INFORMATION = (0);
const int SET_TAPE_DRIVE_INFORMATION = (1);
const int TAPE_ABSOLUTE_POSITION = (0);
const int TAPE_LOGICAL_POSITION = (0x1);
const int TA_BASELINE = (24);
const int TA_BOTTOM = (8);
const int TA_TOP = (0);
const int TA_CENTER = (6);
const int TA_LEFT = (0);
const int TA_RIGHT = (2);
const int TA_RTLREADING = (256);
const int TA_NOUPDATECP = (0);
const int TA_UPDATECP = (1);
const int VTA_BASELINE = (24);
const int VTA_CENTER = (6);
const int THREAD_PRIORITY_ABOVE_NORMAL = (1);
const int THREAD_PRIORITY_BELOW_NORMAL = -((1));
const int THREAD_PRIORITY_HIGHEST = (2);
const int THREAD_PRIORITY_IDLE = -((15));
const int THREAD_PRIORITY_LOWEST = -((2));
const int THREAD_PRIORITY_NORMAL = (0);
const int THREAD_PRIORITY_TIME_CRITICAL = (15);
const int THREAD_PRIORITY_ERROR_RETURN = (2147483647);
const int TLS_MINIMUM_AVAILABLE = (64);
const int TIME_NOMINUTESORSECONDS = (1);
const int TIME_NOSECONDS = (2);
const int TIME_NOTIMEMARKER = (4);
const int TIME_FORCE24HOURFORMAT = (8);
const int TIME_ZONE_ID_INVALID = -(1);
const int TIME_ZONE_ID_UNKNOWN = (0);
const int TIME_ZONE_ID_STANDARD = (1);
const int TIME_ZONE_ID_DAYLIGHT = (2);
const int UOI_FLAGS = (1);
const int UOI_NAME = (2);
const int UOI_TYPE = (3);
const int FS_CASE_IS_PRESERVED = (2);
const int FS_CASE_SENSITIVE = (1);
const int FS_UNICODE_STORED_ON_DISK = (4);
const int FS_PERSISTENT_ACLS = (8);
const int FS_FILE_COMPRESSION = (16);
const int FS_VOL_IS_COMPRESSED = (32768);
const int GWL_EXSTYLE = -((20));
const int GWL_STYLE = -((16));
const int GWL_WNDPROC = -((4));
const int GWL_HINSTANCE = -((6));
const int GWL_HWNDPARENT = -((8));
const int GWL_ID = -((12));
const int GWL_USERDATA = -((21));
const int DWL_DLGPROC = (4);
const int DWL_MSGRESULT = (0);
const int DWL_USER = (8);
const int GMEM_FIXED = (0);
const int GMEM_MOVEABLE = (2);
const int GPTR = (64);
const int GHND = (66);
const int GMEM_DDESHARE = (8192);
const int GMEM_DISCARDABLE = (256);
const int GMEM_LOWER = (4096);
const int GMEM_NOCOMPACT = (16);
const int GMEM_NODISCARD = (32);
const int GMEM_NOT_BANKED = (4096);
const int GMEM_NOTIFY = (16384);
const int GMEM_SHARE = (8192);
const int GMEM_ZEROINIT = (64);
const int GMEM_DISCARDED = (16384);
const int GMEM_INVALID_HANDLE = (32768);
const int GMEM_LOCKCOUNT = (255);
const int HEAP_GENERATE_EXCEPTIONS = (4);
const int HEAP_NO_SERIALIZE = (1);
const int HEAP_ZERO_MEMORY = (8);
const int STATUS_NO_MEMORY = (int)(0xc0000017);
const int STATUS_ACCESS_VIOLATION = (int)(0xc0000005);
const int HEAP_REALLOC_IN_PLACE_ONLY = (16);
const int ILC_COLOR = (0);
const int ILC_COLOR4 = (4);
const int ILC_COLOR8 = (8);
const int ILC_COLOR16 = (16);
const int ILC_COLOR24 = (24);
const int ILC_COLOR32 = (32);
const int ILC_COLORDDB = (254);
const int ILC_MASK = (1);
const int ILC_PALETTE = (2048);
const int ILD_BLEND25 = (2);
const int ILD_BLEND50 = (4);
const int ILD_SELECTED = (4);
const int ILD_BLEND = (4);
const int ILD_FOCUS = (2);
const int ILD_MASK = (16);
const int ILD_NORMAL = (0);
const int ILD_TRANSPARENT = (1);
const int CLR_NONE = (int)(0xffffffff);
const int CLR_DEFAULT = (int)(0xff000000);
const int CLR_INVALID = (int)(0xFFFFFFFF);
const int LR_LOADFROMFILE = (16);
const int LR_LOADMAP3DCOLORS = (4096);
const int LR_LOADTRANSPARENT = (32);
const int IME_CONFIG_GENERAL = (1);
const int IME_CONFIG_REGISTERWORD = (2);
const int IME_CONFIG_SELECTDICTIONARY = (3);
const int GCL_CONVERSION = (1);
const int GCL_REVERSECONVERSION = (2);
const int GCL_REVERSE_LENGTH = (3);
const int GGL_LEVEL = (1);
const int GGL_INDEX = (2);
const int GGL_STRING = (3);
const int GGL_PRIVATE = (4);
const int GL_LEVEL_ERROR = (2);
const int GL_LEVEL_FATAL = (1);
const int GL_LEVEL_INFORMATION = (4);
const int GL_LEVEL_NOGUIDELINE = (0);
const int GL_LEVEL_WARNING = (3);
const int GL_ID_CANNOTSAVE = (17);
const int GL_ID_NOCONVERT = (32);
const int GL_ID_NODICTIONARY = (16);
const int GL_ID_NOMODULE = (1);
const int GL_ID_READINGCONFLICT = (35);
const int GL_ID_TOOMANYSTROKE = (34);
const int GL_ID_TYPINGERROR = (33);
const int GL_ID_UNKNOWN = (0);
const int GL_ID_INPUTREADING = (36);
const int GL_ID_INPUTRADICAL = (37);
const int GL_ID_INPUTCODE = (38);
const int GL_ID_CHOOSECANDIDATE = (40);
const int GL_ID_REVERSECONVERSION = (41);
const int IGP_PROPERTY = (4);
const int IGP_CONVERSION = (8);
const int IGP_SENTENCE = (12);
const int IGP_UI = (16);
const int IGP_SETCOMPSTR = (20);
const int IGP_SELECT = (24);
const int IME_PROP_AT_CARET = (65536);
const int IME_PROP_SPECIAL_UI = (131072);
const int IME_PROP_CANDLIST_START_FROM_1 = (262144);
const int IME_PROP_UNICODE = (524288);
const int UI_CAP_2700 = (1);
const int UI_CAP_ROT90 = (2);
const int UI_CAP_ROTANY = (4);
const int SCS_CAP_COMPSTR = (1);
const int SCS_CAP_MAKEREAD = (2);
const int SELECT_CAP_CONVERSION = (1);
const int SELECT_CAP_SENTENCE = (2);
const int NI_CHANGECANDIDATELIST = (19);
const int NI_CLOSECANDIDATE = (17);
const int NI_COMPOSITIONSTR = (21);
const int NI_OPENCANDIDATE = (16);
const int NI_SELECTCANDIDATESTR = (18);
const int NI_SETCANDIDATE_PAGESIZE = (23);
const int NI_SETCANDIDATE_PAGESTART = (22);
const int CPS_CANCEL = (4);
const int CPS_COMPLETE = (1);
const int CPS_CONVERT = (2);
const int CPS_REVERT = (3);
const int SCS_SETSTR = (9);
const int SCS_CHANGEATTR = (18);
const int SCS_CHANGECLAUSE = (36);
const int IME_REGWORD_STYLE_EUDC = (1);
const int IME_REGWORD_STYLE_USER_FIRST = (int)(0x80000000);
const int IME_REGWORD_STYLE_USER_LAST = -((1));
const int SECURITY_DESCRIPTOR_REVISION = (1);
const int IS_TEXT_UNICODE_ASCII16 = (1);
const int IS_TEXT_UNICODE_REVERSE_ASCII16 = (16);
const int IS_TEXT_UNICODE_STATISTICS = (2);
const int IS_TEXT_UNICODE_REVERSE_STATISTICS = (32);
const int IS_TEXT_UNICODE_CONTROLS = (4);
const int IS_TEXT_UNICODE_REVERSE_CONTROLS = (64);
const int IS_TEXT_UNICODE_SIGNATURE = (8);
const int IS_TEXT_UNICODE_REVERSE_SIGNATURE = (128);
const int IS_TEXT_UNICODE_ILLEGAL_CHARS = (256);
const int IS_TEXT_UNICODE_ODD_LENGTH = (512);
const int IS_TEXT_UNICODE_NULL_BYTES = (4096);
const int IS_TEXT_UNICODE_UNICODE_MASK = (15);
const int IS_TEXT_UNICODE_REVERSE_MASK = (240);
const int IS_TEXT_UNICODE_NOT_UNICODE_MASK = (3840);
const int IS_TEXT_UNICODE_NOT_ASCII_MASK = (61440);
const int HC_GETNEXT = (1);
const int HC_SKIP = (2);
const int HC_SYSMODALOFF = (5);
const int HC_SYSMODALON = (4);
const int HC_NOREMOVE = (3);
const int KEYEVENTF_EXTENDEDKEY = (1);
const int KEYEVENTF_KEYUP = (2);
const int OBM_BTNCORNERS = (32758);
const int OBM_BTSIZE = (32761);
const int OBM_CHECK = (32760);
const int OBM_CHECKBOXES = (32759);
const int OBM_CLOSE = (32754);
const int OBM_COMBO = (32738);
const int OBM_DNARROW = (32752);
const int OBM_DNARROWD = (32742);
const int OBM_DNARROWI = (32736);
const int OBM_LFARROW = (32750);
const int OBM_LFARROWI = (32734);
const int OBM_LFARROWD = (32740);
const int OBM_MNARROW = (32739);
const int OBM_OLD_CLOSE = (32767);
const int OBM_OLD_DNARROW = (32764);
const int OBM_OLD_LFARROW = (32762);
const int OBM_OLD_REDUCE = (32757);
const int OBM_OLD_RESTORE = (32755);
const int OBM_OLD_RGARROW = (32763);
const int OBM_OLD_UPARROW = (32765);
const int OBM_OLD_ZOOM = (32756);
const int OBM_REDUCE = (32749);
const int OBM_REDUCED = (32746);
const int OBM_RESTORE = (32747);
const int OBM_RESTORED = (32744);
const int OBM_RGARROW = (32751);
const int OBM_RGARROWD = (32741);
const int OBM_RGARROWI = (32735);
const int OBM_SIZE = (32766);
const int OBM_UPARROW = (32753);
const int OBM_UPARROWD = (32743);
const int OBM_UPARROWI = (32737);
const int OBM_ZOOM = (32748);
const int OBM_ZOOMD = (32745);
const int DONT_RESOLVE_DLL_REFERENCES = (1);
const int LOAD_LIBRARY_AS_DATAFILE = (2);
const int LOAD_WITH_ALTERED_SEARCH_PATH = (8);
const int LPTR = (64);
const int LHND = (66);
const int NONZEROLHND = (2);
const int NONZEROLPTR = (0);
const int LMEM_NONZEROLHND = (2);
const int LMEM_NONZEROLPTR = (0);
const int LMEM_FIXED = (0);
const int LMEM_MOVEABLE = (2);
const int LMEM_NOCOMPACT = (16);
const int LMEM_NODISCARD = (32);
const int LMEM_ZEROINIT = (64);
const int LMEM_MODIFY = (128);
const int LMEM_LOCKCOUNT = (255);
const int LMEM_DISCARDABLE = (3840);
const int LMEM_DISCARDED = (16384);
const int LMEM_INVALID_HANDLE = (32768);
const int LOCKFILE_FAIL_IMMEDIATELY = (1);
const int LOCKFILE_EXCLUSIVE_LOCK = (2);
const int MB_USERICON = (0x80);
const int MB_ICONASTERISK = (0x40);
const int MB_ICONEXCLAMATION = (0x30);
const int MB_ICONWARNING = (0x30);
const int MB_ICONERROR = (0x10);
const int MB_ICONHAND = (0x10);
const int MB_ICONQUESTION = (0x20);
const int MB_OK = (0);
const int MB_ABORTRETRYIGNORE = (0x2);
const int MB_APPLMODAL = (0);
const int MB_DEFAULT_DESKTOP_ONLY = (0x20000);
const int MB_HELP = (0x4000);
const int MB_RIGHT = (0x80000);
const int MB_RTLREADING = (0x100000);
const int MB_TOPMOST = (0x40000);
const int MB_DEFBUTTON1 = (0);
const int MB_DEFBUTTON2 = (0x100);
const int MB_DEFBUTTON3 = (0x200);
const int MB_DEFBUTTON4 = (0x300);
const int MB_ICONINFORMATION = (0x40);
const int MB_ICONSTOP = (0x10);
const int MB_OKCANCEL = (0x1);
const int MB_RETRYCANCEL = (0x5);
const int MB_SERVICE_NOTIFICATION = (0x40000);
const int MB_SETFOREGROUND = (0x10000);
const int MB_SYSTEMMODAL = (0x1000);
const int MB_TASKMODAL = (0x2000);
const int MB_YESNO = (0x4);
const int MB_YESNOCANCEL = (0x3);
const int IDABORT = (3);
const int IDCANCEL = (2);
const int IDCLOSE = (8);
const int IDHELP = (9);
const int IDIGNORE = (5);
const int IDNO = (7);
const int IDOK = (1);
const int IDRETRY = (4);
const int IDYES = (6);
const int MSGF_DIALOGBOX = (0);
const int MSGF_MENU = (2);
const int MSGF_NEXTWINDOW = (6);
const int MSGF_SCROLLBAR = (5);
const int MSGF_MAINLOOP = (8);
const int MSGF_USER = (4096);
const int MWT_IDENTITY = (1);
const int MWT_LEFTMULTIPLY = (2);
const int MWT_RIGHTMULTIPLY = (3);
const int MOUSEEVENTF_ABSOLUTE = (32768);
const int MOUSEEVENTF_MOVE = (1);
const int MOUSEEVENTF_LEFTDOWN = (2);
const int MOUSEEVENTF_LEFTUP = (4);
const int MOUSEEVENTF_RIGHTDOWN = (8);
const int MOUSEEVENTF_RIGHTUP = (16);
const int MOUSEEVENTF_MIDDLEDOWN = (32);
const int MOUSEEVENTF_MIDDLEUP = (64);
const int MOVEFILE_REPLACE_EXISTING = (1);
const int MOVEFILE_COPY_ALLOWED = (2);
const int MOVEFILE_DELAY_UNTIL_REBOOT = (4);
const int WAIT_OBJECT_0 = (0);
const int WAIT_ABANDONED_0 = (0x80);
const int WAIT_TIMEOUT = (0x102);
const int WAIT_IO_COMPLETION = (0xc0);
const int WAIT_ABANDONED = (0x80);
const int WAIT_FAILED = (int)(0xffffffff);
const int MAXIMUM_WAIT_OBJECTS = (0x40);
const int MAXIMUM_SUSPEND_COUNT = (0x7f);
const int MB_PRECOMPOSED = (1);
const int MB_COMPOSITE = (2);
const int MB_ERR_INVALID_CHARS = (8);
const int MB_USEGLYPHCHARS = (4);
const int TOKEN_ADJUST_DEFAULT = (128);
const int TOKEN_ADJUST_GROUPS = (64);
const int TOKEN_ADJUST_PRIVILEGES = (32);
const int TOKEN_ALL_ACCESS = (0xf00ff);
const int TOKEN_ASSIGN_PRIMARY = (1);
const int TOKEN_DUPLICATE = (2);
const int TOKEN_EXECUTE = (0x20000);
const int TOKEN_IMPERSONATE = (4);
const int TOKEN_QUERY = (8);
const int TOKEN_QUERY_SOURCE = (16);
const int TOKEN_READ = (0x20008);
const int TOKEN_WRITE = (0x200e0);
const int SC_MANAGER_ALL_ACCESS = (0xf003f);
const int SC_MANAGER_CONNECT = (1);
const int SC_MANAGER_CREATE_SERVICE = (2);
const int SC_MANAGER_ENUMERATE_SERVICE = (4);
const int SC_MANAGER_LOCK = (8);
const int SC_MANAGER_QUERY_LOCK_STATUS = (16);
const int SC_MANAGER_MODIFY_BOOT_CONFIG = (32);
const int HWND_BROADCAST = (0xFFFF);
const int TAPE_FORMAT = (0x5);
const int TAPE_LOAD = (0);
const int TAPE_LOCK = (0x3);
const int TAPE_TENSION = (0x2);
const int TAPE_UNLOAD = (0x1);
const int TAPE_UNLOCK = (0x4);
const int IS_PSREBOOTSYSTEM = (3);
const int IS_PSRESTARTWINDOWS = (2);
const int PSPCB_CREATE = (2);
const int PSPCB_RELEASE = (1);
const int PURGE_TXABORT = (1);
const int PURGE_RXABORT = (2);
const int PURGE_TXCLEAR = (4);
const int PURGE_RXCLEAR = (8);
const int OWNER_SECURITY_INFORMATION = (0x1);
const int GROUP_SECURITY_INFORMATION = (0x2);
const int DACL_SECURITY_INFORMATION = (0x4);
const int SACL_SECURITY_INFORMATION = (0x8);
const int EVENTLOG_FORWARDS_READ = (4);
const int EVENTLOG_BACKWARDS_READ = (8);
const int EVENTLOG_SEEK_READ = (2);
const int EVENTLOG_SEQUENTIAL_READ = (1);
const int EVENTLOG_ERROR_TYPE = (1);
const int EVENTLOG_WARNING_TYPE = (2);
const int EVENTLOG_INFORMATION_TYPE = (4);
const int EVENTLOG_AUDIT_SUCCESS = (8);
const int EVENTLOG_AUDIT_FAILURE = (16);
const int RDW_ERASE = (4);
const int RDW_FRAME = (1024);
const int RDW_INTERNALPAINT = (2);
const int RDW_INVALIDATE = (1);
const int RDW_NOERASE = (32);
const int RDW_NOFRAME = (2048);
const int RDW_NOINTERNALPAINT = (16);
const int RDW_VALIDATE = (8);
const int RDW_ERASENOW = (512);
const int RDW_UPDATENOW = (256);
const int RDW_ALLCHILDREN = (128);
const int RDW_NOCHILDREN = (64);
const int HKEY_CLASSES_ROOT = (int)(0x80000000);
const int HKEY_CURRENT_USER = (int)(0x80000001);
const int HKEY_LOCAL_MACHINE = (int)(0x80000002);
const int HKEY_USERS = (int)(0x80000003);
const int HKEY_PERFORMANCE_DATA = (int)(0x80000004);
const int HKEY_CURRENT_CONFIG = (int)(0x80000005);
const int HKEY_DYN_DATA = (int)(0x80000006);
const int REG_OPTION_VOLATILE = (0x1);
const int REG_OPTION_NON_VOLATILE = (0);
const int REG_CREATED_NEW_KEY = (0x1);
const int REG_OPENED_EXISTING_KEY = (0x2);
const int REG_BINARY = (3);
const int REG_DWORD = (4);
const int REG_DWORD_LITTLE_ENDIAN = (4);
const int REG_DWORD_BIG_ENDIAN = (5);
const int REG_EXPAND_SZ = (2);
const int REG_FULL_RESOURCE_DESCRIPTOR = (9);
const int REG_LINK = (6);
const int REG_MULTI_SZ = (7);
const int REG_NONE = (0);
const int REG_RESOURCE_LIST = (8);
const int REG_RESOURCE_REQUIREMENTS_LIST = (10);
const int REG_SZ = (1);
const int MOD_ALT = (1);
const int MOD_CONTROL = (2);
const int MOD_SHIFT = (4);
const int MOD_WIN = (8);
const int IDHOT_SNAPDESKTOP = -((2));
const int IDHOT_SNAPWINDOW = -((1));
const int REG_NOTIFY_CHANGE_NAME = (0x1);
const int REG_NOTIFY_CHANGE_ATTRIBUTES = (0x2);
const int REG_NOTIFY_CHANGE_LAST_SET = (0x4);
const int REG_NOTIFY_CHANGE_SECURITY = (0x8);
const int SW_ERASE = (4);
const int SW_INVALIDATE = (2);
const int SW_SCROLLCHILDREN = (1);
const int SMTO_ABORTIFHUNG = (2);
const int SMTO_BLOCK = (1);
const int SMTO_NORMAL = (0);
const int OPAQUE = (2);
const int TRANSPARENT = (1);
const int SLE_ERROR = (1);
const int SLE_MINORERROR = (2);
const int SLE_WARNING = (3);
const int SEM_FAILCRITICALERRORS = (1);
const int SEM_NOALIGNMENTFAULTEXCEPT = (4);
const int SEM_NOGPFAULTERRORBOX = (2);
const int SEM_NOOPENFILEERRORBOX = (32768);
const int ICM_ON = (2);
const int ICM_OFF = (1);
const int ICM_QUERY = (3);
const int LOCALE_ILANGUAGE = (1);
const int LOCALE_SLANGUAGE = (2);
const int LOCALE_SENGLANGUAGE = (4097);
const int LOCALE_SABBREVLANGNAME = (3);
const int LOCALE_SNATIVELANGNAME = (4);
const int LOCALE_ICOUNTRY = (5);
const int LOCALE_SCOUNTRY = (6);
const int LOCALE_SENGCOUNTRY = (4098);
const int LOCALE_SABBREVCTRYNAME = (7);
const int LOCALE_SNATIVECTRYNAME = (8);
const int LOCALE_IDEFAULTLANGUAGE = (9);
const int LOCALE_IDEFAULTCOUNTRY = (10);
const int LOCALE_IDEFAULTANSICODEPAGE = (4100);
const int LOCALE_IDEFAULTCODEPAGE = (11);
const int LOCALE_SLIST = (12);
const int LOCALE_IMEASURE = (13);
const int LOCALE_SDECIMAL = (14);
const int LOCALE_STHOUSAND = (15);
const int LOCALE_SGROUPING = (16);
const int LOCALE_IDIGITS = (17);
const int LOCALE_ILZERO = (18);
const int LOCALE_INEGNUMBER = (4112);
const int LOCALE_SCURRENCY = (20);
const int LOCALE_SMONDECIMALSEP = (22);
const int LOCALE_SMONTHOUSANDSEP = (23);
const int LOCALE_SMONGROUPING = (24);
const int LOCALE_ICURRDIGITS = (25);
const int LOCALE_ICURRENCY = (27);
const int LOCALE_INEGCURR = (28);
const int LOCALE_SDATE = (29);
const int LOCALE_STIME = (30);
const int LOCALE_STIMEFORMAT = (4099);
const int LOCALE_SSHORTDATE = (31);
const int LOCALE_SLONGDATE = (32);
const int LOCALE_IDATE = (33);
const int LOCALE_ILDATE = (34);
const int LOCALE_ITIME = (35);
const int LOCALE_ITLZERO = (37);
const int LOCALE_IDAYLZERO = (38);
const int LOCALE_IMONLZERO = (39);
const int LOCALE_S1159 = (40);
const int LOCALE_S2359 = (41);
const int LOCALE_ICALENDARTYPE = (4105);
const int LOCALE_IOPTIONALCALENDAR = (4107);
const int LOCALE_IFIRSTDAYOFWEEK = (4108);
const int LOCALE_IFIRSTWEEKOFYEAR = (4109);
const int LOCALE_SDAYNAME1 = (42);
const int LOCALE_SDAYNAME2 = (43);
const int LOCALE_SDAYNAME3 = (44);
const int LOCALE_SDAYNAME4 = (45);
const int LOCALE_SDAYNAME5 = (46);
const int LOCALE_SDAYNAME6 = (47);
const int LOCALE_SDAYNAME7 = (48);
const int LOCALE_SABBREVDAYNAME1 = (49);
const int LOCALE_SABBREVDAYNAME2 = (50);
const int LOCALE_SABBREVDAYNAME3 = (51);
const int LOCALE_SABBREVDAYNAME4 = (52);
const int LOCALE_SABBREVDAYNAME5 = (53);
const int LOCALE_SABBREVDAYNAME6 = (54);
const int LOCALE_SABBREVDAYNAME7 = (55);
const int LOCALE_SMONTHNAME1 = (56);
const int LOCALE_SMONTHNAME2 = (57);
const int LOCALE_SMONTHNAME3 = (58);
const int LOCALE_SMONTHNAME4 = (59);
const int LOCALE_SMONTHNAME5 = (60);
const int LOCALE_SMONTHNAME6 = (61);
const int LOCALE_SMONTHNAME7 = (62);
const int LOCALE_SMONTHNAME8 = (63);
const int LOCALE_SMONTHNAME9 = (64);
const int LOCALE_SMONTHNAME10 = (65);
const int LOCALE_SMONTHNAME11 = (66);
const int LOCALE_SMONTHNAME12 = (67);
const int LOCALE_SMONTHNAME13 = (4110);
const int LOCALE_SABBREVMONTHNAME1 = (68);
const int LOCALE_SABBREVMONTHNAME2 = (69);
const int LOCALE_SABBREVMONTHNAME3 = (70);
const int LOCALE_SABBREVMONTHNAME4 = (71);
const int LOCALE_SABBREVMONTHNAME5 = (72);
const int LOCALE_SABBREVMONTHNAME6 = (73);
const int LOCALE_SABBREVMONTHNAME7 = (74);
const int LOCALE_SABBREVMONTHNAME8 = (75);
const int LOCALE_SABBREVMONTHNAME9 = (76);
const int LOCALE_SABBREVMONTHNAME10 = (77);
const int LOCALE_SABBREVMONTHNAME11 = (78);
const int LOCALE_SABBREVMONTHNAME12 = (79);
const int LOCALE_SABBREVMONTHNAME13 = (4111);
const int LOCALE_SPOSITIVESIGN = (80);
const int LOCALE_SNEGATIVESIGN = (81);
const int LOCALE_IPOSSIGNPOSN = (82);
const int LOCALE_INEGSIGNPOSN = (83);
const int LOCALE_IPOSSYMPRECEDES = (84);
const int LOCALE_IPOSSEPBYSPACE = (85);
const int LOCALE_INEGSYMPRECEDES = (86);
const int LOCALE_INEGSEPBYSPACE = (87);
const int LOCALE_NOUSEROVERRIDE = (int)(0x80000000);
const int CAL_ICALINTVALUE = (1);
const int CAL_IYEAROFFSETRANGE = (3);
const int CAL_SABBREVDAYNAME1 = (14);
const int CAL_SABBREVDAYNAME2 = (15);
const int CAL_SABBREVDAYNAME3 = (16);
const int CAL_SABBREVDAYNAME4 = (17);
const int CAL_SABBREVDAYNAME5 = (18);
const int CAL_SABBREVDAYNAME6 = (19);
const int CAL_SABBREVDAYNAME7 = (20);
const int CAL_SABBREVMONTHNAME1 = (34);
const int CAL_SABBREVMONTHNAME2 = (35);
const int CAL_SABBREVMONTHNAME3 = (36);
const int CAL_SABBREVMONTHNAME4 = (37);
const int CAL_SABBREVMONTHNAME5 = (38);
const int CAL_SABBREVMONTHNAME6 = (39);
const int CAL_SABBREVMONTHNAME7 = (40);
const int CAL_SABBREVMONTHNAME8 = (41);
const int CAL_SABBREVMONTHNAME9 = (42);
const int CAL_SABBREVMONTHNAME10 = (43);
const int CAL_SABBREVMONTHNAME11 = (44);
const int CAL_SABBREVMONTHNAME12 = (45);
const int CAL_SABBREVMONTHNAME13 = (46);
const int CAL_SCALNAME = (2);
const int CAL_SDAYNAME1 = (7);
const int CAL_SDAYNAME2 = (8);
const int CAL_SDAYNAME3 = (9);
const int CAL_SDAYNAME4 = (10);
const int CAL_SDAYNAME5 = (11);
const int CAL_SDAYNAME6 = (12);
const int CAL_SDAYNAME7 = (13);
const int CAL_SERASTRING = (4);
const int CAL_SLONGDATE = (6);
const int CAL_SMONTHNAME1 = (21);
const int CAL_SMONTHNAME2 = (22);
const int CAL_SMONTHNAME3 = (23);
const int CAL_SMONTHNAME4 = (24);
const int CAL_SMONTHNAME5 = (25);
const int CAL_SMONTHNAME6 = (26);
const int CAL_SMONTHNAME7 = (27);
const int CAL_SMONTHNAME8 = (28);
const int CAL_SMONTHNAME9 = (29);
const int CAL_SMONTHNAME10 = (30);
const int CAL_SMONTHNAME11 = (31);
const int CAL_SMONTHNAME12 = (32);
const int CAL_SMONTHNAME13 = (33);
const int CAL_SSHORTDATE = (5);
const int PROCESS_SET_QUOTA = (256);
const int BLACKONWHITE = (1);
const int COLORONCOLOR = (3);
const int HALFTONE = (4);
const int STRETCH_ANDSCANS = (1);
const int STRETCH_DELETESCANS = (3);
const int STRETCH_HALFTONE = (4);
const int STRETCH_ORSCANS = (2);
const int WHITEONBLACK = (2);
const int OCR_NORMAL = (32512);
const int OCR_IBEAM = (32513);
const int OCR_WAIT = (32514);
const int OCR_CROSS = (32515);
const int OCR_UP = (32516);
const int OCR_SIZE = (32640);
const int OCR_ICON = (32641);
const int OCR_SIZENWSE = (32642);
const int OCR_SIZENESW = (32643);
const int OCR_SIZEWE = (32644);
const int OCR_SIZENS = (32645);
const int OCR_SIZEALL = (32646);
const int OCR_NO = (32648);
const int OCR_APPSTARTING = (32650);
const int TAPE_ABSOLUTE_BLOCK = (0x1);
const int TAPE_LOGICAL_BLOCK = (0x2);
const int TAPE_REWIND = (0);
const int TAPE_SPACE_END_OF_DATA = (0x4);
const int TAPE_SPACE_FILEMARKS = (0x6);
const int TAPE_SPACE_RELATIVE_BLOCKS = (0x5);
const int TAPE_SPACE_SEQUENTIAL_FMKS = (0x7);
const int TAPE_SPACE_SEQUENTIAL_SMKS = (0x9);
const int TAPE_SPACE_SETMARKS = (0x8);
const int EXCEPTION_EXECUTE_HANDLER = (1);
const int EXCEPTION_CONTINUE_EXECUTION = -((1));
const int EXCEPTION_CONTINUE_SEARCH = (0);
const int HWND_BOTTOM = (1);
const int HWND_NOTOPMOST = -(2);
const int HWND_TOP = (0);
const int HWND_TOPMOST = -(1);
const int SWP_DRAWFRAME = (32);
const int SWP_FRAMECHANGED = (32);
const int SWP_HIDEWINDOW = (128);
const int SWP_NOACTIVATE = (16);
const int SWP_NOCOPYBITS = (256);
const int SWP_NOMOVE = (2);
const int SWP_NOSIZE = (1);
const int SWP_NOREDRAW = (8);
const int SWP_NOZORDER = (4);
const int SWP_SHOWWINDOW = (64);
const int SWP_NOOWNERZORDER = (512);
const int SWP_NOREPOSITION = (512);
const int SWP_NOSENDCHANGING = (1024);
const int HSHELL_ACTIVATESHELLWINDOW = (3);
const int HSHELL_GETMINRECT = (5);
const int HSHELL_LANGUAGE = (8);
const int HSHELL_REDRAW = (6);
const int HSHELL_TASKMAN = (7);
const int HSHELL_WINDOWACTIVATED = (4);
const int HSHELL_WINDOWCREATED = (1);
const int HSHELL_WINDOWDESTROYED = (2);
const int SW_HIDE = (0);
const int SW_MAXIMIZE = (3);
const int SW_MINIMIZE = (6);
const int SW_NORMAL = (1);
const int SW_RESTORE = (9);
const int SW_SHOW = (5);
const int SW_SHOWDEFAULT = (10);
const int SW_SHOWMAXIMIZED = (3);
const int SW_SHOWMINIMIZED = (2);
const int SW_SHOWMINNOACTIVE = (7);
const int SW_SHOWNA = (8);
const int SW_SHOWNOACTIVATE = (4);
const int SW_SHOWNORMAL = (1);
const int WPF_RESTORETOMAXIMIZED = (2);
const int WPF_SETMINPOSITION = (1);
const int INFINITE = (int)(0xFFFFFFFF);
const int SPI_GETACCESSTIMEOUT = (60);
const int SPI_GETANIMATION = (72);
const int SPI_GETBEEP = (1);
const int SPI_GETBORDER = (5);
const int SPI_GETDEFAULTINPUTLANG = (89);
const int SPI_GETDRAGFULLWINDOWS = (38);
const int SPI_GETFASTTASKSWITCH = (35);
const int SPI_GETFILTERKEYS = (50);
const int SPI_GETFONTSMOOTHING = (74);
const int SPI_GETGRIDGRANULARITY = (18);
const int SPI_GETHIGHCONTRAST = (66);
const int SPI_GETICONMETRICS = (45);
const int SPI_GETICONTITLELOGFONT = (31);
const int SPI_GETICONTITLEWRAP = (25);
const int SPI_GETKEYBOARDDELAY = (22);
const int SPI_GETKEYBOARDPREF = (68);
const int SPI_GETKEYBOARDSPEED = (10);
const int SPI_GETLOWPOWERACTIVE = (83);
const int SPI_GETLOWPOWERTIMEOUT = (79);
const int SPI_GETMENUDROPALIGNMENT = (27);
const int SPI_GETMINIMIZEDMETRICS = (43);
const int SPI_GETMOUSE = (3);
const int SPI_GETMOUSEKEYS = (54);
const int SPI_GETMOUSETRAILS = (94);
const int SPI_GETNONCLIENTMETRICS = (41);
const int SPI_GETPOWEROFFACTIVE = (84);
const int SPI_GETPOWEROFFTIMEOUT = (80);
const int SPI_GETSCREENREADER = (70);
const int SPI_GETSCREENSAVEACTIVE = (16);
const int SPI_GETSCREENSAVETIMEOUT = (14);
const int SPI_GETSERIALKEYS = (62);
const int SPI_GETSHOWSOUNDS = (56);
const int SPI_GETSOUNDSENTRY = (64);
const int SPI_GETSTICKYKEYS = (58);
const int SPI_GETTOGGLEKEYS = (52);
const int SPI_GETWINDOWSEXTENSION = (92);
const int SPI_GETWORKAREA = (48);
const int SPI_ICONHORIZONTALSPACING = (13);
const int SPI_ICONVERTICALSPACING = (24);
const int SPI_LANGDRIVER = (12);
const int SPI_SCREENSAVERRUNNING = (97);
const int SPI_SETACCESSTIMEOUT = (61);
const int SPI_SETANIMATION = (73);
const int SPI_SETBEEP = (2);
const int SPI_SETBORDER = (6);
const int SPI_SETDEFAULTINPUTLANG = (90);
const int SPI_SETDESKPATTERN = (21);
const int SPI_SETDESKWALLPAPER = (20);
const int SPI_SETDOUBLECLICKTIME = (32);
const int SPI_SETDOUBLECLKHEIGHT = (30);
const int SPI_SETDOUBLECLKWIDTH = (29);
const int SPI_SETDRAGFULLWINDOWS = (37);
const int SPI_SETDRAGHEIGHT = (77);
const int SPI_SETDRAGWIDTH = (76);
const int SPI_SETFASTTASKSWITCH = (36);
const int SPI_SETFILTERKEYS = (51);
const int SPI_SETFONTSMOOTHING = (75);
const int SPI_SETGRIDGRANULARITY = (19);
const int SPI_SETHANDHELD = (78);
const int SPI_SETHIGHCONTRAST = (67);
const int SPI_SETICONMETRICS = (46);
const int SPI_SETICONTITLELOGFONT = (34);
const int SPI_SETICONTITLEWRAP = (26);
const int SPI_SETKEYBOARDDELAY = (23);
const int SPI_SETKEYBOARDPREF = (69);
const int SPI_SETKEYBOARDSPEED = (11);
const int SPI_SETLANGTOGGLE = (91);
const int SPI_SETLOWPOWERACTIVE = (85);
const int SPI_SETLOWPOWERTIMEOUT = (81);
const int SPI_SETMENUDROPALIGNMENT = (28);
const int SPI_SETMINIMIZEDMETRICS = (44);
const int SPI_SETMOUSE = (4);
const int SPI_SETMOUSEBUTTONSWAP = (33);
const int SPI_SETMOUSEKEYS = (55);
const int SPI_SETMOUSETRAILS = (93);
const int SPI_SETNONCLIENTMETRICS = (42);
const int SPI_SETPENWINDOWS = (49);
const int SPI_SETPOWEROFFACTIVE = (86);
const int SPI_SETPOWEROFFTIMEOUT = (82);
const int SPI_SETSCREENREADER = (71);
const int SPI_SETSCREENSAVEACTIVE = (17);
const int SPI_SETSCREENSAVETIMEOUT = (15);
const int SPI_SETSERIALKEYS = (63);
const int SPI_SETSHOWSOUNDS = (57);
const int SPI_SETSOUNDSENTRY = (65);
const int SPI_SETSTICKYKEYS = (59);
const int SPI_SETTOGGLEKEYS = (53);
const int SPI_SETWORKAREA = (47);
const int SPIF_UPDATEINIFILE = (1);
const int SPIF_SENDWININICHANGE = (2);
const int SPIF_SENDCHANGE = (2);
const int TPM_CENTERALIGN = (0x4);
const int TPM_LEFTALIGN = (0);
const int TPM_RIGHTALIGN = (0x8);
const int TPM_LEFTBUTTON = (0);
const int TPM_RIGHTBUTTON = (0x2);
const int TPM_HORIZONTAL = (0);
const int TPM_VERTICAL = (0x40);
const int TCI_SRCCHARSET = (1);
const int TCI_SRCCODEPAGE = (2);
const int TCI_SRCFONTSIG = (3);
const int VFFF_ISSHAREDFILE = (1);
const int VFF_CURNEDEST = (1);
const int VFF_FILEINUSE = (2);
const int VFF_BUFFTOOSMALL = (4);
const int VIFF_FORCEINSTALL = (1);
const int VIFF_DONTDELETEOLD = (2);
const int VIF_TEMPFILE = (0x1);
const int VIF_MISMATCH = (0x2);
const int VIF_SRCOLD = (0x4);
const int VIF_DIFFLANG = (0x8);
const int VIF_DIFFCODEPG = (0x10);
const int VIF_DIFFTYPE = (0x20);
const int VIF_WRITEPROT = (0x40);
const int VIF_FILEINUSE = (0x80);
const int VIF_OUTOFSPACE = (0x100);
const int VIF_ACCESSVIOLATION = (0x200);
const int VIF_SHARINGVIOLATION = (0x400);
const int VIF_CANNOTCREATE = (0x800);
const int VIF_CANNOTDELETE = (0x1000);
const int VIF_CANNOTDELETECUR = (0x4000);
const int VIF_CANNOTRENAME = (0x2000);
const int VIF_OUTOFMEMORY = (0x8000);
const int VIF_CANNOTREADSRC = (0x10000);
const int VIF_CANNOTREADDST = (0x20000);
const int VIF_BUFFTOOSMALL = (0x40000);
const int WC_COMPOSITECHECK = (512);
const int WC_DISCARDNS = (16);
const int WC_SEPCHARS = (32);
const int WC_DEFAULTCHAR = (64);
const int HELP_COMMAND = (0x102);
const int HELP_CONTENTS = (0x3);
const int HELP_CONTEXT = (0x1);
const int HELP_CONTEXTPOPUP = (0x8);
const int HELP_FORCEFILE = (0x9);
const int HELP_HELPONHELP = (0x4);
const int HELP_INDEX = (0x3);
const int HELP_KEY = (0x101);
const int HELP_MULTIKEY = (0x201);
const int HELP_PARTIALKEY = (0x105);
const int HELP_QUIT = (0x2);
const int HELP_SETCONTENTS = (0x5);
const int HELP_SETINDEX = (0x5);
const int HELP_CONTEXTMENU = (0xa);
const int HELP_FINDER = (0xb);
const int HELP_WM_HELP = (0xc);
const int HELP_TCARD = (0x8000);
const int HELP_TCARD_DATA = (0x10);
const int HELP_TCARD_OTHER_CALLER = (0x11);
const int CONNECT_UPDATE_PROFILE = (1);
const int RESOURCETYPE_DISK = (1);
const int RESOURCETYPE_PRINT = (2);
const int RESOURCETYPE_ANY = (0);
const int RESOURCE_CONNECTED = (1);
const int RESOURCE_GLOBALNET = (2);
const int RESOURCE_REMEMBERED = (3);
const int RESOURCEUSAGE_CONNECTABLE = (1);
const int RESOURCEUSAGE_CONTAINER = (2);
const int WN_BAD_NETNAME = (0x43);
const int WN_EXTENDED_ERROR = (0x4b8);
const int WN_MORE_DATA = (0xea);
const int WN_NO_NETWORK = (0x4c6);
const int WN_SUCCESS = (0);
const int WN_ACCESS_DENIED = (0x5);
const int WN_BAD_PROVIDER = (0x4b4);
const int WN_NOT_AUTHENTICATED = (0x4dc);
const int UNIVERSAL_NAME_INFO_LEVEL = (1);
const int REMOTE_NAME_INFO_LEVEL = (2);
const int STILL_ACTIVE = (0x103);
const int SP_SERIALCOMM = (0x1);
const int BAUD_075 = (0x1);
const int BAUD_110 = (0x2);
const int BAUD_134_5 = (0x4);
const int BAUD_150 = (0x8);
const int BAUD_300 = (0x10);
const int BAUD_600 = (0x20);
const int BAUD_1200 = (0x40);
const int BAUD_1800 = (0x80);
const int BAUD_2400 = (0x100);
const int BAUD_4800 = (0x200);
const int BAUD_7200 = (0x400);
const int BAUD_9600 = (0x800);
const int BAUD_14400 = (0x1000);
const int BAUD_19200 = (0x2000);
const int BAUD_38400 = (0x4000);
const int BAUD_56K = (0x8000);
const int BAUD_57600 = (0x40000);
const int BAUD_115200 = (0x20000);
const int BAUD_128K = (0x10000);
const int BAUD_USER = (0x10000000);
const int PST_FAX = (0x21);
const int PST_LAT = (0x101);
const int PST_MODEM = (0x6);
const int PST_NETWORK_BRIDGE = (0x100);
const int PST_PARALLELPORT = (0x2);
const int PST_RS232 = (0x1);
const int PST_RS422 = (0x3);
const int PST_RS423 = (0x4);
const int PST_RS449 = (0x5);
const int PST_SCANNER = (0x22);
const int PST_TCPIP_TELNET = (0x102);
const int PST_UNSPECIFIED = (0);
const int PST_X25 = (0x103);
const int PCF_16BITMODE = (0x200);
const int PCF_DTRDSR = (0x1);
const int PCF_INTTIMEOUTS = (0x80);
const int PCF_PARITY_CHECK = (0x8);
const int PCF_RLSD = (0x4);
const int PCF_RTSCTS = (0x2);
const int PCF_SETXCHAR = (0x20);
const int PCF_SPECIALCHARS = (0x100);
const int PCF_TOTALTIMEOUTS = (0x40);
const int PCF_XONXOFF = (0x10);
const int SP_BAUD = (0x2);
const int SP_DATABITS = (0x4);
const int SP_HANDSHAKING = (0x10);
const int SP_PARITY = (0x1);
const int SP_PARITY_CHECK = (0x20);
const int SP_RLSD = (0x40);
const int SP_STOPBITS = (0x8);
const int DATABITS_5 = (1);
const int DATABITS_6 = (2);
const int DATABITS_7 = (4);
const int DATABITS_8 = (8);
const int DATABITS_16 = (16);
const int DATABITS_16X = (32);
const int STOPBITS_10 = (1);
const int STOPBITS_15 = (2);
const int STOPBITS_20 = (4);
const int PARITY_NONE = (256);
const int PARITY_ODD = (512);
const int PARITY_EVEN = (1024);
const int PARITY_MARK = (2048);
const int PARITY_SPACE = (4096);
const int COMMPROP_INITIALIZED = (int)(0xe73cf52e);
const int CBR_110 = (110);
const int CBR_300 = (300);
const int CBR_600 = (600);
const int CBR_1200 = (1200);
const int CBR_2400 = (2400);
const int CBR_4800 = (4800);
const int CBR_9600 = (9600);
const int CBR_14400 = (14400);
const int CBR_19200 = (19200);
const int CBR_38400 = (38400);
const int CBR_56000 = (56000);
const int CBR_57600 = (57600);
const int CBR_115200 = (115200);
const int CBR_128000 = (128000);
const int CBR_256000 = (256000);
const int DTR_CONTROL_DISABLE = (0);
const int DTR_CONTROL_ENABLE = (1);
const int DTR_CONTROL_HANDSHAKE = (2);
const int RTS_CONTROL_DISABLE = (0);
const int RTS_CONTROL_ENABLE = (1);
const int RTS_CONTROL_HANDSHAKE = (2);
const int RTS_CONTROL_TOGGLE = (3);
const int EVENPARITY = (2);
const int MARKPARITY = (3);
const int NOPARITY = (0);
const int ODDPARITY = (1);
const int SPACEPARITY = (4);
const int ONESTOPBIT = (0);
const int ONE5STOPBITS = (1);
const int TWOSTOPBITS = (2);
const int CREATE_PROCESS_DEBUG_EVENT = (3);
const int CREATE_THREAD_DEBUG_EVENT = (2);
const int EXCEPTION_DEBUG_EVENT = (1);
const int EXIT_PROCESS_DEBUG_EVENT = (5);
const int EXIT_THREAD_DEBUG_EVENT = (4);
const int LOAD_DLL_DEBUG_EVENT = (6);
const int OUTPUT_DEBUG_STRING_EVENT = (8);
const int UNLOAD_DLL_DEBUG_EVENT = (7);
const int RIP_EVENT = (9);
const int PROCESS_HEAP_REGION = (1);
const int PROCESS_HEAP_UNCOMMITTED_RANGE = (2);
const int PROCESS_HEAP_ENTRY_BUSY = (4);
const int PROCESS_HEAP_ENTRY_MOVEABLE = (16);
const int PROCESS_HEAP_ENTRY_DDESHARE = (32);
const int HINSTANCE_ERROR = (32);
const int BACKUP_DATA = (1);
const int BACKUP_EA_DATA = (2);
const int BACKUP_SECURITY_DATA = (3);
const int BACKUP_ALTERNATE_DATA = (4);
const int BACKUP_LINK = (5);
const int STREAM_MODIFIED_WHEN_READ = (1);
const int STREAM_CONTAINS_SECURITY = (2);
const int STARTF_USESHOWWINDOW = (1);
const int STARTF_USEPOSITION = (4);
const int STARTF_USESIZE = (2);
const int STARTF_USECOUNTCHARS = (8);
const int STARTF_USEFILLATTRIBUTE = (16);
const int STARTF_RUNFULLSCREEN = (32);
const int STARTF_FORCEONFEEDBACK = (64);
const int STARTF_FORCEOFFFEEDBACK = (128);
const int STARTF_USESTDHANDLES = (256);
const int STARTF_USEHOTKEY = (512);
const int VER_PLATFORM_WIN32s = (0);
const int VER_PLATFORM_WIN32_WINDOWS = (1);
const int VER_PLATFORM_WIN32_NT = (2);
const int MAXPROPPAGES = (100);
const int PSP_DEFAULT = (0);
const int PSP_DLGINDIRECT = (1);
const int PSP_HASHELP = (32);
const int PSP_USECALLBACK = (128);
const int PSP_USEHICON = (2);
const int PSP_USEICONID = (4);
const int PSP_USEREFPARENT = (64);
const int PSP_USETITLE = (8);
const int PSP_RTLREADING = (16);
const int PSH_DEFAULT = (0);
const int PSH_HASHELP = (512);
const int PSH_MODELESS = (1024);
const int PSH_NOAPPLYNOW = (128);
const int PSH_PROPSHEETPAGE = (8);
const int PSH_PROPTITLE = (1);
const int PSH_USECALLBACK = (256);
const int PSH_USEHICON = (2);
const int PSH_USEICONID = (4);
const int PSH_USEPSTARTPAGE = (64);
const int PSH_WIZARD = (32);
const int PSH_RTLREADING = (2048);
const int PSCB_INITIALIZED = (1);
const int PSCB_PRECREATE = (2);
const int PSNRET_NOERROR = (0);
const int PSNRET_INVALID_NOCHANGEPAGE = (2);
const int PSBTN_APPLYNOW = (4);
const int PSBTN_BACK = (0);
const int PSBTN_CANCEL = (5);
const int PSBTN_FINISH = (2);
const int PSBTN_HELP = (6);
const int PSBTN_NEXT = (1);
const int PSBTN_OK = (3);
const int PSWIZB_BACK = (1);
const int PSWIZB_NEXT = (2);
const int PSWIZB_FINISH = (4);
const int PSWIZB_DISABLEDFINISH = (8);
const int ID_PSREBOOTSYSTEM = (3);
const int ID_PSRESTARTWINDOWS = (2);
const int WIZ_BODYCX = (184);
const int WIZ_BODYX = (92);
const int WIZ_CXBMP = (80);
const int WIZ_CXDLG = (276);
const int WIZ_CYDLG = (140);
const char* VS_FILE_INFO = cast(char*) ((16));
const int VS_VERSION_INFO = (1);
const int VS_FF_DEBUG = (0x1);
const int VS_FF_INFOINFERRED = (0x10);
const int VS_FF_PATCHED = (0x4);
const int VS_FF_PRERELEASE = (0x2);
const int VS_FF_PRIVATEBUILD = (0x8);
const int VS_FF_SPECIALBUILD = (0x20);
const int VOS_UNKNOWN = (0);
const int VOS_DOS = (0x10000);
const int VOS_OS216 = (0x20000);
const int VOS_OS232 = (0x30000);
const int VOS_NT = (0x40000);
const int VOS_DOS_WINDOWS16 = (0x10001);
const int VOS_DOS_WINDOWS32 = (0x10004);
const int VOS_OS216_PM16 = (0x20002);
const int VOS_OS232_PM32 = (0x30003);
const int VOS_NT_WINDOWS32 = (0x40004);
const int VFT_UNKNOWN = (0);
const int VFT_APP = (0x1);
const int VFT_DLL = (0x2);
const int VFT_DRV = (0x3);
const int VFT_FONT = (0x4);
const int VFT_VXD = (0x5);
const int VFT_STATIC_LIB = (0x7);
const int VFT2_UNKNOWN = (0);
const int VFT2_DRV_PRINTER = (0x1);
const int VFT2_DRV_KEYBOARD = (0x2);
const int VFT2_DRV_LANGUAGE = (0x3);
const int VFT2_DRV_DISPLAY = (0x4);
const int VFT2_DRV_MOUSE = (0x5);
const int VFT2_DRV_NETWORK = (0x6);
const int VFT2_DRV_SYSTEM = (0x7);
const int VFT2_DRV_INSTALLABLE = (0x8);
const int VFT2_DRV_SOUND = (0x9);
const int VFT2_FONT_RASTER = (0x1);
const int VFT2_FONT_VECTOR = (0x2);
const int VFT2_FONT_TRUETYPE = (0x3);
const int PAN_ANY = (0);
const int PAN_NO_FIT = (1);
const int PAN_FAMILY_TEXT_DISPLAY = (2);
const int PAN_FAMILY_SCRIPT = (3);
const int PAN_FAMILY_DECORATIVE = (4);
const int PAN_FAMILY_PICTORIAL = (5);
const int PAN_SERIF_COVE = (2);
const int PAN_SERIF_OBTUSE_COVE = (3);
const int PAN_SERIF_SQUARE_COVE = (4);
const int PAN_SERIF_OBTUSE_SQUARE_COVE = (5);
const int PAN_SERIF_SQUARE = (6);
const int PAN_SERIF_THIN = (7);
const int PAN_SERIF_BONE = (8);
const int PAN_SERIF_EXAGGERATED = (9);
const int PAN_SERIF_TRIANGLE = (10);
const int PAN_SERIF_NORMAL_SANS = (11);
const int PAN_SERIF_OBTUSE_SANS = (12);
const int PAN_SERIF_PERP_SANS = (13);
const int PAN_SERIF_FLARED = (14);
const int PAN_SERIF_ROUNDED = (15);
const int PAN_WEIGHT_VERY_LIGHT = (2);
const int PAN_WEIGHT_LIGHT = (3);
const int PAN_WEIGHT_THIN = (4);
const int PAN_WEIGHT_BOOK = (5);
const int PAN_WEIGHT_MEDIUM = (6);
const int PAN_WEIGHT_DEMI = (7);
const int PAN_WEIGHT_BOLD = (8);
const int PAN_WEIGHT_HEAVY = (9);
const int PAN_WEIGHT_BLACK = (10);
const int PAN_WEIGHT_NORD = (11);
const int PAN_PROP_OLD_STYLE = (2);
const int PAN_PROP_MODERN = (3);
const int PAN_PROP_EVEN_WIDTH = (4);
const int PAN_PROP_EXPANDED = (5);
const int PAN_PROP_CONDENSED = (6);
const int PAN_PROP_VERY_EXPANDED = (7);
const int PAN_PROP_VERY_CONDENSED = (8);
const int PAN_PROP_MONOSPACED = (9);
const int PAN_CONTRAST_NONE = (2);
const int PAN_CONTRAST_VERY_LOW = (3);
const int PAN_CONTRAST_LOW = (4);
const int PAN_CONTRAST_MEDIUM_LOW = (5);
const int PAN_CONTRAST_MEDIUM = (6);
const int PAN_CONTRAST_MEDIUM_HIGH = (7);
const int PAN_CONTRAST_HIGH = (8);
const int PAN_CONTRAST_VERY_HIGH = (9);
const int PAN_STROKE_GRADUAL_DIAG = (2);
const int PAN_STROKE_GRADUAL_TRAN = (3);
const int PAN_STROKE_GRADUAL_VERT = (4);
const int PAN_STROKE_GRADUAL_HORZ = (5);
const int PAN_STROKE_RAPID_VERT = (6);
const int PAN_STROKE_RAPID_HORZ = (7);
const int PAN_STROKE_INSTANT_VERT = (8);
const int PAN_STRAIGHT_ARMS_HORZ = (2);
const int PAN_STRAIGHT_ARMS_WEDGE = (3);
const int PAN_STRAIGHT_ARMS_VERT = (4);
const int PAN_STRAIGHT_ARMS_SINGLE_SERIF = (5);
const int PAN_STRAIGHT_ARMS_DOUBLE_SERIF = (6);
const int PAN_BENT_ARMS_HORZ = (7);
const int PAN_BENT_ARMS_VERT = (9);
const int PAN_BENT_ARMS_WEDGE = (8);
const int PAN_BENT_ARMS_SINGLE_SERIF = (10);
const int PAN_BENT_ARMS_DOUBLE_SERIF = (11);
const int PAN_LETT_NORMAL_CONTACT = (2);
const int PAN_LETT_NORMAL_WEIGHTED = (3);
const int PAN_LETT_NORMAL_BOXED = (4);
const int PAN_LETT_NORMAL_FLATTENED = (5);
const int PAN_LETT_NORMAL_ROUNDED = (6);
const int PAN_LETT_NORMAL_OFF_CENTER = (7);
const int PAN_LETT_NORMAL_SQUARE = (8);
const int PAN_LETT_OBLIQUE_CONTACT = (9);
const int PAN_LETT_OBLIQUE_WEIGHTED = (10);
const int PAN_LETT_OBLIQUE_BOXED = (11);
const int PAN_LETT_OBLIQUE_FLATTENED = (12);
const int PAN_LETT_OBLIQUE_ROUNDED = (13);
const int PAN_LETT_OBLIQUE_OFF_CENTER = (14);
const int PAN_LETT_OBLIQUE_SQUARE = (15);
const int PAN_MIDLINE_STANDARD_TRIMMED = (2);
const int PAN_MIDLINE_STANDARD_POINTED = (3);
const int PAN_MIDLINE_STANDARD_SERIFED = (4);
const int PAN_MIDLINE_HIGH_TRIMMED = (5);
const int PAN_MIDLINE_HIGH_POINTED = (6);
const int PAN_MIDLINE_HIGH_SERIFED = (7);
const int PAN_MIDLINE_CONSTANT_TRIMMED = (8);
const int PAN_MIDLINE_CONSTANT_POINTED = (9);
const int PAN_MIDLINE_CONSTANT_SERIFED = (10);
const int PAN_MIDLINE_LOW_TRIMMED = (11);
const int PAN_MIDLINE_LOW_POINTED = (12);
const int PAN_MIDLINE_LOW_SERIFED = (13);
const int PAN_XHEIGHT_CONSTANT_SMALL = (2);
const int PAN_XHEIGHT_CONSTANT_STD = (3);
const int PAN_XHEIGHT_CONSTANT_LARGE = (4);
const int PAN_XHEIGHT_DUCKING_SMALL = (5);
const int PAN_XHEIGHT_DUCKING_STD = (6);
const int PAN_XHEIGHT_DUCKING_LARGE = (7);
const int PC_EXPLICIT = (2);
const int PC_NOCOLLAPSE = (4);
const int PC_RESERVED = (1);
const int BS_DIBPATTERN = (5);
const int BS_DIBPATTERN8X8 = (8);
const int BS_DIBPATTERNPT = (6);
const int BS_HATCHED = (2);
const int BS_HOLLOW = (1);
const int BS_NULL = (1);
const int BS_PATTERN = (3);
const int BS_PATTERN8X8 = (7);
const int BS_SOLID = (0);
const int DM_ORIENTATION = (0x1);
const int DM_PAPERSIZE = (0x2);
const int DM_PAPERLENGTH = (0x4);
const int DM_PAPERWIDTH = (0x8);
const int DM_SCALE = (0x10);
const int DM_COPIES = (0x100);
const int DM_DEFAULTSOURCE = (0x200);
const int DM_PRINTQUALITY = (0x400);
const int DM_COLOR = (0x800);
const int DM_DUPLEX = (0x1000);
const int DM_YRESOLUTION = (0x2000);
const int DM_TTOPTION = (0x4000);
const int DM_COLLATE = (0x8000);
const int DM_FORMNAME = (0x10000);
const int DM_LOGPIXELS = (0x20000);
const int DM_ICMMETHOD = (0x800000);
const int DM_ICMINTENT = (0x1000000);
const int DM_MEDIATYPE = (0x2000000);
const int DM_DITHERTYPE = (0x4000000);
const int DMORIENT_LANDSCAPE = (2);
const int DMORIENT_PORTRAIT = (1);
const int DMPAPER_LETTER = (1);
const int DMPAPER_LEGAL = (5);
const int DMPAPER_A4 = (9);
const int DMPAPER_CSHEET = (24);
const int DMPAPER_DSHEET = (25);
const int DMPAPER_ESHEET = (26);
const int DMPAPER_LETTERSMALL = (2);
const int DMPAPER_TABLOID = (3);
const int DMPAPER_LEDGER = (4);
const int DMPAPER_STATEMENT = (6);
const int DMPAPER_EXECUTIVE = (7);
const int DMPAPER_A3 = (8);
const int DMPAPER_A4SMALL = (10);
const int DMPAPER_A5 = (11);
const int DMPAPER_B4 = (12);
const int DMPAPER_B5 = (13);
const int DMPAPER_FOLIO = (14);
const int DMPAPER_QUARTO = (15);
const int DMPAPER_10X14 = (16);
const int DMPAPER_11X17 = (17);
const int DMPAPER_NOTE = (18);
const int DMPAPER_ENV_9 = (19);
const int DMPAPER_ENV_10 = (20);
const int DMPAPER_ENV_11 = (21);
const int DMPAPER_ENV_12 = (22);
const int DMPAPER_ENV_14 = (23);
const int DMPAPER_ENV_DL = (27);
const int DMPAPER_ENV_C5 = (28);
const int DMPAPER_ENV_C3 = (29);
const int DMPAPER_ENV_C4 = (30);
const int DMPAPER_ENV_C6 = (31);
const int DMPAPER_ENV_C65 = (32);
const int DMPAPER_ENV_B4 = (33);
const int DMPAPER_ENV_B5 = (34);
const int DMPAPER_ENV_B6 = (35);
const int DMPAPER_ENV_ITALY = (36);
const int DMPAPER_ENV_MONARCH = (37);
const int DMPAPER_ENV_PERSONAL = (38);
const int DMPAPER_FANFOLD_US = (39);
const int DMPAPER_FANFOLD_STD_GERMAN = (40);
const int DMPAPER_FANFOLD_LGL_GERMAN = (41);
const int DMRES_HIGH = -((4));
const int DMRES_MEDIUM = -((3));
const int DMRES_LOW = -((2));
const int DMRES_DRAFT = -((1));
const int DMCOLOR_COLOR = (2);
const int DMCOLOR_MONOCHROME = (1);
const int DMDUP_SIMPLEX = (1);
const int DMDUP_HORIZONTAL = (3);
const int DMDUP_VERTICAL = (2);
const int DMTT_BITMAP = (1);
const int DMTT_DOWNLOAD = (2);
const int DMTT_SUBDEV = (3);
const int DMCOLLATE_TRUE = (1);
const int DMCOLLATE_FALSE = (0);
const int DM_GRAYSCALE = (1);
const int DM_INTERLACED = (2);
const int DMICMMETHOD_NONE = (1);
const int DMICMMETHOD_SYSTEM = (2);
const int DMICMMETHOD_DRIVER = (3);
const int DMICMMETHOD_DEVICE = (4);
const int DMICMMETHOD_USER = (256);
const int DMICM_SATURATE = (1);
const int DMICM_CONTRAST = (2);
const int DMICM_COLORMETRIC = (3);
const int DMICM_USER = (256);
const int DMMEDIA_STANDARD = (1);
const int DMMEDIA_GLOSSY = (3);
const int DMMEDIA_TRANSPARENCY = (2);
const int DMMEDIA_USER = (256);
const int DMDITHER_NONE = (1);
const int DMDITHER_COARSE = (2);
const int DMDITHER_FINE = (3);
const int DMDITHER_LINEART = (4);
const int DMDITHER_GRAYSCALE = (10);
const int DMDITHER_USER = (256);
const int RDH_RECTANGLES = (1);
const int TT_POLYGON_TYPE = (24);
const int TT_PRIM_LINE = (1);
const int TT_PRIM_QSPLINE = (2);
const int GCPCLASS_ARABIC = (2);
const int GCPCLASS_HEBREW = (2);
const int GCPCLASS_LATIN = (1);
const int GCPCLASS_LATINNUMBER = (5);
const int GCPCLASS_LOCALNUMBER = (4);
const int GCPCLASS_LATINNUMERICSEPARATOR = (7);
const int GCPCLASS_LATINNUMERICTERMINATOR = (6);
const int GCPCLASS_NEUTRAL = (3);
const int GCPCLASS_NUMERICSEPARATOR = (8);
const int GCPCLASS_PREBOUNDLTR = (128);
const int GCPCLASS_PREBOUNDRTL = (64);
const int GCPCLASS_POSTBOUNDLTR = (32);
const int GCPCLASS_POSTBOUNDRTL = (16);
const int GCPGLYPH_LINKBEFORE = (32768);
const int GCPGLYPH_LINKAFTER = (16384);
const int TT_AVAILABLE = (1);
const int TT_ENABLED = (2);
const int CA_NEGATIVE = (1);
const int CA_LOG_FILTER = (2);
const int ILLUMINANT_DEVICE_DEFAULT = (0);
const int ILLUMINANT_A = (1);
const int ILLUMINANT_B = (2);
const int ILLUMINANT_C = (3);
const int ILLUMINANT_D50 = (4);
const int ILLUMINANT_D55 = (5);
const int ILLUMINANT_D65 = (6);
const int ILLUMINANT_D75 = (7);
const int ILLUMINANT_F2 = (8);
const int ILLUMINANT_TUNGSTEN = (1);
const int ILLUMINANT_DAYLIGHT = (3);
const int ILLUMINANT_FLUORESCENT = (8);
const int ILLUMINANT_NTSC = (3);
const int DI_APPBANDING = (1);
const int EMR_HEADER = (1);
const int ENHMETA_SIGNATURE = (1179469088);
const int ENM_CHANGE = (1);
const int ENM_CORRECTTEXT = (4194304);
const int ENM_DROPFILES = (1048576);
const int ENM_KEYEVENTS = (65536);
const int ENM_MOUSEEVENTS = (131072);
const int ENM_PROTECTED = (2097152);
const int ENM_REQUESTRESIZE = (262144);
const int ENM_SCROLL = (4);
const int ENM_SELCHANGE = (524288);
const int ENM_UPDATE = (2);
const int ENM_NONE = (0);
const int ES_DISABLENOSCROLL = (8192);
const int ES_EX_NOCALLOLEINIT = (16777216);
const int ES_NOIME = (524288);
const int ES_SAVESEL = (32768);
const int ES_SELFIME = (262144);
const int ES_SUNKEN = (16384);
const int ES_VERTICAL = (4194304);
const int ES_SELECTIONBAR = (16777216);
const int ECOOP_SET = (1);
const int ECOOP_OR = (2);
const int ECOOP_AND = (3);
const int ECOOP_XOR = (4);
const int ECO_AUTOWORDSELECTION = (1);
const int ECO_AUTOVSCROLL = (64);
const int ECO_AUTOHSCROLL = (128);
const int ECO_NOHIDESEL = (256);
const int ECO_READONLY = (2048);
const int ECO_WANTRETURN = (4096);
const int ECO_SAVESEL = (32768);
const int ECO_SELECTIONBAR = (16777216);
const int ECO_VERTICAL = (4194304);
const int SCF_WORD = (2);
const int SCF_SELECTION = (1);
const int SF_TEXT = (1);
const int SF_RTF = (2);
const int SF_RTFNOOBJS = (3);
const int SF_TEXTIZED = (4);
const int SFF_SELECTION = (32768);
const int SFF_PLAINRTF = (16384);
const int WB_CLASSIFY = (3);
const int WB_LEFTBREAK = (6);
const int WB_PREVBREAK = (6);
const int WB_MOVEWORDLEFT = (4);
const int WB_MOVEWORDPREV = (4);
const int WB_MOVEWORDRIGHT = (5);
const int WB_MOVEWORDNEXT = (5);
const int WB_RIGHTBREAK = (7);
const int WB_NEXTBREAK = (7);
const int PC_LEADING = (2);
const int PC_FOLLOWING = (1);
const int PC_DELIMITER = (4);
const int PC_OVERFLOW = (3);
const int WBF_WORDWRAP = (16);
const int WBF_WORDBREAK = (32);
const int WBF_OVERFLOW = (64);
const int WBF_LEVEL1 = (128);
const int WBF_LEVEL2 = (256);
const int WBF_CUSTOM = (512);
const int WBF_BREAKAFTER = (64);
const int WBF_BREAKLINE = (32);
const int WBF_ISWHITE = (16);
const int CFM_BOLD = (1);
const int CFM_COLOR = (1073741824);
const int CFM_FACE = (536870912);
const int CFM_ITALIC = (2);
const int CFM_OFFSET = (268435456);
const int CFM_PROTECTED = (16);
const int CFM_SIZE = (int)(0x80000000);
const int CFM_STRIKEOUT = (8);
const int CFM_UNDERLINE = (4);
const int CFE_AUTOCOLOR = (1073741824);
const int CFE_BOLD = (1);
const int CFE_ITALIC = (2);
const int CFE_STRIKEOUT = (8);
const int CFE_UNDERLINE = (4);
const int CFE_PROTECTED = (16);
const int PFM_ALIGNMENT = (8);
const int PFM_NUMBERING = (32);
const int PFM_OFFSET = (4);
const int PFM_OFFSETINDENT = (int)(0x80000000);
const int PFM_RIGHTINDENT = (2);
const int PFM_STARTINDENT = (1);
const int PFM_TABSTOPS = (16);
const int PFN_BULLET = (1);
const int PFA_LEFT = (1);
const int PFA_RIGHT = (2);
const int PFA_CENTER = (3);
const int SEL_EMPTY = (0);
const int SEL_TEXT = (1);
const int SEL_OBJECT = (2);
const int SEL_MULTICHAR = (4);
const int SEL_MULTIOBJECT = (8);
const char* CF_RTF = ("Rich Text Format");
const char* CF_RETEXTOBJ = ("RichEdit Text and Objects");
const int ODT_BUTTON = (4);
const int ODT_COMBOBOX = (3);
const int ODT_LISTBOX = (2);
const int ODT_LISTVIEW = (102);
const int ODT_MENU = (1);
const int ODT_STATIC = (5);
const int ODT_TAB = (101);
const int ODT_HEADER = (100);
const int ODA_DRAWENTIRE = (1);
const int ODA_FOCUS = (4);
const int ODA_SELECT = (2);
const int ODS_CHECKED = (8);
const int ODS_COMBOBOXEDIT = (4096);
const int ODS_DEFAULT = (32);
const int ODS_DISABLED = (4);
const int ODS_FOCUS = (16);
const int ODS_GRAYED = (2);
const int ODS_SELECTED = (1);
const char* ANIMATE_CLASSW = ("SysAnimate32");
const char* HOTKEY_CLASSW = ("msctls_hotkey32");
const char* PROGRESS_CLASSW = ("msctls_progress32");
const char* STATUSCLASSNAMEW = ("msctls_statusbar32");
const char* TOOLBARCLASSNAMEW = ("ToolbarWindow32");
const char* TOOLTIPS_CLASSW = ("tooltips_class32");
const char* TRACKBAR_CLASSW = ("msctls_trackbar32");
const char* UPDOWN_CLASSW = ("msctls_updown32");
const char* WC_HEADERW = ("SysHeader32");
const char* WC_LISTVIEWW = ("SysListView32");
const char* WC_TABCONTROLW = ("SysTabControl32");
const char* WC_TREEVIEWW = ("SysTreeView32");
const int CCS_ADJUSTABLE = (0x20);
const int CCS_BOTTOM = (0x3);
const int CCS_NODIVIDER = (0x40);
const int CCS_NOMOVEY = (0x2);
const int CCS_NOPARENTALIGN = (0x8);
const int CCS_NORESIZE = (0x4);
const int CCS_TOP = (0x1);
const char* ANIMATE_CLASSA = ("SysAnimate32");
const char* HOTKEY_CLASSA = ("msctls_hotkey32");
const char* PROGRESS_CLASSA = ("msctls_progress32");
const char* STATUSCLASSNAMEA = ("msctls_statusbar32");
const char* TOOLBARCLASSNAMEA = ("ToolbarWindow32");
const char* TOOLTIPS_CLASSA = ("tooltips_class32");
const char* TRACKBAR_CLASSA = ("msctls_trackbar32");
const char* UPDOWN_CLASSA = ("msctls_updown32");
const char* WC_HEADERA = ("SysHeader32");
const char* WC_LISTVIEWA = ("SysListView32");
const char* WC_TABCONTROLA = ("SysTabControl32");
const char* WC_TREEVIEWA = ("SysTreeView32");
const char* ANIMATE_CLASS = (ANIMATE_CLASSA);
const char* HOTKEY_CLASS = (HOTKEY_CLASSA);
const char* PROGRESS_CLASS = (PROGRESS_CLASSA);
const char* STATUSCLASSNAME = (STATUSCLASSNAMEA);
const char* TOOLBARCLASSNAME = (TOOLBARCLASSNAMEA);
const char* TOOLTIPS_CLASS = (TOOLTIPS_CLASSA);
const char* TRACKBAR_CLASS = (TRACKBAR_CLASSA);
const char* UPDOWN_CLASS = (UPDOWN_CLASSA);
const char* WC_HEADER = (WC_HEADERA);
const char* WC_LISTVIEW = (WC_LISTVIEWA);
const char* WC_TABCONTROL = (WC_TABCONTROLA);
const char* WC_TREEVIEW = (WC_TREEVIEWA);
const int HDS_BUTTONS = (2);
const int HDS_HIDDEN = (8);
const int HDS_HORZ = (0);
const int HDI_BITMAP = (16);
const int HDI_FORMAT = (4);
const int HDI_HEIGHT = (1);
const int HDI_LPARAM = (8);
const int HDI_TEXT = (2);
const int HDI_WIDTH = (1);
const int HDF_CENTER = (2);
const int HDF_LEFT = (0);
const int HDF_RIGHT = (1);
const int HDF_RTLREADING = (4);
const int HDF_BITMAP = (8192);
const int HDF_OWNERDRAW = (32768);
const int HDF_STRING = (16384);
const int HDF_JUSTIFYMASK = (3);
const int HHT_NOWHERE = (1);
const int HHT_ONDIVIDER = (4);
const int HHT_ONDIVOPEN = (8);
const int HHT_ONHEADER = (2);
const int HHT_TOLEFT = (2048);
const int HHT_TORIGHT = (1024);
const int HINST_COMMCTRL = -(1);
const int IDB_STD_LARGE_COLOR = (1);
const int IDB_STD_SMALL_COLOR = (0);
const int IDB_VIEW_LARGE_COLOR = (5);
const int IDB_VIEW_SMALL_COLOR = (4);
const int STD_COPY = (1);
const int STD_CUT = (0);
const int STD_DELETE = (5);
const int STD_FILENEW = (6);
const int STD_FILEOPEN = (7);
const int STD_FILESAVE = (8);
const int STD_FIND = (12);
const int STD_HELP = (11);
const int STD_PASTE = (2);
const int STD_PRINT = (14);
const int STD_PRINTPRE = (9);
const int STD_PROPERTIES = (10);
const int STD_REDOW = (4);
const int STD_REPLACE = (13);
const int STD_UNDO = (3);
const int VIEW_LARGEICONS = (0);
const int VIEW_SMALLICONS = (1);
const int VIEW_LIST = (2);
const int VIEW_DETAILS = (3);
const int VIEW_SORTNAME = (4);
const int VIEW_SORTSIZE = (5);
const int VIEW_SORTDATE = (6);
const int VIEW_SORTTYPE = (7);
const int TBSTYLE_ALTDRAG = (1024);
const int TBSTYLE_TOOLTIPS = (256);
const int TBSTYLE_WRAPABLE = (512);
const int TBSTYLE_BUTTON = (0);
const int TBSTYLE_CHECK = (2);
const int TBSTYLE_CHECKGROUP = (6);
const int TBSTYLE_GROUP = (4);
const int TBSTYLE_SEP = (1);
const int TBSTATE_CHECKED = (1);
const int TBSTATE_ENABLED = (4);
const int TBSTATE_HIDDEN = (8);
const int TBSTATE_INDETERMINATE = (16);
const int TBSTATE_PRESSED = (2);
const int TBSTATE_WRAP = (32);
const int TTS_ALWAYSTIP = (1);
const int TTS_NOPREFIX = (2);
const int TTF_IDISHWND = (1);
const int TTF_CENTERTIP = (2);
const int TTF_RTLREADING = (4);
const int TTF_SUBCLASS = (16);
const int TTDT_AUTOMATIC = (0);
const int TTDT_AUTOPOP = (2);
const int TTDT_INITIAL = (3);
const int TTDT_RESHOW = (1);
const int SBARS_SIZEGRIP = (256);
const int DL_MOVECURSOR = (3);
const int DL_COPYCURSOR = (2);
const int DL_STOPCURSOR = (1);
const int UDS_ALIGNLEFT = (8);
const int UDS_ALIGNRIGHT = (4);
const int UDS_ARROWKEYS = (32);
const int UDS_AUTOBUDDY = (16);
const int UDS_HORZ = (64);
const int UDS_NOTHOUSANDS = (128);
const int UDS_SETBUDDYINT = (2);
const int UDS_WRAP = (1);
const int UD_MAXVAL = (32767);
const int UD_MINVAL = -((32767));
const int HOTKEYF_ALT = (4);
const int HOTKEYF_CONTROL = (2);
const int HOTKEYF_EXT = (8);
const int HOTKEYF_SHIFT = (1);
const int HKCOMB_A = (8);
const int HKCOMB_C = (4);
const int HKCOMB_CA = (64);
const int HKCOMB_NONE = (1);
const int HKCOMB_S = (2);
const int HKCOMB_SA = (32);
const int HKCOMB_SC = (16);
const int HKCOMB_SCA = (128);
const int TBS_HORZ = (0);
const int TBS_VERT = (2);
const int TBS_AUTOTICKS = (1);
const int TBS_NOTICKS = (16);
const int TBS_TOP = (4);
const int TBS_BOTTOM = (0);
const int TBS_LEFT = (4);
const int TBS_RIGHT = (0);
const int TBS_BOTH = (8);
const int TBS_ENABLESELRANGE = (32);
const int TBS_FIXEDLENGTH = (64);
const int TBS_NOTHUMB = (128);
const int TB_BOTTOM = (7);
const int TB_ENDTRACK = (8);
const int TB_LINEDOWN = (1);
const int TB_LINEUP = (0);
const int TB_PAGEDOWN = (3);
const int TB_PAGEUP = (2);
const int TB_THUMBPOSITION = (4);
const int TB_THUMBTRACK = (5);
const int TB_TOP = (6);
const int LVS_ALIGNLEFT = (2048);
const int LVS_ALIGNTOP = (0);
const int LVS_AUTOARRANGE = (256);
const int LVS_EDITLABELS = (512);
const int LVS_ICON = (0);
const int LVS_LIST = (3);
const int LVS_NOCOLUMNHEADER = (16384);
const int LVS_NOLABELWRAP = (128);
const int LVS_NOSCROLL = (8192);
const int LVS_NOSORTHEADER = (32768);
const int LVS_OWNERDRAWFIXED = (1024);
const int LVS_REPORT = (1);
const int LVS_SHAREIMAGELISTS = (64);
const int LVS_SHOWSELALWAYS = (8);
const int LVS_SINGLESEL = (4);
const int LVS_SMALLICON = (2);
const int LVS_SORTASCENDING = (16);
const int LVS_SORTDESCENDING = (32);
const int LVS_TYPESTYLEMASK = (64512);
const int LVSIL_NORMAL = (0);
const int LVSIL_SMALL = (1);
const int LVSIL_STATE = (2);
const int LVIS_CUT = (4);
const int LVIS_DROPHILITED = (8);
const int LVIS_FOCUSED = (1);
const int LVIS_SELECTED = (2);
const int LVIS_OVERLAYMASK = (3840);
const int LVIS_STATEIMAGEMASK = (61440);
const wchar* LPSTR_TEXTCALLBACKW = (LPWSTR)(-(1));
const char* LPSTR_TEXTCALLBACKA = (LPSTR)(-(1));
const char* LPSTR_TEXTCALLBACK = (LPSTR_TEXTCALLBACKA);
const int LVIF_TEXT = (1);
const int LVIF_IMAGE = (2);
const int LVIF_PARAM = (4);
const int LVIF_STATE = (8);
const int LVIF_DI_SETITEM = (4096);
const int LVNI_ABOVE = (256);
const int LVNI_ALL = (0);
const int LVNI_BELOW = (512);
const int LVNI_TOLEFT = (1024);
const int LVNI_TORIGHT = (2048);
const int LVNI_CUT = (4);
const int LVNI_DROPHILITED = (8);
const int LVNI_FOCUSED = (1);
const int LVNI_SELECTED = (2);
const int LVFI_PARAM = (1);
const int LVFI_PARTIAL = (8);
const int LVFI_STRING = (2);
const int LVFI_WRAP = (32);
const int LVFI_NEARESTXY = (64);
const int LVHT_ABOVE = (8);
const int LVHT_BELOW = (16);
const int LVHT_NOWHERE = (1);
const int LVHT_ONITEMICON = (2);
const int LVHT_ONITEMLABEL = (4);
const int LVHT_ONITEMSTATEICON = (8);
const int LVHT_TOLEFT = (64);
const int LVHT_TORIGHT = (32);
const int LVCF_FMT = (1);
const int LVCF_SUBITEM = (8);
const int LVCF_TEXT = (4);
const int LVCF_WIDTH = (2);
const int LVCFMT_CENTER = (2);
const int LVCFMT_LEFT = (0);
const int LVCFMT_RIGHT = (1);
const int LVIR_BOUNDS = (0);
const int LVIR_ICON = (1);
const int LVIR_LABEL = (2);
const int LVIR_SELECTBOUNDS = (3);
const int LVA_ALIGNLEFT = (1);
const int LVA_ALIGNTOP = (2);
const int LVA_DEFAULT = (0);
const int LVA_SNAPTOGRID = (5);
const int LVSCW_AUTOSIZE = -((1));
const int LVSCW_AUTOSIZE_USEHEADER = -((2));
const int TVS_DISABLEDRAGDROP = (16);
const int TVS_EDITLABELS = (8);
const int TVS_HASBUTTONS = (1);
const int TVS_HASLINES = (2);
const int TVS_LINESATROOT = (4);
const int TVS_SHOWSELALWAYS = (32);
const int TVIS_BOLD = (16);
const int TVIS_CUT = (4);
const int TVIS_DROPHILITED = (8);
const int TVIS_EXPANDED = (32);
const int TVIS_EXPANDEDONCE = (64);
const int TVIS_FOCUSED = (1);
const int TVIS_OVERLAYMASK = (3840);
const int TVIS_SELECTED = (2);
const int TVIS_STATEIMAGEMASK = (61440);
const int TVIS_USERMASK = (61440);
const int TVIF_CHILDREN = (64);
const int TVIF_HANDLE = (16);
const int TVIF_IMAGE = (2);
const int TVIF_PARAM = (4);
const int TVIF_SELECTEDIMAGE = (32);
const int TVIF_STATE = (8);
const int TVIF_TEXT = (1);
const int I_CHILDRENCALLBACK = -((1));
const int I_IMAGECALLBACK = -((1));

extern (Windows) struct TREEITEM
{
}

alias TREEITEM* HTREEITEM;
alias TREEITEM TTREEITEM;
alias TREEITEM* PTREEITEM;
const int TVI_ROOT = (int)(0xFFFF0000);
const int TVI_FIRST = (int)(0xFFFF0001);
const int TVI_LAST = (int)(0xFFFF0002);
const int TVI_SORT = (int)(0xFFFF0003);
const int TVHT_ABOVE = (256);
const int TVHT_BELOW = (512);
const int TVHT_NOWHERE = (1);
const int TVHT_ONITEM = (70);
const int TVHT_ONITEMBUTTON = (16);
const int TVHT_ONITEMICON = (2);
const int TVHT_ONITEMINDENT = (8);
const int TVHT_ONITEMLABEL = (4);
const int TVHT_ONITEMRIGHT = (32);
const int TVHT_ONITEMSTATEICON = (64);
const int TVHT_TOLEFT = (2048);
const int TVHT_TORIGHT = (1024);
const int TVE_COLLAPSE = (1);
const int TVE_COLLAPSERESET = (32768);
const int TVE_EXPAND = (2);
const int TVE_TOGGLE = (3);
const int TVSIL_NORMAL = (0);
const int TVSIL_STATE = (2);
const int TVGN_CARET = (9);
const int TVGN_CHILD = (4);
const int TVGN_DROPHILITE = (8);
const int TVGN_FIRSTVISIBLE = (5);
const int TVGN_NEXT = (1);
const int TVGN_NEXTVISIBLE = (6);
const int TVGN_PARENT = (3);
const int TVGN_PREVIOUS = (2);
const int TVGN_PREVIOUSVISIBLE = (7);
const int TVGN_ROOT = (0);
const int TVC_BYKEYBOARD = (2);
const int TVC_BYMOUSE = (1);
const int TVC_UNKNOWN = (0);
const int TCS_BUTTONS = (256);
const int TCS_FIXEDWIDTH = (1024);
const int TCS_FOCUSNEVER = (32768);
const int TCS_FOCUSONBUTTONDOWN = (4096);
const int TCS_FORCEICONLEFT = (16);
const int TCS_FORCELABELLEFT = (32);
const int TCS_MULTILINE = (512);
const int TCS_OWNERDRAWFIXED = (8192);
const int TCS_RAGGEDRIGHT = (2048);
const int TCS_RIGHTJUSTIFY = (0);
const int TCS_SINGLELINE = (0);
const int TCS_TABS = (0);
const int TCS_TOOLTIPS = (16384);
const int TCIF_TEXT = (1);
const int TCIF_IMAGE = (2);
const int TCIF_PARAM = (8);
const int TCIF_RTLREADING = (4);
const int TCHT_NOWHERE = (1);
const int TCHT_ONITEM = (6);
const int TCHT_ONITEMICON = (2);
const int TCHT_ONITEMLABEL = (4);
const int ACS_AUTOPLAY = (4);
const int ACS_CENTER = (1);
const int ACS_TRANSPARENT = (2);
const int DIALOPTION_BILLING = (64);
const int DIALOPTION_QUIET = (128);
const int DIALOPTION_DIALTONE = (256);
const int MDMVOLFLAG_LOW = (1);
const int MDMVOLFLAG_MEDIUM = (2);
const int MDMVOLFLAG_HIGH = (4);
const int MDMVOL_LOW = (0);
const int MDMVOL_MEDIUM = (1);
const int MDMVOL_HIGH = (2);
const int MDMSPKRFLAG_OFF = (1);
const int MDMSPKRFLAG_DIAL = (2);
const int MDMSPKRFLAG_ON = (4);
const int MDMSPKRFLAG_CALLSETUP = (8);
const int MDMSPKR_OFF = (0);
const int MDMSPKR_DIAL = (1);
const int MDMSPKR_ON = (2);
const int MDMSPKR_CALLSETUP = (3);
const int MDM_BLIND_DIAL = (512);
const int MDM_CCITT_OVERRIDE = (64);
const int MDM_CELLULAR = (8);
const int MDM_COMPRESSION = (1);
const int MDM_ERROR_CONTROL = (2);
const int MDM_FLOWCONTROL_HARD = (16);
const int MDM_FLOWCONTROL_SOFT = (32);
const int MDM_FORCED_EC = (4);
const int MDM_SPEED_ADJUST = (128);
const int MDM_TONE_DIAL = (256);
const int MDM_V23_OVERRIDE = (1024);
const int LANG_BULGARIAN = (2);
const int LANG_CHINESE = (4);
const int LANG_CROATIAN = (26);
const int LANG_CZECH = (5);
const int LANG_DANISH = (6);
const int LANG_DUTCH = (19);
const int LANG_ENGLISH = (9);
const int LANG_FINNISH = (11);
const int LANG_FRENCH = (12);
const int LANG_GERMAN = (7);
const int LANG_GREEK = (8);
const int LANG_HUNGARIAN = (14);
const int LANG_ICELANDIC = (15);
const int LANG_ITALIAN = (16);
const int LANG_JAPANESE = (17);
const int LANG_KOREAN = (18);
const int LANG_NEUTRAL = (0);
const int LANG_NORWEGIAN = (20);
const int LANG_POLISH = (21);
const int LANG_PORTUGUESE = (22);
const int LANG_ROMANIAN = (24);
const int LANG_RUSSIAN = (25);
const int LANG_SLOVAK = (27);
const int LANG_SLOVENIAN = (36);
const int LANG_SPANISH = (10);
const int LANG_SWEDISH = (29);
const int LANG_TURKISH = (31);
const int SUBLANG_CHINESE_SIMPLIFIED = (2);
const int SUBLANG_CHINESE_TRADITIONAL = (1);
const int SUBLANG_CHINESE_HONGKONG = (3);
const int SUBLANG_CHINESE_SINGAPORE = (4);
const int SUBLANG_DEFAULT = (1);
const int SUBLANG_DUTCH = (1);
const int SUBLANG_DUTCH_BELGIAN = (2);
const int SUBLANG_ENGLISH_AUS = (3);
const int SUBLANG_ENGLISH_CAN = (4);
const int SUBLANG_ENGLISH_EIRE = (6);
const int SUBLANG_ENGLISH_NZ = (5);
const int SUBLANG_ENGLISH_UK = (2);
const int SUBLANG_ENGLISH_US = (1);
const int SUBLANG_FRENCH = (1);
const int SUBLANG_FRENCH_BELGIAN = (2);
const int SUBLANG_FRENCH_CANADIAN = (3);
const int SUBLANG_FRENCH_SWISS = (4);
const int SUBLANG_GERMAN = (1);
const int SUBLANG_GERMAN_AUSTRIAN = (3);
const int SUBLANG_GERMAN_SWISS = (2);
const int SUBLANG_ITALIAN = (1);
const int SUBLANG_ITALIAN_SWISS = (2);
const int SUBLANG_NEUTRAL = (0);
const int SUBLANG_NORWEGIAN_BOKMAL = (1);
const int SUBLANG_NORWEGIAN_NYNORSK = (2);
const int SUBLANG_PORTUGUESE = (2);
const int SUBLANG_PORTUGUESE_BRAZILIAN = (1);
const int SUBLANG_SPANISH = (1);
const int SUBLANG_SPANISH_MEXICAN = (2);
const int SUBLANG_SPANISH_MODERN = (3);
const int SUBLANG_SYS_DEFAULT = (2);
const int NLS_VALID_LOCALE_MASK = (1048575);
const int SORT_DEFAULT = (0);
const int SORT_JAPANESE_XJIS = (0);
const int SORT_JAPANESE_UNICODE = (1);
const int SORT_CHINESE_BIG5 = (0);
const int SORT_CHINESE_UNICODE = (1);
const int SORT_KOREAN_KSC = (0);
const int SORT_KOREAN_UNICODE = (1);
const int PROCESSOR_INTEL_386 = (386);
const int PROCESSOR_INTEL_486 = (486);
const int PROCESSOR_INTEL_PENTIUM = (586);
const int PROCESSOR_MIPS_R4000 = (4000);
const int PROCESSOR_ALPHA_21064 = (21064);
const int COMPRESSION_FORMAT_NONE = (0);
const int COMPRESSION_FORMAT_DEFAULT = (1);
const int COMPRESSION_FORMAT_LZNT1 = (2);
const int TAPE_DRIVE_COMPRESSION = (131072);
const int TAPE_DRIVE_ECC = (65536);
const int TAPE_DRIVE_ERASE_BOP_ONLY = (64);
const int TAPE_DRIVE_ERASE_LONG = (32);
const int TAPE_DRIVE_ERASE_IMMEDIATE = (128);
const int TAPE_DRIVE_ERASE_SHORT = (16);
const int TAPE_DRIVE_FIXED = (1);
const int TAPE_DRIVE_FIXED_BLOCK = (1024);
const int TAPE_DRIVE_INITIATOR = (4);
const int TAPE_DRIVE_PADDING = (262144);
const int TAPE_DRIVE_GET_ABSOLUTE_BLK = (1048576);
const int TAPE_DRIVE_GET_LOGICAL_BLK = (2097152);
const int TAPE_DRIVE_REPORT_SMKS = (524288);
const int TAPE_DRIVE_SELECT = (2);
const int TAPE_DRIVE_SET_EOT_WZ_SIZE = (4194304);
const int TAPE_DRIVE_TAPE_CAPACITY = (256);
const int TAPE_DRIVE_TAPE_REMAINING = (512);
const int TAPE_DRIVE_VARIABLE_BLOCK = (2048);
const int TAPE_DRIVE_WRITE_PROTECT = (4096);
const int TAPE_DRIVE_ABS_BLK_IMMED = -((2147475456));
const int TAPE_DRIVE_ABSOLUTE_BLK = -((2147479552));
const int TAPE_DRIVE_END_OF_DATA = -((2147418112));
const int TAPE_DRIVE_FILEMARKS = -((2147221504));
const int TAPE_DRIVE_LOAD_UNLOAD = -((2147483647));
const int TAPE_DRIVE_LOAD_UNLD_IMMED = -((2147483616));
const int TAPE_DRIVE_LOCK_UNLOCK = -((2147483644));
const int TAPE_DRIVE_LOCK_UNLK_IMMED = -((2147483520));
const int TAPE_DRIVE_LOG_BLK_IMMED = -((2147450880));
const int TAPE_DRIVE_LOGICAL_BLK = -((2147467264));
const int TAPE_DRIVE_RELATIVE_BLKS = -((2147352576));
const int TAPE_DRIVE_REVERSE_POSITION = -((2143289344));
const int TAPE_DRIVE_REWIND_IMMEDIATE = -((2147483640));
const int TAPE_DRIVE_SEQUENTIAL_FMKS = -((2146959360));
const int TAPE_DRIVE_SEQUENTIAL_SMKS = -((2145386496));
const int TAPE_DRIVE_SET_BLOCK_SIZE = -((2147483632));
const int TAPE_DRIVE_SET_COMPRESSION = -((2147483136));
const int TAPE_DRIVE_SET_ECC = -((2147483392));
const int TAPE_DRIVE_SET_PADDING = -((2147482624));
const int TAPE_DRIVE_SET_REPORT_SMKS = -((2147481600));
const int TAPE_DRIVE_SETMARKS = -((2146435072));
const int TAPE_DRIVE_SPACE_IMMEDIATE = -((2139095040));
const int TAPE_DRIVE_TENSION = -((2147483646));
const int TAPE_DRIVE_TENSION_IMMED = -((2147483584));
const int TAPE_DRIVE_WRITE_FILEMARKS = -((2113929216));
const int TAPE_DRIVE_WRITE_LONG_FMKS = -((2013265920));
const int TAPE_DRIVE_WRITE_MARK_IMMED = -((1879048192));
const int TAPE_DRIVE_WRITE_SETMARKS = -((2130706432));
const int TAPE_DRIVE_WRITE_SHORT_FMKS = -((2080374784));
const int STANDARD_RIGHTS_REQUIRED = (0xf0000);
const int STANDARD_RIGHTS_WRITE = (0x20000);
const int STANDARD_RIGHTS_READ = (0x20000);
const int STANDARD_RIGHTS_EXECUTE = (0x20000);
const int STANDARD_RIGHTS_ALL = (0x1f0000);
const int SPECIFIC_RIGHTS_ALL = (0xffff);
const int MAXIMUM_ALLOWED = (0x2000000);
const int GENERIC_ALL = (0x10000000);
const int SECURITY_NULL_RID = (0);
const int SECURITY_WORLD_RID = (0);
const int SECURITY_LOCAL_RID = (0);
const int SECURITY_CREATOR_OWNER_RID = (0);
const int SECURITY_CREATOR_GROUP_RID = (0x1);
const int SECURITY_DIALUP_RID = (0x1);
const int SECURITY_NETWORK_RID = (0x2);
const int SECURITY_BATCH_RID = (0x3);
const int SECURITY_INTERACTIVE_RID = (0x4);
const int SECURITY_LOGON_IDS_RID = (0x5);
const int SECURITY_LOGON_IDS_RID_COUNT = (0x3);
const int SECURITY_SERVICE_RID = (0x6);
const int SECURITY_LOCAL_SYSTEM_RID = (0x12);
const int SECURITY_BUILTIN_DOMAIN_RID = (0x20);
const int DOMAIN_USER_RID_ADMIN = (0x1f4);
const int DOMAIN_USER_RID_GUEST = (0x1f5);
const int DOMAIN_GROUP_RID_ADMINS = (0x200);
const int DOMAIN_GROUP_RID_USERS = (0x201);
const int DOMAIN_ALIAS_RID_ADMINS = (0x220);
const int DOMAIN_ALIAS_RID_USERS = (0x221);
const int DOMAIN_ALIAS_RID_GUESTS = (0x222);
const int DOMAIN_ALIAS_RID_POWER_USERS = (0x223);
const int DOMAIN_ALIAS_RID_ACCOUNT_OPS = (0x224);
const int DOMAIN_ALIAS_RID_SYSTEM_OPS = (0x225);
const int DOMAIN_ALIAS_RID_PRINT_OPS = (0x226);
const int DOMAIN_ALIAS_RID_BACKUP_OPS = (0x227);
const int DOMAIN_ALIAS_RID_REPLICATOR = (0x228);
const int SE_GROUP_MANDATORY = (0x1);
const int SE_GROUP_ENABLED_BY_DEFAULT = (0x2);
const int SE_GROUP_ENABLED = (0x4);
const int SE_GROUP_OWNER = (0x8);
const int SE_GROUP_LOGON_ID = (int)(0xc0000000);
const int ACL_REVISION = (2);
const int ACCESS_ALLOWED_ACE_TYPE = (0x0);
const int ACCESS_DENIED_ACE_TYPE = (0x1);
const int SYSTEM_AUDIT_ACE_TYPE = (0x2);
const int SYSTEM_ALARM_ACE_TYPE = (0x3);
const int OBJECT_INHERIT_ACE = (0x1);
const int CONTAINER_INHERIT_ACE = (0x2);
const int NO_PROPAGATE_INHERIT_ACE = (0x4);
const int INHERIT_ONLY_ACE = (0x8);
const int SUCCESSFUL_ACCESS_ACE_FLAG = (0x40);
const int FAILED_ACCESS_ACE_FLAG = (0x80);
const int SECURITY_DESCRIPTOR_MIN_LENGTH = (20);
const int SE_OWNER_DEFAULTED = (1);
const int SE_GROUP_DEFAULTED = (2);
const int SE_DACL_PRESENT = (4);
const int SE_DACL_DEFAULTED = (8);
const int SE_SACL_PRESENT = (16);
const int SE_SACL_DEFAULTED = (32);
const int SE_SELF_RELATIVE = (32768);
const int SE_PRIVILEGE_ENABLED_BY_DEFAULT = (0x1);
const int SE_PRIVILEGE_ENABLED = (0x2);
const int SE_PRIVILEGE_USED_FOR_ACCESS = (int)(0x80000000);
const int PRIVILEGE_SET_ALL_NECESSARY = (0x1);
const int OFN_ALLOWMULTISELECT = (0x200);
const int OFN_CREATEPROMPT = (0x2000);
const int OFN_ENABLEHOOK = (0x20);
const int OFN_ENABLETEMPLATE = (0x40);
const int OFN_ENABLETEMPLATEHANDLE = (0x80);
const int OFN_EXPLORER = (0x80000);
const int OFN_EXTENSIONDIFFERENT = (0x400);
const int OFN_FILEMUSTEXIST = (0x1000);
const int OFN_HIDEREADONLY = (0x4);
const int OFN_LONGNAMES = (0x200000);
const int OFN_NOCHANGEDIR = (0x8);
const int OFN_NODEREFERENCELINKS = (0x100000);
const int OFN_NOLONGNAMES = (0x40000);
const int OFN_NONETWORKBUTTON = (0x20000);
const int OFN_NOREADONLYRETURN = (0x8000);
const int OFN_NOTESTFILECREATE = (0x10000);
const int OFN_NOVALIDATE = (0x100);
const int OFN_OVERWRITEPROMPT = (0x2);
const int OFN_PATHMUSTEXIST = (0x800);
const int OFN_READONLY = (0x1);
const int OFN_SHAREAWARE = (0x4000);
const int OFN_SHOWHELP = (0x10);
const int OFN_SHAREFALLTHROUGH = (0x2);
const int OFN_SHARENOWARN = (0x1);
const int OFN_SHAREWARN = (0);
const int CDN_INITDONE = (int)(0xfffffda7);
const int CDN_SELCHANGE = (int)(0xfffffda6);
const int CDN_FOLDERCHANGE = (int)(0xfffffda5);
const int CDN_SHAREVIOLATION = (int)(0xfffffda4);
const int CDN_HELP = (int)(0xfffffda3);
const int CDN_FILEOK = (int)(0xfffffda2);
const int CDN_TYPECHANGE = (int)(0xfffffda1);
const int CDM_GETFILEPATH = (0x465);
const int CDM_GETFOLDERIDLIST = (0x467);
const int CDM_GETFOLDERPATH = (0x466);
const int CDM_GETSPEC = (0x464);
const int CDM_HIDECONTROL = (0x469);
const int CDM_SETCONTROLTEXT = (0x468);
const int CDM_SETDEFEXT = (0x46a);
const int CC_ENABLEHOOK = (0x10);
const int CC_ENABLETEMPLATE = (0x20);
const int CC_ENABLETEMPLATEHANDLE = (0x40);
const int CC_FULLOPEN = (0x2);
const int CC_PREVENTFULLOPEN = (0x4);
const int CC_RGBINIT = (0x1);
const int CC_SHOWHELP = (0x8);
const int CC_SOLIDCOLOR = (0x80);
const int FR_DIALOGTERM = (0x40);
const int FR_DOWN = (0x1);
const int FR_ENABLEHOOK = (0x100);
const int FR_ENABLETEMPLATE = (0x200);
const int FR_ENABLETEMPLATEHANDLE = (0x2000);
const int FR_FINDNEXT = (0x8);
const int FR_HIDEUPDOWN = (0x4000);
const int FR_HIDEMATCHCASE = (0x8000);
const int FR_HIDEWHOLEWORD = (0x10000);
const int FR_MATCHCASE = (0x4);
const int FR_NOMATCHCASE = (0x800);
const int FR_NOUPDOWN = (0x400);
const int FR_NOWHOLEWORD = (0x1000);
const int FR_REPLACE = (0x10);
const int FR_REPLACEALL = (0x20);
const int FR_SHOWHELP = (0x80);
const int FR_WHOLEWORD = (0x2);
const int CF_APPLY = (0x200);
const int CF_ANSIONLY = (0x400);
const int CF_BOTH = (0x3);
const int CF_TTONLY = (0x40000);
const int CF_EFFECTS = (0x100);
const int CF_ENABLEHOOK = (0x8);
const int CF_ENABLETEMPLATE = (0x10);
const int CF_ENABLETEMPLATEHANDLE = (0x20);
const int CF_FIXEDPITCHONLY = (0x4000);
const int CF_FORCEFONTEXIST = (0x10000);
const int CF_INITTOLOGFONTSTRUCT = (0x40);
const int CF_LIMITSIZE = (0x2000);
const int CF_NOOEMFONTS = (0x800);
const int CF_NOFACESEL = (0x80000);
const int CF_NOSCRIPTSEL = (0x800000);
const int CF_NOSTYLESEL = (0x100000);
const int CF_NOSIZESEL = (0x200000);
const int CF_NOSIMULATIONS = (0x1000);
const int CF_NOVECTORFONTS = (0x800);
const int CF_NOVERTFONTS = (0x1000000);
const int CF_PRINTERFONTS = (0x2);
const int CF_SCALABLEONLY = (0x20000);
const int CF_SCREENFONTS = (0x1);
const int CF_SCRIPTSONLY = (0x400);
const int CF_SELECTSCRIPT = (0x400000);
const int CF_SHOWHELP = (0x4);
const int CF_USESTYLE = (0x80);
const int CF_WYSIWYG = (0x8000);
const int BOLD_FONTTYPE = (0x100);
const int ITALIC_FONTTYPE = (0x200);
const int PRINTER_FONTTYPE = (0x4000);
const int REGULAR_FONTTYPE = (0x400);
const int SCREEN_FONTTYPE = (0x2000);
const int SIMULATED_FONTTYPE = (0x8000);
const char* COLOROKSTRINGW = ("commdlg_ColorOK");
const char* FILEOKSTRINGW = ("commdlg_FileNameOK");
const char* FINDMSGSTRINGW = ("commdlg_FindReplace");
const char* HELPMSGSTRINGW = ("commdlg_help");
const char* LBSELCHSTRINGW = ("commdlg_LBSelChangedNotify");
const char* SETRGBSTRINGW = ("commdlg_SetRGBColor");
const char* SHAREVISTRINGW = ("commdlg_ShareViolation");
const char* COLOROKSTRINGA = ("commdlg_ColorOK");
const char* FILEOKSTRINGA = ("commdlg_FileNameOK");
const char* FINDMSGSTRINGA = ("commdlg_FindReplace");
const char* HELPMSGSTRINGA = ("commdlg_help");
const char* LBSELCHSTRINGA = ("commdlg_LBSelChangedNotify");
const char* SETRGBSTRINGA = ("commdlg_SetRGBColor");
const char* SHAREVISTRINGA = ("commdlg_ShareViolation");
const char* COLOROKSTRING = (COLOROKSTRINGA);
const char* FILEOKSTRING = (FILEOKSTRINGA);
const char* FINDMSGSTRING = (FINDMSGSTRINGA);
const char* HELPMSGSTRING = (HELPMSGSTRINGA);
const char* LBSELCHSTRING = (LBSELCHSTRINGA);
const char* SETRGBSTRING = (SETRGBSTRINGA);
const char* SHAREVISTRING = (SHAREVISTRINGA);
const int CD_LBSELCHANGE = (0);
const int CD_LBSELADD = (2);
const int CD_LBSELSUB = (1);
const int CD_LBSELNOITEMS = -((1));
const int DN_DEFAULTPRN = (1);
const int PD_ALLPAGES = (0);
const int PD_COLLATE = (16);
const int PD_DISABLEPRINTTOFILE = (524288);
const int PD_ENABLEPRINTHOOK = (4096);
const int PD_ENABLEPRINTTEMPLATE = (16384);
const int PD_ENABLEPRINTTEMPLATEHANDLE = (65536);
const int PD_ENABLESETUPHOOK = (8192);
const int PD_ENABLESETUPTEMPLATE = (32768);
const int PD_ENABLESETUPTEMPLATEHANDLE = (131072);
const int PD_HIDEPRINTTOFILE = (1048576);
const int PD_NOPAGENUMS = (8);
const int PD_NOSELECTION = (4);
const int PD_NOWARNING = (128);
const int PD_PAGENUMS = (2);
const int PD_PRINTSETUP = (64);
const int PD_PRINTTOFILE = (32);
const int PD_RETURNDC = (256);
const int PD_RETURNDEFAULT = (1024);
const int PD_RETURNIC = (512);
const int PD_SELECTION = (1);
const int PD_SHOWHELP = (2048);
const int PD_USEDEVMODECOPIES = (262144);
const int PD_USEDEVMODECOPIESANDCOLLATE = (262144);
const int PSD_DEFAULTMINMARGINS = (0);
const int PSD_DISABLEMARGINS = (16);
const int PSD_DISABLEORIENTATION = (256);
const int PSD_DISABLEPAGEPAINTING = (524288);
const int PSD_DISABLEPAPER = (512);
const int PSD_DISABLEPRINTER = (32);
const int PSD_ENABLEPAGEPAINTHOOK = (262144);
const int PSD_ENABLEPAGESETUPHOOK = (8192);
const int PSD_ENABLEPAGESETUPTEMPLATE = (32768);
const int PSD_ENABLEPAGESETUPTEMPLATEHANDLE = (131072);
const int PSD_INHUNDREDTHSOFMILLIMETERS = (8);
const int PSD_INTHOUSANDTHSOFINCHES = (4);
const int PSD_INWININIINTLMEASURE = (0);
const int PSD_MARGINS = (2);
const int PSD_MINMARGINS = (1);
const int PSD_NOWARNING = (128);
const int PSD_RETURNDEFAULT = (1024);
const int PSD_SHOWHELP = (2048);
const int SW_OTHERUNZOOM = (4);
const int SW_OTHERZOOM = (2);
const int SW_PARENTCLOSING = (1);
const int SW_PARENTOPENING = (3);
const int VK_LBUTTON = (1);
const int VK_RBUTTON = (2);
const int VK_CANCEL = (3);
const int VK_MBUTTON = (4);
const int VK_BACK = (8);
const int VK_TAB = (9);
const int VK_CLEAR = (12);
const int VK_RETURN = (13);
const int VK_SHIFT = (16);
const int VK_CONTROL = (17);
const int VK_MENU = (18);
const int VK_PAUSE = (19);
const int VK_CAPITAL = (20);
const int VK_ESCAPE = (27);
const int VK_SPACE = (32);
const int VK_PRIOR = (33);
const int VK_NEXT = (34);
const int VK_END = (35);
const int VK_HOME = (36);
const int VK_LEFT = (37);
const int VK_UP = (38);
const int VK_RIGHT = (39);
const int VK_DOWN = (40);
const int VK_SELECT = (41);
const int VK_PRINT = (42);
const int VK_EXECUTE = (43);
const int VK_SNAPSHOT = (44);
const int VK_INSERT = (45);
const int VK_DELETE = (46);
const int VK_HELP = (47);
const int VK_0 = (48);
const int VK_1 = (49);
const int VK_2 = (50);
const int VK_3 = (51);
const int VK_4 = (52);
const int VK_5 = (53);
const int VK_6 = (54);
const int VK_7 = (55);
const int VK_8 = (56);
const int VK_9 = (57);
const int VK_A = (65);
const int VK_B = (66);
const int VK_C = (67);
const int VK_D = (68);
const int VK_E = (69);
const int VK_F = (70);
const int VK_G = (71);
const int VK_H = (72);
const int VK_I = (73);
const int VK_J = (74);
const int VK_K = (75);
const int VK_L = (76);
const int VK_M = (77);
const int VK_N = (78);
const int VK_O = (79);
const int VK_P = (80);
const int VK_Q = (81);
const int VK_R = (82);
const int VK_S = (83);
const int VK_T = (84);
const int VK_U = (85);
const int VK_V = (86);
const int VK_W = (87);
const int VK_X = (88);
const int VK_Y = (89);
const int VK_Z = (90);
const int VK_NUMPAD0 = (96);
const int VK_NUMPAD1 = (97);
const int VK_NUMPAD2 = (98);
const int VK_NUMPAD3 = (99);
const int VK_NUMPAD4 = (100);
const int VK_NUMPAD5 = (101);
const int VK_NUMPAD6 = (102);
const int VK_NUMPAD7 = (103);
const int VK_NUMPAD8 = (104);
const int VK_NUMPAD9 = (105);
const int VK_MULTIPLY = (106);
const int VK_ADD = (107);
const int VK_SEPARATOR = (108);
const int VK_SUBTRACT = (109);
const int VK_DECIMAL = (110);
const int VK_DIVIDE = (111);
const int VK_F1 = (112);
const int VK_F2 = (113);
const int VK_F3 = (114);
const int VK_F4 = (115);
const int VK_F5 = (116);
const int VK_F6 = (117);
const int VK_F7 = (118);
const int VK_F8 = (119);
const int VK_F9 = (120);
const int VK_F10 = (121);
const int VK_F11 = (122);
const int VK_F12 = (123);
const int VK_F13 = (124);
const int VK_F14 = (125);
const int VK_F15 = (126);
const int VK_F16 = (127);
const int VK_F17 = (128);
const int VK_F18 = (129);
const int VK_F19 = (130);
const int VK_F20 = (131);
const int VK_F21 = (132);
const int VK_F22 = (133);
const int VK_F23 = (134);
const int VK_F24 = (135);
const int VK_NUMLOCK = (144);
const int VK_SCROLL = (145);
const int VK_LSHIFT = (160);
const int VK_LCONTROL = (162);
const int VK_LMENU = (164);
const int VK_RSHIFT = (161);
const int VK_RCONTROL = (163);
const int VK_RMENU = (165);
const int VK_PROCESSKEY = (229);
const int KF_ALTDOWN = (8192);
const int KF_DLGMODE = (2048);
const int KF_EXTENDED = (256);
const int KF_MENUMODE = (4096);
const int KF_REPEAT = (16384);
const int KF_UP = (32768);
const int KL_NAMELENGTH = (9);
const int WA_ACTIVE = (1);
const int WA_CLICKACTIVE = (2);
const int WA_INACTIVE = (0);
const int PWR_CRITICALRESUME = (3);
const int PWR_SUSPENDREQUEST = (1);
const int PWR_SUSPENDRESUME = (2);
const int PWR_FAIL = -((1));
const int PWR_OK = (1);
const int NF_QUERY = (3);
const int NF_REQUERY = (4);
const int NFR_ANSI = (1);
const int NFR_UNICODE = (2);
const int WMSZ_BOTTOM = (6);
const int WMSZ_BOTTOMLEFT = (7);
const int WMSZ_BOTTOMRIGHT = (8);
const int WMSZ_LEFT = (1);
const int WMSZ_RIGHT = (2);
const int WMSZ_TOP = (3);
const int WMSZ_TOPLEFT = (4);
const int WMSZ_TOPRIGHT = (5);
const int MA_ACTIVATE = (1);
const int MA_ACTIVATEANDEAT = (2);
const int MA_NOACTIVATE = (3);
const int MA_NOACTIVATEANDEAT = (4);
const int SIZE_MAXHIDE = (4);
const int SIZE_MAXIMIZED = (2);
const int SIZE_MAXSHOW = (3);
const int SIZE_MINIMIZED = (1);
const int SIZE_RESTORED = (0);
const int WVR_ALIGNTOP = (16);
const int WVR_ALIGNLEFT = (32);
const int WVR_ALIGNBOTTOM = (64);
const int WVR_ALIGNRIGHT = (128);
const int WVR_HREDRAW = (256);
const int WVR_VREDRAW = (512);
const int WVR_REDRAW = (768);
const int WVR_VALIDRECTS = (1024);
const int HTBOTTOM = (15);
const int HTBOTTOMLEFT = (16);
const int HTBOTTOMRIGHT = (17);
const int HTCAPTION = (2);
const int HTCLIENT = (1);
const int HTERROR = -((2));
const int HTGROWBOX = (4);
const int HTHSCROLL = (6);
const int HTLEFT = (10);
const int HTMENU = (5);
const int HTNOWHERE = (0);
const int HTREDUCE = (8);
const int HTRIGHT = (11);
const int HTSIZE = (4);
const int HTSYSMENU = (3);
const int HTTOP = (12);
const int HTTOPLEFT = (13);
const int HTTOPRIGHT = (14);
const int HTTRANSPARENT = -((1));
const int HTVSCROLL = (7);
const int HTZOOM = (9);
const int MK_CONTROL = (8);
const int MK_LBUTTON = (1);
const int MK_MBUTTON = (16);
const int MK_RBUTTON = (2);
const int MK_SHIFT = (4);
const int CS_BYTEALIGNCLIENT = (4096);
const int CS_BYTEALIGNWINDOW = (8192);
const int CS_CLASSDC = (64);
const int CS_DBLCLKS = (8);
const int CS_GLOBALCLASS = (16384);
const int CS_HREDRAW = (2);
const int CS_KEYCVTWINDOW = (4);
const int CS_NOCLOSE = (512);
const int CS_NOKEYCVT = (256);
const int CS_OWNDC = (32);
const int CS_PARENTDC = (128);
const int CS_SAVEBITS = (2048);
const int CS_VREDRAW = (1);
const int DLGWINDOWEXTRA = (30);
const int FALT = (16);
const int FCONTROL = (8);
const int FNOINVERT = (2);
const int FSHIFT = (4);
const int FVIRTKEY = (1);
const int MIIM_CHECKMARKS = (8);
const int MIIM_DATA = (32);
const int MIIM_ID = (2);
const int MIIM_STATE = (1);
const int MIIM_SUBMENU = (4);
const int MIIM_TYPE = (16);
const int MFT_BITMAP = (0x4);
const int MFT_MENUBARBREAK = (0x20);
const int MFT_MENUBREAK = (0x40);
const int MFT_OWNERDRAW = (0x100);
const int MFT_RADIOCHECK = (0x200);
const int MFT_RIGHTJUSTIFY = (0x4000);
const int MFT_SEPARATOR = (0x800);
const int MFT_STRING = (0);
const int MFS_CHECKED = (0x8);
const int MFS_DEFAULT = (0x1000);
const int MFS_DISABLED = (0x3);
const int MFS_ENABLED = (0);
const int MFS_GRAYED = (0x3);
const int MFS_HILITE = (0x80);
const int MFS_UNCHECKED = (0);
const int MFS_UNHILITE = (0);
const int SERKF_AVAILABLE = (2);
const int SERKF_INDICATOR = (4);
const int SERKF_SERIALKEYSON = (1);
const int FKF_AVAILABLE = (2);
const int FKF_CLICKON = (64);
const int FKF_FILTERKEYSON = (1);
const int FKF_HOTKEYACTIVE = (4);
const int FKF_HOTKEYSOUND = (16);
const int FKF_CONFIRMHOTKEY = (8);
const int FKF_INDICATOR = (32);
const int HELPINFO_MENUITEM = (2);
const int HELPINFO_WINDOW = (1);
const int PRF_CHECKVISIBLE = (0x1);
const int PRF_CHILDREN = (0x10);
const int PRF_CLIENT = (0x4);
const int PRF_ERASEBKGND = (0x8);
const int PRF_NONCLIENT = (0x2);
const int PRF_OWNED = (0x20);
const int HWND_DESKTOP = (0);
const int SC_CLOSE = (61536);
const int SC_CONTEXTHELP = (61824);
const int SC_DEFAULT = (61792);
const int SC_HOTKEY = (61776);
const int SC_HSCROLL = (61568);
const int SC_KEYMENU = (61696);
const int SC_MAXIMIZE = (61488);
const int SC_ZOOM = (61488);
const int SC_MINIMIZE = (61472);
const int SC_ICON = (61472);
const int SC_MONITORPOWER = (61808);
const int SC_MOUSEMENU = (61584);
const int SC_MOVE = (61456);
const int SC_NEXTWINDOW = (61504);
const int SC_PREVWINDOW = (61520);
const int SC_RESTORE = (61728);
const int SC_SCREENSAVE = (61760);
const int SC_SIZE = (61440);
const int SC_TASKLIST = (61744);
const int SC_VSCROLL = (61552);
const int DC_HASDEFID = (21323);
const int DLGC_BUTTON = (8192);
const int DLGC_DEFPUSHBUTTON = (16);
const int DLGC_HASSETSEL = (8);
const int DLGC_RADIOBUTTON = (64);
const int DLGC_STATIC = (256);
const int DLGC_UNDEFPUSHBUTTON = (32);
const int DLGC_WANTALLKEYS = (4);
const int DLGC_WANTARROWS = (1);
const int DLGC_WANTCHARS = (128);
const int DLGC_WANTMESSAGE = (4);
const int DLGC_WANTTAB = (2);
const int EC_LEFTMARGIN = (1);
const int EC_RIGHTMARGIN = (2);
const int EC_USEFONTINFO = (65535);
const int LB_ERR = -((1));
const int LB_ERRSPACE = -((2));
const int LB_OKAY = (0);
const int CB_ERR = -((1));
const int CB_ERRSPACE = -((2));
const int IMC_GETCANDIDATEPOS = (7);
const int IMC_GETCOMPOSITIONFONT = (9);
const int IMC_GETCOMPOSITIONWINDOW = (11);
const int IMC_GETSTATUSWINDOWPOS = (15);
const int IMC_CLOSESTATUSWINDOW = (33);
const int IMC_OPENSTATUSWINDOW = (34);
const int IMC_SETCANDIDATEPOS = (8);
const int IMC_SETCOMPOSITIONFONT = (10);
const int IMC_SETCOMPOSITIONWINDOW = (12);
const int IMC_SETSTATUSWINDOWPOS = (16);
const int IMN_CHANGECANDIDATE = (3);
const int IMN_CLOSECANDIDATE = (4);
const int IMN_CLOSESTATUSWINDOW = (1);
const int IMN_GUIDELINE = (13);
const int IMN_OPENCANDIDATE = (5);
const int IMN_OPENSTATUSWINDOW = (2);
const int IMN_SETCANDIDATEPOS = (9);
const int IMN_SETCOMPOSITIONFONT = (10);
const int IMN_SETCOMPOSITIONWINDOW = (11);
const int IMN_SETCONVERSIONMODE = (6);
const int IMN_SETOPENSTATUS = (8);
const int IMN_SETSENTENCEMODE = (7);
const int IMN_SETSTATUSWINDOWPOS = (12);
const int IMN_PRIVATE = (14);
const int SKF_AUDIBLEFEEDBACK = (64);
const int SKF_AVAILABLE = (2);
const int SKF_CONFIRMHOTKEY = (8);
const int SKF_HOTKEYACTIVE = (4);
const int SKF_HOTKEYSOUND = (16);
const int SKF_INDICATOR = (32);
const int SKF_STICKYKEYSON = (1);
const int SKF_TRISTATE = (128);
const int SKF_TWOKEYSOFF = (256);
const int MKF_AVAILABLE = (2);
const int MKF_CONFIRMHOTKEY = (8);
const int MKF_HOTKEYACTIVE = (4);
const int MKF_HOTKEYSOUND = (16);
const int MKF_INDICATOR = (32);
const int MKF_MOUSEKEYSON = (1);
const int MKF_MODIFIERS = (64);
const int MKF_REPLACENUMBERS = (128);
const int SSF_AVAILABLE = (2);
const int SSF_SOUNDSENTRYON = (1);
const int SSTF_BORDER = (2);
const int SSTF_CHARS = (1);
const int SSTF_DISPLAY = (3);
const int SSTF_NONE = (0);
const int SSGF_DISPLAY = (3);
const int SSGF_NONE = (0);
const int SSWF_CUSTOM = (4);
const int SSWF_DISPLAY = (3);
const int SSWF_NONE = (0);
const int SSWF_TITLE = (1);
const int SSWF_WINDOW = (2);
const int ATF_ONOFFFEEDBACK = (2);
const int ATF_TIMEOUTON = (1);
const int HCF_AVAILABLE = (2);
const int HCF_CONFIRMHOTKEY = (8);
const int HCF_HIGHCONTRASTON = (1);
const int HCF_HOTKEYACTIVE = (4);
const int HCF_HOTKEYAVAILABLE = (64);
const int HCF_HOTKEYSOUND = (16);
const int HCF_INDICATOR = (32);
const int TKF_AVAILABLE = (2);
const int TKF_CONFIRMHOTKEY = (8);
const int TKF_HOTKEYACTIVE = (4);
const int TKF_HOTKEYSOUND = (16);
const int TKF_TOGGLEKEYSON = (1);
const int PP_DISPLAYERRORS = (1);
const int RESOURCEDISPLAYTYPE_DOMAIN = (1);
const int RESOURCEDISPLAYTYPE_FILE = (4);
const int RESOURCEDISPLAYTYPE_GENERIC = (0);
const int RESOURCEDISPLAYTYPE_GROUP = (5);
const int RESOURCEDISPLAYTYPE_SERVER = (2);
const int RESOURCEDISPLAYTYPE_SHARE = (3);
const int CAPSLOCK_ON = (128);
const int ENHANCED_KEY = (256);
const int LEFT_ALT_PRESSED = (2);
const int LEFT_CTRL_PRESSED = (8);
const int NUMLOCK_ON = (32);
const int RIGHT_ALT_PRESSED = (1);
const int RIGHT_CTRL_PRESSED = (4);
const int SCROLLLOCK_ON = (64);
const int SHIFT_PRESSED = (16);
const int FROM_LEFT_1ST_BUTTON_PRESSED = (1);
const int RIGHTMOST_BUTTON_PRESSED = (2);
const int FROM_LEFT_2ND_BUTTON_PRESSED = (4);
const int FROM_LEFT_3RD_BUTTON_PRESSED = (8);
const int FROM_LEFT_4TH_BUTTON_PRESSED = (16);
const int DOUBLE_CLICK = (2);
const int MOUSE_MOVED = (1);
const int KEY_EVENT = (1);
const int _MOUSE_EVENT = (2);
const int cMOUSE_EVENT = (2);
const int WINDOW_BUFFER_SIZE_EVENT = (4);
const int MENU_EVENT = (8);
const int FOCUS_EVENT = (16);
const int BI_RGB = (0);
const int BI_RLE8 = (1);
const int BI_RLE4 = (2);
const int BI_BITFIELDS = (3);
const int PFD_DRAW_TO_WINDOW = (0x4);
const int PFD_DRAW_TO_BITMAP = (0x8);
const int PFD_SUPPORT_GDI = (0x10);
const int PFD_SUPPORT_OPENGL = (0x20);
const int PFD_DOUBLEBUFFER = (0x1);
const int PFD_STEREO = (0x2);
const int PFD_DOUBLEBUFFER_DONTCARE = (0x40000000);
const int PFD_STEREO_DONTCARE = (int)(0x80000000);
const int PFD_TYPE_RGBA = (0);
const int PFD_TYPE_COLORINDEX = (1);
const int PFD_MAIN_PLANE = (0);
const int PFD_OVERLAY_PLANE = (1);
const int PFD_UNDERLAY_PLANE = -((1));
const int WGL_FONT_LINES = (0);
const int WGL_FONT_POLYGONS = (1);
const int PFD_GENERIC_FORMAT = (0x40);
const int PFD_NEED_PALETTE = (0x80);
const int PFD_NEED_SYSTEM_PALETTE = (0x100);
const int PFD_SWAP_COPY = (0x400);
const int PFD_SWAP_EXCHANGE = (0x200);
const int TMPF_FIXED_PITCH = (0x1);
const int TMPF_VECTOR = (0x2);
const int TMPF_TRUETYPE = (0x4);
const int TMPF_DEVICE = (0x8);
const int SE_ERR_SHARE = (26);
const int SE_ERR_ASSOCINCOMPLETE = (27);
const int SE_ERR_DDETIMEOUT = (28);
const int SE_ERR_DDEFAIL = (29);
const int SE_ERR_DDEBUSY = (30);
const int SE_ERR_NOASSOC = (31);
const int XCLASS_BOOL = (0x1000);
const int XCLASS_DATA = (0x2000);
const int XCLASS_FLAGS = (0x4000);
const int XCLASS_MASK = (0xfc00);
const int XCLASS_NOTIFICATION = (0x8000);
const int XTYPF_NOBLOCK = (0x0002);
const int XTYP_ADVDATA = (0x4010);
const int XTYP_ADVREQ = (0x2022);
const int XTYP_ADVSTART = (0x1030);
const int XTYP_ADVSTOP = (0x8040);
const int XTYP_CONNECT = (0x1062);
const int XTYP_CONNECT_CONFIRM = (0x8072);
const int XTYP_DISCONNECT = (0x80c2);
const int XTYP_EXECUTE = (0x4050);
const int XTYP_POKE = (0x4090);
const int XTYP_REQUEST = (0x20b0);
const int XTYP_WILDCONNECT = (0x20E2);
const int XTYP_REGISTER = (0x80A2);
const int XTYP_ERROR = (0x8002);
const int XTYP_XACT_COMPLETE = (0x8080);
const int XTYP_UNREGISTER = (0x80D2);
const int DMLERR_DLL_USAGE = (0x4004);
const int DMLERR_INVALIDPARAMETER = (0x4006);
const int DMLERR_NOTPROCESSED = (0x4009);
const int DMLERR_POSTMSG_FAILED = (0x400c);
const int DMLERR_SERVER_DIED = (0x400e);
const int DMLERR_SYS_ERROR = (0x400f);
const int DMLERR_BUSY = (0x4001);
const int DMLERR_DATAACKTIMEOUT = (0x4002);
const int DMLERR_ADVACKTIMEOUT = (0x4000);
const int DMLERR_DLL_NOT_INITIALIZED = (0x4003);
const int DMLERR_LOW_MEMORY = (0x4007);
const int DMLERR_MEMORY_ERROR = (0x4008);
const int DMLERR_POKEACKTIMEOUT = (0x400b);
const int DMLERR_NO_CONV_ESTABLISHED = (0x400a);
const int DMLERR_REENTRANCY = (0x400d);
const int DMLERR_UNFOUND_QUEUE_ID = (0x4011);
const int DMLERR_UNADVACKTIMEOUT = (0x4010);
const int DMLERR_EXECACKTIMEOUT = (0x4005);
const int DDE_FACK = (0x8000);
const int DDE_FNOTPROCESSED = (0x0000);
const int DNS_REGISTER = (0x0001);
const int DNS_UNREGISTER = (0x0002);
const int CP_WINANSI = (1004);
const int CP_WINUNICODE = (1200);
const int APPCLASS_STANDARD = (0x00000000);
const int BKMODE_LAST = (2);
const int CTLCOLOR_MSGBOX = (0);
const int CTLCOLOR_EDIT = (1);
const int CTLCOLOR_LISTBOX = (2);
const int CTLCOLOR_BTN = (3);
const int CTLCOLOR_DLG = (4);
const int CTLCOLOR_SCROLLBAR = (5);
const int CTLCOLOR_STATIC = (6);
const int CTLCOLOR_MAX = (7);
const int META_SETMAPMODE = (0x0103);
const int META_SETWINDOWORG = (0x020B);
const int META_SETWINDOWEXT = (0x020C);
const int POLYFILL_LAST = (2);
const int STATUS_WAIT_0 = (0x00000000);
const int STATUS_ABANDONED_WAIT_0 = (0x00000080);
const int STATUS_USER_APC = (0x000000C0);
const int STATUS_TIMEOUT = (0x00000102);
const int STATUS_PENDING = (0x00000103);
const int STATUS_GUARD_PAGE_VIOLATION = (int)(0x80000001);
const int STATUS_DATATYPE_MISALIGNMENT = (int)(0x80000002);
const int STATUS_BREAKPOINT = (int)(0x80000003);
const int STATUS_SINGLE_STEP = (int)(0x80000004);
const int STATUS_IN_PAGE_ERROR = (int)(0xC0000006);
const int STATUS_INVALID_HANDLE = (int)(0xC0000008);
const int STATUS_ILLEGAL_INSTRUCTION = (int)(0xC000001D);
const int STATUS_NONCONTINUABLE_EXCEPTION = (int)(0xC0000025);
const int STATUS_INVALID_DISPOSITION = (int)(0xC0000026);
const int STATUS_ARRAY_BOUNDS_EXCEEDED = (int)(0xC000008C);
const int STATUS_FLOAT_DENORMAL_OPERAND = (int)(0xC000008D);
const int STATUS_FLOAT_DIVIDE_BY_ZERO = (int)(0xC000008E);
const int STATUS_FLOAT_INEXACT_RESULT = (int)(0xC000008F);
const int STATUS_FLOAT_INVALID_OPERATION = (int)(0xC0000090);
const int STATUS_FLOAT_OVERFLOW = (int)(0xC0000091);
const int STATUS_FLOAT_STACK_CHECK = (int)(0xC0000092);
const int STATUS_FLOAT_UNDERFLOW = (int)(0xC0000093);
const int STATUS_INTEGER_DIVIDE_BY_ZERO = (int)(0xC0000094);
const int STATUS_INTEGER_OVERFLOW = (int)(0xC0000095);
const int STATUS_PRIVILEGED_INSTRUCTION = (int)(0xC0000096);
const int STATUS_STACK_OVERFLOW = (int)(0xC00000FD);
const int STATUS_CONTROL_C_EXIT = (int)(0xC000013A);
const int PROCESSOR_ARCHITECTURE_INTEL = (0);
const int PROCESSOR_ARCHITECTURE_MIPS = (1);
const int PROCESSOR_ARCHITECTURE_ALPHA = (2);
const int PROCESSOR_ARCHITECTURE_PPC = (3);
const int SIZEFULLSCREEN = (SIZE_MAXIMIZED);
const int SIZENORMAL = (SIZE_RESTORED);
const int SIZEICONIC = (SIZE_MINIMIZED);
const int SIZE_OF_80387_REGISTERS = (80);
const int CONTEXT_i386 = (0x10000);
const int CONTEXT_CONTROL = (CONTEXT_i386) | (1);
const int CONTEXT_INTEGER = (CONTEXT_i386) | (2);
const int CONTEXT_SEGMENTS = (CONTEXT_i386) | (4);
const int CONTEXT_FLOATING_POINT = (CONTEXT_i386) | (8);
const int CONTEXT_DEBUG_REGISTERS = (CONTEXT_i386) | (0x10);
const int CONTEXT_FULL = ((CONTEXT_CONTROL) | (CONTEXT_INTEGER)) | (CONTEXT_SEGMENTS);
const int FLAG_TRACE_BIT = (0x100);
const int CONTEXT_DEBUGGER = (CONTEXT_FULL) | (CONTEXT_FLOATING_POINT);
const int FILTER_TEMP_DUPLICATE_ACCOUNT = (0x0001);
const int FILTER_NORMAL_ACCOUNT = (0x0002);
const int FILTER_INTERDOMAIN_TRUST_ACCOUNT = (0x0008);
const int FILTER_WORKSTATION_TRUST_ACCOUNT = (0x0010);
const int FILTER_SERVER_TRUST_ACCOUNT = (0x0020);
const int LOGON32_LOGON_INTERACTIVE = (0x02);
const int LOGON32_LOGON_BATCH = (0x04);
const int LOGON32_LOGON_SERVICE = (0x05);
const int LOGON32_PROVIDER_DEFAULT = (0x00);
const int LOGON32_PROVIDER_WINNT35 = (0x01);
const int QID_SYNC = (int)(0xFFFFFFFF);
const int IMAGE_DOS_SIGNATURE = (0x5a4d);
const int IMAGE_NT_SIGNATURE = (0x4550);
const int SEVERITY_SUCCESS = (0);
const int SEVERITY_ERROR = (1);
const int VT_EMPTY = (0);
const int VT_NULL = (1);
const int VT_I2 = (2);
const int VT_I4 = (3);
const int VT_R4 = (4);
const int VT_R8 = (5);
const int VT_BSTR = (8);
const int VT_ERROR = (10);
const int VT_BOOL = (11);
const int VT_UI1 = (17);
const int VT_BYREF = (0x4000);
const int VT_RESERVED = (0x8000);
const int FACILITY_WINDOWS = (8);
const int FACILITY_STORAGE = (3);
const int FACILITY_RPC = (1);
const int FACILITY_SSPI = (9);
const int FACILITY_WIN32 = (7);
const int FACILITY_CONTROL = (10);
const int FACILITY_NULL = (0);
const int FACILITY_INTERNET = (12);
const int FACILITY_ITF = (4);
const int FACILITY_DISPATCH = (2);
const int FACILITY_CERT = (11);
const int ACM_OPENW = (1127);
const int ACM_OPENA = (1124);
const int ACM_OPEN = (ACM_OPENA);
const int ACM_PLAY = (1125);
const int ACM_STOP = (1126);
const int ACN_START = (1);
const int ACN_STOP = (2);
const int BM_CLICK = (245);
const int BM_GETCHECK = (240);
const int BM_GETIMAGE = (246);
const int BM_GETSTATE = (242);
const int BM_SETCHECK = (241);
const int BM_SETIMAGE = (247);
const int BM_SETSTATE = (243);
const int BM_SETSTYLE = (244);
const int BN_CLICKED = (0);
const int BN_DBLCLK = (5);
const int BN_DISABLE = (4);
const int BN_DOUBLECLICKED = (5);
const int BN_HILITE = (2);
const int BN_KILLFOCUS = (7);
const int BN_PAINT = (1);
const int BN_PUSHED = (2);
const int BN_SETFOCUS = (6);
const int BN_UNHILITE = (3);
const int BN_UNPUSHED = (3);
const int CB_ADDSTRING = (323);
const int CB_DELETESTRING = (324);
const int CB_DIR = (325);
const int CB_FINDSTRING = (332);
const int CB_FINDSTRINGEXACT = (344);
const int CB_GETCOUNT = (326);
const int CB_GETCURSEL = (327);
const int CB_GETDROPPEDCONTROLRECT = (338);
const int CB_GETDROPPEDSTATE = (343);
const int CB_GETDROPPEDWIDTH = (351);
const int CB_GETEDITSEL = (320);
const int CB_GETEXTENDEDUI = (342);
const int CB_GETHORIZONTALEXTENT = (349);
const int CB_GETITEMDATA = (336);
const int CB_GETITEMHEIGHT = (340);
const int CB_GETLBTEXT = (328);
const int CB_GETLBTEXTLEN = (329);
const int CB_GETLOCALE = (346);
const int CB_GETTOPINDEX = (347);
const int CB_INITSTORAGE = (353);
const int CB_INSERTSTRING = (330);
const int CB_LIMITTEXT = (321);
const int CB_RESETCONTENT = (331);
const int CB_SELECTSTRING = (333);
const int CB_SETCURSEL = (334);
const int CB_SETDROPPEDWIDTH = (352);
const int CB_SETEDITSEL = (322);
const int CB_SETEXTENDEDUI = (341);
const int CB_SETHORIZONTALEXTENT = (350);
const int CB_SETITEMDATA = (337);
const int CB_SETITEMHEIGHT = (339);
const int CB_SETLOCALE = (345);
const int CB_SETTOPINDEX = (348);
const int CB_SHOWDROPDOWN = (335);
const int CBN_CLOSEUP = (8);
const int CBN_DBLCLK = (2);
const int CBN_DROPDOWN = (7);
const int CBN_EDITCHANGE = (5);
const int CBN_EDITUPDATE = (6);
const int CBN_ERRSPACE = -((1));
const int CBN_KILLFOCUS = (4);
const int CBN_SELCHANGE = (1);
const int CBN_SELENDCANCEL = (10);
const int CBN_SELENDOK = (9);
const int CBN_SETFOCUS = (3);
const int DL_BEGINDRAG = (1157);
const int DL_CANCELDRAG = (1160);
const int DL_DRAGGING = (1158);
const int DL_DROPPED = (1159);
const int DM_GETDEFID = (1024);
const int DM_REPOSITION = (1026);
const int DM_SETDEFID = (1025);
const int EM_CANPASTE = (1074);
const int EM_CANUNDO = (198);
const int EM_CHARFROMPOS = (215);
const int EM_DISPLAYBAND = (1075);
const int EM_EMPTYUNDOBUFFER = (205);
const int EM_EXGETSEL = (1076);
const int EM_EXLIMITTEXT = (1077);
const int EM_EXLINEFROMCHAR = (1078);
const int EM_EXSETSEL = (1079);
const int EM_FINDTEXT = (1080);
const int EM_FINDTEXTEX = (1103);
const int EM_FINDWORDBREAK = (1100);
const int EM_FMTLINES = (200);
const int EM_FORMATRANGE = (1081);
const int EM_GETCHARFORMAT = (1082);
const int EM_GETEVENTMASK = (1083);
const int EM_GETFIRSTVISIBLELINE = (206);
const int EM_GETHANDLE = (189);
const int EM_GETLIMITTEXT = (213);
const int EM_GETLINE = (196);
const int EM_GETLINECOUNT = (186);
const int EM_GETMARGINS = (212);
const int EM_GETMODIFY = (184);
const int EM_GETIMECOLOR = (1129);
const int EM_GETIMEOPTIONS = (1131);
const int EM_GETOPTIONS = (1102);
const int EM_GETOLEINTERFACE = (1084);
const int EM_GETPARAFORMAT = (1085);
const int EM_GETPASSWORDCHAR = (210);
const int EM_GETPUNCTUATION = (1125);
const int EM_GETRECT = (178);
const int EM_GETSEL = (176);
const int EM_GETSELTEXT = (1086);
const int EM_GETTEXTRANGE = (1099);
const int EM_GETTHUMB = (190);
const int EM_GETWORDBREAKPROC = (209);
const int EM_GETWORDBREAKPROCEX = (1104);
const int EM_GETWORDWRAPMODE = (1127);
const int EM_HIDESELECTION = (1087);
const int EM_LIMITTEXT = (197);
const int EM_LINEFROMCHAR = (201);
const int EM_LINEINDEX = (187);
const int EM_LINELENGTH = (193);
const int EM_LINESCROLL = (182);
const int EM_PASTESPECIAL = (1088);
const int EM_POSFROMCHAR = (214);
const int EM_REPLACESEL = (194);
const int EM_REQUESTRESIZE = (1089);
const int EM_SCROLL = (181);
const int EM_SCROLLCARET = (183);
const int EM_SELECTIONTYPE = (1090);
const int EM_SETBKGNDCOLOR = (1091);
const int EM_SETCHARFORMAT = (1092);
const int EM_SETEVENTMASK = (1093);
const int EM_SETHANDLE = (188);
const int EM_SETIMECOLOR = (1128);
const int EM_SETIMEOPTIONS = (1130);
const int EM_SETLIMITTEXT = (197);
const int EM_SETMARGINS = (211);
const int EM_SETMODIFY = (185);
const int EM_SETOLECALLBACK = (1094);
const int EM_SETOPTIONS = (1101);
const int EM_SETPARAFORMAT = (1095);
const int EM_SETPASSWORDCHAR = (204);
const int EM_SETPUNCTUATION = (1124);
const int EM_SETREADONLY = (207);
const int EM_SETRECT = (179);
const int EM_SETRECTNP = (180);
const int EM_SETSEL = (177);
const int EM_SETTABSTOPS = (203);
const int EM_SETTARGETDEVICE = (1096);
const int EM_SETWORDBREAKPROC = (208);
const int EM_SETWORDBREAKPROCEX = (1105);
const int EM_SETWORDWRAPMODE = (1126);
const int EM_STREAMIN = (1097);
const int EM_STREAMOUT = (1098);
const int EM_UNDO = (199);
const int EN_CHANGE = (768);
const int EN_CORRECTTEXT = (1797);
const int EN_DROPFILES = (1795);
const int EN_ERRSPACE = (1280);
const int EN_HSCROLL = (1537);
const int EN_IMECHANGE = (1799);
const int EN_KILLFOCUS = (512);
const int EN_MAXTEXT = (1281);
const int EN_MSGFILTER = (1792);
const int EN_OLEOPFAILED = (1801);
const int EN_PROTECTED = (1796);
const int EN_REQUESTRESIZE = (1793);
const int EN_SAVECLIPBOARD = (1800);
const int EN_SELCHANGE = (1794);
const int EN_SETFOCUS = (256);
const int EN_STOPNOUNDO = (1798);
const int EN_UPDATE = (1024);
const int EN_VSCROLL = (1538);
const int HDM_DELETEITEM = (4610);
const int HDM_GETITEMW = (4619);
const int HDM_INSERTITEMW = (4618);
const int HDM_SETITEMW = (4620);
const int HDM_GETITEMA = (4611);
const int HDM_INSERTITEMA = (4609);
const int HDM_SETITEMA = (4612);
const int HDM_GETITEM = (HDM_GETITEMA);
const int HDM_INSERTITEM = (HDM_INSERTITEMA);
const int HDM_SETITEM = (HDM_SETITEMA);
const int HDM_GETITEMCOUNT = (4608);
const int HDM_HITTEST = (4614);
const int HDM_LAYOUT = (4613);
const int HDN_BEGINTRACKW = -((326));
const int HDN_DIVIDERDBLCLICKW = -((325));
const int HDN_ENDTRACKW = -((327));
const int HDN_ITEMCHANGEDW = -((321));
const int HDN_ITEMCHANGINGW = -((320));
const int HDN_ITEMCLICKW = -((322));
const int HDN_ITEMDBLCLICKW = -((323));
const int HDN_TRACKW = -((328));
const int HDN_BEGINTRACKA = -((306));
const int HDN_DIVIDERDBLCLICKA = -((305));
const int HDN_ENDTRACKA = -((307));
const int HDN_ITEMCHANGEDA = -((301));
const int HDN_ITEMCHANGINGA = -((300));
const int HDN_ITEMCLICKA = -((302));
const int HDN_ITEMDBLCLICKA = -((303));
const int HDN_TRACKA = -((308));
const int HDN_BEGINTRACK = (HDN_BEGINTRACKA);
const int HDN_DIVIDERDBLCLICK = (HDN_DIVIDERDBLCLICKA);
const int HDN_ENDTRACK = (HDN_ENDTRACKA);
const int HDN_ITEMCHANGED = (HDN_ITEMCHANGEDA);
const int HDN_ITEMCHANGING = (HDN_ITEMCHANGINGA);
const int HDN_ITEMCLICK = (HDN_ITEMCLICKA);
const int HDN_ITEMDBLCLICK = (HDN_ITEMDBLCLICKA);
const int HDN_TRACK = (HDN_TRACKA);
const int HKM_GETHOTKEY = (1026);
const int HKM_SETHOTKEY = (1025);
const int HKM_SETRULES = (1027);
const int LB_ADDFILE = (406);
const int LB_ADDSTRING = (384);
const int LB_DELETESTRING = (386);
const int LB_DIR = (397);
const int LB_FINDSTRING = (399);
const int LB_FINDSTRINGEXACT = (418);
const int LB_GETANCHORINDEX = (413);
const int LB_GETCARETINDEX = (415);
const int LB_GETCOUNT = (395);
const int LB_GETCURSEL = (392);
const int LB_GETHORIZONTALEXTENT = (403);
const int LB_GETITEMDATA = (409);
const int LB_GETITEMHEIGHT = (417);
const int LB_GETITEMRECT = (408);
const int LB_GETLOCALE = (422);
const int LB_GETSEL = (391);
const int LB_GETSELCOUNT = (400);
const int LB_GETSELITEMS = (401);
const int LB_GETTEXT = (393);
const int LB_GETTEXTLEN = (394);
const int LB_GETTOPINDEX = (398);
const int LB_INITSTORAGE = (424);
const int LB_INSERTSTRING = (385);
const int LB_ITEMFROMPOINT = (425);
const int LB_RESETCONTENT = (388);
const int LB_SELECTSTRING = (396);
const int LB_SELITEMRANGE = (411);
const int LB_SELITEMRANGEEX = (387);
const int LB_SETANCHORINDEX = (412);
const int LB_SETCARETINDEX = (414);
const int LB_SETCOLUMNWIDTH = (405);
const int LB_SETCOUNT = (423);
const int LB_SETCURSEL = (390);
const int LB_SETHORIZONTALEXTENT = (404);
const int LB_SETITEMDATA = (410);
const int LB_SETITEMHEIGHT = (416);
const int LB_SETLOCALE = (421);
const int LB_SETSEL = (389);
const int LB_SETTABSTOPS = (402);
const int LB_SETTOPINDEX = (407);
const int LBN_DBLCLK = (2);
const int LBN_ERRSPACE = -((2));
const int LBN_KILLFOCUS = (5);
const int LBN_SELCANCEL = (3);
const int LBN_SELCHANGE = (1);
const int LBN_SETFOCUS = (4);
const int LVM_ARRANGE = (4118);
const int LVM_CREATEDRAGIMAGE = (4129);
const int LVM_DELETEALLITEMS = (4105);
const int LVM_DELETECOLUMN = (4124);
const int LVM_DELETEITEM = (4104);
const int LVM_ENSUREVISIBLE = (4115);
const int LVM_GETBKCOLOR = (4096);
const int LVM_GETCALLBACKMASK = (4106);
const int LVM_GETCOLUMNWIDTH = (4125);
const int LVM_GETCOUNTPERPAGE = (4136);
const int LVM_GETEDITCONTROL = (4120);
const int LVM_GETIMAGELIST = (4098);
const int LVM_EDITLABELW = (4214);
const int LVM_FINDITEMW = (4179);
const int LVM_GETCOLUMNW = (4191);
const int LVM_GETISEARCHSTRINGW = (4213);
const int LVM_GETITEMW = (4171);
const int LVM_GETITEMTEXTW = (4211);
const int LVM_GETSTRINGWIDTHW = (4183);
const int LVM_INSERTCOLUMNW = (4193);
const int LVM_INSERTITEMW = (4173);
const int LVM_SETCOLUMNW = (4192);
const int LVM_SETITEMW = (4172);
const int LVM_SETITEMTEXTW = (4212);
const int LVM_EDITLABELA = (4119);
const int LVM_FINDITEMA = (4109);
const int LVM_GETCOLUMNA = (4121);
const int LVM_GETISEARCHSTRINGA = (4148);
const int LVM_GETITEMA = (4101);
const int LVM_GETITEMTEXTA = (4141);
const int LVM_GETSTRINGWIDTHA = (4113);
const int LVM_INSERTCOLUMNA = (4123);
const int LVM_INSERTITEMA = (4103);
const int LVM_SETCOLUMNA = (4122);
const int LVM_SETITEMA = (4102);
const int LVM_SETITEMTEXTA = (4142);
const int LVM_EDITLABEL = (LVM_EDITLABELA);
const int LVM_FINDITEM = (LVM_FINDITEMA);
const int LVM_GETCOLUMN = (LVM_GETCOLUMNA);
const int LVM_GETISEARCHSTRING = (LVM_GETISEARCHSTRINGA);
const int LVM_GETITEM = (LVM_GETITEMA);
const int LVM_GETITEMTEXT = (LVM_GETITEMTEXTA);
const int LVM_GETSTRINGWIDTH = (LVM_GETSTRINGWIDTHA);
const int LVM_INSERTCOLUMN = (LVM_INSERTCOLUMNA);
const int LVM_INSERTITEM = (LVM_INSERTITEMA);
const int LVM_SETCOLUMN = (LVM_SETCOLUMNA);
const int LVM_SETITEM = (LVM_SETITEMA);
const int LVM_SETITEMTEXT = (LVM_SETITEMTEXTA);
const int LVM_GETITEMCOUNT = (4100);
const int LVM_GETITEMPOSITION = (4112);
const int LVM_GETITEMRECT = (4110);
const int LVM_GETITEMSPACING = (4147);
const int LVM_GETITEMSTATE = (4140);
const int LVM_GETNEXTITEM = (4108);
const int LVM_GETORIGIN = (4137);
const int LVM_GETSELECTEDCOUNT = (4146);
const int LVM_GETTEXTBKCOLOR = (4133);
const int LVM_GETTEXTCOLOR = (4131);
const int LVM_GETTOPINDEX = (4135);
const int LVM_GETVIEWRECT = (4130);
const int LVM_HITTEST = (4114);
const int LVM_REDRAWITEMS = (4117);
const int LVM_SCROLL = (4116);
const int LVM_SETBKCOLOR = (4097);
const int LVM_SETCALLBACKMASK = (4107);
const int LVM_SETCOLUMNWIDTH = (4126);
const int LVM_SETIMAGELIST = (4099);
const int LVM_SETITEMCOUNT = (4143);
const int LVM_SETITEMPOSITION = (4111);
const int LVM_SETITEMPOSITION32 = (4145);
const int LVM_SETITEMSTATE = (4139);
const int LVM_SETTEXTBKCOLOR = (4134);
const int LVM_SETTEXTCOLOR = (4132);
const int LVM_SORTITEMS = (4144);
const int LVM_UPDATE = (4138);
const int LVN_BEGINDRAG = -((109));
const int LVN_BEGINRDRAG = -((111));
const int LVN_COLUMNCLICK = -((108));
const int LVN_DELETEALLITEMS = -((104));
const int LVN_DELETEITEM = -((103));
const int LVN_BEGINLABELEDITW = -((175));
const int LVN_ENDLABELEDITW = -((176));
const int LVN_GETDISPINFOW = -((177));
const int LVN_SETDISPINFOW = -((178));
const int LVN_BEGINLABELEDITA = -((105));
const int LVN_ENDLABELEDITA = -((106));
const int LVN_GETDISPINFOA = -((150));
const int LVN_SETDISPINFOA = -((151));
const int LVN_BEGINLABELEDIT = (LVN_BEGINLABELEDITA);
const int LVN_ENDLABELEDIT = (LVN_ENDLABELEDITA);
const int LVN_GETDISPINFO = (LVN_GETDISPINFOA);
const int LVN_SETDISPINFO = (LVN_SETDISPINFOA);
const int LVN_INSERTITEM = -((102));
const int LVN_ITEMCHANGED = -((101));
const int LVN_ITEMCHANGING = -((100));
const int LVN_KEYDOWN = -((155));
const int NM_CLICK = -((2));
const int NM_DBLCLK = -((3));
const int NM_KILLFOCUS = -((8));
const int NM_OUTOFMEMORY = -((1));
const int NM_RCLICK = -((5));
const int NM_RDBLCLK = -((6));
const int NM_RETURN = -((4));
const int NM_SETFOCUS = -((7));
const int PBM_DELTAPOS = (1027);
const int PBM_SETPOS = (1026);
const int PBM_SETRANGE = (1025);
const int PBM_SETSTEP = (1028);
const int PBM_STEPIT = (1029);
const int PSM_ADDPAGE = (1127);
const int PSM_APPLY = (1134);
const int PSM_CANCELTOCLOSE = (1131);
const int PSM_CHANGED = (1128);
const int PSM_GETTABCONTROL = (1140);
const int PSM_GETCURRENTPAGEHWND = (1142);
const int PSM_ISDIALOGMESSAGE = (1141);
const int PSM_PRESSBUTTON = (1137);
const int PSM_QUERYSIBLINGS = (1132);
const int PSM_REBOOTSYSTEM = (1130);
const int PSM_REMOVEPAGE = (1126);
const int PSM_RESTARTWINDOWS = (1129);
const int PSM_SETCURSEL = (1125);
const int PSM_SETCURSELID = (1138);
const int PSM_SETFINISHTEXTW = (1145);
const int PSM_SETTITLEW = (1144);
const int PSM_SETFINISHTEXTA = (1139);
const int PSM_SETTITLEA = (1135);
const int PSM_SETFINISHTEXT = (PSM_SETFINISHTEXTA);
const int PSM_SETTITLE = (PSM_SETTITLEA);
const int PSM_SETWIZBUTTONS = (1136);
const int PSM_UNCHANGED = (1133);
const int PSN_APPLY = -((202));
const int PSN_HELP = -((205));
const int PSN_KILLACTIVE = -((201));
const int PSN_QUERYCANCEL = -((209));
const int PSN_RESET = -((203));
const int PSN_SETACTIVE = -((200));
const int PSN_WIZBACK = -((206));
const int PSN_WIZFINISH = -((208));
const int PSN_WIZNEXT = -((207));
const int SB_GETBORDERS = (1031);
const int SB_GETPARTS = (1030);
const int SB_GETRECT = (1034);
const int SB_GETTEXTW = (1037);
const int SB_GETTEXTLENGTHW = (1036);
const int SB_SETTEXTW = (1035);
const int SB_GETTEXTA = (1026);
const int SB_GETTEXTLENGTHA = (1027);
const int SB_SETTEXTA = (1025);
const int SB_GETTEXT = (SB_GETTEXTA);
const int SB_GETTEXTLENGTH = (SB_GETTEXTLENGTHA);
const int SB_SETTEXT = (SB_SETTEXTA);
const int SB_SETMINHEIGHT = (1032);
const int SB_SETPARTS = (1028);
const int SB_SIMPLE = (1033);
const int SBM_ENABLE_ARROWS = (228);
const int SBM_GETPOS = (225);
const int SBM_GETRANGE = (227);
const int SBM_GETSCROLLINFO = (234);
const int SBM_SETPOS = (224);
const int SBM_SETRANGE = (226);
const int SBM_SETRANGEREDRAW = (230);
const int SBM_SETSCROLLINFO = (233);
const int STM_GETICON = (369);
const int STM_GETIMAGE = (371);
const int STM_SETICON = (368);
const int STM_SETIMAGE = (370);
const int STN_CLICKED = (0);
const int STN_DBLCLK = (1);
const int STN_DISABLE = (3);
const int STN_ENABLE = (2);
const int TB_ADDBITMAP = (1043);
const int TB_ADDBUTTONS = (1044);
const int TB_AUTOSIZE = (1057);
const int TB_BUTTONCOUNT = (1048);
const int TB_BUTTONSTRUCTSIZE = (1054);
const int TB_CHANGEBITMAP = (1067);
const int TB_CHECKBUTTON = (1026);
const int TB_COMMANDTOINDEX = (1049);
const int TB_CUSTOMIZE = (1051);
const int TB_DELETEBUTTON = (1046);
const int TB_ENABLEBUTTON = (1025);
const int TB_GETBITMAP = (1068);
const int TB_GETBITMAPFLAGS = (1065);
const int TB_GETBUTTON = (1047);
const int TB_ADDSTRINGW = (1101);
const int TB_GETBUTTONTEXTW = (1099);
const int TB_SAVERESTOREW = (1100);
const int TB_ADDSTRINGA = (1052);
const int TB_GETBUTTONTEXTA = (1069);
const int TB_SAVERESTOREA = (1050);
const int TB_ADDSTRING = (TB_ADDSTRINGA);
const int TB_GETBUTTONTEXT = (TB_GETBUTTONTEXTA);
const int TB_SAVERESTORE = (TB_SAVERESTOREA);
const int TB_GETITEMRECT = (1053);
const int TB_GETROWS = (1064);
const int TB_GETSTATE = (1042);
const int TB_GETTOOLTIPS = (1059);
const int TB_HIDEBUTTON = (1028);
const int TB_INDETERMINATE = (1029);
const int TB_INSERTBUTTON = (1045);
const int TB_ISBUTTONCHECKED = (1034);
const int TB_ISBUTTONENABLED = (1033);
const int TB_ISBUTTONHIDDEN = (1036);
const int TB_ISBUTTONINDETERMINATE = (1037);
const int TB_ISBUTTONPRESSED = (1035);
const int TB_PRESSBUTTON = (1027);
const int TB_SETBITMAPSIZE = (1056);
const int TB_SETBUTTONSIZE = (1055);
const int TB_SETCMDID = (1066);
const int TB_SETPARENT = (1061);
const int TB_SETROWS = (1063);
const int TB_SETSTATE = (1041);
const int TB_SETTOOLTIPS = (1060);
const int TBM_CLEARSEL = (1043);
const int TBM_CLEARTICS = (1033);
const int TBM_GETCHANNELRECT = (1050);
const int TBM_GETLINESIZE = (1048);
const int TBM_GETNUMTICS = (1040);
const int TBM_GETPAGESIZE = (1046);
const int TBM_GETPOS = (1024);
const int TBM_GETPTICS = (1038);
const int TBM_GETRANGEMAX = (1026);
const int TBM_GETRANGEMIN = (1025);
const int TBM_GETSELEND = (1042);
const int TBM_GETSELSTART = (1041);
const int TBM_GETTHUMBLENGTH = (1052);
const int TBM_GETTHUMBRECT = (1049);
const int TBM_GETTIC = (1027);
const int TBM_GETTICPOS = (1039);
const int TBM_SETLINESIZE = (1047);
const int TBM_SETPAGESIZE = (1045);
const int TBM_SETPOS = (1029);
const int TBM_SETRANGE = (1030);
const int TBM_SETRANGEMAX = (1032);
const int TBM_SETRANGEMIN = (1031);
const int TBM_SETSEL = (1034);
const int TBM_SETSELEND = (1036);
const int TBM_SETSELSTART = (1035);
const int TBM_SETTHUMBLENGTH = (1051);
const int TBM_SETTIC = (1028);
const int TBM_SETTICFREQ = (1044);
const int TBN_BEGINADJUST = -((703));
const int TBN_BEGINDRAG = -((701));
const int TBN_CUSTHELP = -((709));
const int TBN_ENDADJUST = -((704));
const int TBN_ENDDRAG = -((702));
const int TBN_GETBUTTONINFOW = -((720));
const int TBN_GETBUTTONINFOA = -((700));
const int TBN_GETBUTTONINFO = (TBN_GETBUTTONINFOA);
const int TBN_QUERYDELETE = -((707));
const int TBN_QUERYINSERT = -((706));
const int TBN_RESET = -((705));
const int TBN_TOOLBARCHANGE = -((708));
const int TCM_ADJUSTRECT = (4904);
const int TCM_DELETEALLITEMS = (4873);
const int TCM_DELETEITEM = (4872);
const int TCM_GETCURFOCUS = (4911);
const int TCM_GETCURSEL = (4875);
const int TCM_GETIMAGELIST = (4866);
const int TCM_GETITEMW = (4924);
const int TCM_INSERTITEMW = (4926);
const int TCM_SETITEMW = (4925);
const int TCM_GETITEMA = (4869);
const int TCM_INSERTITEMA = (4871);
const int TCM_SETITEMA = (4870);
const int TCM_GETITEM = (TCM_GETITEMA);
const int TCM_INSERTITEM = (TCM_INSERTITEMA);
const int TCM_SETITEM = (TCM_SETITEMA);
const int TCM_GETITEMCOUNT = (4868);
const int TCM_GETITEMRECT = (4874);
const int TCM_GETROWCOUNT = (4908);
const int TCM_GETTOOLTIPS = (4909);
const int TCM_HITTEST = (4877);
const int TCM_REMOVEIMAGE = (4906);
const int TCM_SETCURFOCUS = (4912);
const int TCM_SETCURSEL = (4876);
const int TCM_SETIMAGELIST = (4867);
const int TCM_SETITEMEXTRA = (4878);
const int TCM_SETITEMSIZE = (4905);
const int TCM_SETPADDING = (4907);
const int TCM_SETTOOLTIPS = (4910);
const int TCN_KEYDOWN = -((550));
const int TCN_SELCHANGE = -((551));
const int TCN_SELCHANGING = -((552));
const int TTM_ACTIVATE = (1025);
const int TTM_ADDTOOLW = (1074);
const int TTM_DELTOOLW = (1075);
const int TTM_ENUMTOOLSW = (1082);
const int TTM_GETCURRENTTOOLW = (1083);
const int TTM_GETTEXTW = (1080);
const int TTM_GETTOOLINFOW = (1077);
const int TTM_HITTESTW = (1079);
const int TTM_NEWTOOLRECTW = (1076);
const int TTM_SETTOOLINFOW = (1078);
const int TTM_UPDATETIPTEXTW = (1081);
const int TTM_ADDTOOLA = (1028);
const int TTM_DELTOOLA = (1029);
const int TTM_ENUMTOOLSA = (1038);
const int TTM_GETCURRENTTOOLA = (1039);
const int TTM_GETTEXTA = (1035);
const int TTM_GETTOOLINFOA = (1032);
const int TTM_HITTESTA = (1034);
const int TTM_NEWTOOLRECTA = (1030);
const int TTM_SETTOOLINFOA = (1033);
const int TTM_UPDATETIPTEXTA = (1036);
const int TTM_ADDTOOL = (TTM_ADDTOOLA);
const int TTM_DELTOOL = (TTM_DELTOOLA);
const int TTM_ENUMTOOLS = (TTM_ENUMTOOLSA);
const int TTM_GETCURRENTTOOL = (TTM_GETCURRENTTOOLA);
const int TTM_GETTEXT = (TTM_GETTEXTA);
const int TTM_GETTOOLINFO = (TTM_GETTOOLINFOA);
const int TTM_HITTEST = (TTM_HITTESTA);
const int TTM_NEWTOOLRECT = (TTM_NEWTOOLRECTA);
const int TTM_SETTOOLINFO = (TTM_SETTOOLINFOA);
const int TTM_UPDATETIPTEXT = (TTM_UPDATETIPTEXTA);
const int TTM_GETTOOLCOUNT = (1037);
const int TTM_RELAYEVENT = (1031);
const int TTM_SETDELAYTIME = (1027);
const int TTM_WINDOWFROMPOINT = (1040);
const int TTN_NEEDTEXTW = -((530));
const int TTN_NEEDTEXTA = -((520));
const int TTN_NEEDTEXT = (TTN_NEEDTEXTA);
const int TTN_POP = -((522));
const int TTN_SHOW = -((521));
const int TVM_CREATEDRAGIMAGE = (4370);
const int TVM_DELETEITEM = (4353);
const int TVM_ENDEDITLABELNOW = (4374);
const int TVM_ENSUREVISIBLE = (4372);
const int TVM_EXPAND = (4354);
const int TVM_GETCOUNT = (4357);
const int TVM_GETEDITCONTROL = (4367);
const int TVM_GETIMAGELIST = (4360);
const int TVM_GETINDENT = (4358);
const int TVM_GETITEMRECT = (4356);
const int TVM_GETNEXTITEM = (4362);
const int TVM_GETVISIBLECOUNT = (4368);
const int TVM_HITTEST = (4369);
const int TVM_EDITLABELW = (4417);
const int TVM_GETISEARCHSTRINGW = (4416);
const int TVM_GETITEMW = (4414);
const int TVM_INSERTITEMW = (4402);
const int TVM_SETITEMW = (4415);
const int TVM_EDITLABELA = (4366);
const int TVM_GETISEARCHSTRINGA = (4375);
const int TVM_GETITEMA = (4364);
const int TVM_INSERTITEMA = (4352);
const int TVM_SETITEMA = (4365);
const int TVM_EDITLABEL = (TVM_EDITLABELA);
const int TVM_GETISEARCHSTRING = (TVM_GETISEARCHSTRINGA);
const int TVM_GETITEM = (TVM_GETITEMA);
const int TVM_INSERTITEM = (TVM_INSERTITEMA);
const int TVM_SETITEM = (TVM_SETITEMA);
const int TVM_SELECTITEM = (4363);
const int TVM_SETIMAGELIST = (4361);
const int TVM_SETINDENT = (4359);
const int TVM_SORTCHILDREN = (4371);
const int TVM_SORTCHILDRENCB = (4373);
const int TVN_KEYDOWN = -((412));
const int TVN_BEGINDRAGW = -((456));
const int TVN_BEGINLABELEDITW = -((459));
const int TVN_BEGINRDRAGW = -((457));
const int TVN_DELETEITEMW = -((458));
const int TVN_ENDLABELEDITW = -((460));
const int TVN_GETDISPINFOW = -((452));
const int TVN_ITEMEXPANDEDW = -((455));
const int TVN_ITEMEXPANDINGW = -((454));
const int TVN_SELCHANGEDW = -((451));
const int TVN_SELCHANGINGW = -((450));
const int TVN_SETDISPINFOW = -((453));
const int TVN_BEGINDRAGA = -((407));
const int TVN_BEGINLABELEDITA = -((410));
const int TVN_BEGINRDRAGA = -((408));
const int TVN_DELETEITEMA = -((409));
const int TVN_ENDLABELEDITA = -((411));
const int TVN_GETDISPINFOA = -((403));
const int TVN_ITEMEXPANDEDA = -((406));
const int TVN_ITEMEXPANDINGA = -((405));
const int TVN_SELCHANGEDA = -((402));
const int TVN_SELCHANGINGA = -((401));
const int TVN_SETDISPINFOA = -((404));
const int TVN_BEGINDRAG = (TVN_BEGINDRAGA);
const int TVN_BEGINLABELEDIT = (TVN_BEGINLABELEDITA);
const int TVN_BEGINRDRAG = (TVN_BEGINRDRAGA);
const int TVN_DELETEITEM = (TVN_DELETEITEMA);
const int TVN_ENDLABELEDIT = (TVN_ENDLABELEDITA);
const int TVN_GETDISPINFO = (TVN_GETDISPINFOA);
const int TVN_ITEMEXPANDED = (TVN_ITEMEXPANDEDA);
const int TVN_ITEMEXPANDING = (TVN_ITEMEXPANDINGA);
const int TVN_SELCHANGED = (TVN_SELCHANGEDA);
const int TVN_SELCHANGING = (TVN_SELCHANGINGA);
const int TVN_SETDISPINFO = (TVN_SETDISPINFOA);
const int UDM_GETACCEL = (1132);
const int UDM_GETBASE = (1134);
const int UDM_GETBUDDY = (1130);
const int UDM_GETPOS = (1128);
const int UDM_GETRANGE = (1126);
const int UDM_SETACCEL = (1131);
const int UDM_SETBASE = (1133);
const int UDM_SETBUDDY = (1129);
const int UDM_SETPOS = (1127);
const int UDM_SETRANGE = (1125);
const int UDN_DELTAPOS = -((722));
const int WM_ACTIVATE = (6);
const int WM_ACTIVATEAPP = (28);
const int WM_ASKCBFORMATNAME = (780);
const int WM_CANCELJOURNAL = (75);
const int WM_CANCELMODE = (31);
const int WM_CAPTURECHANGED = (533);
const int WM_CHANGECBCHAIN = (781);
const int WM_CHAR = (258);
const int WM_CHARTOITEM = (47);
const int WM_CHILDACTIVATE = (34);
const int WM_CHOOSEFONT_GETLOGFONT = (1025);
const int WM_CHOOSEFONT_SETLOGFONT = (1125);
const int WM_CHOOSEFONT_SETFLAGS = (1126);
const int WM_CLEAR = (771);
const int WM_CLOSE = (16);
const int WM_COMMAND = (273);
const int WM_COMPACTING = (65);
const int WM_COMPAREITEM = (57);
const int WM_CONTEXTMENU = (123);
const int WM_COPY = (769);
const int WM_COPYDATA = (74);
const int WM_CREATE = (1);
const int WM_CTLCOLORBTN = (309);
const int WM_CTLCOLORDLG = (310);
const int WM_CTLCOLOREDIT = (307);
const int WM_CTLCOLORLISTBOX = (308);
const int WM_CTLCOLORMSGBOX = (306);
const int WM_CTLCOLORSCROLLBAR = (311);
const int WM_CTLCOLORSTATIC = (312);
const int WM_CUT = (768);
const int WM_DEADCHAR = (259);
const int WM_DELETEITEM = (45);
const int WM_DESTROY = (2);
const int WM_DESTROYCLIPBOARD = (775);
const int WM_DEVICECHANGE = (537);
const int WM_DEVMODECHANGE = (27);
const int WM_DISPLAYCHANGE = (126);
const int WM_DRAWCLIPBOARD = (776);
const int WM_DRAWITEM = (43);
const int WM_DROPFILES = (563);
const int WM_ENABLE = (10);
const int WM_ENDSESSION = (22);
const int WM_ENTERIDLE = (289);
const int WM_ENTERMENULOOP = (529);
const int WM_ENTERSIZEMOVE = (561);
const int WM_ERASEBKGND = (20);
const int WM_EXITMENULOOP = (530);
const int WM_EXITSIZEMOVE = (562);
const int WM_FONTCHANGE = (29);
const int WM_GETDLGCODE = (135);
const int WM_GETFONT = (49);
const int WM_GETHOTKEY = (51);
const int WM_GETICON = (127);
const int WM_GETMINMAXINFO = (36);
const int WM_GETTEXT = (13);
const int WM_GETTEXTLENGTH = (14);
const int WM_HELP = (83);
const int WM_HOTKEY = (786);
const int WM_HSCROLL = (276);
const int WM_HSCROLLCLIPBOARD = (782);
const int WM_ICONERASEBKGND = (39);
const int WM_IME_CHAR = (646);
const int WM_IME_COMPOSITION = (271);
const int WM_IME_COMPOSITIONFULL = (644);
const int WM_IME_CONTROL = (643);
const int WM_IME_ENDCOMPOSITION = (270);
const int WM_IME_KEYDOWN = (656);
const int WM_IME_KEYUP = (657);
const int WM_IME_NOTIFY = (642);
const int WM_IME_SELECT = (645);
const int WM_IME_SETCONTEXT = (641);
const int WM_IME_STARTCOMPOSITION = (269);
const int WM_INITDIALOG = (272);
const int WM_INITMENU = (278);
const int WM_INITMENUPOPUP = (279);
const int WM_INPUTLANGCHANGE = (81);
const int WM_INPUTLANGCHANGEREQUEST = (80);
const int WM_KEYDOWN = (256);
const int WM_KEYUP = (257);
const int WM_KILLFOCUS = (8);
const int WM_LBUTTONDBLCLK = (515);
const int WM_LBUTTONDOWN = (513);
const int WM_LBUTTONUP = (514);
const int WM_MBUTTONDBLCLK = (521);
const int WM_MBUTTONDOWN = (519);
const int WM_MBUTTONUP = (520);
const int WM_MDIACTIVATE = (546);
const int WM_MDICASCADE = (551);
const int WM_MDICREATE = (544);
const int WM_MDIDESTROY = (545);
const int WM_MDIGETACTIVE = (553);
const int WM_MDIICONARRANGE = (552);
const int WM_MDIMAXIMIZE = (549);
const int WM_MDINEXT = (548);
const int WM_MDIREFRESHMENU = (564);
const int WM_MDIRESTORE = (547);
const int WM_MDISETMENU = (560);
const int WM_MDITILE = (550);
const int WM_MEASUREITEM = (44);
const int WM_MENUCHAR = (288);
const int WM_MENUSELECT = (287);
const int WM_MOUSEACTIVATE = (33);
const int WM_MOUSEMOVE = (512);
const int WM_MOVE = (3);
const int WM_MOVING = (534);
const int WM_NCACTIVATE = (134);
const int WM_NCCALCSIZE = (131);
const int WM_NCCREATE = (129);
const int WM_NCDESTROY = (130);
const int WM_NCHITTEST = (132);
const int WM_NCLBUTTONDBLCLK = (163);
const int WM_NCLBUTTONDOWN = (161);
const int WM_NCLBUTTONUP = (162);
const int WM_NCMBUTTONDBLCLK = (169);
const int WM_NCMBUTTONDOWN = (167);
const int WM_NCMBUTTONUP = (168);
const int WM_NCMOUSEMOVE = (160);
const int WM_NCPAINT = (133);
const int WM_NCRBUTTONDBLCLK = (166);
const int WM_NCRBUTTONDOWN = (164);
const int WM_NCRBUTTONUP = (165);
const int WM_NEXTDLGCTL = (40);
const int WM_NOTIFY = (78);
const int WM_NOTIFYFORMAT = (85);
const int WM_NULL = (0);
const int WM_PAINT = (15);
const int WM_PAINTCLIPBOARD = (777);
const int WM_PAINTICON = (38);
const int WM_PALETTECHANGED = (785);
const int WM_PALETTEISCHANGING = (784);
const int WM_PARENTNOTIFY = (528);
const int WM_PASTE = (770);
const int WM_PENWINFIRST = (896);
const int WM_PENWINLAST = (911);
const int WM_POWER = (72);
const int WM_POWERBROADCAST = (536);
const int WM_PRINT = (791);
const int WM_PRINTCLIENT = (792);
const int WM_PSD_ENVSTAMPRECT = (1029);
const int WM_PSD_FULLPAGERECT = (1025);
const int WM_PSD_GREEKTEXTRECT = (1028);
const int WM_PSD_MARGINRECT = (1027);
const int WM_PSD_MINMARGINRECT = (1026);
const int WM_PSD_PAGESETUPDLG = (1024);
const int WM_PSD_YAFULLPAGERECT = (1030);
const int WM_QUERYDRAGICON = (55);
const int WM_QUERYENDSESSION = (17);
const int WM_QUERYNEWPALETTE = (783);
const int WM_QUERYOPEN = (19);
const int WM_QUEUESYNC = (35);
const int WM_QUIT = (18);
const int WM_RBUTTONDBLCLK = (518);
const int WM_RBUTTONDOWN = (516);
const int WM_RBUTTONUP = (517);
const int WM_RENDERALLFORMATS = (774);
const int WM_RENDERFORMAT = (773);
const int WM_SETCURSOR = (32);
const int WM_SETFOCUS = (7);
const int WM_SETFONT = (48);
const int WM_SETHOTKEY = (50);
const int WM_SETICON = (128);
const int WM_SETREDRAW = (11);
const int WM_SETTEXT = (12);
const int WM_SETTINGCHANGE = (26);
const int WM_SHOWWINDOW = (24);
const int WM_SIZE = (5);
const int WM_SIZECLIPBOARD = (779);
const int WM_SIZING = (532);
const int WM_SPOOLERSTATUS = (42);
const int WM_STYLECHANGED = (125);
const int WM_STYLECHANGING = (124);
const int WM_SYSCHAR = (262);
const int WM_SYSCOLORCHANGE = (21);
const int WM_SYSCOMMAND = (274);
const int WM_SYSDEADCHAR = (263);
const int WM_SYSKEYDOWN = (260);
const int WM_SYSKEYUP = (261);
const int WM_TCARD = (82);
const int WM_TIMECHANGE = (30);
const int WM_TIMER = (275);
const int WM_UNDO = (772);
const int WM_USER = (1024);
const int WM_USERCHANGED = (84);
const int WM_VKEYTOITEM = (46);
const int WM_VSCROLL = (277);
const int WM_VSCROLLCLIPBOARD = (778);
const int WM_WINDOWPOSCHANGED = (71);
const int WM_WINDOWPOSCHANGING = (70);
const int WM_WININICHANGE = (26);
const int WM_KEYFIRST = (256);
const int WM_KEYLAST = (264);
const int WM_MOUSEFIRST = (512);
const int WM_MOUSELAST = (521);

struct VA_LIST
{
}


struct ABC
{
    int abcA;
    UINT abcB;
    int abcC;
}

alias ABC* LPABC;
alias ABC _ABC;
alias ABC TABC;
alias ABC* PABC;

struct ABCFLOAT
{
    FLOAT abcfA;
    FLOAT abcfB;
    FLOAT abcfC;
}

alias ABCFLOAT* LPABCFLOAT;
alias ABCFLOAT _ABCFLOAT;
alias ABCFLOAT TABCFLOAT;
alias ABCFLOAT* PABCFLOAT;

struct ACCEL
{
    ubyte fVirt;
    ushort key;
    ushort cmd;
}

alias ACCEL* LPACCEL;
alias ACCEL _ACCEL;
alias ACCEL TACCEL;
alias ACCEL* PACCEL;

struct ACE_HEADER
{
    ubyte AceType;
    ubyte AceFlags;
    ushort AceSize;
}

alias ACE_HEADER _ACE_HEADER;
alias ACE_HEADER TACE_HEADER;
alias ACE_HEADER* PACE_HEADER;
alias DWORD ACCESS_MASK;
alias ACCESS_MASK REGSAM;

struct ACCESS_ALLOWED_ACE
{
    ACE_HEADER Header;
    ACCESS_MASK Mask;
    DWORD SidStart;
}

alias ACCESS_ALLOWED_ACE _ACCESS_ALLOWED_ACE;
alias ACCESS_ALLOWED_ACE TACCESS_ALLOWED_ACE;
alias ACCESS_ALLOWED_ACE* PACCESS_ALLOWED_ACE;

struct ACCESS_DENIED_ACE
{
    ACE_HEADER Header;
    ACCESS_MASK Mask;
    DWORD SidStart;
}

alias ACCESS_DENIED_ACE _ACCESS_DENIED_ACE;
alias ACCESS_DENIED_ACE TACCESS_DENIED_ACE;

struct ACCESSTIMEOUT
{
    UINT cbSize;
    DWORD dwFlags;
    DWORD iTimeOutMSec;
}

alias ACCESSTIMEOUT _ACCESSTIMEOUT;
alias ACCESSTIMEOUT TACCESSTIMEOUT;
alias ACCESSTIMEOUT* PACCESSTIMEOUT;

struct ACL
{
    ubyte AclRevision;
    ubyte Sbz1;
    ushort AclSize;
    ushort AceCount;
    ushort Sbz2;
}

alias ACL* PACL;
alias ACL _ACL;
alias ACL TACL;

struct ACL_REVISION_INFORMATION
{
    DWORD AclRevision;
}

alias ACL_REVISION_INFORMATION _ACL_REVISION_INFORMATION;
alias ACL_REVISION_INFORMATION TACLREVISIONINFORMATION;
alias ACL_REVISION_INFORMATION* PACLREVISIONINFORMATION;

struct ACL_SIZE_INFORMATION
{
    DWORD AceCount;
    DWORD AclBytesInUse;
    DWORD AclBytesFree;
}

alias ACL_SIZE_INFORMATION _ACL_SIZE_INFORMATION;
alias ACL_SIZE_INFORMATION TACLSIZEINFORMATION;
alias ACL_SIZE_INFORMATION* PACLSIZEINFORMATION;

struct ACTION_HEADER
{
    ULONG transport_id;
    USHORT action_code;
    USHORT reserved;
}

alias ACTION_HEADER _ACTION_HEADER;
alias ACTION_HEADER TACTIONHEADER;
alias ACTION_HEADER* PACTIONHEADER;

struct ADAPTER_STATUS
{
    UCHAR[1 + 5] adapter_address;
    UCHAR rev_major;
    UCHAR reserved0;
    UCHAR adapter_type;
    UCHAR rev_minor;
    ushort duration;
    ushort frmr_recv;
    ushort frmr_xmit;
    ushort iframe_recv_err;
    ushort xmit_aborts;
    DWORD xmit_success;
    DWORD recv_success;
    ushort iframe_xmit_err;
    ushort recv_buff_unavail;
    ushort t1_timeouts;
    ushort ti_timeouts;
    DWORD reserved1;
    ushort free_ncbs;
    ushort max_cfg_ncbs;
    ushort max_ncbs;
    ushort xmit_buf_unavail;
    ushort max_dgram_size;
    ushort pending_sess;
    ushort max_cfg_sess;
    ushort max_sess;
    ushort max_sess_pkt_size;
    ushort name_count;
}

alias ADAPTER_STATUS _ADAPTER_STATUS;
alias ADAPTER_STATUS TADAPTERSTATUS;
alias ADAPTER_STATUS* PADAPTERSTATUS;

struct ADDJOB_INFO_1
{
    LPTSTR Path;
    DWORD JobId;
}

alias ADDJOB_INFO_1 _ADDJOB_INFO_1;
alias ADDJOB_INFO_1 TADDJOB_INFO_1;
alias ADDJOB_INFO_1* PADDJOB_INFO_1;

struct ANIMATIONINFO
{
    UINT cbSize;
    int iMinAnimate;
}

alias ANIMATIONINFO* LPANIMATIONINFO;
alias ANIMATIONINFO _ANIMATIONINFO;
alias ANIMATIONINFO TANIMATIONINFO;
alias ANIMATIONINFO* PANIMATIONINFO;

struct RECT
{
    LONG left;
    LONG top;
    LONG right;
    LONG bottom;
}

alias RECT* LPRECT;
alias RECT _RECT;
alias RECT TRECT;
alias RECT* PRECT;

struct RECTL
{
    LONG left;
    LONG top;
    LONG right;
    LONG bottom;
}

alias RECTL _RECTL;
alias RECTL TRECTL;
alias RECTL* PRECTL;

struct APPBARDATA
{
    DWORD cbSize;
    HWND hWnd;
    UINT uCallbackMessage;
    UINT uEdge;
    RECT rc;
    LPARAM lParam;
}

alias APPBARDATA _APPBARDATA;
alias APPBARDATA TAPPBARDATA;
alias APPBARDATA* PAPPBARDATA;

struct BITMAP
{
    LONG bmType;
    LONG bmWidth;
    LONG bmHeight;
    LONG bmWidthBytes;
    ushort bmPlanes;
    ushort bmBitsPixel;
    LPVOID bmBits;
}

alias BITMAP* PBITMAP;
alias BITMAP* NPBITMAP;
alias BITMAP* LPBITMAP;
alias BITMAP TAGBITMAP;
alias BITMAP TBITMAP;

struct BITMAPCOREHEADER
{
    DWORD bcSize;
    ushort bcWidth;
    ushort bcHeight;
    ushort bcPlanes;
    ushort bcBitCount;
}

alias BITMAPCOREHEADER TAGBITMAPCOREHEADER;
alias BITMAPCOREHEADER TBITMAPCOREHEADER;
alias BITMAPCOREHEADER* PBITMAPCOREHEADER;

struct RGBTRIPLE
{
    ubyte rgbtBlue;
    ubyte rgbtGreen;
    ubyte rgbtRed;
}

alias RGBTRIPLE TAGRGBTRIPLE;
alias RGBTRIPLE TRGBTRIPLE;
alias RGBTRIPLE* PRGBTRIPLE;

struct BITMAPCOREINFO
{
    BITMAPCOREHEADER bmciHeader;
    RGBTRIPLE[1 + 0] bmciColors;
}

alias BITMAPCOREINFO* PBITMAPCOREINFO;
alias BITMAPCOREINFO* LPBITMAPCOREINFO;
alias BITMAPCOREINFO _BITMAPCOREINFO;
alias BITMAPCOREINFO TBITMAPCOREINFO;

struct BITMAPINFOHEADER
{
    DWORD biSize;
    LONG biWidth;
    LONG biHeight;
    ushort biPlanes;
    ushort biBitCount;
    DWORD biCompression;
    DWORD biSizeImage;
    LONG biXPelsPerMeter;
    LONG biYPelsPerMeter;
    DWORD biClrUsed;
    DWORD biClrImportant;
}

alias BITMAPINFOHEADER* LPBITMAPINFOHEADER;
alias BITMAPINFOHEADER TBITMAPINFOHEADER;
alias BITMAPINFOHEADER* PBITMAPINFOHEADER;

struct RGBQUAD
{
    ubyte rgbBlue;
    ubyte rgbGreen;
    ubyte rgbRed;
    ubyte rgbReserved;
}

alias RGBQUAD TAGRGBQUAD;
alias RGBQUAD TRGBQUAD;
alias RGBQUAD* PRGBQUAD;

struct BITMAPINFO
{
    BITMAPINFOHEADER bmiHeader;
    RGBQUAD[1 + 0] bmiColors;
}

alias BITMAPINFO* LPBITMAPINFO;
alias BITMAPINFO* PBITMAPINFO;
alias BITMAPINFO TBITMAPINFO;
alias int FXPT2DOT30;
alias FXPT2DOT30* LPFXPT2DOT30;
alias FXPT2DOT30 TPFXPT2DOT30;
alias FXPT2DOT30* PPFXPT2DOT30;

struct CIEXYZ
{
    FXPT2DOT30 ciexyzX;
    FXPT2DOT30 ciexyzY;
    FXPT2DOT30 ciexyzZ;
}

alias CIEXYZ TAGCIEXYZ;
alias CIEXYZ* LPCIEXYZ;
alias CIEXYZ TPCIEXYZ;
alias CIEXYZ* PCIEXYZ;

struct CIEXYZTRIPLE
{
    CIEXYZ ciexyzRed;
    CIEXYZ ciexyzGreen;
    CIEXYZ ciexyzBlue;
}

alias CIEXYZTRIPLE TAGCIEXYZTRIPLE;
alias CIEXYZTRIPLE* LPCIEXYZTRIPLE;
alias CIEXYZTRIPLE TCIEXYZTRIPLE;
alias CIEXYZTRIPLE* PCIEXYZTRIPLE;

struct BITMAPV4HEADER
{
    DWORD bV4Size;
    LONG bV4Width;
    LONG bV4Height;
    ushort bV4Planes;
    ushort bV4BitCount;
    DWORD bV4V4Compression;
    DWORD bV4SizeImage;
    LONG bV4XPelsPerMeter;
    LONG bV4YPelsPerMeter;
    DWORD bV4ClrUsed;
    DWORD bV4ClrImportant;
    DWORD bV4RedMask;
    DWORD bV4GreenMask;
    DWORD bV4BlueMask;
    DWORD bV4AlphaMask;
    DWORD bV4CSType;
    CIEXYZTRIPLE bV4Endpoints;
    DWORD bV4GammaRed;
    DWORD bV4GammaGreen;
    DWORD bV4GammaBlue;
}

alias BITMAPV4HEADER* LPBITMAPV4HEADER;
alias BITMAPV4HEADER TBITMAPV4HEADER;
alias BITMAPV4HEADER* PBITMAPV4HEADER;

align(1) struct BITMAPFILEHEADER
{
    ushort bfType;
    DWORD bfSize;
    ushort bfReserved1;
    ushort bfReserved2;
    DWORD bfOffBits;
}


struct BLOB
{
    ULONG cbSize;
    ubyte* pBlobData;
}

alias BLOB _BLOB;
alias BLOB TBLOB;
alias BLOB* PBLOB;

struct SHITEMID
{
    USHORT cb;
    ubyte[1 + 0] abID;
}

alias SHITEMID* LPSHITEMID;
alias SHITEMID* LPCSHITEMID;
alias SHITEMID _SHITEMID;
alias SHITEMID TSHITEMID;
alias SHITEMID* PSHITEMID;

struct ITEMIDLIST
{
    SHITEMID mkid;
}

alias ITEMIDLIST* LPITEMIDLIST;
alias ITEMIDLIST* LPCITEMIDLIST;
alias ITEMIDLIST _ITEMIDLIST;
alias ITEMIDLIST TITEMIDLIST;
alias ITEMIDLIST* PITEMIDLIST;

struct BROWSEINFO
{
    HWND hwndOwner;
    LPCITEMIDLIST pidlRoot;
    LPSTR pszDisplayName;
    LPCSTR lpszTitle;
    UINT ulFlags;
    BFFCALLBACK lpfn;
    LPARAM lParam;
    int iImage;
}

alias BROWSEINFO* LPBROWSEINFO;
alias BROWSEINFO _BROWSEINFO;
alias BROWSEINFO TBROWSEINFO;
alias BROWSEINFO* PBROWSEINFO;

struct FILETIME
{
    DWORD dwLowDateTime;
    DWORD dwHighDateTime;
}

alias FILETIME* LPFILETIME;
alias FILETIME _FILETIME;
alias FILETIME TFILETIME;
alias FILETIME* PFILETIME;

struct BY_HANDLE_FILE_INFORMATION
{
    DWORD dwFileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    DWORD dwVolumeSerialNumber;
    DWORD nFileSizeHigh;
    DWORD nFileSizeLow;
    DWORD nNumberOfLinks;
    DWORD nFileIndexHigh;
    DWORD nFileIndexLow;
}

alias BY_HANDLE_FILE_INFORMATION* LPBY_HANDLE_FILE_INFORMATION;
alias BY_HANDLE_FILE_INFORMATION _BY_HANDLE_FILE_INFORMATION;
alias BY_HANDLE_FILE_INFORMATION TBYHANDLEFILEINFORMATION;
alias BY_HANDLE_FILE_INFORMATION* PBYHANDLEFILEINFORMATION;

struct FIXED
{
    ushort fract;
    int value;
}

alias FIXED _FIXED;
alias FIXED TFIXED;
alias FIXED* PFIXED;

struct POINT
{
    LONG x;
    LONG y;
}

alias POINT* LPPOINT;
alias POINT TAGPOINT;
alias POINT TPOINT;
alias POINT* PPOINT;

struct POINTFX
{
    FIXED x;
    FIXED y;
}

alias POINTFX TAGPOINTFX;
alias POINTFX TPOINTFX;
alias POINTFX* PPOINTFX;

struct POINTL
{
    LONG x;
    LONG y;
}

alias POINTL _POINTL;
alias POINTL TPOINTL;
alias POINTL* PPOINTL;

struct TSMALLPOINT
{
    byte X, Y;
}


struct POINTS
{
    SHORT x;
    SHORT y;
}

alias POINTS TAGPOINTS;
alias POINTS TPOINTS;
alias POINTS* PPOINTS;

struct CANDIDATEFORM
{
    DWORD dwIndex;
    DWORD dwStyle;
    POINT ptCurrentPos;
    RECT rcArea;
}

alias CANDIDATEFORM* LPCANDIDATEFORM;
alias CANDIDATEFORM _TAGCANDIDATEFORM;
alias CANDIDATEFORM TCANDIDATEFORM;
alias CANDIDATEFORM* PCANDIDATEFORM;

struct CANDIDATELIST
{
    DWORD dwSize;
    DWORD dwStyle;
    DWORD dwCount;
    DWORD dwSelection;
    DWORD dwPageStart;
    DWORD dwPageSize;
    DWORD[1 + 0] dwOffset;
}

alias CANDIDATELIST* LPCANDIDATELIST;
alias CANDIDATELIST _TAGCANDIDATELIST;
alias CANDIDATELIST TCANDIDATELIST;
alias CANDIDATELIST* PCANDIDATELIST;

struct CREATESTRUCT
{
    LPVOID lpCreateParams;
    HINST hInstance;
    HMENU hMenu;
    HWND hwndParent;
    int cy;
    int cx;
    int y;
    int x;
    LONG style;
    LPCTSTR lpszName;
    LPCTSTR lpszClass;
    DWORD dwExStyle;
}

alias CREATESTRUCT* LPCREATESTRUCT;
alias CREATESTRUCT TAGCREATESTRUCT;
alias CREATESTRUCT TCREATESTRUCT;
alias CREATESTRUCT* PCREATESTRUCT;

struct CBT_CREATEWND
{
    LPCREATESTRUCT lpcs;
    HWND hwndInsertAfter;
}

alias CBT_CREATEWND TAGCBT_CREATEWND;
alias CBT_CREATEWND TCBT_CREATEWND;
alias CBT_CREATEWND* PCBT_CREATEWND;

struct CBTACTIVATESTRUCT
{
    BOOL fMouse;
    HWND hWndActive;
}

alias CBTACTIVATESTRUCT TAGCBTACTIVATESTRUCT;
alias CBTACTIVATESTRUCT TCBTACTIVATESTRUCT;
alias CBTACTIVATESTRUCT* PCBTACTIVATESTRUCT;

struct CHAR_INFO
{

    union
    {
        struct
        {
            WCHAR UnicodeChar;
            ushort Attributes;
        }
        struct
        {
            char AsciiChar;
        }
    }
}

alias CHAR_INFO _CHAR_INFO;
alias CHAR_INFO TCHAR_INFO;
alias CHAR_INFO* PCHAR_INFO;

struct CHARFORMAT
{
    UINT cbSize;
    DWORD dwMask;
    DWORD dwEffects;
    LONG yHeight;
    LONG yOffset;
    COLORREF crTextColor;
    ubyte bCharSet;
    ubyte bPitchAndFamily;
    TCHAR[1 + LF_FACESIZE-1] szFaceName;
}

alias CHARFORMAT _CHARFORMAT;
alias CHARFORMAT TCHARFORMAT;
alias CHARFORMAT* PCHARFORMAT;

struct CHARRANGE
{
    LONG cpMin;
    LONG cpMax;
}

alias CHARRANGE _CHARRANGE;
alias CHARRANGE TCHARRANGE;
alias CHARRANGE* PCHARRANGE;

struct CHARSET
{
    DWORD[1 + 2] aflBlock;
    DWORD flLang;
}

alias CHARSET TAGCHARSET;
alias CHARSET TCHARSET;
alias CHARSET* PCHARSET;

struct FONTSIGNATURE
{
    DWORD[1 + 3] fsUsb;
    DWORD[1 + 1] fsCsb;
}

alias FONTSIGNATURE* LPFONTSIGNATURE;
alias FONTSIGNATURE TAGFONTSIGNATURE;
alias FONTSIGNATURE TFONTSIGNATURE;
alias FONTSIGNATURE* PFONTSIGNATURE;

struct CHARSETINFO
{
    UINT ciCharset;
    UINT ciACP;
    FONTSIGNATURE fs;
}

alias CHARSETINFO* LPCHARSETINFO;
alias CHARSETINFO TCHARSETINFO;
alias CHARSETINFO* PCHARSETINFO;

struct TCHOOSECOLOR
{
    DWORD lStructSize;
    HWND hwndOwner;
    HWND hInstance;
    COLORREF rgbResult;
    COLORREF* lpCustColors;
    DWORD Flags;
    LPARAM lCustData;
    LPCCHOOKPROC lpfnHook;
    LPCTSTR lpTemplateName;
}

alias TCHOOSECOLOR* LPCHOOSECOLOR;
alias TCHOOSECOLOR* PCHOOSECOLOR;

struct LOGFONT
{
    LONG lfHeight;
    LONG lfWidth;
    LONG lfEscapement;
    LONG lfOrientation;
    LONG lfWeight;
    ubyte lfItalic;
    ubyte lfUnderline;
    ubyte lfStrikeOut;
    ubyte lfCharSet;
    ubyte lfOutPrecision;
    ubyte lfClipPrecision;
    ubyte lfQuality;
    ubyte lfPitchAndFamily;
    TCHAR[1 + LF_FACESIZE-1] lfFaceName;
}

alias LOGFONT* LPLOGFONT;
alias LOGFONT TLOGFONT;
alias LOGFONT TLOGFONTA;
alias LOGFONT* PLOGFONT;

struct TCHOOSEFONT
{
    DWORD lStructSize;
    HWND hwndOwner;
    HDC hDC;
    LPLOGFONT lpLogFont;
    INT iPointSize;
    DWORD Flags;
    DWORD rgbColors;
    LPARAM lCustData;
    LPCFHOOKPROC lpfnHook;
    LPCTSTR lpTemplateName;
    HINST hInstance;
    LPTSTR lpszStyle;
    ushort nFontType;
    ushort ___MISSING_ALIGNMENT__;
    INT nSizeMin;
    INT nSizeMax;
}

alias TCHOOSEFONT* LPCHOOSEFONT;
alias TCHOOSEFONT* PCHOOSEFONT;

struct CIDA
{
    UINT cidl;
    UINT[1 + 0] aoffset;
}

alias CIDA* LPIDA;
alias CIDA _IDA;
alias CIDA TIDA;
alias CIDA* PIDA;

struct CLIENTCREATESTRUCT
{
    HANDLE hWindowMenu;
    UINT idFirstChild;
}

alias CLIENTCREATESTRUCT* LPCLIENTCREATESTRUCT;
alias CLIENTCREATESTRUCT TAGCLIENTCREATESTRUCT;
alias CLIENTCREATESTRUCT TCLIENTCREATESTRUCT;
alias CLIENTCREATESTRUCT* PCLIENTCREATESTRUCT;

struct CMINVOKECOMMANDINFO
{
    DWORD cbSize;
    DWORD fMask;
    HWND hwnd;
    LPCSTR lpVerb;
    LPCSTR lpParameters;
    LPCSTR lpDirectory;
    int nShow;
    DWORD dwHotKey;
    HANDLE hIcon;
}

alias CMINVOKECOMMANDINFO* LPCMINVOKECOMMANDINFO;
alias CMINVOKECOMMANDINFO _CMINVOKECOMMANDINFO;
alias CMINVOKECOMMANDINFO TCMINVOKECOMMANDINFO;
alias CMINVOKECOMMANDINFO* PCMINVOKECOMMANDINFO;

struct COLORADJUSTMENT
{
    ushort caSize;
    ushort caFlags;
    ushort caIlluminantIndex;
    ushort caRedGamma;
    ushort caGreenGamma;
    ushort caBlueGamma;
    ushort caReferenceBlack;
    ushort caReferenceWhite;
    SHORT caContrast;
    SHORT caBrightness;
    SHORT caColorfulness;
    SHORT caRedGreenTint;
}

alias COLORADJUSTMENT* LPCOLORADJUSTMENT;
alias COLORADJUSTMENT TAGCOLORADJUSTMENT;
alias COLORADJUSTMENT TCOLORADJUSTMENT;
alias COLORADJUSTMENT* PCOLORADJUSTMENT;

struct COLORMAP
{
    COLORREF from;
    COLORREF _to;
}

alias COLORMAP* LPCOLORMAP;
alias COLORMAP _COLORMAP;
alias COLORMAP TCOLORMAP;
alias COLORMAP* PCOLORMAP;

struct DCB
{
    DWORD DCBlength;
    DWORD BaudRate;
    int flag0;
    ushort wReserved;
    ushort XonLim;
    ushort XoffLim;
    ubyte ByteSize;
    ubyte Parity;
    ubyte StopBits;
    char XonChar;
    char XoffChar;
    char ErrorChar;
    char EofChar;
    char EvtChar;
    ushort wReserved1;
}

alias DCB* LPDCB;
alias DCB _DCB;
alias DCB TDCB;
alias DCB* PDCB;
const int bm_DCB_fBinary = (0x1);
const int bp_DCB_fBinary = (0);
const int bm_DCB_fParity = (0x2);
const int bp_DCB_fParity = (1);
const int bm_DCB_fOutxCtsFlow = (0x4);
const int bp_DCB_fOutxCtsFlow = (2);
const int bm_DCB_fOutxDsrFlow = (0x8);
const int bp_DCB_fOutxDsrFlow = (3);
const int bm_DCB_fDtrControl = (0x30);
const int bp_DCB_fDtrControl = (4);
const int bm_DCB_fDsrSensitivity = (0x40);
const int bp_DCB_fDsrSensitivity = (6);
const int bm_DCB_fTXContinueOnXoff = (0x80);
const int bp_DCB_fTXContinueOnXoff = (7);
const int bm_DCB_fOutX = (0x100);
const int bp_DCB_fOutX = (8);
const int bm_DCB_fInX = (0x200);
const int bp_DCB_fInX = (9);
const int bm_DCB_fErrorChar = (0x400);
const int bp_DCB_fErrorChar = (10);
const int bm_DCB_fNull = (0x800);
const int bp_DCB_fNull = (11);
const int bm_DCB_fRtsControl = (0x3000);
const int bp_DCB_fRtsControl = (12);
const int bm_DCB_fAbortOnError = (0x4000);
const int bp_DCB_fAbortOnError = (14);
const int bm_DCB_fDummy2 = (int)(0xFFFF8000);
const int bp_DCB_fDummy2 = (15);

struct COMMCONFIG
{
    DWORD dwSize;
    ushort wVersion;
    ushort wReserved;
    DCB dcb;
    DWORD dwProviderSubType;
    DWORD dwProviderOffset;
    DWORD dwProviderSize;
    WCHAR[1 + 0] wcProviderData;
}

alias COMMCONFIG* LPCOMMCONFIG;
alias COMMCONFIG _COMM_CONFIG;
alias COMMCONFIG TCOMMCONFIG;
alias COMMCONFIG* PCOMMCONFIG;

struct COMMPROP
{
    ushort wPacketLength;
    ushort wPacketVersion;
    DWORD dwServiceMask;
    DWORD dwReserved1;
    DWORD dwMaxTxQueue;
    DWORD dwMaxRxQueue;
    DWORD dwMaxBaud;
    DWORD dwProvSubType;
    DWORD dwProvCapabilities;
    DWORD dwSettableParams;
    DWORD dwSettableBaud;
    ushort wSettableData;
    ushort wSettableStopParity;
    DWORD dwCurrentTxQueue;
    DWORD dwCurrentRxQueue;
    DWORD dwProvSpec1;
    DWORD dwProvSpec2;
    WCHAR[1 + 0] wcProvChar;
}

alias COMMPROP* LPCOMMPROP;
alias COMMPROP _COMMPROP;
alias COMMPROP TCOMMPROP;
alias COMMPROP* PCOMMPROP;

struct COMMTIMEOUTS
{
    DWORD ReadIntervalTimeout;
    DWORD ReadTotalTimeoutMultiplier;
    DWORD ReadTotalTimeoutConstant;
    DWORD WriteTotalTimeoutMultiplier;
    DWORD WriteTotalTimeoutConstant;
}

alias COMMTIMEOUTS* LPCOMMTIMEOUTS;
alias COMMTIMEOUTS _COMMTIMEOUTS;
alias COMMTIMEOUTS TCOMMTIMEOUTS;
alias COMMTIMEOUTS* PCOMMTIMEOUTS;

struct COMPAREITEMSTRUCT
{
    UINT CtlType;
    UINT CtlID;
    HWND hwndItem;
    UINT itemID1;
    DWORD itemData1;
    UINT itemID2;
    DWORD itemData2;
}

alias COMPAREITEMSTRUCT TAGCOMPAREITEMSTRUCT;
alias COMPAREITEMSTRUCT TCOMPAREITEMSTRUCT;
alias COMPAREITEMSTRUCT* PCOMPAREITEMSTRUCT;

struct COMPCOLOR
{
    COLORREF crText;
    COLORREF crBackground;
    DWORD dwEffects;
}

alias COMPCOLOR TCOMPCOLOR;
alias COMPCOLOR* PCOMPCOLOR;

struct COMPOSITIONFORM
{
    DWORD dwStyle;
    POINT ptCurrentPos;
    RECT rcArea;
}

alias COMPOSITIONFORM* LPCOMPOSITIONFORM;
alias COMPOSITIONFORM _TAGCOMPOSITIONFORM;
alias COMPOSITIONFORM TCOMPOSITIONFORM;
alias COMPOSITIONFORM* PCOMPOSITIONFORM;

struct COMSTAT
{
    int flag0;
    DWORD cbInQue;
    DWORD cbOutQue;
}

alias COMSTAT* LPCOMSTAT;
alias COMSTAT _COMSTAT;
alias COMSTAT TCOMSTAT;
alias COMSTAT* PCOMSTAT;
const int bm_COMSTAT_fCtsHold = (0x1);
const int bp_COMSTAT_fCtsHold = (0);
const int bm_COMSTAT_fDsrHold = (0x2);
const int bp_COMSTAT_fDsrHold = (1);
const int bm_COMSTAT_fRlsdHold = (0x4);
const int bp_COMSTAT_fRlsdHold = (2);
const int bm_COMSTAT_fXoffHold = (0x8);
const int bp_COMSTAT_fXoffHold = (3);
const int bm_COMSTAT_fXoffSent = (0x10);
const int bp_COMSTAT_fXoffSent = (4);
const int bm_COMSTAT_fEof = (0x20);
const int bp_COMSTAT_fEof = (5);
const int bm_COMSTAT_fTxim = (0x40);
const int bp_COMSTAT_fTxim = (6);
const int bm_COMSTAT_fReserved = (int)(0xFFFFFF80);
const int bp_COMSTAT_fReserved = (7);

struct CONSOLE_CURSOR_INFO
{
    DWORD dwSize;
    BOOL bVisible;
}

alias CONSOLE_CURSOR_INFO* PCONSOLE_CURSOR_INFO;
alias CONSOLE_CURSOR_INFO _CONSOLE_CURSOR_INFO;
alias CONSOLE_CURSOR_INFO TCONSOLECURSORINFO;
alias CONSOLE_CURSOR_INFO* PCONSOLECURSORINFO;
alias CONSOLE_CURSOR_INFO TCURSORINFO;

struct COORD
{
    SHORT X;
    SHORT Y;
}

alias COORD _COORD;
alias COORD TCOORD;
alias COORD* PCOORD;

struct SMALL_RECT
{
    SHORT Left;
    SHORT Top;
    SHORT Right;
    SHORT Bottom;
}

alias SMALL_RECT _SMALL_RECT;
alias SMALL_RECT TSMALL_RECT;
alias SMALL_RECT* PSMALL_RECT;

align(1) struct CONSOLE_SCREEN_BUFFER_INFO
{
    COORD dwSize;
    COORD dwCursorPosition;
    ushort wAttributes;
    SMALL_RECT srWindow;
    COORD dwMaximumWindowSize;
}

alias CONSOLE_SCREEN_BUFFER_INFO* PCONSOLE_SCREEN_BUFFER_INFO;
alias CONSOLE_SCREEN_BUFFER_INFO _CONSOLE_SCREEN_BUFFER_INFO;
alias CONSOLE_SCREEN_BUFFER_INFO TCONSOLESCREENBUFFERINFO;
alias CONSOLE_SCREEN_BUFFER_INFO* PCONSOLESCREENBUFFERINFO;

struct FLOATING_SAVE_AREA
{
    DWORD ControlWord;
    DWORD StatusWord;
    DWORD TagWord;
    DWORD ErrorOffset;
    DWORD ErrorSelector;
    DWORD DataOffset;
    DWORD DataSelector;
    ubyte[1 + 79] RegisterArea;
    DWORD Cr0NpxState;
}

alias FLOATING_SAVE_AREA _FLOATING_SAVE_AREA;
alias FLOATING_SAVE_AREA TFLOATINGSAVEAREA;
alias FLOATING_SAVE_AREA* PFLOATINGSAVEAREA;

struct CONTEXT
{
    DWORD ContextFlags;
    DWORD Dr0;
    DWORD Dr1;
    DWORD Dr2;
    DWORD Dr3;
    DWORD Dr6;
    DWORD Dr7;
    FLOATING_SAVE_AREA FloatSave;
    DWORD SegGs;
    DWORD SegFs;
    DWORD SegEs;
    DWORD SegDs;
    DWORD Edi;
    DWORD Esi;
    DWORD Ebx;
    DWORD Edx;
    DWORD Ecx;
    DWORD Eax;
    DWORD Ebp;
    DWORD Eip;
    DWORD SegCs;
    DWORD EFlags;
    DWORD Esp;
    DWORD SegSs;
}

alias CONTEXT* LPCONTEXT;
alias CONTEXT _CONTEXT;
alias CONTEXT TCONTEXT;
alias CONTEXT* PCONTEXT;

struct LIST_ENTRY
{
    _LIST_ENTRY* Flink;
    _LIST_ENTRY* Blink;
}

alias LIST_ENTRY _LIST_ENTRY;
alias LIST_ENTRY TLISTENTRY;
alias LIST_ENTRY* PLISTENTRY;

struct CRITICAL_SECTION_DEBUG
{
    ushort _Type;
    ushort CreatorBackTraceIndex;
    _CRITICAL_SECTION* CriticalSection;
    LIST_ENTRY ProcessLocksList;
    DWORD EntryCount;
    DWORD ContentionCount;
    DWORD Depth;
    PVOID[1 + 4] OwnerBackTrace;
}

alias CRITICAL_SECTION_DEBUG* LPCRITICAL_SECTION_DEBUG;
alias CRITICAL_SECTION_DEBUG PCRITICAL_SECTION_DEBUG;
alias CRITICAL_SECTION_DEBUG _CRITICAL_SECTION_DEBUG;
alias CRITICAL_SECTION_DEBUG TCRITICALSECTIONDEBUG;
alias CRITICAL_SECTION_DEBUG* PCRITICALSECTIONDEBUG;

struct CRITICAL_SECTION
{
    PCRITICAL_SECTION_DEBUG DebugInfo;
    LONG LockCount;
    LONG RecursionCount;
    HANDLE OwningThread;
    HANDLE LockSemaphore;
    DWORD Reserved;
}

alias CRITICAL_SECTION* LPCRITICAL_SECTION;
alias CRITICAL_SECTION* PCRITICAL_SECTION;
alias CRITICAL_SECTION _CRITICAL_SECTION;
alias CRITICAL_SECTION TCRITICALSECTION;
alias CRITICAL_SECTION* PCRITICALSECTION;

struct SECURITY_QUALITY_OF_SERVICE
{
    DWORD Length;
    SECURITY_IMPERSONATION_LEVEL ImpersonationLevel;
    BOOL ContextTrackingMode;
    ubyte EffectiveOnly;
}

alias SECURITY_QUALITY_OF_SERVICE* PSECURITY_QUALITY_OF_SERVICE;
alias SECURITY_QUALITY_OF_SERVICE _SECURITY_QUALITY_OF_SERVICE;
alias SECURITY_QUALITY_OF_SERVICE TSECURITYQUALITYOFSERVICE;
alias SECURITY_QUALITY_OF_SERVICE* PSECURITYQUALITYOFSERVICE;

struct CONVCONTEXT
{
    UINT cb;
    UINT wFlags;
    UINT wCountryID;
    int iCodePage;
    DWORD dwLangID;
    DWORD dwSecurity;
    SECURITY_QUALITY_OF_SERVICE qos;
}

alias CONVCONTEXT TAGCONVCONTEXT;
alias CONVCONTEXT TCONVCONTEXT;
alias CONVCONTEXT* PCONVCONTEXT;

struct CONVINFO
{
    DWORD cb;
    DWORD hUser;
    HCONV hConvPartner;
    HSZ hszSvcPartner;
    HSZ hszServiceReq;
    HSZ hszTopic;
    HSZ hszItem;
    UINT wFmt;
    UINT wType;
    UINT wStatus;
    UINT wConvst;
    UINT wLastError;
    HCONVLIST hConvList;
    CONVCONTEXT ConvCtxt;
    HWND _hwnd;
    HWND hwndPartner;
}

alias CONVINFO TAGCONVINFO;
alias CONVINFO TCONVINFO;
alias CONVINFO* PCONVINFO;

struct COPYDATASTRUCT
{
    DWORD dwData;
    DWORD cbData;
    PVOID lpData;
}

alias COPYDATASTRUCT TAGCOPYDATASTRUCT;
alias COPYDATASTRUCT TCOPYDATASTRUCT;
alias COPYDATASTRUCT* PCOPYDATASTRUCT;

struct CPINFO
{
    UINT MaxCharSize;
    ubyte[1 + MAX_DEFAULTCHAR-1] DefaultChar;
    ubyte[1 + MAX_LEADBYTES-1] LeadByte;
}

alias CPINFO* LPCPINFO;
alias CPINFO _CPINFO;
alias CPINFO TCPINFO;
alias CPINFO* PCPINFO;

struct CPLINFO
{
    int idIcon;
    int idName;
    int idInfo;
    LONG lData;
}

alias CPLINFO TAGCPLINFO;
alias CPLINFO TCPLINFO;
alias CPLINFO* PCPLINFO;

struct CREATE_PROCESS_DEBUG_INFO
{
    HANDLE hFile;
    HANDLE hProcess;
    HANDLE hThread;
    LPVOID lpBaseOfImage;
    DWORD dwDebugInfoFileOffset;
    DWORD nDebugInfoSize;
    LPVOID lpThreadLocalBase;
    LPTHREAD_START_ROUTINE lpStartAddress;
    LPVOID lpImageName;
    ushort fUnicode;
}

alias CREATE_PROCESS_DEBUG_INFO _CREATE_PROCESS_DEBUG_INFO;
alias CREATE_PROCESS_DEBUG_INFO TCREATEPROCESSDEBUGINFO;
alias CREATE_PROCESS_DEBUG_INFO* PCREATEPROCESSDEBUGINFO;

struct CREATE_THREAD_DEBUG_INFO
{
    HANDLE hThread;
    LPVOID lpThreadLocalBase;
    LPTHREAD_START_ROUTINE lpStartAddress;
}

alias CREATE_THREAD_DEBUG_INFO _CREATE_THREAD_DEBUG_INFO;
alias CREATE_THREAD_DEBUG_INFO TCREATETHREADDEBUGINFO;
alias CREATE_THREAD_DEBUG_INFO* PCREATETHREADDEBUGINFO;

struct CURRENCYFMT
{
    UINT NumDigits;
    UINT LeadingZero;
    UINT Grouping;
    LPTSTR lpDecimalSep;
    LPTSTR lpThousandSep;
    UINT NegativeOrder;
    UINT PositiveOrder;
    LPTSTR lpCurrencySymbol;
}

alias CURRENCYFMT _CURRENCYFMT;
alias CURRENCYFMT TCURRENCYFMT;
alias CURRENCYFMT* PCURRENCYFMT;

struct CURSORSHAPE
{
    int xHotSpot;
    int yHotSpot;
    int cx;
    int cy;
    int cbWidth;
    ubyte Planes;
    ubyte BitsPixel;
}

alias CURSORSHAPE* LPCURSORSHAPE;
alias CURSORSHAPE TAGCURSORSHAPE;
alias CURSORSHAPE TCURSORSHAPE;
alias CURSORSHAPE* PCURSORSHAPE;

struct CWPRETSTRUCT
{
    LRESULT lResult;
    LPARAM lParam;
    WPARAM wParam;
    DWORD message;
    HWND hwnd;
}

alias CWPRETSTRUCT TAGCWPRETSTRUCT;
alias CWPRETSTRUCT TCWPRETSTRUCT;
alias CWPRETSTRUCT* PCWPRETSTRUCT;

struct CWPSTRUCT
{
    LPARAM lParam;
    WPARAM wParam;
    UINT message;
    HWND hwnd;
}

alias CWPSTRUCT TAGCWPSTRUCT;
alias CWPSTRUCT TCWPSTRUCT;
alias CWPSTRUCT* PCWPSTRUCT;

struct DATATYPES_INFO_1
{
    LPTSTR pName;
}

alias DATATYPES_INFO_1 _DATATYPES_INFO_1;
alias DATATYPES_INFO_1 TDATATYPESINFO1;
alias DATATYPES_INFO_1* PDATATYPESINFO1;

struct DDEACK
{
    ushort flag0;
}

alias DDEACK TDDEACK;
alias DDEACK* PDDEACK;
const int bm_DDEACK_bAppReturnCode = (0xFF);
const int bp_DDEACK_bAppReturnCode = (0);
const int bm_DDEACK_reserved = (0x3F00);
const int bp_DDEACK_reserved = (8);
const int bm_DDEACK_fBusy = (0x4000);
const int bp_DDEACK_fBusy = (14);
const int bm_DDEACK_fAck = (0x8000);
const int bp_DDEACK_fAck = (15);

struct DDEADVISE
{
    ushort flag0;
    int cfFormat;
}

alias DDEADVISE TDDEADVISE;
alias DDEADVISE* PDDEADVISE;
const int bm_DDEADVISE_reserved = (0x3FFF);
const int bp_DDEADVISE_reserved = (0);
const int bm_DDEADVISE_fDeferUpd = (0x4000);
const int bp_DDEADVISE_fDeferUpd = (14);
const int bm_DDEADVISE_fAckReq = (0x8000);
const int bp_DDEADVISE_fAckReq = (15);

struct DDEDATA
{
    ushort flag0;
    int cfFormat;
    ubyte[1 + 0] Value;
}

alias DDEDATA* PDDEDATA;
const int bm_DDEDATA_unused = (0xFFF);
const int bp_DDEDATA_unused = (0);
const int bm_DDEDATA_fResponse = (0x1000);
const int bp_DDEDATA_fResponse = (12);
const int bm_DDEDATA_fRelease = (0x2000);
const int bp_DDEDATA_fRelease = (13);
const int bm_DDEDATA_reserved = (0x4000);
const int bp_DDEDATA_reserved = (14);
const int bm_DDEDATA_fAckReq = (0x8000);
const int bp_DDEDATA_fAckReq = (15);

struct DDELN
{
    ushort flag0;
    int cfFormat;
}

alias DDELN TDDELN;
alias DDELN* PDDELN;
const int bm_DDELN_unused = (0x1FFF);
const int bp_DDELN_unused = (0);
const int bm_DDELN_fRelease = (0x2000);
const int bp_DDELN_fRelease = (13);
const int bm_DDELN_fDeferUpd = (0x4000);
const int bp_DDELN_fDeferUpd = (14);
const int bm_DDELN_fAckReq = (0x8000);
const int bp_DDELN_fAckReq = (15);

struct DDEML_MSG_HOOK_DATA
{
    UINT uiLo;
    UINT uiHi;
    DWORD cbData;
    DWORD[1 + 7] Data;
}

alias DDEML_MSG_HOOK_DATA TAGDDEML_MSG_HOOK_DATA;
alias DDEML_MSG_HOOK_DATA TDDEMLMSGHOOKDATA;
alias DDEML_MSG_HOOK_DATA* PDDEMLMSGHOOKDATA;

struct DDEPOKE
{
    ushort flag0;
    int cfFormat;
    ubyte[1 + 0] Value;
}

alias DDEPOKE TDDEPOKE;
alias DDEPOKE* PDDEPOKE;
const int bm_DDEPOKE_unused = (0x1FFF);
const int bp_DDEPOKE_unused = (0);
const int bm_DDEPOKE_fRelease = (0x2000);
const int bp_DDEPOKE_fRelease = (13);
const int bm_DDEPOKE_fReserved = (0xC000);
const int bp_DDEPOKE_fReserved = (14);

struct DDEUP
{
    ushort flag0;
    int cfFormat;
    ubyte[1 + 0] rgb;
}

alias DDEUP TDDEUP;
alias DDEUP* PDDEUP;
const int bm_DDEUP_unused = (0xFFF);
const int bp_DDEUP_unused = (0);
const int bm_DDEUP_fAck = (0x1000);
const int bp_DDEUP_fAck = (12);
const int bm_DDEUP_fRelease = (0x2000);
const int bp_DDEUP_fRelease = (13);
const int bm_DDEUP_fReserved = (0x4000);
const int bp_DDEUP_fReserved = (14);
const int bm_DDEUP_fAckReq = (0x8000);
const int bp_DDEUP_fAckReq = (15);

struct EXCEPTION_RECORD
{
    DWORD ExceptionCode;
    DWORD ExceptionFlags;
    _EXCEPTION_RECORD* ExceptionRecord;
    PVOID ExceptionAddress;
    DWORD NumberParameters;
    DWORD[1 + EXCEPTION_MAXIMUM_PARAMETERS-1] ExceptionInformation;
}

alias EXCEPTION_RECORD* PEXCEPTION_RECORD;
alias EXCEPTION_RECORD _EXCEPTION_RECORD;
alias EXCEPTION_RECORD TEXCEPTIONRECORD;
alias EXCEPTION_RECORD* PEXCEPTIONRECORD;

struct EXCEPTION_DEBUG_INFO
{
    EXCEPTION_RECORD ExceptionRecord;
    DWORD dwFirstChance;
}

alias EXCEPTION_DEBUG_INFO* PEXCEPTION_DEBUG_INFO;
alias EXCEPTION_DEBUG_INFO _EXCEPTION_DEBUG_INFO;
alias EXCEPTION_DEBUG_INFO TEXCEPTIONDEBUGINFO;
alias EXCEPTION_DEBUG_INFO* PEXCEPTIONDEBUGINFO;

struct EXIT_PROCESS_DEBUG_INFO
{
    DWORD dwExitCode;
}

alias EXIT_PROCESS_DEBUG_INFO _EXIT_PROCESS_DEBUG_INFO;
alias EXIT_PROCESS_DEBUG_INFO TEXITPROCESSDEBUGINFO;
alias EXIT_PROCESS_DEBUG_INFO* PEXITPROCESSDEBUGINFO;

struct EXIT_THREAD_DEBUG_INFO
{
    DWORD dwExitCode;
}

alias EXIT_THREAD_DEBUG_INFO _EXIT_THREAD_DEBUG_INFO;
alias EXIT_THREAD_DEBUG_INFO TEXITTHREADDEBUGINFO;
alias EXIT_THREAD_DEBUG_INFO* PEXITTHREADDEBUGINFO;

struct LOAD_DLL_DEBUG_INFO
{
    HANDLE hFile;
    LPVOID lpBaseOfDll;
    DWORD dwDebugInfoFileOffset;
    DWORD nDebugInfoSize;
    LPVOID lpImageName;
    ushort fUnicode;
}

alias LOAD_DLL_DEBUG_INFO _LOAD_DLL_DEBUG_INFO;
alias LOAD_DLL_DEBUG_INFO TLOADDLLDEBUGINFO;
alias LOAD_DLL_DEBUG_INFO* PLOADDLLDEBUGINFO;

struct UNLOAD_DLL_DEBUG_INFO
{
    LPVOID lpBaseOfDll;
}

alias UNLOAD_DLL_DEBUG_INFO _UNLOAD_DLL_DEBUG_INFO;
alias UNLOAD_DLL_DEBUG_INFO TUNLOADDLLDEBUGINFO;
alias UNLOAD_DLL_DEBUG_INFO* PUNLOADDLLDEBUGINFO;

struct OUTPUT_DEBUG_STRING_INFO
{
    LPSTR lpDebugStringData;
    ushort fUnicode;
    ushort nDebugStringLength;
}

alias OUTPUT_DEBUG_STRING_INFO _OUTPUT_DEBUG_STRING_INFO;
alias OUTPUT_DEBUG_STRING_INFO TOUTPUTDEBUGSTRINGINFO;
alias OUTPUT_DEBUG_STRING_INFO* POUTPUTDEBUGSTRINGINFO;

struct RIP_INFO
{
    DWORD dwError;
    DWORD dwType;
}

alias RIP_INFO _RIP_INFO;
alias RIP_INFO TRIPINFO;
alias RIP_INFO* PRIPINFO;

struct DEBUG_EVENT
{
    DWORD dwDebugEventCode;
    DWORD dwProcessId;
    DWORD dwThreadId;

    union
    {
        struct
        {
            EXCEPTION_DEBUG_INFO Exception;
        }
        struct
        {
            CREATE_THREAD_DEBUG_INFO CreateThread;
        }
        struct
        {
            CREATE_PROCESS_DEBUG_INFO CreateProcessInfo;
        }
        struct
        {
            EXIT_THREAD_DEBUG_INFO ExitThread;
        }
        struct
        {
            EXIT_PROCESS_DEBUG_INFO ExitProcess;
        }
        struct
        {
            LOAD_DLL_DEBUG_INFO LoadDll;
        }
        struct
        {
            UNLOAD_DLL_DEBUG_INFO UnloadDll;
        }
        struct
        {
            OUTPUT_DEBUG_STRING_INFO DebugString;
        }
        struct
        {
            RIP_INFO RipInfo;
        }
    }
}

alias DEBUG_EVENT* LPDEBUG_EVENT;
alias DEBUG_EVENT _DEBUG_EVENT;
alias DEBUG_EVENT TDEBUGEVENT;
alias DEBUG_EVENT* PDEBUGEVENT;

struct DEBUGHOOKINFO
{
    DWORD idThread;
    DWORD idThreadInstaller;
    LPARAM lParam;
    WPARAM wParam;
    int code;
}

alias DEBUGHOOKINFO TAGDEBUGHOOKINFO;
alias DEBUGHOOKINFO TDEBUGHOOKINFO;
alias DEBUGHOOKINFO* PDEBUGHOOKINFO;

struct DELETEITEMSTRUCT
{
    UINT CtlType;
    UINT CtlID;
    UINT itemID;
    HWND hwndItem;
    UINT itemData;
}

alias DELETEITEMSTRUCT TAGDELETEITEMSTRUCT;
alias DELETEITEMSTRUCT TDELETEITEMSTRUCT;
alias DELETEITEMSTRUCT* PDELETEITEMSTRUCT;

struct DEV_BROADCAST_HDR
{
    ULONG dbch_size;
    ULONG dbch_devicetype;
    ULONG dbch_reserved;
}

alias DEV_BROADCAST_HDR* PDEV_BROADCAST_HDR;
alias DEV_BROADCAST_HDR _DEV_BROADCAST_HDR;
alias DEV_BROADCAST_HDR TDEVBROADCASTHDR;
alias DEV_BROADCAST_HDR* PDEVBROADCASTHDR;

struct DEV_BROADCAST_OEM
{
    ULONG dbco_size;
    ULONG dbco_devicetype;
    ULONG dbco_reserved;
    ULONG dbco_identifier;
    ULONG dbco_suppfunc;
}

alias DEV_BROADCAST_OEM* PDEV_BROADCAST_OEM;
alias DEV_BROADCAST_OEM _DEV_BROADCAST_OEM;
alias DEV_BROADCAST_OEM TDEVBROADCASTOEM;
alias DEV_BROADCAST_OEM* PDEVBROADCASTOEM;

struct DEV_BROADCAST_PORT
{
    ULONG dbcp_size;
    ULONG dbcp_devicetype;
    ULONG dbcp_reserved;
    char[1 + 0] dbcp_name;
}

alias DEV_BROADCAST_PORT* PDEV_BROADCAST_PORT;
alias DEV_BROADCAST_PORT _DEV_BROADCAST_PORT;
alias DEV_BROADCAST_PORT TDEVBROADCASTPORT;
alias DEV_BROADCAST_PORT* PDEVBROADCASTPORT;

struct _DEV_BROADCAST_USERDEFINED
{
    _DEV_BROADCAST_HDR dbud_dbh;
    char[1 + 0] dbud_szName;
    ubyte[1 + 0] dbud_rgbUserDefined;
}

alias _DEV_BROADCAST_USERDEFINED TDEVBROADCASTUSERDEFINED;
alias _DEV_BROADCAST_USERDEFINED* PDEVBROADCASTUSERDEFINED;

struct DEV_BROADCAST_VOLUME
{
    ULONG dbcv_size;
    ULONG dbcv_devicetype;
    ULONG dbcv_reserved;
    ULONG dbcv_unitmask;
    USHORT dbcv_flags;
}

alias DEV_BROADCAST_VOLUME* PDEV_BROADCAST_VOLUME;
alias DEV_BROADCAST_VOLUME _DEV_BROADCAST_VOLUME;
alias DEV_BROADCAST_VOLUME TDEVBROADCASTVOLUME;
alias DEV_BROADCAST_VOLUME* PDEVBROADCASTVOLUME;

struct DEVMODE
{
    BCHAR[1 + CCHDEVICENAME-1] dmDeviceName;
    ushort dmSpecVersion;
    ushort dmDriverVersion;
    ushort dmSize;
    ushort dmDriverExtra;
    DWORD dmFields;
    int dmOrientation;
    int dmPaperSize;
    int dmPaperLength;
    int dmPaperWidth;
    int dmScale;
    int dmCopies;
    int dmDefaultSource;
    int dmPrintQuality;
    int dmColor;
    int dmDuplex;
    int dmYResolution;
    int dmTTOption;
    int dmCollate;
    BCHAR[1 + CCHFORMNAME-1] dmFormName;
    ushort dmLogPixels;
    DWORD dmBitsPerPel;
    DWORD dmPelsWidth;
    DWORD dmPelsHeight;
    DWORD dmDisplayFlags;
    DWORD dmDisplayFrequency;
    DWORD dmICMMethod;
    DWORD dmICMIntent;
    DWORD dmMediaType;
    DWORD dmDitherType;
    DWORD dmICCManufacturer;
    DWORD dmICCModel;
}

alias DEVMODE* LPDEVMODE;
alias DEVMODE _DEVICEMODE;
alias DEVMODE DEVICEMODE;
alias DEVMODE TDEVICEMODE;
alias DEVMODE TDEVICEMODEA;
alias DEVMODE TDEVMODE;
alias DEVMODE* PDEVMODE;

struct DEVNAMES
{
    ushort wDriverOffset;
    ushort wDeviceOffset;
    ushort wOutputOffset;
    ushort wDefault;
}

alias DEVNAMES* LPDEVNAMES;
alias DEVNAMES TAGDEVNAMES;
alias DEVNAMES TDEVNAMES;
alias DEVNAMES* PDEVNAMES;

struct DIBSECTION
{
    BITMAP dsBm;
    BITMAPINFOHEADER dsBmih;
    DWORD[1 + 2] dsBitfields;
    HANDLE dshSection;
    DWORD dsOffset;
}

alias DIBSECTION TAGDIBSECTION;
alias DIBSECTION TDIBSECTION;
alias DIBSECTION* PDIBSECTION;

struct LARGE_INTEGER
{
    DWORD LowPart;
    LONG HighPart;
}

alias LARGE_INTEGER* PLARGE_INTEGER;
alias LARGE_INTEGER _LARGE_INTEGER;
alias LARGE_INTEGER TLARGEINTEGER;
alias LARGE_INTEGER* PLARGEINTEGER;

struct DISK_GEOMETRY
{
    LARGE_INTEGER Cylinders;
    MEDIA_TYPE MediaType;
    DWORD TracksPerCylinder;
    DWORD SectorsPerTrack;
    DWORD BytesPerSector;
}

alias DISK_GEOMETRY _DISK_GEOMETRY;
alias DISK_GEOMETRY TDISKGEOMETRY;
alias DISK_GEOMETRY* PDISKGEOMETRY;

struct DISK_PERFORMANCE
{
    LARGE_INTEGER BytesRead;
    LARGE_INTEGER BytesWritten;
    LARGE_INTEGER ReadTime;
    LARGE_INTEGER WriteTime;
    DWORD ReadCount;
    DWORD WriteCount;
    DWORD QueueDepth;
}

alias DISK_PERFORMANCE _DISK_PERFORMANCE;
alias DISK_PERFORMANCE TDISKPERFORMANCE;
alias DISK_PERFORMANCE* PDISKPERFORMANCE;

align(1) struct DLGITEMTEMPLATE
{
    DWORD style;
    DWORD dwExtendedStyle;
    int x;
    int y;
    int cx;
    int cy;
    ushort id;
}

alias DLGITEMTEMPLATE* LPDLGITEMTEMPLATE;
alias DLGITEMTEMPLATE TDLGITEMTEMPLATE;
alias DLGITEMTEMPLATE* PDLGITEMTEMPLATE;

align(1) struct DLGTEMPLATE
{
    DWORD style;
    DWORD dwExtendedStyle;
    ushort cdit;
    int x;
    int y;
    int cx;
    int cy;
}

alias DLGTEMPLATE* LPDLGTEMPLATE;
alias DLGTEMPLATE* LPCDLGTEMPLATE;
alias DLGTEMPLATE TDLGTEMPLATE;
alias DLGTEMPLATE* PDLGTEMPLATE;

struct DOC_INFO_1
{
    LPTSTR pDocName;
    LPTSTR pOutputFile;
    LPTSTR pDatatype;
}

alias DOC_INFO_1 _DOC_INFO_1;
alias DOC_INFO_1 TDOCINFO1;
alias DOC_INFO_1* PDOCINFO1;

struct DOC_INFO_2
{
    LPTSTR pDocName;
    LPTSTR pOutputFile;
    LPTSTR pDatatype;
    DWORD dwMode;
    DWORD JobId;
}

alias DOC_INFO_2 _DOC_INFO_2;
alias DOC_INFO_2 TDOCINFO2;
alias DOC_INFO_2* PDOCINFO2;

struct DOCINFO
{
    int cbSize;
    LPCTSTR lpszDocName;
    LPCTSTR lpszOutput;
    LPCTSTR lpszDatatype;
    DWORD fwType;
}

alias DOCINFO TDOCINFO;
alias DOCINFO TDOCINFOA;
alias DOCINFO* PDOCINFO;

struct DRAGLISTINFO
{
    UINT uNotification;
    HWND hWnd;
    POINT ptCursor;
}

alias DRAGLISTINFO* LPDRAGLISTINFO;
alias DRAGLISTINFO TDRAGLISTINFO;
alias DRAGLISTINFO* PDRAGLISTINFO;

struct DRAWITEMSTRUCT
{
    UINT CtlType;
    UINT CtlID;
    UINT itemID;
    UINT itemAction;
    UINT itemState;
    HWND hwndItem;
    HDC hDC;
    RECT rcItem;
    DWORD itemData;
}

alias DRAWITEMSTRUCT* LPDRAWITEMSTRUCT;
alias DRAWITEMSTRUCT TAGDRAWITEMSTRUCT;
alias DRAWITEMSTRUCT TDRAWITEMSTRUCT;
alias DRAWITEMSTRUCT* PDRAWITEMSTRUCT;

struct DRAWTEXTPARAMS
{
    UINT cbSize;
    int iTabLength;
    int iLeftMargin;
    int iRightMargin;
    UINT uiLengthDrawn;
}

alias DRAWTEXTPARAMS* LPDRAWTEXTPARAMS;
alias DRAWTEXTPARAMS TDRAWTEXTPARAMS;
alias DRAWTEXTPARAMS* PDRAWTEXTPARAMS;

struct PARTITION_INFORMATION
{
    ubyte PartitionType;
    ubyte BootIndicator;
    ubyte RecognizedPartition;
    ubyte RewritePartition;
    LARGE_INTEGER StartingOffset;
    LARGE_INTEGER PartitionLength;
    LARGE_INTEGER HiddenSectors;
}

alias PARTITION_INFORMATION _PARTITION_INFORMATION;
alias PARTITION_INFORMATION TPARTITIONINFORMATION;
alias PARTITION_INFORMATION* PPARTITIONINFORMATION;

struct DRIVE_LAYOUT_INFORMATION
{
    DWORD PartitionCount;
    DWORD Signature;
    PARTITION_INFORMATION[1 + 0] PartitionEntry;
}

alias DRIVE_LAYOUT_INFORMATION _DRIVE_LAYOUT_INFORMATION;
alias DRIVE_LAYOUT_INFORMATION TDRIVELAYOUTINFORMATION;
alias DRIVE_LAYOUT_INFORMATION* PDRIVELAYOUTINFORMATION;

struct DRIVER_INFO_1
{
    LPTSTR pName;
}

alias DRIVER_INFO_1 _DRIVER_INFO_1;
alias DRIVER_INFO_1 TDRIVERINFO1;
alias DRIVER_INFO_1* PDRIVERINFO1;

struct DRIVER_INFO_2
{
    DWORD cVersion;
    LPTSTR pName;
    LPTSTR pEnvironment;
    LPTSTR pDriverPath;
    LPTSTR pDataFile;
    LPTSTR pConfigFile;
}

alias DRIVER_INFO_2 _DRIVER_INFO_2;
alias DRIVER_INFO_2 TDRIVERINFO2;
alias DRIVER_INFO_2* PDRIVERINFO2;

struct DRIVER_INFO_3
{
    DWORD cVersion;
    LPTSTR pName;
    LPTSTR pEnvironment;
    LPTSTR pDriverPath;
    LPTSTR pDataFile;
    LPTSTR pConfigFile;
    LPTSTR pHelpFile;
    LPTSTR pDependentFiles;
    LPTSTR pMonitorName;
    LPTSTR pDefaultDataType;
}

alias DRIVER_INFO_3 _DRIVER_INFO_3;
alias DRIVER_INFO_3 TDRIVERINFO3;
alias DRIVER_INFO_3* PDRIVERINFO3;

struct EDITSTREAM
{
    DWORD dwCookie;
    DWORD dwError;
    EDITSTREAMCALLBACK pfnCallback;
}

alias EDITSTREAM _EDITSTREAM;
alias EDITSTREAM TEDITSTREAM;
alias EDITSTREAM* PEDITSTREAM;

struct EMR
{
    DWORD iType;
    DWORD nSize;
}

alias EMR TAGEMR;
alias EMR TEMR;
alias EMR* PEMR;

struct EMRANGLEARC
{
    EMR emr;
    POINTL ptlCenter;
    DWORD nRadius;
    FLOAT eStartAngle;
    FLOAT eSweepAngle;
}

alias EMRANGLEARC TAGEMRANGLEARC;
alias EMRANGLEARC TEMRANGLEARC;
alias EMRANGLEARC* PEMRANGLEARC;

struct EMRARC
{
    EMR emr;
    RECTL rclBox;
    POINTL ptlStart;
    POINTL ptlEnd;
}

alias EMRARC TAGEMRARC;
alias EMRARC TEMRARC;
alias EMRARC* PEMRARC;
alias EMRARC EMRARCTO;
alias EMRARC TEMRARCTO;
alias EMRARC* PEMRARCTO;
alias EMRARC EMRCHORD;
alias EMRARC TEMRCHORD;
alias EMRARC* PEMRCHORD;
alias EMRARC EMRPIE;
alias EMRARC TEMRPIE;
alias EMRARC* PEMRPIE;

struct XFORM
{
    FLOAT eM11;
    FLOAT eM12;
    FLOAT eM21;
    FLOAT eM22;
    FLOAT eDx;
    FLOAT eDy;
}

alias XFORM* LPXFORM;
alias XFORM _XFORM;
alias XFORM TXFORM;
alias XFORM* PXFORM;

struct EMRBITBLT
{
    EMR emr;
    RECTL rclBounds;
    LONG xDest;
    LONG yDest;
    LONG cxDest;
    LONG cyDest;
    DWORD dwRop;
    LONG xSrc;
    LONG ySrc;
    XFORM xformSrc;
    COLORREF crBkColorSrc;
    DWORD iUsageSrc;
    DWORD offBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
}

alias EMRBITBLT TAGEMRBITBLT;
alias EMRBITBLT TEMRBITBLT;
alias EMRBITBLT* PEMRBITBLT;

struct LOGBRUSH
{
    UINT lbStyle;
    COLORREF lbColor;
    LONG lbHatch;
}

alias LOGBRUSH TAGLOGBRUSH;
alias LOGBRUSH TLOGBRUSH;
alias LOGBRUSH* PLOGBRUSH;

struct EMRCREATEBRUSHINDIRECT
{
    EMR emr;
    DWORD ihBrush;
    LOGBRUSH lb;
}

alias EMRCREATEBRUSHINDIRECT TAGEMRCREATEBRUSHINDIRECT;
alias EMRCREATEBRUSHINDIRECT TEMRCREATEBRUSHINDIRECT;
alias EMRCREATEBRUSHINDIRECT* PEMRCREATEBRUSHINDIRECT;
alias LONG LCSCSTYPE;
alias LONG LCSGAMUTMATCH;

struct LOGCOLORSPACE
{
    DWORD lcsSignature;
    DWORD lcsVersion;
    DWORD lcsSize;
    LCSCSTYPE lcsCSType;
    LCSGAMUTMATCH lcsIntent;
    CIEXYZTRIPLE lcsEndpoints;
    DWORD lcsGammaRed;
    DWORD lcsGammaGreen;
    DWORD lcsGammaBlue;
    TCHAR[1 + MAX_PATH-1] lcsFilename;
}

alias LOGCOLORSPACE* LPLOGCOLORSPACE;
alias LOGCOLORSPACE TAGLOGCOLORSPACE;
alias LOGCOLORSPACE TLOGCOLORSPACE;
alias LOGCOLORSPACE TLOGCOLORSPACEA;
alias LOGCOLORSPACE* PLOGCOLORSPACE;

struct EMRCREATECOLORSPACE
{
    EMR emr;
    DWORD ihCS;
    LOGCOLORSPACE lcs;
}

alias EMRCREATECOLORSPACE TAGEMRCREATECOLORSPACE;
alias EMRCREATECOLORSPACE TEMRCREATECOLORSPACE;
alias EMRCREATECOLORSPACE* PEMRCREATECOLORSPACE;

struct EMRCREATEDIBPATTERNBRUSHPT
{
    EMR emr;
    DWORD ihBrush;
    DWORD iUsage;
    DWORD offBmi;
    DWORD cbBmi;
    DWORD offBits;
    DWORD cbBits;
}

alias EMRCREATEDIBPATTERNBRUSHPT TAGEMRCREATEDIBPATTERNBRUSHPT;
alias EMRCREATEDIBPATTERNBRUSHPT TEMRCREATEDIBPATTERNBRUSHPT;
alias EMRCREATEDIBPATTERNBRUSHPT PEMRCREATEDIBPATTERNBRUSHPT;

struct EMRCREATEMONOBRUSH
{
    EMR emr;
    DWORD ihBrush;
    DWORD iUsage;
    DWORD offBmi;
    DWORD cbBmi;
    DWORD offBits;
    DWORD cbBits;
}

alias EMRCREATEMONOBRUSH TAGEMRCREATEMONOBRUSH;
alias EMRCREATEMONOBRUSH TEMRCREATEMONOBRUSH;
alias EMRCREATEMONOBRUSH* PEMRCREATEMONOBRUSH;

struct PALETTEENTRY
{
    ubyte peRed;
    ubyte peGreen;
    ubyte peBlue;
    ubyte peFlags;
}

alias PALETTEENTRY* LPPALETTEENTRY;
alias PALETTEENTRY TAGPALETTEENTRY;
alias PALETTEENTRY TPALETTEENTRY;
alias PALETTEENTRY* PPALETTEENTRY;

struct LOGPALETTE
{
    ushort palVersion;
    ushort palNumEntries;
    PALETTEENTRY[1 + 0] palPalEntry;
}

alias LOGPALETTE* LPLOGPALETTE;
alias LOGPALETTE TAGLOGPALETTE;
alias LOGPALETTE TLOGPALETTE;
alias LOGPALETTE* PLOGPALETTE;

struct EMRCREATEPALETTE
{
    EMR emr;
    DWORD ihPal;
    LOGPALETTE lgpl;
}

alias EMRCREATEPALETTE TAGEMRCREATEPALETTE;
alias EMRCREATEPALETTE TEMRCREATEPALETTE;
alias EMRCREATEPALETTE* PEMRCREATEPALETTE;

struct LOGPEN
{
    UINT lopnStyle;
    POINT lopnWidth;
    COLORREF lopnColor;
}

alias LOGPEN TAGLOGPEN;
alias LOGPEN TLOGPEN;
alias LOGPEN* PLOGPEN;

struct EMRCREATEPEN
{
    EMR emr;
    DWORD ihPen;
    LOGPEN lopn;
}

alias EMRCREATEPEN TAGEMRCREATEPEN;
alias EMRCREATEPEN TEMRCREATEPEN;
alias EMRCREATEPEN* PEMRCREATEPEN;

struct EMRELLIPSE
{
    EMR emr;
    RECTL rclBox;
}

alias EMRELLIPSE TAGEMRELLIPSE;
alias EMRELLIPSE TEMRELLIPSE;
alias EMRELLIPSE* PEMRELLIPSE;
alias EMRELLIPSE EMRRECTANGLE;
alias EMRELLIPSE TEMRRECTANGLE;
alias EMRELLIPSE* PEMRRECTANGLE;

struct EMREOF
{
    EMR emr;
    DWORD nPalEntries;
    DWORD offPalEntries;
    DWORD nSizeLast;
}

alias EMREOF TAGEMREOF;
alias EMREOF TEMREOF;
alias EMREOF* PEMREOF;

struct EMREXCLUDECLIPRECT
{
    EMR emr;
    RECTL rclClip;
}

alias EMREXCLUDECLIPRECT TAGEMREXCLUDECLIPRECT;
alias EMREXCLUDECLIPRECT TEMREXCLUDECLIPRECT;
alias EMREXCLUDECLIPRECT* PEMREXCLUDECLIPRECT;
alias EMREXCLUDECLIPRECT EMRINTERSECTCLIPRECT;
alias EMREXCLUDECLIPRECT TEMRINTERSECTCLIPRECT;
alias EMREXCLUDECLIPRECT* PEMRINTERSECTCLIPRECT;

struct PANOSE
{
    ubyte bFamilyType;
    ubyte bSerifStyle;
    ubyte bWeight;
    ubyte bProportion;
    ubyte bContrast;
    ubyte bStrokeVariation;
    ubyte bArmStyle;
    ubyte bLetterform;
    ubyte bMidline;
    ubyte bXHeight;
}

alias PANOSE TAGPANOSE;
alias PANOSE TPANOSE;
alias PANOSE* PPANOSE;

struct EXTLOGFONT
{
    LOGFONT elfLogFont;
    BCHAR[1 + LF_FULLFACESIZE-1] elfFullName;
    BCHAR[1 + LF_FACESIZE-1] elfStyle;
    DWORD elfVersion;
    DWORD elfStyleSize;
    DWORD elfMatch;
    DWORD elfReserved;
    ubyte[1 + ELF_VENDOR_SIZE-1] elfVendorId;
    DWORD elfCulture;
    PANOSE elfPanose;
}

alias EXTLOGFONT TAGEXTLOGFONT;
alias EXTLOGFONT TEXTLOGFONT;
alias EXTLOGFONT* PEXTLOGFONT;

struct EMREXTCREATEFONTINDIRECTW
{
    EMR emr;
    DWORD ihFont;
    EXTLOGFONT elfw;
}

alias EMREXTCREATEFONTINDIRECTW TAGEMREXTCREATEFONTINDIRECTW;
alias EMREXTCREATEFONTINDIRECTW TEMREXTCREATEFONTINDIRECTW;
alias EMREXTCREATEFONTINDIRECTW* PEMREXTCREATEFONTINDIRECTW;

struct EXTLOGPEN
{
    UINT elpPenStyle;
    UINT elpWidth;
    UINT elpBrushStyle;
    COLORREF elpColor;
    LONG elpHatch;
    DWORD elpNumEntries;
    DWORD[1 + 0] elpStyleEntry;
}

alias EXTLOGPEN TAGEXTLOGPEN;
alias EXTLOGPEN TEXTLOGPEN;
alias EXTLOGPEN* PEXTLOGPEN;

struct EMREXTCREATEPEN
{
    EMR emr;
    DWORD ihPen;
    DWORD offBmi;
    DWORD cbBmi;
    DWORD offBits;
    DWORD cbBits;
    EXTLOGPEN elp;
}

alias EMREXTCREATEPEN TAGEMREXTCREATEPEN;
alias EMREXTCREATEPEN TEMREXTCREATEPEN;
alias EMREXTCREATEPEN* PEMREXTCREATEPEN;

struct EMREXTFLOODFILL
{
    EMR emr;
    POINTL ptlStart;
    COLORREF crColor;
    DWORD iMode;
}

alias EMREXTFLOODFILL TAGEMREXTFLOODFILL;
alias EMREXTFLOODFILL TEMREXTFLOODFILL;
alias EMREXTFLOODFILL* PEMREXTFLOODFILL;

struct EMREXTSELECTCLIPRGN
{
    EMR emr;
    DWORD cbRgnData;
    DWORD iMode;
    ubyte[1 + 0] RgnData;
}

alias EMREXTSELECTCLIPRGN TAGEMREXTSELECTCLIPRGN;
alias EMREXTSELECTCLIPRGN TEMREXTSELECTCLIPRGN;
alias EMREXTSELECTCLIPRGN* PEMREXTSELECTCLIPRGN;

struct EMRTEXT
{
    POINTL ptlReference;
    DWORD nChars;
    DWORD offString;
    DWORD fOptions;
    RECTL rcl;
    DWORD offDx;
}

alias EMRTEXT TAGEMRTEXT;
alias EMRTEXT TEMRTEXT;
alias EMRTEXT* PEMRTEXT;

struct EMREXTTEXTOUTA
{
    EMR emr;
    RECTL rclBounds;
    DWORD iGraphicsMode;
    FLOAT exScale;
    FLOAT eyScale;
    EMRTEXT emrtext;
}

alias EMREXTTEXTOUTA TAGEMREXTTEXTOUTA;
alias EMREXTTEXTOUTA TEMREXTTEXTOUTA;
alias EMREXTTEXTOUTA* PEMREXTTEXTOUTA;
alias EMREXTTEXTOUTA EMREXTTEXTOUTW;
alias EMREXTTEXTOUTA TEMREXTTEXTOUTW;
alias EMREXTTEXTOUTA* PEMREXTTEXTOUTW;

struct EMRFILLPATH
{
    EMR emr;
    RECTL rclBounds;
}

alias EMRFILLPATH TAGEMRFILLPATH;
alias EMRFILLPATH TEMRFILLPATH;
alias EMRFILLPATH* PEMRFILLPATH;
alias EMRFILLPATH EMRSTROKEANDFILLPATH;
alias EMRFILLPATH TEMRSTROKEANDFILLPATH;
alias EMRFILLPATH* PEMRSTROKEANDFILLPATH;
alias EMRFILLPATH EMRSTROKEPATH;
alias EMRFILLPATH TEMRSTROKEPATH;
alias EMRFILLPATH* PEMRSTROKEPATH;

struct EMRFILLRGN
{
    EMR emr;
    RECTL rclBounds;
    DWORD cbRgnData;
    DWORD ihBrush;
    ubyte[1 + 0] RgnData;
}

alias EMRFILLRGN TAGEMRFILLRGN;
alias EMRFILLRGN TEMRFILLRGN;
alias EMRFILLRGN* PEMRFILLRGN;

struct EMRFORMAT
{
    DWORD dSignature;
    DWORD nVersion;
    DWORD cbData;
    DWORD offData;
}

alias EMRFORMAT TAGEMRFORMAT;
alias EMRFORMAT TEMRFORMAT;
alias EMRFORMAT* PEMRFORMAT;

struct SIZE
{
    LONG cx;
    LONG cy;
}

alias SIZE* LPSIZE;
alias SIZE TAGSIZE;
alias SIZE TSIZE;
alias SIZE* PSIZE;
alias SIZE SIZEL;
alias SIZE TSIZEL;
alias SIZE* PSIZEL;
alias SIZE* LPSIZEL;

struct EMRFRAMERGN
{
    EMR emr;
    RECTL rclBounds;
    DWORD cbRgnData;
    DWORD ihBrush;
    SIZEL szlStroke;
    ubyte[1 + 0] RgnData;
}

alias EMRFRAMERGN TAGEMRFRAMERGN;
alias EMRFRAMERGN TEMRFRAMERGN;
alias EMRFRAMERGN* PEMRFRAMERGN;

struct EMRGDICOMMENT
{
    EMR emr;
    DWORD cbData;
    ubyte[1 + 0] Data;
}

alias EMRGDICOMMENT TAGEMRGDICOMMENT;
alias EMRGDICOMMENT TEMRGDICOMMENT;
alias EMRGDICOMMENT* PEMRGDICOMMENT;

struct EMRINVERTRGN
{
    EMR emr;
    RECTL rclBounds;
    DWORD cbRgnData;
    ubyte[1 + 0] RgnData;
}

alias EMRINVERTRGN TAGEMRINVERTRGN;
alias EMRINVERTRGN TEMRINVERTRGN;
alias EMRINVERTRGN* PEMRINVERTRGN;
alias EMRINVERTRGN EMRPAINTRGN;
alias EMRINVERTRGN TEMRPAINTRGN;
alias EMRINVERTRGN* PEMRPAINTRGN;

struct EMRLINETO
{
    EMR emr;
    POINTL ptl;
}

alias EMRLINETO TAGEMRLINETO;
alias EMRLINETO TEMRLINETO;
alias EMRLINETO* PEMRLINETO;
alias EMRLINETO EMRMOVETOEX;
alias EMRLINETO TEMRMOVETOEX;
alias EMRLINETO* PEMRMOVETOEX;

struct EMRMASKBLT
{
    EMR emr;
    RECTL rclBounds;
    LONG xDest;
    LONG yDest;
    LONG cxDest;
    LONG cyDest;
    DWORD dwRop;
    LONG xSrc;
    LONG ySrc;
    XFORM xformSrc;
    COLORREF crBkColorSrc;
    DWORD iUsageSrc;
    DWORD offBmiSrc;
    DWORD cbBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
    LONG xMask;
    LONG yMask;
    DWORD iUsageMask;
    DWORD offBmiMask;
    DWORD cbBmiMask;
    DWORD offBitsMask;
    DWORD cbBitsMask;
}

alias EMRMASKBLT TAGEMRMASKBLT;
alias EMRMASKBLT TEMRMASKBLT;
alias EMRMASKBLT* PEMRMASKBLT;

struct EMRMODIFYWORLDTRANSFORM
{
    EMR emr;
    XFORM xform;
    DWORD iMode;
}

alias EMRMODIFYWORLDTRANSFORM TAGEMRMODIFYWORLDTRANSFORM;
alias EMRMODIFYWORLDTRANSFORM TEMRMODIFYWORLDTRANSFORM;
alias EMRMODIFYWORLDTRANSFORM PEMRMODIFYWORLDTRANSFORM;

struct EMROFFSETCLIPRGN
{
    EMR emr;
    POINTL ptlOffset;
}

alias EMROFFSETCLIPRGN TAGEMROFFSETCLIPRGN;
alias EMROFFSETCLIPRGN TEMROFFSETCLIPRGN;
alias EMROFFSETCLIPRGN* PEMROFFSETCLIPRGN;

struct EMRPLGBLT
{
    EMR emr;
    RECTL rclBounds;
    POINTL[1 + 2] aptlDest;
    LONG xSrc;
    LONG ySrc;
    LONG cxSrc;
    LONG cySrc;
    XFORM xformSrc;
    COLORREF crBkColorSrc;
    DWORD iUsageSrc;
    DWORD offBmiSrc;
    DWORD cbBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
    LONG xMask;
    LONG yMask;
    DWORD iUsageMask;
    DWORD offBmiMask;
    DWORD cbBmiMask;
    DWORD offBitsMask;
    DWORD cbBitsMask;
}

alias EMRPLGBLT TAGEMRPLGBLT;
alias EMRPLGBLT TEMRPLGBLT;
alias EMRPLGBLT* PEMRPLGBLT;

struct EMRPOLYDRAW
{
    EMR emr;
    RECTL rclBounds;
    DWORD cptl;
    POINTL[1 + 0] aptl;
    ubyte[1 + 0] abTypes;
}

alias EMRPOLYDRAW TAGEMRPOLYDRAW;
alias EMRPOLYDRAW TEMRPOLYDRAW;
alias EMRPOLYDRAW* PEMRPOLYDRAW;

struct EMRPOLYDRAW16
{
    EMR emr;
    RECTL rclBounds;
    DWORD cpts;
    POINTS[1 + 0] apts;
    ubyte[1 + 0] abTypes;
}

alias EMRPOLYDRAW16 TAGEMRPOLYDRAW16;
alias EMRPOLYDRAW16 TEMRPOLYDRAW16;
alias EMRPOLYDRAW16* PEMRPOLYDRAW16;

struct EMRPOLYLINE
{
    EMR emr;
    RECTL rclBounds;
    DWORD cptl;
    POINTL[1 + 0] aptl;
}

alias EMRPOLYLINE TAGEMRPOLYLINE;
alias EMRPOLYLINE TEMRPOLYLINE;
alias EMRPOLYLINE* PEMRPOLYLINE;
alias EMRPOLYLINE EMRPOLYBEZIER;
alias EMRPOLYLINE TEMRPOLYBEZIER;
alias EMRPOLYLINE* PEMRPOLYBEZIER;
alias EMRPOLYLINE EMRPOLYGON;
alias EMRPOLYLINE TEMRPOLYGON;
alias EMRPOLYLINE* PEMRPOLYGON;
alias EMRPOLYLINE EMRPOLYBEZIERTO;
alias EMRPOLYLINE TEMRPOLYBEZIERTO;
alias EMRPOLYLINE* PEMRPOLYBEZIERTO;
alias EMRPOLYLINE EMRPOLYLINETO;
alias EMRPOLYLINE TEMRPOLYLINETO;
alias EMRPOLYLINE* PEMRPOLYLINETO;

struct EMRPOLYLINE16
{
    EMR emr;
    RECTL rclBounds;
    DWORD cpts;
    POINTL[1 + 0] apts;
}

alias EMRPOLYLINE16 TAGEMRPOLYLINE16;
alias EMRPOLYLINE16 TEMRPOLYLINE16;
alias EMRPOLYLINE16* PEMRPOLYLINE16;
alias EMRPOLYLINE16 EMRPOLYBEZIER16;
alias EMRPOLYLINE16 TEMRPOLYBEZIER16;
alias EMRPOLYLINE16* PEMRPOLYBEZIER16;
alias EMRPOLYLINE16 EMRPOLYGON16;
alias EMRPOLYLINE16 TEMRPOLYGON16;
alias EMRPOLYLINE16* PEMRPOLYGON16;
alias EMRPOLYLINE16 EMRPOLYBEZIERTO16;
alias EMRPOLYLINE16 TEMRPOLYBEZIERTO16;
alias EMRPOLYLINE16* PEMRPOLYBEZIERTO16;
alias EMRPOLYLINE16 EMRPOLYLINETO16;
alias EMRPOLYLINE16 TEMRPOLYLINETO16;
alias EMRPOLYLINE16* PEMRPOLYLINETO16;

struct EMRPOLYPOLYLINE
{
    EMR emr;
    RECTL rclBounds;
    DWORD nPolys;
    DWORD cptl;
    DWORD[1 + 0] aPolyCounts;
    POINTL[1 + 0] aptl;
}

alias EMRPOLYPOLYLINE TAGEMRPOLYPOLYLINE;
alias EMRPOLYPOLYLINE TEMRPOLYPOLYLINE;
alias EMRPOLYPOLYLINE* PEMRPOLYPOLYLINE;
alias EMRPOLYPOLYLINE EMRPOLYPOLYGON;
alias EMRPOLYPOLYLINE TEMRPOLYPOLYGON;
alias EMRPOLYPOLYLINE* PEMRPOLYPOLYGON;

struct EMRPOLYPOLYLINE16
{
    EMR emr;
    RECTL rclBounds;
    DWORD nPolys;
    DWORD cpts;
    DWORD[1 + 0] aPolyCounts;
    POINTS[1 + 0] apts;
}

alias EMRPOLYPOLYLINE16 TAGEMRPOLYPOLYLINE16;
alias EMRPOLYPOLYLINE16 TEMRPOLYPOLYLINE16;
alias EMRPOLYPOLYLINE16* PEMRPOLYPOLYLINE16;
alias EMRPOLYPOLYLINE16 EMRPOLYPOLYGON16;
alias EMRPOLYPOLYLINE16 TEMRPOLYPOLYGON16;
alias EMRPOLYPOLYLINE16* PEMRPOLYPOLYGON16;

struct EMRPOLYTEXTOUTA
{
    EMR emr;
    RECTL rclBounds;
    DWORD iGraphicsMode;
    FLOAT exScale;
    FLOAT eyScale;
    LONG cStrings;
    EMRTEXT[1 + 0] aemrtext;
}

alias EMRPOLYTEXTOUTA TAGEMRPOLYTEXTOUTA;
alias EMRPOLYTEXTOUTA TEMRPOLYTEXTOUTA;
alias EMRPOLYTEXTOUTA* PEMRPOLYTEXTOUTA;
alias EMRPOLYTEXTOUTA EMRPOLYTEXTOUTW;
alias EMRPOLYTEXTOUTA TEMRPOLYTEXTOUTW;
alias EMRPOLYTEXTOUTA* PEMRPOLYTEXTOUTW;

struct EMRRESIZEPALETTE
{
    EMR emr;
    DWORD ihPal;
    DWORD cEntries;
}

alias EMRRESIZEPALETTE TAGEMRRESIZEPALETTE;
alias EMRRESIZEPALETTE TEMRRESIZEPALETTE;
alias EMRRESIZEPALETTE* PEMRRESIZEPALETTE;

struct EMRRESTOREDC
{
    EMR emr;
    LONG iRelative;
}

alias EMRRESTOREDC TAGEMRRESTOREDC;
alias EMRRESTOREDC TEMRRESTOREDC;
alias EMRRESTOREDC* PEMRRESTOREDC;

struct EMRROUNDRECT
{
    EMR emr;
    RECTL rclBox;
    SIZEL szlCorner;
}

alias EMRROUNDRECT TAGEMRROUNDRECT;
alias EMRROUNDRECT TEMRROUNDRECT;
alias EMRROUNDRECT* PEMRROUNDRECT;

struct EMRSCALEVIEWPORTEXTEX
{
    EMR emr;
    LONG xNum;
    LONG xDenom;
    LONG yNum;
    LONG yDenom;
}

alias EMRSCALEVIEWPORTEXTEX TAGEMRSCALEVIEWPORTEXTEX;
alias EMRSCALEVIEWPORTEXTEX TEMRSCALEVIEWPORTEXTEX;
alias EMRSCALEVIEWPORTEXTEX* PEMRSCALEVIEWPORTEXTEX;
alias EMRSCALEVIEWPORTEXTEX EMRSCALEWINDOWEXTEX;
alias EMRSCALEVIEWPORTEXTEX TEMRSCALEWINDOWEXTEX;
alias EMRSCALEVIEWPORTEXTEX* PEMRSCALEWINDOWEXTEX;

struct EMRSELECTCOLORSPACE
{
    EMR emr;
    DWORD ihCS;
}

alias EMRSELECTCOLORSPACE TAGEMRSELECTCOLORSPACE;
alias EMRSELECTCOLORSPACE TEMRSELECTCOLORSPACE;
alias EMRSELECTCOLORSPACE* PEMRSELECTCOLORSPACE;
alias EMRSELECTCOLORSPACE EMRDELETECOLORSPACE;
alias EMRSELECTCOLORSPACE TEMRDELETECOLORSPACE;
alias EMRSELECTCOLORSPACE* PEMRDELETECOLORSPACE;

struct EMRSELECTOBJECT
{
    EMR emr;
    DWORD ihObject;
}

alias EMRSELECTOBJECT TAGEMRSELECTOBJECT;
alias EMRSELECTOBJECT TEMRSELECTOBJECT;
alias EMRSELECTOBJECT* PEMRSELECTOBJECT;
alias EMRSELECTOBJECT EMRDELETEOBJECT;
alias EMRSELECTOBJECT TEMRDELETEOBJECT;
alias EMRSELECTOBJECT* PEMRDELETEOBJECT;

struct EMRSELECTPALETTE
{
    EMR emr;
    DWORD ihPal;
}

alias EMRSELECTPALETTE TAGEMRSELECTPALETTE;
alias EMRSELECTPALETTE TEMRSELECTPALETTE;
alias EMRSELECTPALETTE* PEMRSELECTPALETTE;

struct EMRSETARCDIRECTION
{
    EMR emr;
    DWORD iArcDirection;
}

alias EMRSETARCDIRECTION TAGEMRSETARCDIRECTION;
alias EMRSETARCDIRECTION TEMRSETARCDIRECTION;
alias EMRSETARCDIRECTION* PEMRSETARCDIRECTION;

struct EMRSETBKCOLOR
{
    EMR emr;
    COLORREF crColor;
}

alias EMRSETBKCOLOR TAGEMRSETTEXTCOLOR;
alias EMRSETBKCOLOR TEMRSETBKCOLOR;
alias EMRSETBKCOLOR* PEMRSETBKCOLOR;
alias EMRSETBKCOLOR EMRSETTEXTCOLOR;
alias EMRSETBKCOLOR TEMRSETTEXTCOLOR;
alias EMRSETBKCOLOR* PEMRSETTEXTCOLOR;

struct EMRSETCOLORADJUSTMENT
{
    EMR emr;
    COLORADJUSTMENT ColorAdjustment;
}

alias EMRSETCOLORADJUSTMENT TAGEMRSETCOLORADJUSTMENT;
alias EMRSETCOLORADJUSTMENT TEMRSETCOLORADJUSTMENT;
alias EMRSETCOLORADJUSTMENT* PEMRSETCOLORADJUSTMENT;

struct EMRSETDIBITSTODEVICE
{
    EMR emr;
    RECTL rclBounds;
    LONG xDest;
    LONG yDest;
    LONG xSrc;
    LONG ySrc;
    LONG cxSrc;
    LONG cySrc;
    DWORD offBmiSrc;
    DWORD cbBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
    DWORD iUsageSrc;
    DWORD iStartScan;
    DWORD cScans;
}

alias EMRSETDIBITSTODEVICE TAGEMRSETDIBITSTODEVICE;
alias EMRSETDIBITSTODEVICE TEMRSETDIBITSTODEVICE;
alias EMRSETDIBITSTODEVICE* PEMRSETDIBITSTODEVICE;

struct EMRSETMAPPERFLAGS
{
    EMR emr;
    DWORD dwFlags;
}

alias EMRSETMAPPERFLAGS TAGEMRSETMAPPERFLAGS;
alias EMRSETMAPPERFLAGS TEMRSETMAPPERFLAGS;
alias EMRSETMAPPERFLAGS* PEMRSETMAPPERFLAGS;

struct EMRSETMITERLIMIT
{
    EMR emr;
    FLOAT eMiterLimit;
}

alias EMRSETMITERLIMIT TAGEMRSETMITERLIMIT;
alias EMRSETMITERLIMIT TEMRSETMITERLIMIT;
alias EMRSETMITERLIMIT* PEMRSETMITERLIMIT;

struct EMRSETPALETTEENTRIES
{
    EMR emr;
    DWORD ihPal;
    DWORD iStart;
    DWORD cEntries;
    PALETTEENTRY[1 + 0] aPalEntries;
}

alias EMRSETPALETTEENTRIES TAGEMRSETPALETTEENTRIES;
alias EMRSETPALETTEENTRIES TEMRSETPALETTEENTRIES;
alias EMRSETPALETTEENTRIES* PEMRSETPALETTEENTRIES;

struct EMRSETPIXELV
{
    EMR emr;
    POINTL ptlPixel;
    COLORREF crColor;
}

alias EMRSETPIXELV TAGEMRSETPIXELV;
alias EMRSETPIXELV TEMRSETPIXELV;
alias EMRSETPIXELV* PEMRSETPIXELV;

struct EMRSETVIEWPORTEXTEX
{
    EMR emr;
    SIZEL szlExtent;
}

alias EMRSETVIEWPORTEXTEX TAGEMRSETVIEWPORTEXTEX;
alias EMRSETVIEWPORTEXTEX TEMRSETVIEWPORTEXTEX;
alias EMRSETVIEWPORTEXTEX* PEMRSETVIEWPORTEXTEX;
alias EMRSETVIEWPORTEXTEX EMRSETWINDOWEXTEX;
alias EMRSETVIEWPORTEXTEX TEMRSETWINDOWEXTEX;
alias EMRSETVIEWPORTEXTEX* PEMRSETWINDOWEXTEX;

struct EMRSETVIEWPORTORGEX
{
    EMR emr;
    POINTL ptlOrigin;
}

alias EMRSETVIEWPORTORGEX TAGEMRSETVIEWPORTORGEX;
alias EMRSETVIEWPORTORGEX TEMRSETVIEWPORTORGEX;
alias EMRSETVIEWPORTORGEX* PEMRSETVIEWPORTORGEX;
alias EMRSETVIEWPORTORGEX EMRSETWINDOWORGEX;
alias EMRSETVIEWPORTORGEX TEMRSETWINDOWORGEX;
alias EMRSETVIEWPORTORGEX* PEMRSETWINDOWORGEX;
alias EMRSETVIEWPORTORGEX EMRSETBRUSHORGEX;
alias EMRSETVIEWPORTORGEX TEMRSETBRUSHORGEX;
alias EMRSETVIEWPORTORGEX* PEMRSETBRUSHORGEX;

struct EMRSETWORLDTRANSFORM
{
    EMR emr;
    XFORM xform;
}

alias EMRSETWORLDTRANSFORM TAGEMRSETWORLDTRANSFORM;
alias EMRSETWORLDTRANSFORM TEMRSETWORLDTRANSFORM;
alias EMRSETWORLDTRANSFORM* PEMRSETWORLDTRANSFORM;

struct EMRSTRETCHBLT
{
    EMR emr;
    RECTL rclBounds;
    LONG xDest;
    LONG yDest;
    LONG cxDest;
    LONG cyDest;
    DWORD dwRop;
    LONG xSrc;
    LONG ySrc;
    XFORM xformSrc;
    COLORREF crBkColorSrc;
    DWORD iUsageSrc;
    DWORD offBmiSrc;
    DWORD cbBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
    LONG cxSrc;
    LONG cySrc;
}

alias EMRSTRETCHBLT TAGEMRSTRETCHBLT;
alias EMRSTRETCHBLT TEMRSTRETCHBLT;
alias EMRSTRETCHBLT* PEMRSTRETCHBLT;

struct EMRSTRETCHDIBITS
{
    EMR emr;
    RECTL rclBounds;
    LONG xDest;
    LONG yDest;
    LONG xSrc;
    LONG ySrc;
    LONG cxSrc;
    LONG cySrc;
    DWORD offBmiSrc;
    DWORD cbBmiSrc;
    DWORD offBitsSrc;
    DWORD cbBitsSrc;
    DWORD iUsageSrc;
    DWORD dwRop;
    LONG cxDest;
    LONG cyDest;
}

alias EMRSTRETCHDIBITS TAGEMRSTRETCHDIBITS;
alias EMRSTRETCHDIBITS TEMRSTRETCHDIBITS;
alias EMRSTRETCHDIBITS* PEMRSTRETCHDIBITS;

struct EMRABORTPATH
{
    EMR emr;
}

alias EMRABORTPATH TEMRABORTPATH;
alias EMRABORTPATH* PEMRABORTPATH;
alias EMRABORTPATH TAGABORTPATH;
alias EMRABORTPATH TABORTPATH;
alias EMRABORTPATH EMRBEGINPATH;
alias EMRABORTPATH TEMRBEGINPATH;
alias EMRABORTPATH* PEMRBEGINPATH;
alias EMRABORTPATH EMRENDPATH;
alias EMRABORTPATH TEMRENDPATH;
alias EMRABORTPATH* PEMRENDPATH;
alias EMRABORTPATH EMRCLOSEFIGURE;
alias EMRABORTPATH TEMRCLOSEFIGURE;
alias EMRABORTPATH* PEMRCLOSEFIGURE;
alias EMRABORTPATH EMRFLATTENPATH;
alias EMRABORTPATH TEMRFLATTENPATH;
alias EMRABORTPATH* PEMRFLATTENPATH;
alias EMRABORTPATH EMRWIDENPATH;
alias EMRABORTPATH TEMRWIDENPATH;
alias EMRABORTPATH* PEMRWIDENPATH;
alias EMRABORTPATH EMRSETMETARGN;
alias EMRABORTPATH TEMRSETMETARGN;
alias EMRABORTPATH* PEMRSETMETARGN;
alias EMRABORTPATH EMRSAVEDC;
alias EMRABORTPATH TEMRSAVEDC;
alias EMRABORTPATH* PEMRSAVEDC;
alias EMRABORTPATH EMRREALIZEPALETTE;
alias EMRABORTPATH TEMRREALIZEPALETTE;
alias EMRABORTPATH* PEMRREALIZEPALETTE;

struct EMRSELECTCLIPPATH
{
    EMR emr;
    DWORD iMode;
}

alias EMRSELECTCLIPPATH TAGEMRSELECTCLIPPATH;
alias EMRSELECTCLIPPATH TEMRSELECTCLIPPATH;
alias EMRSELECTCLIPPATH* PEMRSELECTCLIPPATH;
alias EMRSELECTCLIPPATH EMRSETBKMODE;
alias EMRSELECTCLIPPATH TEMRSETBKMODE;
alias EMRSELECTCLIPPATH* PEMRSETBKMODE;
alias EMRSELECTCLIPPATH EMRSETMAPMODE;
alias EMRSELECTCLIPPATH TEMRSETMAPMODE;
alias EMRSELECTCLIPPATH* PEMRSETMAPMODE;
alias EMRSELECTCLIPPATH EMRSETPOLYFILLMODE;
alias EMRSELECTCLIPPATH TEMRSETPOLYFILLMODE;
alias EMRSELECTCLIPPATH* PEMRSETPOLYFILLMODE;
alias EMRSELECTCLIPPATH EMRSETROP2;
alias EMRSELECTCLIPPATH TEMRSETROP2;
alias EMRSELECTCLIPPATH* PEMRSETROP2;
alias EMRSELECTCLIPPATH EMRSETSTRETCHBLTMODE;
alias EMRSELECTCLIPPATH TEMRSETSTRETCHBLTMODE;
alias EMRSELECTCLIPPATH* PEMRSETSTRETCHBLTMODE;
alias EMRSELECTCLIPPATH EMRSETTEXTALIGN;
alias EMRSELECTCLIPPATH TEMRSETTEXTALIGN;
alias EMRSELECTCLIPPATH* PEMRSETTEXTALIGN;
alias EMRSELECTCLIPPATH EMRENABLEICM;
alias EMRSELECTCLIPPATH TEMRENABLEICM;
alias EMRSELECTCLIPPATH* PEMRENABLEICM;

struct NMHDR
{
    HWND hwndFrom;
    UINT idFrom;
    UINT code;
}

alias NMHDR TAGNMHDR;
alias NMHDR TNMHDR;
alias NMHDR* PNMHDR;

struct ENCORRECTTEXT
{
    NMHDR nmhdr;
    CHARRANGE chrg;
    ushort seltyp;
}

alias ENCORRECTTEXT _ENCORRECTTEXT;
alias ENCORRECTTEXT TENCORRECTTEXT;
alias ENCORRECTTEXT* PENCORRECTTEXT;

struct ENDROPFILES
{
    NMHDR nmhdr;
    HANDLE hDrop;
    LONG cp;
    BOOL fProtected;
}

alias ENDROPFILES _ENDROPFILES;
alias ENDROPFILES TENDROPFILES;
alias ENDROPFILES* PENDROPFILES;

struct ENSAVECLIPBOARD
{
    NMHDR nmhdr;
    LONG cObjectCount;
    LONG cch;
}

alias ENSAVECLIPBOARD TENSAVECLIPBOARD;
alias ENSAVECLIPBOARD* PENSAVECLIPBOARD;

struct ENOLEOPFAILED
{
    NMHDR nmhdr;
    LONG iob;
    LONG lOper;
    HRESULT hr;
}

alias ENOLEOPFAILED TENOLEOPFAILED;
alias ENOLEOPFAILED* PENOLEOPFAILED;

struct ENHMETAHEADER
{
    DWORD iType;
    DWORD nSize;
    RECTL rclBounds;
    RECTL rclFrame;
    DWORD dSignature;
    DWORD nVersion;
    DWORD nBytes;
    DWORD nRecords;
    ushort nHandles;
    ushort sReserved;
    DWORD nDescription;
    DWORD offDescription;
    DWORD nPalEntries;
    SIZEL szlDevice;
    SIZEL szlMillimeters;
}

alias ENHMETAHEADER* LPENHMETAHEADER;
alias ENHMETAHEADER TAGENHMETAHEADER;
alias ENHMETAHEADER TENHMETAHEADER;
alias ENHMETAHEADER* PENHMETAHEADER;

struct ENHMETARECORD
{
    DWORD iType;
    DWORD nSize;
    DWORD[1 + 0] dParm;
}

alias ENHMETARECORD* LPENHMETARECORD;
alias ENHMETARECORD TAGENHMETARECORD;
alias ENHMETARECORD TENHMETARECORD;
alias ENHMETARECORD* PENHMETARECORD;

struct ENPROTECTED
{
    NMHDR nmhdr;
    UINT msg;
    WPARAM wParam;
    LPARAM lParam;
    CHARRANGE chrg;
}

alias ENPROTECTED _ENPROTECTED;
alias ENPROTECTED TENPROTECTED;
alias ENPROTECTED* PENPROTECTED;

struct SERVICE_STATUS
{
    DWORD dwServiceType;
    DWORD dwCurrentState;
    DWORD dwControlsAccepted;
    DWORD dwWin32ExitCode;
    DWORD dwServiceSpecificExitCode;
    DWORD dwCheckPoint;
    DWORD dwWaitHint;
}

alias SERVICE_STATUS* LPSERVICE_STATUS;
alias SERVICE_STATUS _SERVICE_STATUS;
alias SERVICE_STATUS TSERVICESTATUS;
alias SERVICE_STATUS* PSERVICESTATUS;

struct ENUM_SERVICE_STATUS
{
    LPTSTR lpServiceName;
    LPTSTR lpDisplayName;
    SERVICE_STATUS ServiceStatus;
}

alias ENUM_SERVICE_STATUS* LPENUM_SERVICE_STATUS;
alias ENUM_SERVICE_STATUS _ENUM_SERVICE_STATUS;
alias ENUM_SERVICE_STATUS TENUMSERVICESTATUS;
alias ENUM_SERVICE_STATUS* PENUMSERVICESTATUS;

struct ENUMLOGFONT
{
    LOGFONT elfLogFont;
    BCHAR[1 + LF_FULLFACESIZE-1] elfFullName;
    BCHAR[1 + LF_FACESIZE-1] elfStyle;
}

alias ENUMLOGFONT TAGENUMLOGFONT;
alias ENUMLOGFONT TENUMLOGFONT;
alias ENUMLOGFONT* PENUMLOGFONT;

struct ENUMLOGFONTEX
{
    LOGFONT elfLogFont;
    BCHAR[1 + LF_FULLFACESIZE-1] elfFullName;
    BCHAR[1 + LF_FACESIZE-1] elfStyle;
    BCHAR[1 + LF_FACESIZE-1] elfScript;
}

alias ENUMLOGFONTEX TAGENUMLOGFONTEX;
alias ENUMLOGFONTEX TENUMLOGFONTEX;
alias ENUMLOGFONTEX* PENUMLOGFONTEX;

struct EVENTLOGRECORD
{
    DWORD Length;
    DWORD Reserved;
    DWORD RecordNumber;
    DWORD TimeGenerated;
    DWORD TimeWritten;
    DWORD EventID;
    ushort EventType;
    ushort NumStrings;
    ushort EventCategory;
    ushort ReservedFlags;
    DWORD ClosingRecordNumber;
    DWORD StringOffset;
    DWORD UserSidLength;
    DWORD UserSidOffset;
    DWORD DataLength;
    DWORD DataOffset;
}

alias EVENTLOGRECORD _EVENTLOGRECORD;
alias EVENTLOGRECORD TEVENTLOGRECORD;
alias EVENTLOGRECORD* PEVENTLOGRECORD;

struct EVENTMSG
{
    UINT message;
    UINT paramL;
    UINT paramH;
    DWORD time;
    HWND hwnd;
}

alias EVENTMSG TAGEVENTMSG;
alias EVENTMSG TEVENTMSG;
alias EVENTMSG* PEVENTMSG;

struct EXCEPTION_POINTERS
{
    PEXCEPTION_RECORD ExceptionRecord;
    PCONTEXT ContextRecord;
}

alias EXCEPTION_POINTERS* LPEXCEPTION_POINTERS;
alias EXCEPTION_POINTERS* PEXCEPTION_POINTERS;
alias EXCEPTION_POINTERS _EXCEPTION_POINTERS;
alias EXCEPTION_POINTERS TEXCEPTIONPOINTERS;
alias EXCEPTION_POINTERS* PEXCEPTIONPOINTERS;

struct EXT_BUTTON
{
    ushort idCommand;
    ushort idsHelp;
    ushort fsStyle;
}

alias EXT_BUTTON* LPEXT_BUTTON;
alias EXT_BUTTON _EXT_BUTTON;
alias EXT_BUTTON TEXTBUTTON;
alias EXT_BUTTON* PEXTBUTTON;

struct FILTERKEYS
{
    UINT cbSize;
    DWORD dwFlags;
    DWORD iWaitMSec;
    DWORD iDelayMSec;
    DWORD iRepeatMSec;
    DWORD iBounceMSec;
}

alias FILTERKEYS TAGFILTERKEYS;
alias FILTERKEYS TFILTERKEYS;
alias FILTERKEYS* PFILTERKEYS;

struct FIND_NAME_BUFFER
{
    UCHAR length;
    UCHAR access_control;
    UCHAR frame_control;
    UCHAR[1 + 5] destination_addr;
    UCHAR[1 + 5] source_addr;
    UCHAR[1 + 17] routing_info;
}

alias FIND_NAME_BUFFER _FIND_NAME_BUFFER;
alias FIND_NAME_BUFFER TFINDNAMEBUFFER;
alias FIND_NAME_BUFFER* PFINDNAMEBUFFER;

struct FIND_NAME_HEADER
{
    ushort node_count;
    UCHAR reserved;
    UCHAR unique_group;
}

alias FIND_NAME_HEADER _FIND_NAME_HEADER;
alias FIND_NAME_HEADER TFINDNAMEHEADER;
alias FIND_NAME_HEADER* PFINDNAMEHEADER;

struct FINDREPLACE
{
    DWORD lStructSize;
    HWND hwndOwner;
    HINST hInstance;
    DWORD Flags;
    LPTSTR lpstrFindWhat;
    LPTSTR lpstrReplaceWith;
    ushort wFindWhatLen;
    ushort wReplaceWithLen;
    LPARAM lCustData;
    LPFRHOOKPROC lpfnHook;
    LPCTSTR lpTemplateName;
}

alias FINDREPLACE* LPFINDREPLACE;
alias FINDREPLACE TFINDREPLACE;
alias FINDREPLACE* PFINDREPLACE;

struct TFINDTEXT
{
    CHARRANGE chrg;
    LPSTR lpstrText;
}

alias TFINDTEXT _FINDTEXT;
alias TFINDTEXT* PFINDTEXT;

struct FINDTEXTEX
{
    CHARRANGE chrg;
    LPSTR lpstrText;
    CHARRANGE chrgText;
}

alias FINDTEXTEX _FINDTEXTEX;
alias FINDTEXTEX TFINDTEXTEX;
alias FINDTEXTEX* PFINDTEXTEX;

struct FMS_GETDRIVEINFO
{
    DWORD dwTotalSpace;
    DWORD dwFreeSpace;
    TCHAR[1 + 259] szPath;
    TCHAR[1 + 13] szVolume;
    TCHAR[1 + 127] szShare;
}

alias FMS_GETDRIVEINFO _FMS_GETDRIVEINFO;
alias FMS_GETDRIVEINFO TFMSGETDRIVEINFO;
alias FMS_GETDRIVEINFO* PFMSGETDRIVEINFO;

struct FMS_GETFILESEL
{
    FILETIME ftTime;
    DWORD dwSize;
    ubyte bAttr;
    TCHAR[1 + 259] szName;
}

alias FMS_GETFILESEL _FMS_GETFILESEL;
alias FMS_GETFILESEL TFMSGETFILESEL;
alias FMS_GETFILESEL* PFMSGETFILESEL;

struct FMS_LOAD
{
    DWORD dwSize;
    TCHAR[1 + MENU_TEXT_LEN-1] szMenuName;
    HMENU hMenu;
    UINT wMenuDelta;
}

alias FMS_LOAD _FMS_LOAD;
alias FMS_LOAD TFMSLOAD;
alias FMS_LOAD* PFMSLOAD;

struct FMS_TOOLBARLOAD
{
    DWORD dwSize;
    LPEXT_BUTTON lpButtons;
    ushort cButtons;
    ushort cBitmaps;
    ushort idBitmap;
    HBITMAP hBitmap;
}

alias FMS_TOOLBARLOAD _FMS_TOOLBARLOAD;
alias FMS_TOOLBARLOAD TFMSTOOLBARLOAD;
alias FMS_TOOLBARLOAD* PFMSTOOLBARLOAD;

struct FOCUS_EVENT_RECORD
{
    BOOL bSetFocus;
}

alias FOCUS_EVENT_RECORD _FOCUS_EVENT_RECORD;
alias FOCUS_EVENT_RECORD TFOCUSEVENTRECORD;
alias FOCUS_EVENT_RECORD* PFOCUSEVENTRECORD;

struct FORM_INFO_1
{
    DWORD Flags;
    LPTSTR pName;
    SIZEL Size;
    RECTL ImageableArea;
}

alias FORM_INFO_1 _FORM_INFO_1;
alias FORM_INFO_1 TFORMINFO1;
alias FORM_INFO_1* PFORMINFO1;

struct FORMAT_PARAMETERS
{
    MEDIA_TYPE MediaType;
    DWORD StartCylinderNumber;
    DWORD EndCylinderNumber;
    DWORD StartHeadNumber;
    DWORD EndHeadNumber;
}

alias FORMAT_PARAMETERS _FORMAT_PARAMETERS;
alias FORMAT_PARAMETERS TFORMATPARAMETERS;
alias FORMAT_PARAMETERS* PFORMATPARAMETERS;

struct FORMATRANGE
{
    HDC _hdc;
    HDC hdcTarget;
    RECT rc;
    RECT rcPage;
    CHARRANGE chrg;
}

alias FORMATRANGE _FORMATRANGE;
alias FORMATRANGE TFORMATRANGE;
alias FORMATRANGE* PFORMATRANGE;

struct GCP_RESULTS
{
    DWORD lStructSize;
    LPTSTR lpOutString;
    UINT* lpOrder;
    INT* lpDx;
    INT* lpCaretPos;
    LPTSTR lpClass;
    UINT* lpGlyphs;
    UINT nGlyphs;
    UINT nMaxFit;
}

alias GCP_RESULTS* LPGCP_RESULTS;
alias GCP_RESULTS TAGGCP_RESULTS;
alias GCP_RESULTS TGCPRESULTS;
alias GCP_RESULTS* PGCPRESULTS;

struct GENERIC_MAPPING
{
    ACCESS_MASK GenericRead;
    ACCESS_MASK GenericWrite;
    ACCESS_MASK GenericExecute;
    ACCESS_MASK GenericAll;
}

alias GENERIC_MAPPING* PGENERIC_MAPPING;
alias GENERIC_MAPPING _GENERIC_MAPPING;
alias GENERIC_MAPPING TGENERICMAPPING;
alias GENERIC_MAPPING* PGENERICMAPPING;

struct GLYPHMETRICS
{
    UINT gmBlackBoxX;
    UINT gmBlackBoxY;
    POINT gmptGlyphOrigin;
    int gmCellIncX;
    int gmCellIncY;
}

alias GLYPHMETRICS* LPGLYPHMETRICS;
alias GLYPHMETRICS _GLYPHMETRICS;
alias GLYPHMETRICS TGLYPHMETRICS;
alias GLYPHMETRICS* PGLYPHMETRICS;

struct HANDLETABLE
{
    HGDIOBJ[1 + 0] objectHandle;
}

alias HANDLETABLE TAGHANDLETABLE;
alias HANDLETABLE THANDLETABLE;
alias HANDLETABLE* LPHANDLETABLE;

struct HD_HITTESTINFO
{
    POINT pt;
    UINT flags;
    int iItem;
}

alias HD_HITTESTINFO _HD_HITTESTINFO;
alias HD_HITTESTINFO THDHITTESTINFO;
alias HD_HITTESTINFO* PHDHITTESTINFO;

struct HD_ITEM
{
    UINT mask;
    int cxy;
    LPTSTR pszText;
    HBITMAP hbm;
    int cchTextMax;
    int fmt;
    LPARAM lParam;
}

alias HD_ITEM _HD_ITEM;
alias HD_ITEM THDITEM;
alias HD_ITEM* PHDITEM;

struct WINDOWPOS
{
    HWND _hwnd;
    HWND hwndInsertAfter;
    int x;
    int y;
    int cx;
    int cy;
    UINT flags;
}

alias WINDOWPOS* LPWINDOWPOS;
alias WINDOWPOS _WINDOWPOS;
alias WINDOWPOS TWINDOWPOS;
alias WINDOWPOS* PWINDOWPOS;

struct HD_LAYOUT
{
    RECT* prc;
    WINDOWPOS* pwpos;
}

alias HD_LAYOUT _HD_LAYOUT;
alias HD_LAYOUT THDLAYOUT;
alias HD_LAYOUT* PHDLAYOUT;

struct HD_NOTIFY
{
    NMHDR hdr;
    int iItem;
    int iButton;
    HD_ITEM* pitem;
}

alias HD_NOTIFY _HD_NOTIFY;
alias HD_NOTIFY THDNOTIFY;
alias HD_NOTIFY* PHDNOTIFY;

struct HELPINFO
{
    UINT cbSize;
    int iContextType;
    int iCtrlId;
    HANDLE hItemHandle;
    DWORD dwContextId;
    POINT MousePos;
}

alias HELPINFO* LPHELPINFO;
alias HELPINFO TAGHELPINFO;
alias HELPINFO THELPINFO;
alias HELPINFO* PHELPINFO;

struct HELPWININFO
{
    int wStructSize;
    int x;
    int y;
    int dx;
    int dy;
    int wMax;
    TCHAR[1 + 1] rgchMember;
}

alias HELPWININFO THELPWININFO;
alias HELPWININFO* PHELPWININFO;

struct HIGHCONTRAST
{
    UINT cbSize;
    DWORD dwFlags;
    LPTSTR lpszDefaultScheme;
}

alias HIGHCONTRAST* LPHIGHCONTRAST;
alias HIGHCONTRAST TAGHIGHCONTRAST;
alias HIGHCONTRAST THIGHCONTRAST;
alias HIGHCONTRAST* PHIGHCONTRAST;

struct HSZPAIR
{
    HSZ hszSvc;
    HSZ hszTopic;
}

alias HSZPAIR TAGHSZPAIR;
alias HSZPAIR THSZPAIR;
alias HSZPAIR* PHSZPAIR;

struct ICONINFO
{
    BOOL fIcon;
    DWORD xHotspot;
    DWORD yHotspot;
    HBITMAP hbmMask;
    HBITMAP hbmColor;
}

alias ICONINFO _ICONINFO;
alias ICONINFO TICONINFO;
alias ICONINFO* PICONINFO;

struct ICONMETRICS
{
    UINT cbSize;
    int iHorzSpacing;
    int iVertSpacing;
    int iTitleWrap;
    LOGFONT lfFont;
}

alias ICONMETRICS* LPICONMETRICS;
alias ICONMETRICS TAGICONMETRICS;
alias ICONMETRICS TICONMETRICS;
alias ICONMETRICS* PICONMETRICS;

struct IMAGEINFO
{
    HBITMAP hbmImage;
    HBITMAP hbmMask;
    int Unused1;
    int Unused2;
    RECT rcImage;
}

alias IMAGEINFO _IMAGEINFO;
alias IMAGEINFO TIMAGEINFO;
alias IMAGEINFO* PIMAGEINFO;

align(1) struct KEY_EVENT_RECORD
{
    BOOL bKeyDown;
    ushort wRepeatCount;
    ushort wVirtualKeyCode;
    ushort wVirtualScanCode;

    union
    {
        struct
        {
            WCHAR UnicodeChar;
            DWORD dwControlKeyState;
        }
        struct
        {
            char AsciiChar;
        }
    }
}

alias KEY_EVENT_RECORD _KEY_EVENT_RECORD;
alias KEY_EVENT_RECORD TKEYEVENTRECORD;
alias KEY_EVENT_RECORD* PKEYEVENTRECORD;

struct MOUSE_EVENT_RECORD
{
    COORD dwMousePosition;
    DWORD dwButtonState;
    DWORD dwControlKeyState;
    DWORD dwEventFlags;
}

alias MOUSE_EVENT_RECORD _MOUSE_EVENT_RECORD;
alias MOUSE_EVENT_RECORD TMOUSEEVENTRECORD;
alias MOUSE_EVENT_RECORD* PMOUSEEVENTRECORD;

struct WINDOW_BUFFER_SIZE_RECORD
{
    COORD dwSize;
}

alias WINDOW_BUFFER_SIZE_RECORD _WINDOW_BUFFER_SIZE_RECORD;
alias WINDOW_BUFFER_SIZE_RECORD TWINDOWBUFFERSIZERECORD;
alias WINDOW_BUFFER_SIZE_RECORD* PWINDOWBUFFERSIZERECORD;

struct MENU_EVENT_RECORD
{
    UINT dwCommandId;
}

alias MENU_EVENT_RECORD* PMENU_EVENT_RECORD;
alias MENU_EVENT_RECORD _MENU_EVENT_RECORD;
alias MENU_EVENT_RECORD TMENUEVENTRECORD;
alias MENU_EVENT_RECORD* PMENUEVENTRECORD;

struct INPUT_RECORD
{
    ushort EventType;

    union
    {
        struct
        {
            KEY_EVENT_RECORD KeyEvent;
        }
        struct
        {
            MOUSE_EVENT_RECORD MouseEvent;
        }
        struct
        {
            WINDOW_BUFFER_SIZE_RECORD WindowBufferSizeEvent;
        }
        struct
        {
            MENU_EVENT_RECORD MenuEvent;
        }
        struct
        {
            FOCUS_EVENT_RECORD FocusEvent;
        }
    }
}

alias INPUT_RECORD* PINPUT_RECORD;
alias INPUT_RECORD _INPUT_RECORD;
alias INPUT_RECORD TINPUTRECORD;
alias INPUT_RECORD* PINPUTRECORD;

struct SYSTEMTIME
{
    ushort wYear;
    ushort wMonth;
    ushort wDayOfWeek;
    ushort wDay;
    ushort wHour;
    ushort wMinute;
    ushort wSecond;
    ushort wMilliseconds;
}

alias SYSTEMTIME* LPSYSTEMTIME;
alias SYSTEMTIME _SYSTEMTIME;
alias SYSTEMTIME TSYSTEMTIME;
alias SYSTEMTIME* PSYSTEMTIME;

struct JOB_INFO_1
{
    DWORD JobId;
    LPTSTR pPrinterName;
    LPTSTR pMachineName;
    LPTSTR pUserName;
    LPTSTR pDocument;
    LPTSTR pDatatype;
    LPTSTR pStatus;
    DWORD Status;
    DWORD Priority;
    DWORD Position;
    DWORD TotalPages;
    DWORD PagesPrinted;
    SYSTEMTIME Submitted;
}

alias JOB_INFO_1 _JOB_INFO_1;
alias JOB_INFO_1 TJOBINFO1;
alias JOB_INFO_1* PJOBINFO1;

struct SID_IDENTIFIER_AUTHORITY
{
    ubyte[1 + 5] Value;
}

alias SID_IDENTIFIER_AUTHORITY* LPSID_IDENTIFIER_AUTHORITY;
alias SID_IDENTIFIER_AUTHORITY* PSID_IDENTIFIER_AUTHORITY;
alias SID_IDENTIFIER_AUTHORITY _SID_IDENTIFIER_AUTHORITY;
alias SID_IDENTIFIER_AUTHORITY TSIDIDENTIFIERAUTHORITY;
alias SID_IDENTIFIER_AUTHORITY* PSIDIDENTIFIERAUTHORITY;

struct SID
{
    ubyte Revision;
    ubyte SubAuthorityCount;
    SID_IDENTIFIER_AUTHORITY IdentifierAuthority;
    DWORD[1 + ANYSIZE_ARRAY-1] SubAuthority;
}

alias SID _SID;
alias SID TSID;
alias SID* PSID;
alias ushort SECURITY_DESCRIPTOR_CONTROL;
alias SECURITY_DESCRIPTOR_CONTROL* PSECURITY_DESCRIPTOR_CONTROL;
alias SECURITY_DESCRIPTOR_CONTROL TSECURITYDESCRIPTORCONTROL;
alias SECURITY_DESCRIPTOR_CONTROL* PSECURITYDESCRIPTORCONTROL;

struct SECURITY_DESCRIPTOR
{
    ubyte Revision;
    ubyte Sbz1;
    SECURITY_DESCRIPTOR_CONTROL Control;
    PSID Owner;
    PSID Group;
    PACL Sacl;
    PACL Dacl;
}

alias SECURITY_DESCRIPTOR* PSECURITY_DESCRIPTOR;
alias SECURITY_DESCRIPTOR _SECURITY_DESCRIPTOR;
alias SECURITY_DESCRIPTOR TSECURITYDESCRIPTOR;
alias SECURITY_DESCRIPTOR* PSECURITYDESCRIPTOR;

struct JOB_INFO_2
{
    DWORD JobId;
    LPTSTR pPrinterName;
    LPTSTR pMachineName;
    LPTSTR pUserName;
    LPTSTR pDocument;
    LPTSTR pNotifyName;
    LPTSTR pDatatype;
    LPTSTR pPrintProcessor;
    LPTSTR pParameters;
    LPTSTR pDriverName;
    LPDEVMODE pDevMode;
    LPTSTR pStatus;
    PSECURITY_DESCRIPTOR pSecurityDescriptor;
    DWORD Status;
    DWORD Priority;
    DWORD Position;
    DWORD StartTime;
    DWORD UntilTime;
    DWORD TotalPages;
    DWORD Size;
    SYSTEMTIME Submitted;
    DWORD Time;
    DWORD PagesPrinted;
}

alias JOB_INFO_2 _JOB_INFO_2;
alias JOB_INFO_2 TJOBINFO2;
alias JOB_INFO_2* PJOBINFO2;

struct KERNINGPAIR
{
    ushort wFirst;
    ushort wSecond;
    int iKernAmount;
}

alias KERNINGPAIR* LPKERNINGPAIR;
alias KERNINGPAIR TAGKERNINGPAIR;
alias KERNINGPAIR TKERNINGPAIR;
alias KERNINGPAIR* PKERNINGPAIR;

struct LANA_ENUM
{
    UCHAR length;
    UCHAR[1 + MAX_LANA-1] lana;
}

alias LANA_ENUM _LANA_ENUM;
alias LANA_ENUM TLANAENUM;
alias LANA_ENUM* PLANAENUM;

struct LDT_ENTRY
{
    ushort LimitLow;
    ushort BaseLow;

    union
    {
        struct
        {
            ubyte BaseMid;
            ubyte Flags1;
            ubyte Flags2;
            ubyte BaseHi;
        }
        struct
        {
            int flag0;
        }
    }
}

alias LDT_ENTRY* LPLDT_ENTRY;
alias LDT_ENTRY* PLDT_ENTRY;
alias LDT_ENTRY _LDT_ENTRY;
alias LDT_ENTRY TLDTENTRY;
alias LDT_ENTRY* PLDTENTRY;
const int bm_LDT_ENTRY_BaseMid = (0xFF);
const int bp_LDT_ENTRY_BaseMid = (0);
const int bm_LDT_ENTRY_Type = (0x1F00);
const int bp_LDT_ENTRY_Type = (8);
const int bm_LDT_ENTRY_Dpl = (0x6000);
const int bp_LDT_ENTRY_Dpl = (13);
const int bm_LDT_ENTRY_Pres = (0x8000);
const int bp_LDT_ENTRY_Pres = (15);
const int bm_LDT_ENTRY_LimitHi = (0xF0000);
const int bp_LDT_ENTRY_LimitHi = (16);
const int bm_LDT_ENTRY_Sys = (0x100000);
const int bp_LDT_ENTRY_Sys = (20);
const int bm_LDT_ENTRY_Reserved_0 = (0x200000);
const int bp_LDT_ENTRY_Reserved_0 = (21);
const int bm_LDT_ENTRY_Default_Big = (0x400000);
const int bp_LDT_ENTRY_Default_Big = (22);
const int bm_LDT_ENTRY_Granularity = (0x800000);
const int bp_LDT_ENTRY_Granularity = (23);
const int bm_LDT_ENTRY_BaseHi = (int)(0xFF000000);
const int bp_LDT_ENTRY_BaseHi = (24);

struct LOCALESIGNATURE
{
    DWORD[1 + 3] lsUsb;
    DWORD[1 + 1] lsCsbDefault;
    DWORD[1 + 1] lsCsbSupported;
}

alias LOCALESIGNATURE TAGLOCALESIGNATURE;
alias LOCALESIGNATURE TLOCALESIGNATURE;
alias LOCALESIGNATURE* PLOCALESIGNATURE;

struct LOCALGROUP_MEMBERS_INFO_0
{
    PSID lgrmi0_sid;
}

alias LOCALGROUP_MEMBERS_INFO_0 _LOCALGROUP_MEMBERS_INFO_0;
alias LOCALGROUP_MEMBERS_INFO_0 TLOCALGROUPMEMBERSINFO0;
alias LOCALGROUP_MEMBERS_INFO_0* PLOCALGROUPMEMBERSINFO0;

struct LOCALGROUP_MEMBERS_INFO_3
{
    LPWSTR lgrmi3_domainandname;
}

alias LOCALGROUP_MEMBERS_INFO_3 _LOCALGROUP_MEMBERS_INFO_3;
alias LOCALGROUP_MEMBERS_INFO_3 TLOCALGROUPMEMBERSINFO3;
alias LOCALGROUP_MEMBERS_INFO_3* PLOCALGROUPMEMBERSINFO3;
alias int FXPT16DOT16;
alias FXPT16DOT16* LPFXPT16DOT16;
alias FXPT16DOT16 TFXPT16DOT16;
alias FXPT16DOT16* PFXPT16DOT16;
alias LARGE_INTEGER LUID;
alias LUID TLUID;
alias LUID* PLUID;

struct LUID_AND_ATTRIBUTES
{
    LUID Luid;
    DWORD Attributes;
}

alias LUID_AND_ATTRIBUTES _LUID_AND_ATTRIBUTES;
alias LUID_AND_ATTRIBUTES TLUIDANDATTRIBUTES;
alias LUID_AND_ATTRIBUTES* PLUIDANDATTRIBUTES;
alias LUID_AND_ATTRIBUTES[1 + ANYSIZE_ARRAY-1] LUID_AND_ATTRIBUTES_ARRAY;
alias LUID_AND_ATTRIBUTES_ARRAY* PLUID_AND_ATTRIBUTES_ARRAY;
alias LUID_AND_ATTRIBUTES_ARRAY TLUIDANDATTRIBUTESARRAY;
alias LUID_AND_ATTRIBUTES_ARRAY* PLUIDANDATTRIBUTESARRAY;

struct LV_COLUMN
{
    UINT mask;
    int fmt;
    int cx;
    LPTSTR pszText;
    int cchTextMax;
    int iSubItem;
}

alias LV_COLUMN _LV_COLUMN;
alias LV_COLUMN TLVCOLUMN;
alias LV_COLUMN* PLVCOLUMN;

struct LV_ITEM
{
    UINT mask;
    int iItem;
    int iSubItem;
    UINT state;
    UINT stateMask;
    LPTSTR pszText;
    int cchTextMax;
    int iImage;
    LPARAM lParam;
}

alias LV_ITEM _LV_ITEM;
alias LV_ITEM TLVITEM;
alias LV_ITEM* PLVITEM;

struct LV_DISPINFO
{
    NMHDR hdr;
    LV_ITEM item;
}

alias LV_DISPINFO TAGLV_DISPINFO;
alias LV_DISPINFO TLVDISPINFO;
alias LV_DISPINFO* PLVDISPINFO;

struct LV_FINDINFO
{
    UINT flags;
    LPCTSTR psz;
    LPARAM lParam;
    POINT pt;
    UINT vkDirection;
}

alias LV_FINDINFO _LV_FINDINFO;
alias LV_FINDINFO TLVFINDINFO;
alias LV_FINDINFO* PLVFINDINFO;

struct LV_HITTESTINFO
{
    POINT pt;
    UINT flags;
    int iItem;
}

alias LV_HITTESTINFO _LV_HITTESTINFO;
alias LV_HITTESTINFO TLVHITTESTINFO;
alias LV_HITTESTINFO* PLVHITTESTINFO;

struct LV_KEYDOWN
{
    NMHDR hdr;
    ushort wVKey;
    UINT flags;
}

alias LV_KEYDOWN TAGLV_KEYDOWN;
alias LV_KEYDOWN TLVKEYDOWN;
alias LV_KEYDOWN* PLVKEYDOWN;

struct MAT2
{
    FIXED eM11;
    FIXED eM12;
    FIXED eM21;
    FIXED eM22;
}

alias MAT2 _MAT2;
alias MAT2 TMAT2;
alias MAT2* PMAT2;

struct MDICREATESTRUCT
{
    LPCTSTR szClass;
    LPCTSTR szTitle;
    HANDLE hOwner;
    int x;
    int y;
    int cx;
    int cy;
    DWORD style;
    LPARAM lParam;
}

alias MDICREATESTRUCT* LPMDICREATESTRUCT;
alias MDICREATESTRUCT TAGMDICREATESTRUCT;
alias MDICREATESTRUCT TMDICREATESTRUCT;
alias MDICREATESTRUCT* PMDICREATESTRUCT;

struct MEASUREITEMSTRUCT
{
    UINT CtlType;
    UINT CtlID;
    UINT itemID;
    UINT itemWidth;
    UINT itemHeight;
    DWORD itemData;
}

alias MEASUREITEMSTRUCT* LPMEASUREITEMSTRUCT;
alias MEASUREITEMSTRUCT TAGMEASUREITEMSTRUCT;
alias MEASUREITEMSTRUCT TMEASUREITEMSTRUCT;
alias MEASUREITEMSTRUCT* PMEASUREITEMSTRUCT;

struct MEMORY_BASIC_INFORMATION
{
    PVOID BaseAddress;
    PVOID AllocationBase;
    DWORD AllocationProtect;
    DWORD RegionSize;
    DWORD State;
    DWORD Protect;
    DWORD _Type;
}

alias MEMORY_BASIC_INFORMATION* PMEMORY_BASIC_INFORMATION;
alias MEMORY_BASIC_INFORMATION _MEMORY_BASIC_INFORMATION;
alias MEMORY_BASIC_INFORMATION TMEMORYBASICINFORMATION;
alias MEMORY_BASIC_INFORMATION* PMEMORYBASICINFORMATION;

struct MEMORYSTATUS
{
    DWORD dwLength;
    DWORD dwMemoryLoad;
    DWORD dwTotalPhys;
    DWORD dwAvailPhys;
    DWORD dwTotalPageFile;
    DWORD dwAvailPageFile;
    DWORD dwTotalVirtual;
    DWORD dwAvailVirtual;
}

alias MEMORYSTATUS* LPMEMORYSTATUS;
alias MEMORYSTATUS _MEMORYSTATUS;
alias MEMORYSTATUS TMEMORYSTATUS;
alias MEMORYSTATUS* PMEMORYSTATUS;

struct MENUEX_TEMPLATE_HEADER
{
    ushort wVersion;
    ushort wOffset;
    DWORD dwHelpId;
}

alias MENUEX_TEMPLATE_HEADER TMENUXTEMPLATEHEADER;
alias MENUEX_TEMPLATE_HEADER* PMENUXTEMPLATEHEADER;

struct MENUEX_TEMPLATE_ITEM
{
    DWORD dwType;
    DWORD dwState;
    UINT uId;
    ubyte bResInfo;
    WCHAR[1 + 0] szText;
    DWORD dwHelpId;
}

alias MENUEX_TEMPLATE_ITEM TMENUEXTEMPLATEITEM;
alias MENUEX_TEMPLATE_ITEM* PMENUEXTEMPLATEITEM;

struct MENUITEMINFO
{
    UINT cbSize;
    UINT fMask;
    UINT fType;
    UINT fState;
    UINT wID;
    HMENU hSubMenu;
    HBITMAP hbmpChecked;
    HBITMAP hbmpUnchecked;
    DWORD dwItemData;
    LPTSTR dwTypeData;
    UINT cch;
}

alias MENUITEMINFO* LPMENUITEMINFO;
alias MENUITEMINFO* LPCMENUITEMINFO;
alias MENUITEMINFO TAGMENUITEMINFO;
alias MENUITEMINFO TMENUITEMINFO;
alias MENUITEMINFO TMENUITEMINFOA;
alias MENUITEMINFO* PMENUITEMINFO;

struct MENUITEMTEMPLATE
{
    ushort mtOption;
    ushort mtID;
    WCHAR[1 + 0] mtString;
}

alias MENUITEMTEMPLATE TMENUITEMTEMPLATE;
alias MENUITEMTEMPLATE* PMENUITEMTEMPLATE;

struct MENUITEMTEMPLATEHEADER
{
    ushort versionNumber;
    ushort offset;
}

alias MENUITEMTEMPLATEHEADER TMENUITEMTEMPLATEHEADER;
alias MENUITEMTEMPLATEHEADER* PMENUITEMTEMPLATEHEADER;

struct MENUTEMPLATE
{
}

alias MENUTEMPLATE* LPMENUTEMPLATE;
alias MENUTEMPLATE TMENUTEMPLATE;
alias MENUTEMPLATE* PMENUTEMPLATE;

struct METAFILEPICT
{
    LONG mm;
    LONG xExt;
    LONG yExt;
    HMETAFILE hMF;
}

alias METAFILEPICT* LPMETAFILEPICT;
alias METAFILEPICT TAGMETAFILEPICT;
alias METAFILEPICT TMETAFILEPICT;
alias METAFILEPICT* PMETAFILEPICT;

align(1) struct METAHEADER
{
    ushort mtType;
    ushort mtHeaderSize;
    ushort mtVersion;
    DWORD mtSize;
    ushort mtNoObjects;
    DWORD mtMaxRecord;
    ushort mtNoParameters;
}

alias METAHEADER TAGMETAHEADER;
alias METAHEADER TMETAHEADER;
alias METAHEADER* PMETAHEADER;

struct METARECORD
{
    DWORD rdSize;
    ushort rdFunction;
    ushort[1 + 0] rdParm;
}

alias METARECORD* LPMETARECORD;
alias METARECORD TAGMETARECORD;
alias METARECORD TMETARECORD;
alias METARECORD* PMETARECORD;

struct MINIMIZEDMETRICS
{
    UINT cbSize;
    int iWidth;
    int iHorzGap;
    int iVertGap;
    int iArrange;
}

alias MINIMIZEDMETRICS* LPMINIMIZEDMETRICS;
alias MINIMIZEDMETRICS TAGMINIMIZEDMETRICS;
alias MINIMIZEDMETRICS TMINIMIZEDMETRICS;
alias MINIMIZEDMETRICS* PMINIMIZEDMETRICS;

struct MINMAXINFO
{
    POINT ptReserved;
    POINT ptMaxSize;
    POINT ptMaxPosition;
    POINT ptMinTrackSize;
    POINT ptMaxTrackSize;
}

alias MINMAXINFO TAGMINMAXINFO;
alias MINMAXINFO TMINMAXINFO;
alias MINMAXINFO* PMINMAXINFO;

struct MODEMDEVCAPS
{
    DWORD dwActualSize;
    DWORD dwRequiredSize;
    DWORD dwDevSpecificOffset;
    DWORD dwDevSpecificSize;
    DWORD dwModemProviderVersion;
    DWORD dwModemManufacturerOffset;
    DWORD dwModemManufacturerSize;
    DWORD dwModemModelOffset;
    DWORD dwModemModelSize;
    DWORD dwModemVersionOffset;
    DWORD dwModemVersionSize;
    DWORD dwDialOptions;
    DWORD dwCallSetupFailTimer;
    DWORD dwInactivityTimeout;
    DWORD dwSpeakerVolume;
    DWORD dwSpeakerMode;
    DWORD dwModemOptions;
    DWORD dwMaxDTERate;
    DWORD dwMaxDCERate;
    ubyte[1 + 0] abVariablePortion;
}

alias MODEMDEVCAPS* LPMODEMDEVCAPS;
alias MODEMDEVCAPS TMODEMDEVCAPS;
alias MODEMDEVCAPS* PMODEMDEVCAPS;
alias MODEMDEVCAPS MODEMDEVCAPS_TAG;

struct MODEMSETTINGS
{
    DWORD dwActualSize;
    DWORD dwRequiredSize;
    DWORD dwDevSpecificOffset;
    DWORD dwDevSpecificSize;
    DWORD dwCallSetupFailTimer;
    DWORD dwInactivityTimeout;
    DWORD dwSpeakerVolume;
    DWORD dwSpeakerMode;
    DWORD dwPreferredModemOptions;
    DWORD dwNegotiatedModemOptions;
    DWORD dwNegotiatedDCERate;
    ubyte[1 + 0] abVariablePortion;
}

alias MODEMSETTINGS* LPMODEMSETTINGS;
alias MODEMSETTINGS TMODEMSETTINGS;
alias MODEMSETTINGS* PMODEMSETTINGS;
alias MODEMSETTINGS MODEMSETTINGS_TAG;

struct MONCBSTRUCT
{
    UINT cb;
    DWORD dwTime;
    HANDLE hTask;
    DWORD dwRet;
    UINT wType;
    UINT wFmt;
    HCONV hConv;
    HSZ hsz1;
    HSZ hsz2;
    HDDEDATA hData;
    DWORD dwData1;
    DWORD dwData2;
    CONVCONTEXT cc;
    DWORD cbData;
    DWORD[1 + 7] Data;
}

alias MONCBSTRUCT TAGMONCBSTRUCT;
alias MONCBSTRUCT TMONCBSTRUCT;
alias MONCBSTRUCT* PMONCBSTRUCT;

struct MONCONVSTRUCT
{
    UINT cb;
    BOOL fConnect;
    DWORD dwTime;
    HANDLE hTask;
    HSZ hszSvc;
    HSZ hszTopic;
    HCONV hConvClient;
    HCONV hConvServer;
}

alias MONCONVSTRUCT TAGMONCONVSTRUCT;
alias MONCONVSTRUCT TMONCONVSTRUCT;
alias MONCONVSTRUCT* PMONCONVSTRUCT;

struct MONERRSTRUCT
{
    UINT cb;
    UINT wLastError;
    DWORD dwTime;
    HANDLE hTask;
}

alias MONERRSTRUCT TAGMONERRSTRUCT;
alias MONERRSTRUCT TMONERRSTRUCT;
alias MONERRSTRUCT* PMONERRSTRUCT;

struct MONHSZSTRUCT
{
    UINT cb;
    BOOL fsAction;
    DWORD dwTime;
    HSZ hsz;
    HANDLE hTask;
    TCHAR[1 + 0] str;
}

alias MONHSZSTRUCT TAGMONHSZSTRUCT;
alias MONHSZSTRUCT TMONHSZSTRUCT;
alias MONHSZSTRUCT* PMONHSZSTRUCT;

struct MONITOR_INFO_1
{
    LPTSTR pName;
}

alias MONITOR_INFO_1 _MONITOR_INFO_1;
alias MONITOR_INFO_1 TMONITORINFO1;
alias MONITOR_INFO_1* PMONITORINFO1;

struct MONITOR_INFO_2
{
    LPTSTR pName;
    LPTSTR pEnvironment;
    LPTSTR pDLLName;
}

alias MONITOR_INFO_2 _MONITOR_INFO_2;
alias MONITOR_INFO_2 TMONITORINFO2;
alias MONITOR_INFO_2* PMONITORINFO2;

struct MONLINKSTRUCT
{
    UINT cb;
    DWORD dwTime;
    HANDLE hTask;
    BOOL fEstablished;
    BOOL fNoData;
    HSZ hszSvc;
    HSZ hszTopic;
    HSZ hszItem;
    UINT wFmt;
    BOOL fServer;
    HCONV hConvServer;
    HCONV hConvClient;
}

alias MONLINKSTRUCT TAGMONLINKSTRUCT;
alias MONLINKSTRUCT TMONLINKSTRUCT;
alias MONLINKSTRUCT* PMONLINKSTRUCT;

struct MONMSGSTRUCT
{
    UINT cb;
    HWND hwndTo;
    DWORD dwTime;
    HANDLE hTask;
    UINT wMsg;
    WPARAM wParam;
    LPARAM lParam;
    DDEML_MSG_HOOK_DATA dmhd;
}

alias MONMSGSTRUCT TAGMONMSGSTRUCT;
alias MONMSGSTRUCT TMONMSGSTRUCT;
alias MONMSGSTRUCT* PMONMSGSTRUCT;

struct MOUSEHOOKSTRUCT
{
    POINT pt;
    HWND hwnd;
    UINT wHitTestCode;
    DWORD dwExtraInfo;
}

alias MOUSEHOOKSTRUCT* LPMOUSEHOOKSTRUCT;
alias MOUSEHOOKSTRUCT TAGMOUSEHOOKSTRUCT;
alias MOUSEHOOKSTRUCT TMOUSEHOOKSTRUCT;
alias MOUSEHOOKSTRUCT* PMOUSEHOOKSTRUCT;

struct MOUSEKEYS
{
    DWORD cbSize;
    DWORD dwFlags;
    DWORD iMaxSpeed;
    DWORD iTimeToMaxSpeed;
    DWORD iCtrlSpeed;
    DWORD dwReserved1;
    DWORD dwReserved2;
}

alias MOUSEKEYS TMOUSEKEYS;
alias MOUSEKEYS* PMOUSEKEYS;

struct MSG
{
    HWND hwnd;
    UINT message;
    WPARAM wParam;
    LPARAM lParam;
    DWORD time;
    POINT pt;
}

alias MSG* LPMSG;
alias MSG TAGMSG;
alias MSG TMSG;
alias MSG* PMSG;
extern(Windows) alias void (*MSGBOXCALLBACK)(LPHELPINFO);
alias MSGBOXCALLBACK TMSGBOXCALLBACK;

struct MSGBOXPARAMS
{
    UINT cbSize;
    HWND hwndOwner;
    HINST hInstance;
    LPCSTR lpszText;
    LPCSTR lpszCaption;
    DWORD dwStyle;
    LPCSTR lpszIcon;
    DWORD dwContextHelpId;
    MSGBOXCALLBACK lpfnMsgBoxCallback;
    DWORD dwLanguageId;
}

alias MSGBOXPARAMS* LPMSGBOXPARAMS;
alias MSGBOXPARAMS TMSGBOXPARAMS;
alias MSGBOXPARAMS TMSGBOXPARAMSA;
alias MSGBOXPARAMS* PMSGBOXPARAMS;

struct MSGFILTER
{
    NMHDR nmhdr;
    UINT msg;
    WPARAM wParam;
    LPARAM lParam;
}

alias MSGFILTER _MSGFILTER;
alias MSGFILTER TMSGFILTER;
alias MSGFILTER* PMSGFILTER;

struct MULTIKEYHELP
{
    DWORD mkSize;
    TCHAR mkKeylist;
    TCHAR[1 + 0] szKeyphrase;
}

alias MULTIKEYHELP TAGMULTIKEYHELP;
alias MULTIKEYHELP TMULTIKEYHELP;
alias MULTIKEYHELP* PMULTIKEYHELP;

struct NAME_BUFFER
{
    UCHAR[1 + NCBNAMSZ-1] name;
    UCHAR name_num;
    UCHAR name_flags;
}

alias NAME_BUFFER _NAME_BUFFER;
alias NAME_BUFFER TNAMEBUFFER;
alias NAME_BUFFER* PNAMEBUFFER;
alias _NCB* P_NCB;

struct NCB
{
    UCHAR ncb_command;
    UCHAR ncb_retcode;
    UCHAR ncb_lsn;
    UCHAR ncb_num;
    PUCHAR ncb_buffer;
    ushort ncb_length;
    UCHAR[1 + NCBNAMSZ-1] ncb_callname;
    UCHAR[1 + NCBNAMSZ-1] ncb_name;
    UCHAR ncb_rto;
    UCHAR ncb_sto;
    POINTER ncb_post;
    UCHAR ncb_lana_num;
    UCHAR ncb_cmd_cplt;
    UCHAR[1 + 9] ncb_reserve;
    HANDLE ncb_event;
}

alias NCB _NCB;
alias NCB TNCB;
alias NCB* PNCB;

struct NCCALCSIZE_PARAMS
{
    RECT[1 + 2] rgrc;
    PWINDOWPOS lppos;
}

alias NCCALCSIZE_PARAMS _NCCALCSIZE_PARAMS;
alias NCCALCSIZE_PARAMS TNCCALCSIZEPARAMS;
alias NCCALCSIZE_PARAMS* PNCCALCSIZEPARAMS;

struct NDDESHAREINFO
{
    LONG lRevision;
    LPTSTR lpszShareName;
    LONG lShareType;
    LPTSTR lpszAppTopicList;
    LONG fSharedFlag;
    LONG fService;
    LONG fStartAppFlag;
    LONG nCmdShow;
    LONG[1 + 1] qModifyId;
    LONG cNumItems;
    LPTSTR lpszItemList;
}

alias NDDESHAREINFO _NDDESHAREINFO;
alias NDDESHAREINFO TNDDESHAREINFO;
alias NDDESHAREINFO* PNDDESHAREINFO;

struct NETRESOURCE
{
    DWORD dwScope;
    DWORD dwType;
    DWORD dwDisplayType;
    DWORD dwUsage;
    LPTSTR lpLocalName;
    LPTSTR lpRemoteName;
    LPTSTR lpComment;
    LPTSTR lpProvider;
}

alias NETRESOURCE* LPNETRESOURCE;
alias NETRESOURCE _NETRESOURCE;
alias NETRESOURCE TNETRESOURCE;
alias NETRESOURCE TNETRESOURCEA;
alias NETRESOURCE* PNETRESOURCE;
alias NETRESOURCE* PNETRESOURCEA;

struct NEWCPLINFO
{
    DWORD dwSize;
    DWORD dwFlags;
    DWORD dwHelpContext;
    LONG lData;
    HICON hIcon;
    TCHAR[1 + 31] szName;
    TCHAR[1 + 63] szInfo;
    TCHAR[1 + 127] szHelpFile;
}

alias NEWCPLINFO TAGNEWCPLINFO;
alias NEWCPLINFO TNEWCPLINFO;
alias NEWCPLINFO* PNEWCPLINFO;

struct NEWTEXTMETRIC
{
    LONG tmHeight;
    LONG tmAscent;
    LONG tmDescent;
    LONG tmInternalLeading;
    LONG tmExternalLeading;
    LONG tmAveCharWidth;
    LONG tmMaxCharWidth;
    LONG tmWeight;
    LONG tmOverhang;
    LONG tmDigitizedAspectX;
    LONG tmDigitizedAspectY;
    BCHAR tmFirstChar;
    BCHAR tmLastChar;
    BCHAR tmDefaultChar;
    BCHAR tmBreakChar;
    ubyte tmItalic;
    ubyte tmUnderlined;
    ubyte tmStruckOut;
    ubyte tmPitchAndFamily;
    ubyte tmCharSet;
    DWORD ntmFlags;
    UINT ntmSizeEM;
    UINT ntmCellHeight;
    UINT ntmAvgWidth;
}

alias NEWTEXTMETRIC TAGNEWTEXTMETRIC;
alias NEWTEXTMETRIC TNEWTEXTMETRIC;
alias NEWTEXTMETRIC* PNEWTEXTMETRIC;

struct NEWTEXTMETRICEX
{
    NEWTEXTMETRIC ntmentm;
    FONTSIGNATURE ntmeFontSignature;
}

alias NEWTEXTMETRICEX TAGNEWTEXTMETRICEX;
alias NEWTEXTMETRICEX TNEWTEXTMETRICEX;
alias NEWTEXTMETRICEX* PNEWTEXTMETRICEX;

struct NM_LISTVIEW
{
    NMHDR hdr;
    int iItem;
    int iSubItem;
    UINT uNewState;
    UINT uOldState;
    UINT uChanged;
    POINT ptAction;
    LPARAM lParam;
}

alias NM_LISTVIEW TAGNM_LISTVIEW;
alias NM_LISTVIEW TNMLISTVIEW;
alias NM_LISTVIEW* PNMLISTVIEW;

struct TV_ITEM
{
    UINT mask;
    HTREEITEM hItem;
    UINT state;
    UINT stateMask;
    LPTSTR pszText;
    int cchTextMax;
    int iImage;
    int iSelectedImage;
    int cChildren;
    LPARAM lParam;
}

alias TV_ITEM* LPTV_ITEM;
alias TV_ITEM _TV_ITEM;
alias TV_ITEM TTVITEM;
alias TV_ITEM* PTVITEM;

struct NM_TREEVIEW
{
    NMHDR hdr;
    UINT action;
    TV_ITEM itemOld;
    TV_ITEM itemNew;
    POINT ptDrag;
}

alias NM_TREEVIEW* LPNM_TREEVIEW;
alias NM_TREEVIEW _NM_TREEVIEW;
alias NM_TREEVIEW TNMTREEVIEW;
alias NM_TREEVIEW* PNMTREEVIEW;

struct NM_UPDOWNW
{
    NMHDR hdr;
    int iPos;
    int iDelta;
}

alias NM_UPDOWNW _NM_UPDOWN;
alias NM_UPDOWNW TNMUPDOWN;
alias NM_UPDOWNW* PNMUPDOWN;

struct NONCLIENTMETRICS
{
    UINT cbSize;
    int iBorderWidth;
    int iScrollWidth;
    int iScrollHeight;
    int iCaptionWidth;
    int iCaptionHeight;
    LOGFONT lfCaptionFont;
    int iSmCaptionWidth;
    int iSmCaptionHeight;
    LOGFONT lfSmCaptionFont;
    int iMenuWidth;
    int iMenuHeight;
    LOGFONT lfMenuFont;
    LOGFONT lfStatusFont;
    LOGFONT lfMessageFont;
}

alias NONCLIENTMETRICS* LPNONCLIENTMETRICS;
alias NONCLIENTMETRICS TAGNONCLIENTMETRICS;
alias NONCLIENTMETRICS TNONCLIENTMETRICS;
alias NONCLIENTMETRICS* PNONCLIENTMETRICS;

struct SERVICE_ADDRESS
{
    DWORD dwAddressType;
    DWORD dwAddressFlags;
    DWORD dwAddressLength;
    DWORD dwPrincipalLength;
    ubyte* lpAddress;
    ubyte* lpPrincipal;
}

alias SERVICE_ADDRESS _SERVICE_ADDRESS;
alias SERVICE_ADDRESS TSERVICEADDRESS;
alias SERVICE_ADDRESS* PSERVICEADDRESS;

struct SERVICE_ADDRESSES
{
    DWORD dwAddressCount;
    SERVICE_ADDRESS[1 + 0] Addresses;
}

alias SERVICE_ADDRESSES* LPSERVICE_ADDRESSES;
alias SERVICE_ADDRESSES _SERVICE_ADDRESSES;
alias SERVICE_ADDRESSES TSERVICEADDRESSES;
alias SERVICE_ADDRESSES* PSERVICEADDRESSES;

align(1) struct __GUID
{

    union
    {
        struct
        {
            uint Data1;
            ushort Data2;
            ushort Data3;
            ubyte[1 + 7] Data4;
        }
        struct
        {
            uint D1;
            ushort D2;
            ushort D3;
            ubyte[1 + 7] D4;
        }
    }
}

alias __GUID* LPGUID;
alias __GUID _GUID;
alias __GUID TGUID;
alias __GUID* PGUID;
alias __GUID __CLSID;
alias __CLSID* LPCLSID;
alias __CLSID TCLSID;
alias __CLSID* PCLSID;

struct SERVICE_INFO
{
    LPGUID lpServiceType;
    LPTSTR lpServiceName;
    LPTSTR lpComment;
    LPTSTR lpLocale;
    DWORD dwDisplayHint;
    DWORD dwVersion;
    DWORD dwTime;
    LPTSTR lpMachineName;
    LPSERVICE_ADDRESSES lpServiceAddress;
    BLOB ServiceSpecificInfo;
}

alias SERVICE_INFO _SERVICE_INFO;
alias SERVICE_INFO TSERVICEINFO;
alias SERVICE_INFO* PSERVICEINFO;

struct NS_SERVICE_INFO
{
    DWORD dwNameSpace;
    SERVICE_INFO ServiceInfo;
}

alias NS_SERVICE_INFO _NS_SERVICE_INFO;
alias NS_SERVICE_INFO TNSSERVICEINFO;
alias NS_SERVICE_INFO* PNSSERVICEINFO;

struct NUMBERFMT
{
    UINT NumDigits;
    UINT LeadingZero;
    UINT Grouping;
    LPTSTR lpDecimalSep;
    LPTSTR lpThousandSep;
    UINT NegativeOrder;
}

alias NUMBERFMT _NUMBERFMT;
alias NUMBERFMT TNUMBERFMT;
alias NUMBERFMT* PNUMBERFMT;

struct OFSTRUCT
{
    ubyte cBytes;
    ubyte fFixedDisk;
    ushort nErrCode;
    ushort Reserved1;
    ushort Reserved2;
    char[1 + OFS_MAXPATHNAME-1] szPathName;
}

alias OFSTRUCT* LPOFSTRUCT;
alias OFSTRUCT _OFSTRUCT;
alias OFSTRUCT TOFSTRUCT;
alias OFSTRUCT* POFSTRUCT;

struct OPENFILENAME
{
    DWORD lStructSize;
    HWND hwndOwner;
    HINST hInstance;
    LPCTSTR lpstrFilter;
    LPTSTR lpstrCustomFilter;
    DWORD nMaxCustFilter;
    DWORD nFilterIndex;
    LPTSTR lpstrFile;
    DWORD nMaxFile;
    LPTSTR lpstrFileTitle;
    DWORD nMaxFileTitle;
    LPCTSTR lpstrInitialDir;
    LPCTSTR lpstrTitle;
    DWORD Flags;
    ushort nFileOffset;
    ushort nFileExtension;
    LPCTSTR lpstrDefExt;
    DWORD lCustData;
    LPOFNHOOKPROC lpfnHook;
    LPCTSTR lpTemplateName;
}

alias OPENFILENAME* LPOPENFILENAME;
alias OPENFILENAME TOPENFILENAME;
alias OPENFILENAME* POPENFILENAME;
alias OPENFILENAME TAGOFN;
alias OPENFILENAME TOFN;
alias OPENFILENAME* POFN;

struct OFNOTIFY
{
    NMHDR hdr;
    LPOPENFILENAME lpOFN;
    LPTSTR pszFile;
}

alias OFNOTIFY* LPOFNOTIFY;
alias OFNOTIFY _OFNOTIFY;
alias OFNOTIFY TOFNOTIFY;
alias OFNOTIFY* POFNOTIFY;

struct OSVERSIONINFO
{
    DWORD dwOSVersionInfoSize;
    DWORD dwMajorVersion;
    DWORD dwMinorVersion;
    DWORD dwBuildNumber;
    DWORD dwPlatformId;
    TCHAR[1 + 127] szCSDVersion;
}

alias OSVERSIONINFO* LPOSVERSIONINFO;
alias OSVERSIONINFO _OSVERSIONINFO;
alias OSVERSIONINFO TOSVERSIONINFO;
alias OSVERSIONINFO* POSVERSIONINFO;

struct TEXTMETRIC
{
    LONG tmHeight;
    LONG tmAscent;
    LONG tmDescent;
    LONG tmInternalLeading;
    LONG tmExternalLeading;
    LONG tmAveCharWidth;
    LONG tmMaxCharWidth;
    LONG tmWeight;
    LONG tmOverhang;
    LONG tmDigitizedAspectX;
    LONG tmDigitizedAspectY;
    BCHAR tmFirstChar;
    BCHAR tmLastChar;
    BCHAR tmDefaultChar;
    BCHAR tmBreakChar;
    ubyte tmItalic;
    ubyte tmUnderlined;
    ubyte tmStruckOut;
    ubyte tmPitchAndFamily;
    ubyte tmCharSet;
}

alias TEXTMETRIC* LPTEXTMETRIC;
alias TEXTMETRIC TAGTEXTMETRIC;
alias TEXTMETRIC TTEXTMETRIC;
alias TEXTMETRIC* PTEXTMETRIC;

struct OUTLINETEXTMETRIC
{
    UINT otmSize;
    TEXTMETRIC otmTextMetrics;
    ubyte otmFiller;
    PANOSE otmPanoseNumber;
    UINT otmfsSelection;
    UINT otmfsType;
    int otmsCharSlopeRise;
    int otmsCharSlopeRun;
    int otmItalicAngle;
    UINT otmEMSquare;
    int otmAscent;
    int otmDescent;
    UINT otmLineGap;
    UINT otmsCapEmHeight;
    UINT otmsXHeight;
    RECT otmrcFontBox;
    int otmMacAscent;
    int otmMacDescent;
    UINT otmMacLineGap;
    UINT otmusMinimumPPEM;
    POINT otmptSubscriptSize;
    POINT otmptSubscriptOffset;
    POINT otmptSuperscriptSize;
    POINT otmptSuperscriptOffset;
    UINT otmsStrikeoutSize;
    int otmsStrikeoutPosition;
    int otmsUnderscoreSize;
    int otmsUnderscorePosition;
    PSTR otmpFamilyName;
    PSTR otmpFaceName;
    PSTR otmpStyleName;
    PSTR otmpFullName;
}

alias OUTLINETEXTMETRIC* LPOUTLINETEXTMETRIC;
alias OUTLINETEXTMETRIC _OUTLINETEXTMETRIC;
alias OUTLINETEXTMETRIC TOUTLINETEXTMETRIC;
alias OUTLINETEXTMETRIC* POUTLINETEXTMETRIC;

struct OVERLAPPED
{
    DWORD Internal;
    DWORD InternalHigh;
    DWORD Offset;
    DWORD OffsetHigh;
    HANDLE hEvent;
}

alias OVERLAPPED* LPOVERLAPPED;
alias OVERLAPPED _OVERLAPPED;
alias OVERLAPPED TOVERLAPPED;
alias OVERLAPPED* POVERLAPPED;

struct TPAGESETUPDLG
{
    DWORD lStructSize;
    HWND hwndOwner;
    HGLOBAL hDevMode;
    HGLOBAL hDevNames;
    DWORD Flags;
    POINT ptPaperSize;
    RECT rtMinMargin;
    RECT rtMargin;
    HINST hInstance;
    LPARAM lCustData;
    LPPAGESETUPHOOK lpfnPageSetupHook;
    LPPAGEPAINTHOOK lpfnPagePaintHook;
    LPCTSTR lpPageSetupTemplateName;
    HGLOBAL hPageSetupTemplate;
}

alias TPAGESETUPDLG* LPPAGESETUPDLG;
alias TPAGESETUPDLG* PPAGESETUPDLG;
alias TPAGESETUPDLG TAGPSD;
alias TPAGESETUPDLG TPSD;
alias TPAGESETUPDLG* PPSD;

struct PAINTSTRUCT
{
    HDC hdc;
    BOOL fErase;
    RECT rcPaint;
    BOOL fRestore;
    BOOL fIncUpdate;
    ubyte[1 + 31] rgbReserved;
}

alias PAINTSTRUCT* LPPAINTSTRUCT;
alias PAINTSTRUCT TAGPAINTSTRUCT;
alias PAINTSTRUCT TPAINTSTRUCT;
alias PAINTSTRUCT* PPAINTSTRUCT;

struct PARAFORMAT
{
    UINT cbSize;
    DWORD dwMask;
    ushort wNumbering;
    ushort wReserved;
    LONG dxStartIndent;
    LONG dxRightIndent;
    LONG dxOffset;
    ushort wAlignment;
    SHORT cTabCount;
    LONG[1 + MAX_TAB_STOPS-1] rgxTabs;
}

alias PARAFORMAT _PARAFORMAT;
alias PARAFORMAT TPARAFORMAT;
alias PARAFORMAT* PPARAFORMAT;

struct PERF_COUNTER_BLOCK
{
    DWORD ByteLength;
}

alias PERF_COUNTER_BLOCK _PERF_COUNTER_BLOCK;
alias PERF_COUNTER_BLOCK TPERFCOUNTERBLOCK;
alias PERF_COUNTER_BLOCK* PPERFCOUNTERBLOCK;

struct PERF_COUNTER_DEFINITION
{
    DWORD ByteLength;
    DWORD CounterNameTitleIndex;
    LPWSTR CounterNameTitle;
    DWORD CounterHelpTitleIndex;
    LPWSTR CounterHelpTitle;
    DWORD DefaultScale;
    DWORD DetailLevel;
    DWORD CounterType;
    DWORD CounterSize;
    DWORD CounterOffset;
}

alias PERF_COUNTER_DEFINITION _PERF_COUNTER_DEFINITION;
alias PERF_COUNTER_DEFINITION TPERFCOUNTERDEFINITION;
alias PERF_COUNTER_DEFINITION* PPERFCOUNTERDEFINITION;

struct PERF_DATA_BLOCK
{
    WCHAR[1 + 3] Signature;
    DWORD LittleEndian;
    DWORD Version;
    DWORD Revision;
    DWORD TotalByteLength;
    DWORD HeaderLength;
    DWORD NumObjectTypes;
    DWORD DefaultObject;
    SYSTEMTIME SystemTime;
    LARGE_INTEGER PerfTime;
    LARGE_INTEGER PerfFreq;
    LARGE_INTEGER PerfTime100nSec;
    DWORD SystemNameLength;
    DWORD SystemNameOffset;
}

alias PERF_DATA_BLOCK _PERF_DATA_BLOCK;
alias PERF_DATA_BLOCK TPERFDATABLOCK;
alias PERF_DATA_BLOCK* PPERFDATABLOCK;

struct PERF_INSTANCE_DEFINITION
{
    DWORD ByteLength;
    DWORD ParentObjectTitleIndex;
    DWORD ParentObjectInstance;
    DWORD UniqueID;
    DWORD NameOffset;
    DWORD NameLength;
}

alias PERF_INSTANCE_DEFINITION _PERF_INSTANCE_DEFINITION;
alias PERF_INSTANCE_DEFINITION TPERFINSTANCEDEFINITION;
alias PERF_INSTANCE_DEFINITION PPERFINSTANCEDEFINITION;

struct PERF_OBJECT_TYPE
{
    DWORD TotalByteLength;
    DWORD DefinitionLength;
    DWORD HeaderLength;
    DWORD ObjectNameTitleIndex;
    LPWSTR ObjectNameTitle;
    DWORD ObjectHelpTitleIndex;
    LPWSTR ObjectHelpTitle;
    DWORD DetailLevel;
    DWORD NumCounters;
    DWORD DefaultCounter;
    DWORD NumInstances;
    DWORD CodePage;
    LARGE_INTEGER PerfTime;
    LARGE_INTEGER PerfFreq;
}

alias PERF_OBJECT_TYPE _PERF_OBJECT_TYPE;
alias PERF_OBJECT_TYPE TPERFOBJECTTYPE;
alias PERF_OBJECT_TYPE* PPERFOBJECTTYPE;

struct POLYTEXT
{
    int x;
    int y;
    UINT n;
    LPCTSTR lpstr;
    UINT uiFlags;
    RECT rcl;
    int* pdx;
}

alias POLYTEXT _POLYTEXT;
alias POLYTEXT TPOLYTEXT;
alias POLYTEXT* PPOLYTEXT;

struct PORT_INFO_1
{
    LPTSTR pName;
}

alias PORT_INFO_1 _PORT_INFO_1;
alias PORT_INFO_1 TPORTINFO1;
alias PORT_INFO_1* PPORTINFO1;

struct PORT_INFO_2
{
    LPSTR pPortName;
    LPSTR pMonitorName;
    LPSTR pDescription;
    DWORD fPortType;
    DWORD Reserved;
}

alias PORT_INFO_2 _PORT_INFO_2;
alias PORT_INFO_2 TPORTINFO2;
alias PORT_INFO_2* PPORTINFO2;

struct PREVENT_MEDIA_REMOVAL
{
    ubyte PreventMediaRemoval;
}

alias PREVENT_MEDIA_REMOVAL _PREVENT_MEDIA_REMOVAL;
alias PREVENT_MEDIA_REMOVAL TPREVENTMEDIAREMOVAL;
alias PREVENT_MEDIA_REMOVAL* PPREVENTMEDIAREMOVAL;

align(1) struct TPRINTDLG
{
    DWORD lStructSize;
    HWND hwndOwner;
    HANDLE hDevMode;
    HANDLE hDevNames;
    HDC hDC;
    DWORD Flags;
    ushort nFromPage;
    ushort nToPage;
    ushort nMinPage;
    ushort nMaxPage;
    ushort nCopies;
    HINST hInstance;
    DWORD lCustData;
    LPPRINTHOOKPROC lpfnPrintHook;
    LPSETUPHOOKPROC lpfnSetupHook;
    LPCTSTR lpPrintTemplateName;
    LPCTSTR lpSetupTemplateName;
    HANDLE hPrintTemplate;
    HANDLE hSetupTemplate;
}

alias TPRINTDLG* LPPRINTDLG;
alias TPRINTDLG* PPRINTDLG;
alias TPRINTDLG TAGPD;
alias TPRINTDLG TPD;
alias TPRINTDLG* PPD;

struct PRINTER_DEFAULTS
{
    LPTSTR pDatatype;
    LPDEVMODE pDevMode;
    ACCESS_MASK DesiredAccess;
}

alias PRINTER_DEFAULTS _PRINTER_DEFAULTS;
alias PRINTER_DEFAULTS TPRINTERDEFAULTS;
alias PRINTER_DEFAULTS* PPRINTERDEFAULTS;

struct PRINTER_INFO_1
{
    DWORD Flags;
    LPTSTR pDescription;
    LPTSTR pName;
    LPTSTR pComment;
}

alias PRINTER_INFO_1* LPPRINTER_INFO_1;
alias PRINTER_INFO_1* PPRINTER_INFO_1;
alias PRINTER_INFO_1 _PRINTER_INFO_1;
alias PRINTER_INFO_1 TPRINTERINFO1;
alias PRINTER_INFO_1* PPRINTERINFO1;

struct PRINTER_INFO_2
{
    LPTSTR pServerName;
    LPTSTR pPrinterName;
    LPTSTR pShareName;
    LPTSTR pPortName;
    LPTSTR pDriverName;
    LPTSTR pComment;
    LPTSTR pLocation;
    LPDEVMODE pDevMode;
    LPTSTR pSepFile;
    LPTSTR pPrintProcessor;
    LPTSTR pDatatype;
    LPTSTR pParameters;
    PSECURITY_DESCRIPTOR pSecurityDescriptor;
    DWORD Attributes;
    DWORD Priority;
    DWORD DefaultPriority;
    DWORD StartTime;
    DWORD UntilTime;
    DWORD Status;
    DWORD cJobs;
    DWORD AveragePPM;
}

alias PRINTER_INFO_2 _PRINTER_INFO_2;
alias PRINTER_INFO_2 TPRINTERINFO2;
alias PRINTER_INFO_2* PPRINTERINFO2;

struct PRINTER_INFO_3
{
    PSECURITY_DESCRIPTOR pSecurityDescriptor;
}

alias PRINTER_INFO_3 _PRINTER_INFO_3;
alias PRINTER_INFO_3 TPRINTERINFO3;
alias PRINTER_INFO_3* PPRINTERINFO3;

struct PRINTER_INFO_4
{
    LPTSTR pPrinterName;
    LPTSTR pServerName;
    DWORD Attributes;
}

alias PRINTER_INFO_4 _PRINTER_INFO_4;
alias PRINTER_INFO_4 TPRINTERINFO4;
alias PRINTER_INFO_4* PPRINTERINFO4;

struct PRINTER_INFO_5
{
    LPTSTR pPrinterName;
    LPTSTR pPortName;
    DWORD Attributes;
    DWORD DeviceNotSelectedTimeout;
    DWORD TransmissionRetryTimeout;
}

alias PRINTER_INFO_5 _PRINTER_INFO_5;
alias PRINTER_INFO_5 TPRINTERINFO5;
alias PRINTER_INFO_5* PPRINTERINFO5;

struct PRINTER_NOTIFY_INFO_DATA
{
    ushort _Type;
    ushort Field;
    DWORD Reserved;
    DWORD Id;

    union
    {
        struct
        {
            DWORD[1 + 1] adwData;
        }
        struct
        {
            DWORD cbBuf;
            LPVOID pBuf;
        }
    }
}

alias PRINTER_NOTIFY_INFO_DATA _PRINTER_NOTIFY_INFO_DATA;
alias PRINTER_NOTIFY_INFO_DATA TPRINTERNOTIFYINFODATA;
alias PRINTER_NOTIFY_INFO_DATA* PPRINTERNOTIFYINFODATA;

struct PRINTER_NOTIFY_INFO
{
    DWORD Version;
    DWORD Flags;
    DWORD Count;
    PRINTER_NOTIFY_INFO_DATA[1 + 0] aData;
}

alias PRINTER_NOTIFY_INFO _PRINTER_NOTIFY_INFO;
alias PRINTER_NOTIFY_INFO TPRINTERNOTIFYINFO;
alias PRINTER_NOTIFY_INFO* PPRINTERNOTIFYINFO;

struct PRINTER_NOTIFY_OPTIONS_TYPE
{
    ushort _Type;
    ushort Reserved0;
    DWORD Reserved1;
    DWORD Reserved2;
    DWORD Count;
    PWORD pFields;
}

alias PRINTER_NOTIFY_OPTIONS_TYPE* PPRINTER_NOTIFY_OPTIONS_TYPE;
alias PRINTER_NOTIFY_OPTIONS_TYPE _PRINTER_NOTIFY_OPTIONS_TYPE;
alias PRINTER_NOTIFY_OPTIONS_TYPE TPRINTERNOTIFYOPTIONSTYPE;
alias PRINTER_NOTIFY_OPTIONS_TYPE* PPRINTERNOTIFYOPTIONSTYPE;

struct PRINTER_NOTIFY_OPTIONS
{
    DWORD Version;
    DWORD Flags;
    DWORD Count;
    PPRINTER_NOTIFY_OPTIONS_TYPE pTypes;
}

alias PRINTER_NOTIFY_OPTIONS _PRINTER_NOTIFY_OPTIONS;
alias PRINTER_NOTIFY_OPTIONS TPRINTERNOTIFYOPTIONS;
alias PRINTER_NOTIFY_OPTIONS* PPRINTERNOTIFYOPTIONS;

struct PRINTPROCESSOR_INFO_1
{
    LPTSTR pName;
}

alias PRINTPROCESSOR_INFO_1 _PRINTPROCESSOR_INFO_1;
alias PRINTPROCESSOR_INFO_1 TPRINTPROCESSORINFO1;
alias PRINTPROCESSOR_INFO_1* PPRINTPROCESSORINFO1;

struct PRIVILEGE_SET
{
    DWORD PrivilegeCount;
    DWORD Control;
    LUID_AND_ATTRIBUTES[1 + ANYSIZE_ARRAY-1] Privilege;
}

alias PRIVILEGE_SET* LPPRIVILEGE_SET;
alias PRIVILEGE_SET* PPRIVILEGE_SET;
alias PRIVILEGE_SET _PRIVILEGE_SET;
alias PRIVILEGE_SET TPRIVILEGESET;
alias PRIVILEGE_SET* PPRIVILEGESET;

struct PROCESS_HEAPENTRY
{
    PVOID lpData;
    DWORD cbData;
    ubyte cbOverhead;
    ubyte iRegionIndex;
    ushort wFlags;
    DWORD dwCommittedSize;
    DWORD dwUnCommittedSize;
    LPVOID lpFirstBlock;
    LPVOID lpLastBlock;
    HANDLE hMem;
}

alias PROCESS_HEAPENTRY* LPPROCESS_HEAP_ENTRY;
alias PROCESS_HEAPENTRY _PROCESS_HEAP_ENTRY;
alias PROCESS_HEAPENTRY TPROCESSHEAPENTRY;
alias PROCESS_HEAPENTRY* PPROCESSHEAPENTRY;

struct PROCESS_INFORMATION
{
    HANDLE hProcess;
    HANDLE hThread;
    DWORD dwProcessId;
    DWORD dwThreadId;
}

alias PROCESS_INFORMATION* LPPROCESS_INFORMATION;
alias PROCESS_INFORMATION _PROCESS_INFORMATION;
alias PROCESS_INFORMATION TPROCESSINFORMATION;
alias PROCESS_INFORMATION* PPROCESSINFORMATION;
extern(Windows) alias UINT (*LPFNPSPCALLBACK)(HWND, UINT, LPVOID);
alias LPFNPSPCALLBACK TFNPSPCALLBACK;

struct PROPSHEETPAGE_U1
{

    union
    {
        struct
        {
            LPCTSTR pszTemplate;
        }
        struct
        {
            LPCDLGTEMPLATE pResource;
        }
    }
}


struct PROPSHEETPAGE_U2
{

    union
    {
        struct
        {
            HICON hIcon;
        }
        struct
        {
            LPCTSTR pszIcon;
        }
    }
}


struct PROPSHEETPAGE
{
    DWORD dwSize;
    DWORD dwFlags;
    HINST hInstance;
    PROPSHEETPAGE_U1 u1;
    PROPSHEETPAGE_U2 u2;
    LPCTSTR pszTitle;
    DLGPROC pfnDlgProc;
    LPARAM lParam;
    LPFNPSPCALLBACK pfnCallback;
    UINT* pcRefParent;
}

alias PROPSHEETPAGE* LPPROPSHEETPAGE;
alias PROPSHEETPAGE* LPCPROPSHEETPAGE;
alias PROPSHEETPAGE _PROPSHEETPAGE;
alias PROPSHEETPAGE TPROPSHEETPAGE;
alias PROPSHEETPAGE* PPROPSHEETPAGE;

struct EMPTYRECORD
{
}

alias EMPTYRECORD* HPROPSHEETPAGE;

struct PROPSHEETHEADER_U1
{

    union
    {
        struct
        {
            HICON hIcon;
        }
        struct
        {
            LPCTSTR pszIcon;
        }
    }
}


struct PROPSHEETHEADER_U2
{

    union
    {
        struct
        {
            UINT nStartPage;
        }
        struct
        {
            LPCTSTR pStartPage;
        }
    }
}


struct PROPSHEETHEADER_U3
{

    union
    {
        struct
        {
            LPCPROPSHEETPAGE ppsp;
        }
        struct
        {
            HPROPSHEETPAGE* phpage;
        }
    }
}


struct PROPSHEETHEADER
{
    DWORD dwSize;
    DWORD dwFlags;
    HWND hwndParent;
    HINST hInstance;
    PROPSHEETHEADER_U1 u1;
    LPCTSTR pszCaption;
    UINT nPages;
    PROPSHEETHEADER_U2 u2;
    PROPSHEETHEADER_U3 u3;
    PFNPROPSHEETCALLBACK pfnCallback;
}

alias PROPSHEETHEADER* LPPROPSHEETHEADER;
alias PROPSHEETHEADER* LPCPROPSHEETHEADER;
alias PROPSHEETHEADER _PROPSHEETHEADER;
alias PROPSHEETHEADER TPROPSHEETHEADER;
alias PROPSHEETHEADER* PPROPSHEETHEADER;
extern(Windows) alias BOOL (*LPFNADDPROPSHEETPAGE)(HPROPSHEETPAGE, LPARAM);
alias LPFNADDPROPSHEETPAGE TFNADDPROPSHEETPAGE;
extern(Windows) alias BOOL (*LPFNADDPROPSHEETPAGES)(LPVOID, LPFNADDPROPSHEETPAGE, LPARAM);
alias LPFNADDPROPSHEETPAGES TFNADDPROPSHEETPAGES;

struct PROTOCOL_INFO
{
    DWORD dwServiceFlags;
    INT iAddressFamily;
    INT iMaxSockAddr;
    INT iMinSockAddr;
    INT iSocketType;
    INT iProtocol;
    DWORD dwMessageSize;
    LPTSTR lpProtocol;
}

alias PROTOCOL_INFO _PROTOCOL_INFO;
alias PROTOCOL_INFO TPROTOCOLINFO;
alias PROTOCOL_INFO* PPROTOCOLINFO;

struct PROVIDOR_INFO_1
{
    LPTSTR pName;
    LPTSTR pEnvironment;
    LPTSTR pDLLName;
}

alias PROVIDOR_INFO_1 _PROVIDOR_INFO_1;
alias PROVIDOR_INFO_1 TPROVIDORINFO1;
alias PROVIDOR_INFO_1* PPROVIDORINFO1;

struct PSHNOTIFY
{
    NMHDR hdr;
    LPARAM lParam;
}

alias PSHNOTIFY* LPPSHNOTIFY;
alias PSHNOTIFY _PSHNOTIFY;
alias PSHNOTIFY TPSHNOTIFY;
alias PSHNOTIFY* PPSHNOTIFY;

struct PUNCTUATION
{
    UINT iSize;
    LPSTR szPunctuation;
}

alias PUNCTUATION _PUNCTUATION;
alias PUNCTUATION TPUNCTUATION;
alias PUNCTUATION* PPUNCTUATION;

struct QUERY_SERVICE_CONFIG
{
    DWORD dwServiceType;
    DWORD dwStartType;
    DWORD dwErrorControl;
    LPTSTR lpBinaryPathName;
    LPTSTR lpLoadOrderGroup;
    DWORD dwTagId;
    LPTSTR lpDependencies;
    LPTSTR lpServiceStartName;
    LPTSTR lpDisplayName;
}

alias QUERY_SERVICE_CONFIG* LPQUERY_SERVICE_CONFIG;
alias QUERY_SERVICE_CONFIG _QUERY_SERVICE_CONFIG;
alias QUERY_SERVICE_CONFIG TQUERYSERVICECONFIG;
alias QUERY_SERVICE_CONFIG* PQUERYSERVICECONFIG;

struct QUERY_SERVICE_LOCK_STATUS
{
    DWORD fIsLocked;
    LPTSTR lpLockOwner;
    DWORD dwLockDuration;
}

alias QUERY_SERVICE_LOCK_STATUS* LPQUERY_SERVICE_LOCK_STATUS;
alias QUERY_SERVICE_LOCK_STATUS _QUERY_SERVICE_LOCK_STATUS;
alias QUERY_SERVICE_LOCK_STATUS TQUERYSERVICELOCKSTATUS;
alias QUERY_SERVICE_LOCK_STATUS* PQUERYSERVICELOCKSTATUS;

struct RASAMB
{
    DWORD dwSize;
    DWORD dwError;
    TCHAR[1 + NETBIOS_NAME_LEN+1-1] szNetBiosError;
    ubyte bLana;
}

alias RASAMB _RASAMB;
alias RASAMB TRASAMB;
alias RASAMB* PRASAMB;

struct RASCONN
{
    DWORD dwSize;
    HRASCONN hrasconn;
    TCHAR[1 + RAS_MaxEntryName+1-1] szEntryName;
    char[1 + RAS_MaxDeviceType+1-1] szDeviceType;
    char[1 + RAS_MaxDeviceName+1-1] szDeviceName;
}

alias RASCONN _RASCONN;
alias RASCONN TRASCONN;
alias RASCONN* PRASCONN;

struct RASCONNSTATUS
{
    DWORD dwSize;
    RASCONNSTATE rasconnstate;
    DWORD dwError;
    TCHAR[1 + RAS_MaxDeviceType+1-1] szDeviceType;
    TCHAR[1 + RAS_MaxDeviceName+1-1] szDeviceName;
}

alias RASCONNSTATUS _RASCONNSTATUS;
alias RASCONNSTATUS TRASCONNSTATUS;
alias RASCONNSTATUS* PRASCONNSTATUS;

struct RASDIALEXTENSIONS
{
    DWORD dwSize;
    DWORD dwfOptions;
    HWND hwndParent;
    DWORD reserved;
}

alias RASDIALEXTENSIONS _RASDIALEXTENSIONS;
alias RASDIALEXTENSIONS TRASDIALEXTENSIONS;
alias RASDIALEXTENSIONS* PRASDIALEXTENSIONS;

struct RASDIALPARAMS
{
    DWORD dwSize;
    TCHAR[1 + RAS_MaxEntryName+1-1] szEntryName;
    TCHAR[1 + RAS_MaxPhoneNumber+1-1] szPhoneNumber;
    TCHAR[1 + (RAS_MaxCallbackNumber+1)-1] szCallbackNumber;
    TCHAR[1 + (UNLEN+1)-1] szUserName;
    TCHAR[1 + (PWLEN+1)-1] szPassword;
    TCHAR[1 + (DNLEN+1)-1] szDomain;
}

alias RASDIALPARAMS _RASDIALPARAMS;
alias RASDIALPARAMS TRASDIALPARAMS;
alias RASDIALPARAMS* PRASDIALPARAMS;

struct RASENTRYNAME
{
    DWORD dwSize;
    TCHAR[1 + (RAS_MaxEntryName+1)-1] szEntryName;
}

alias RASENTRYNAME _RASENTRYNAME;
alias RASENTRYNAME TRASENTRYNAME;
alias RASENTRYNAME* PRASENTRYNAME;

struct RASPPPIP
{
    DWORD dwSize;
    DWORD dwError;
    TCHAR[1 + (RAS_MaxIpAddress+1)-1] szIpAddress;
}

alias RASPPPIP _RASPPPIP;
alias RASPPPIP TRASPPPIP;
alias RASPPPIP* PRASPPPIP;

struct RASPPPIPX
{
    DWORD dwSize;
    DWORD dwError;
    TCHAR[1 + (RAS_MaxIpxAddress+1)-1] szIpxAddress;
}

alias RASPPPIPX _RASPPPIPX;
alias RASPPPIPX TRASPPPIPX;
alias RASPPPIPX* PRASPPPIPX;

struct RASPPPNBF
{
    DWORD dwSize;
    DWORD dwError;
    DWORD dwNetBiosError;
    TCHAR[1 + (NETBIOS_NAME_LEN+1)-1] szNetBiosError;
    TCHAR[1 + (NETBIOS_NAME_LEN+1)-1] szWorkstationName;
    ubyte bLana;
}

alias RASPPPNBF _RASPPPNBF;
alias RASPPPNBF TRASPPPNBF;
alias RASPPPNBF* PRASPPPNBF;

struct RASTERIZER_STATUS
{
    int nSize;
    int wFlags;
    int nLanguageID;
}

alias RASTERIZER_STATUS* LPRASTERIZER_STATUS;
alias RASTERIZER_STATUS _RASTERIZER_STATUS;
alias RASTERIZER_STATUS TRASTERIZERSTATUS;
alias RASTERIZER_STATUS* PRASTERIZERSTATUS;

struct REASSIGN_BLOCKS
{
    ushort Reserved;
    ushort Count;
    DWORD[1 + 0] BlockNumber;
}

alias REASSIGN_BLOCKS _REASSIGN_BLOCKS;
alias REASSIGN_BLOCKS TREASSIGNBLOCKS;
alias REASSIGN_BLOCKS* PREASSIGNBLOCKS;

struct REMOTE_NAME_INFO
{
    LPTSTR lpUniversalName;
    LPTSTR lpConnectionName;
    LPTSTR lpRemainingPath;
}

alias REMOTE_NAME_INFO _REMOTE_NAME_INFO;
alias REMOTE_NAME_INFO TREMOTENAMEINFO;
alias REMOTE_NAME_INFO* PREMOTENAMEINFO;

struct REPASTESPECIAL
{
    DWORD dwAspect;
    DWORD dwParam;
}

alias REPASTESPECIAL _REPASTESPECIAL;
alias REPASTESPECIAL TREPASTESPECIAL;
alias REPASTESPECIAL* PREPASTESPECIAL;

struct REQRESIZE
{
    NMHDR nmhdr;
    RECT rc;
}

alias REQRESIZE _REQRESIZE;
alias REQRESIZE TREQRESIZE;
alias REQRESIZE* PREQRESIZE;

struct RGNDATAHEADER
{
    DWORD dwSize;
    DWORD iType;
    DWORD nCount;
    DWORD nRgnSize;
    RECT rcBound;
}

alias RGNDATAHEADER _RGNDATAHEADER;
alias RGNDATAHEADER TRGNDATAHEADER;
alias RGNDATAHEADER* PRGNDATAHEADER;

struct RGNDATA
{
    RGNDATAHEADER rdh;
    char[1 + 0] Buffer;
}

alias RGNDATA* LPRGNDATA;
alias RGNDATA _RGNDATA;
alias RGNDATA TRGNDATA;
alias RGNDATA* PRGNDATA;

struct SCROLLINFO
{
    UINT cbSize;
    UINT fMask;
    int nMin;
    int nMax;
    UINT nPage;
    int nPos;
    int nTrackPos;
}

alias SCROLLINFO* LPSCROLLINFO;
alias SCROLLINFO* LPCSCROLLINFO;
alias SCROLLINFO TAGSCROLLINFO;
alias SCROLLINFO TSCROLLINFO;
alias SCROLLINFO* PSCROLLINFO;

struct SECURITY_ATTRIBUTES
{
    DWORD nLength;
    LPVOID lpSecurityDescriptor;
    BOOL bInheritHandle;
}

alias SECURITY_ATTRIBUTES* LPSECURITY_ATTRIBUTES;
alias SECURITY_ATTRIBUTES _SECURITY_ATTRIBUTES;
alias SECURITY_ATTRIBUTES TSECURITYATTRIBUTES;
alias SECURITY_ATTRIBUTES* PSECURITYATTRIBUTES;
alias DWORD SECURITY_INFORMATION;
alias SECURITY_INFORMATION* PSECURITY_INFORMATION;
alias SECURITY_INFORMATION TSECURITYINFORMATION;
alias SECURITY_INFORMATION* PSECURITYINFORMATION;

struct SELCHANGE
{
    NMHDR nmhdr;
    CHARRANGE chrg;
    ushort seltyp;
}

alias SELCHANGE _SELCHANGE;
alias SELCHANGE TSELCHANGE;
alias SELCHANGE* PSELCHANGE;

struct SERIALKEYS
{
    DWORD cbSize;
    DWORD dwFlags;
    LPSTR lpszActivePort;
    LPSTR lpszPort;
    DWORD iBaudRate;
    DWORD iPortState;
}

alias SERIALKEYS* LPSERIALKEYS;
alias SERIALKEYS TAGSERIALKEYS;
alias SERIALKEYS TSERIALKEYS;
alias SERIALKEYS* PSERIALKEYS;

struct SERVICE_TABLE_ENTRY
{
    LPTSTR lpServiceName;
    LPSERVICE_MAIN_FUNCTION lpServiceProc;
}

alias SERVICE_TABLE_ENTRY* LPSERVICE_TABLE_ENTRY;
alias SERVICE_TABLE_ENTRY _SERVICE_TABLE_ENTRY;
alias SERVICE_TABLE_ENTRY TSERVICETABLEENTRY;
alias SERVICE_TABLE_ENTRY* PSERVICETABLEENTRY;

struct SERVICE_TYPE_VALUE_ABS
{
    DWORD dwNameSpace;
    DWORD dwValueType;
    DWORD dwValueSize;
    LPTSTR lpValueName;
    PVOID lpValue;
}

alias SERVICE_TYPE_VALUE_ABS _SERVICE_TYPE_VALUE_ABS;
alias SERVICE_TYPE_VALUE_ABS TSERVICETYPEVALUEABS;
alias SERVICE_TYPE_VALUE_ABS* PSERVICETYPEVALUEABS;

struct SERVICE_TYPE_INFO_ABS
{
    LPTSTR lpTypeName;
    DWORD dwValueCount;
    SERVICE_TYPE_VALUE_ABS[1 + 0] Values;
}

alias SERVICE_TYPE_INFO_ABS _SERVICE_TYPE_INFO_ABS;
alias SERVICE_TYPE_INFO_ABS TSERVICETYPEINFOABS;
alias SERVICE_TYPE_INFO_ABS* PSERVICETYPEINFOABS;

struct SESSION_BUFFER
{
    UCHAR lsn;
    UCHAR state;
    UCHAR[1 + NCBNAMSZ-1] local_name;
    UCHAR[1 + NCBNAMSZ-1] remote_name;
    UCHAR rcvs_outstanding;
    UCHAR sends_outstanding;
}

alias SESSION_BUFFER _SESSION_BUFFER;
alias SESSION_BUFFER TSESSIONBUFFER;
alias SESSION_BUFFER* PSESSIONBUFFER;

struct SESSION_HEADER
{
    UCHAR sess_name;
    UCHAR num_sess;
    UCHAR rcv_dg_outstanding;
    UCHAR rcv_any_outstanding;
}

alias SESSION_HEADER _SESSION_HEADER;
alias SESSION_HEADER TSESSIONHEADER;
alias SESSION_HEADER* PSESSIONHEADER;

struct SET_PARTITION_INFORMATION
{
    ubyte PartitionType;
}

alias SET_PARTITION_INFORMATION _SET_PARTITION_INFORMATION;
alias SET_PARTITION_INFORMATION TSETPARTITIONINFORMATION;
alias SET_PARTITION_INFORMATION* PSETPARTITIONINFORMATION;
alias int SHCONTF;
enum { SHCONTF_FOLDERS = 32, SHCONTF_NONFOLDERS = 64, SHCONTF_INCLUDEHIDDEN = 128,  };
alias SHCONTF TAGSHCONTF;
alias SHCONTF TSHCONTF;

struct SHFILEINFO
{
    HICON hIcon;
    int iIcon;
    DWORD dwAttributes;
    char[1 + MAX_PATH-1] szDisplayName;
    char[1 + 79] szTypeName;
}

alias SHFILEINFO _SHFILEINFO;
alias SHFILEINFO TSHFILEINFO;
alias SHFILEINFO* PSHFILEINFO;
alias ushort FILEOP_FLAGS;
alias FILEOP_FLAGS TFILEOPFLAGS;
alias FILEOP_FLAGS* PFILEOPFLAGS;

struct SHFILEOPSTRUCT
{
    HWND hwnd;
    UINT wFunc;
    LPCSTR pFrom;
    LPCSTR pTo;
    FILEOP_FLAGS fFlags;
    BOOL fAnyOperationsAborted;
    LPVOID hNameMappings;
    LPCSTR lpszProgressTitle;
}

alias SHFILEOPSTRUCT* LPSHFILEOPSTRUCT;
alias SHFILEOPSTRUCT _SHFILEOPSTRUCT;
alias SHFILEOPSTRUCT TSHFILEOPSTRUCT;
alias SHFILEOPSTRUCT* PSHFILEOPSTRUCT;
alias int SHGNO;
enum { SHGDN_NORMAL = 0, SHGDN_INFOLDER = 1, SHGDN_FORPARSING = 0x8000,  };
alias SHGNO TAGSHGDN;
alias SHGNO TSHGDN;

struct SHNAMEMAPPING
{
    LPSTR pszOldPath;
    LPSTR pszNewPath;
    int cchOldPath;
    int cchNewPath;
}

alias SHNAMEMAPPING* LPSHNAMEMAPPING;
alias SHNAMEMAPPING _SHNAMEMAPPING;
alias SHNAMEMAPPING TSHNAMEMAPPING;
alias SHNAMEMAPPING* PSHNAMEMAPPING;

struct SID_AND_ATTRIBUTES
{
    PSID Sid;
    DWORD Attributes;
}

alias SID_AND_ATTRIBUTES _SID_AND_ATTRIBUTES;
alias SID_AND_ATTRIBUTES TSIDANDATTRIBUTES;
alias SID_AND_ATTRIBUTES* PSIDANDATTRIBUTES;
alias SID_AND_ATTRIBUTES[1 + ANYSIZE_ARRAY-1] SID_AND_ATTRIBUTES_ARRAY;
alias SID_AND_ATTRIBUTES_ARRAY* PSID_AND_ATTRIBUTES_ARRAY;
alias SID_AND_ATTRIBUTES_ARRAY TSIDANDATTRIBUTESARRAY;
alias SID_AND_ATTRIBUTES_ARRAY* PSIDANDATTRIBUTESARRAY;

struct SINGLE_LIST_ENTRY
{
    _SINGLE_LIST_ENTRY* Next;
}

alias SINGLE_LIST_ENTRY _SINGLE_LIST_ENTRY;
alias SINGLE_LIST_ENTRY TSINGLELISTENTRY;
alias SINGLE_LIST_ENTRY* PSINGLELISTENTRY;

struct SOUNDSENTRY
{
    UINT cbSize;
    DWORD dwFlags;
    DWORD iFSTextEffect;
    DWORD iFSTextEffectMSec;
    DWORD iFSTextEffectColorBits;
    DWORD iFSGrafEffect;
    DWORD iFSGrafEffectMSec;
    DWORD iFSGrafEffectColor;
    DWORD iWindowsEffect;
    DWORD iWindowsEffectMSec;
    LPTSTR lpszWindowsEffectDLL;
    DWORD iWindowsEffectOrdinal;
}

alias SOUNDSENTRY* LPSOUNDSENTRY;
alias SOUNDSENTRY TAGSOUNDSENTRY;
alias SOUNDSENTRY TSOUNDSENTRY;
alias SOUNDSENTRY* PSOUNDSENTRY;

struct STARTUPINFO
{
    DWORD cb;
    LPTSTR lpReserved;
    LPTSTR lpDesktop;
    LPTSTR lpTitle;
    DWORD dwX;
    DWORD dwY;
    DWORD dwXSize;
    DWORD dwYSize;
    DWORD dwXCountChars;
    DWORD dwYCountChars;
    DWORD dwFillAttribute;
    DWORD dwFlags;
    ushort wShowWindow;
    ushort cbReserved2;
    LPBYTE lpReserved2;
    HANDLE hStdInput;
    HANDLE hStdOutput;
    HANDLE hStdError;
}

alias STARTUPINFO* LPSTARTUPINFO;
alias STARTUPINFO _STARTUPINFO;
alias STARTUPINFO TSTARTUPINFO;
alias STARTUPINFO* PSTARTUPINFO;

struct STICKYKEYS
{
    DWORD cbSize;
    DWORD dwFlags;
}

alias STICKYKEYS* LPSTICKYKEYS;
alias STICKYKEYS TAGSTICKYKEYS;
alias STICKYKEYS TSTICKYKEYS;
alias STICKYKEYS* PSTICKYKEYS;

struct STRRET
{
    UINT uType;

    union
    {
        struct
        {
            LPWSTR pOleStr;
        }
        struct
        {
            UINT uOffset;
        }
        struct
        {
            char[1 + MAX_PATH-1] cStr;
        }
    }
}

alias STRRET* LPSTRRET;
alias STRRET _STRRET;
alias STRRET TSTRRET;
alias STRRET* PSTRRET;

struct STYLEBUF
{
    DWORD dwStyle;
    char[1 + 31] szDescription;
}

alias STYLEBUF* LPSTYLEBUF;
alias STYLEBUF _TAGSTYLEBUF;
alias STYLEBUF TSTYLEBUF;
alias STYLEBUF* PSTYLEBUF;

struct STYLESTRUCT
{
    DWORD styleOld;
    DWORD styleNew;
}

alias STYLESTRUCT* LPSTYLESTRUCT;
alias STYLESTRUCT TAGSTYLESTRUCT;
alias STYLESTRUCT TSTYLESTRUCT;
alias STYLESTRUCT* PSTYLESTRUCT;

struct SYSTEM_AUDIT_ACE
{
    ACE_HEADER Header;
    ACCESS_MASK Mask;
    DWORD SidStart;
}

alias SYSTEM_AUDIT_ACE _SYSTEM_AUDIT_ACE;
alias SYSTEM_AUDIT_ACE TSYSTEMAUDITACE;
alias SYSTEM_AUDIT_ACE* PSYSTEMAUDITACE;

struct SYSTEM_INFO_U
{

    union
    {
        struct
        {
            DWORD dwOemId;
        }
        struct
        {
            ushort wProcessorArchitecture;
            ushort wReserved;
        }
    }
}


struct SYSTEM_INFO
{
    SYSTEM_INFO_U u;
    DWORD dwPageSize;
    LPVOID lpMinimumApplicationAddress;
    LPVOID lpMaximumApplicationAddress;
    DWORD dwActiveProcessorMask;
    DWORD dwNumberOfProcessors;
    DWORD dwProcessorType;
    DWORD dwAllocationGranularity;
    ushort wProcessorLevel;
    ushort wProcessorRevision;
}

alias SYSTEM_INFO* LPSYSTEM_INFO;
alias SYSTEM_INFO _SYSTEM_INFO;
alias SYSTEM_INFO TSYSTEMINFO;
alias SYSTEM_INFO* PSYSTEMINFO;

struct SYSTEM_POWER_STATUS
{
    ubyte ACLineStatus;
    ubyte BatteryFlag;
    ubyte BatteryLifePercent;
    ubyte Reserved1;
    DWORD BatteryLifeTime;
    DWORD BatteryFullLifeTime;
}

alias SYSTEM_POWER_STATUS _SYSTEM_POWER_STATUS;
alias SYSTEM_POWER_STATUS TSYSTEMPOWERSTATUS;
alias SYSTEM_POWER_STATUS* PSYSTEMPOWERSTATUS;
alias EMPTYRECORD* LPSYSTEM_POWER_STATUS;

struct TAPE_ERASE
{
    ULONG _Type;
}

alias TAPE_ERASE _TAPE_ERASE;
alias TAPE_ERASE TTAPEERASE;
alias TAPE_ERASE* PTAPEERASE;

struct TAPE_GET_DRIVE_PARAMETERS
{
    ubyte ECC;
    ubyte Compression;
    ubyte DataPadding;
    ubyte ReportSetmarks;
    ULONG DefaultBlockSize;
    ULONG MaximumBlockSize;
    ULONG MinimumBlockSize;
    ULONG MaximumPartitionCount;
    ULONG FeaturesLow;
    ULONG FeaturesHigh;
    ULONG EOTWarningZoneSize;
}

alias TAPE_GET_DRIVE_PARAMETERS _TAPE_GET_DRIVE_PARAMETERS;
alias TAPE_GET_DRIVE_PARAMETERS TTAPEGETDRIVEPARAMETERS;
alias TAPE_GET_DRIVE_PARAMETERS* PTAPEGETDRIVEPARAMETERS;

struct TAPE_GET_MEDIA_PARAMETERS
{
    LARGE_INTEGER Capacity;
    LARGE_INTEGER Remaining;
    DWORD BlockSize;
    DWORD PartitionCount;
    ubyte WriteProtected;
}

alias TAPE_GET_MEDIA_PARAMETERS _TAPE_GET_MEDIA_PARAMETERS;
alias TAPE_GET_MEDIA_PARAMETERS TTAPEGETMEDIAPARAMETERS;
alias TAPE_GET_MEDIA_PARAMETERS* PTAPEGETMEDIAPARAMETERS;

struct TAPE_GET_POSITION
{
    ULONG _Type;
    ULONG Partition;
    ULONG OffsetLow;
    ULONG OffsetHigh;
}

alias TAPE_GET_POSITION _TAPE_GET_POSITION;
alias TAPE_GET_POSITION TTAPEGETPOSITION;
alias TAPE_GET_POSITION* PTAPEGETPOSITION;

struct TAPE_PREPARE
{
    ULONG Operation;
}

alias TAPE_PREPARE _TAPE_PREPARE;
alias TAPE_PREPARE TTAPEPREPARE;
alias TAPE_PREPARE* PTAPEPREPARE;

struct TAPE_SET_DRIVE_PARAMETERS
{
    ubyte ECC;
    ubyte Compression;
    ubyte DataPadding;
    ubyte ReportSetmarks;
    ULONG EOTWarningZoneSize;
}

alias TAPE_SET_DRIVE_PARAMETERS _TAPE_SET_DRIVE_PARAMETERS;
alias TAPE_SET_DRIVE_PARAMETERS TTAPESETDRIVEPARAMETERS;
alias TAPE_SET_DRIVE_PARAMETERS* PTAPESETDRIVEPARAMETERS;

struct TAPE_SET_MEDIA_PARAMETERS
{
    ULONG BlockSize;
}

alias TAPE_SET_MEDIA_PARAMETERS _TAPE_SET_MEDIA_PARAMETERS;
alias TAPE_SET_MEDIA_PARAMETERS TTAPESETMEDIAPARAMETERS;
alias TAPE_SET_MEDIA_PARAMETERS* PTAPESETMEDIAPARAMETERS;

struct TAPE_SET_POSITION
{
    ULONG Method;
    ULONG Partition;
    ULONG OffsetLow;
    ULONG OffsetHigh;
}

alias TAPE_SET_POSITION _TAPE_SET_POSITION;
alias TAPE_SET_POSITION TTAPESETPOSITION;
alias TAPE_SET_POSITION* PTAPESETPOSITION;

struct TAPE_WRITE_MARKS
{
    ULONG _Type;
    ULONG Count;
}

alias TAPE_WRITE_MARKS _TAPE_WRITE_MARKS;
alias TAPE_WRITE_MARKS TTAPEWRITEMARKS;
alias TAPE_WRITE_MARKS* PTAPEWRITEMARKS;

struct TBADDBITMAP
{
    HINST hInst;
    UINT nID;
}

alias TBADDBITMAP* LPTBADDBITMAP;
alias TBADDBITMAP TTBADDBITMAP;
alias TBADDBITMAP* PTBADDBITMAP;

struct TBBUTTON
{
    int iBitmap;
    int idCommand;
    ubyte fsState;
    ubyte fsStyle;
    DWORD dwData;
    int iString;
}

alias TBBUTTON* LPTBBUTTON;
alias TBBUTTON* LPCTBBUTTON;
alias TBBUTTON _TBBUTTON;
alias TBBUTTON TTBBUTTON;
alias TBBUTTON* PTBBUTTON;

struct TBNOTIFY
{
    NMHDR hdr;
    int iItem;
    TBBUTTON tbButton;
    int cchText;
    LPTSTR pszText;
}

alias TBNOTIFY* LPTBNOTIFY;
alias TBNOTIFY TTBNOTIFY;
alias TBNOTIFY* PTBNOTIFY;

struct TBSAVEPARAMS
{
    HKEY hkr;
    LPCTSTR pszSubKey;
    LPCTSTR pszValueName;
}

alias TBSAVEPARAMS TTBSAVEPARAMS;
alias TBSAVEPARAMS* PTBSAVEPARAMS;

struct TC_HITTESTINFO
{
    POINT pt;
    UINT flags;
}

alias TC_HITTESTINFO _TC_HITTESTINFO;
alias TC_HITTESTINFO TTCHITTESTINFO;
alias TC_HITTESTINFO* PTCHITTESTINFO;

struct TC_ITEM
{
    UINT mask;
    UINT lpReserved1;
    UINT lpReserved2;
    LPTSTR pszText;
    int cchTextMax;
    int iImage;
    LPARAM lParam;
}

alias TC_ITEM _TC_ITEM;
alias TC_ITEM TTCITEM;
alias TC_ITEM* PTCITEM;

struct TC_ITEMHEADER
{
    UINT mask;
    UINT lpReserved1;
    UINT lpReserved2;
    LPTSTR pszText;
    int cchTextMax;
    int iImage;
}

alias TC_ITEMHEADER _TC_ITEMHEADER;
alias TC_ITEMHEADER TTCITEMHEADER;
alias TC_ITEMHEADER* PTCITEMHEADER;

struct TC_KEYDOWN
{
    NMHDR hdr;
    ushort wVKey;
    UINT flags;
}

alias TC_KEYDOWN _TC_KEYDOWN;
alias TC_KEYDOWN TTCKEYDOWN;
alias TC_KEYDOWN* PTCKEYDOWN;

struct TEXTRANGE
{
    CHARRANGE chrg;
    LPSTR lpstrText;
}

alias TEXTRANGE _TEXTRANGE;
alias TEXTRANGE TTEXTRANGE;
alias TEXTRANGE* PTEXTRANGE;

struct TIME_ZONE_INFORMATION
{
    LONG Bias;
    WCHAR[1 + 31] StandardName;
    SYSTEMTIME StandardDate;
    LONG StandardBias;
    WCHAR[1 + 31] DaylightName;
    SYSTEMTIME DaylightDate;
    LONG DaylightBias;
}

alias TIME_ZONE_INFORMATION* LPTIME_ZONE_INFORMATION;
alias TIME_ZONE_INFORMATION _TIME_ZONE_INFORMATION;
alias TIME_ZONE_INFORMATION TTIMEZONEINFORMATION;
alias TIME_ZONE_INFORMATION* PTIMEZONEINFORMATION;

struct TOGGLEKEYS
{
    DWORD cbSize;
    DWORD dwFlags;
}

alias TOGGLEKEYS TAGTOGGLEKEYS;
alias TOGGLEKEYS TTOGGLEKEYS;
alias TOGGLEKEYS* PTOGGLEKEYS;

struct TOKEN_SOURCE
{
    char[1 + 7] SourceName;
    LUID SourceIdentifier;
}

alias TOKEN_SOURCE _TOKEN_SOURCE;
alias TOKEN_SOURCE TTOKENSOURCE;
alias TOKEN_SOURCE* PTOKENSOURCE;

struct TOKEN_CONTROL
{
    LUID TokenId;
    LUID AuthenticationId;
    LUID ModifiedId;
    TOKEN_SOURCE TokenSource;
}

alias TOKEN_CONTROL _TOKEN_CONTROL;
alias TOKEN_CONTROL TTOKENCONTROL;
alias TOKEN_CONTROL* PTOKENCONTROL;

struct TOKEN_DEFAULT_DACL
{
    PACL DefaultDacl;
}

alias TOKEN_DEFAULT_DACL _TOKEN_DEFAULT_DACL;
alias TOKEN_DEFAULT_DACL TTOKENDEFAULTDACL;
alias TOKEN_DEFAULT_DACL* PTOKENDEFAULTDACL;

struct TOKEN_GROUPS
{
    DWORD GroupCount;
    SID_AND_ATTRIBUTES[1 + ANYSIZE_ARRAY-1] Groups;
}

alias TOKEN_GROUPS* PTOKEN_GROUPS;
alias TOKEN_GROUPS* LPTOKEN_GROUPS;
alias TOKEN_GROUPS _TOKEN_GROUPS;
alias TOKEN_GROUPS TTOKENGROUPS;
alias TOKEN_GROUPS* PTOKENGROUPS;

struct TOKEN_OWNER
{
    PSID Owner;
}

alias TOKEN_OWNER _TOKEN_OWNER;
alias TOKEN_OWNER TTOKENOWNER;
alias TOKEN_OWNER* PTOKENOWNER;

struct TOKEN_PRIMARY_GROUP
{
    PSID PrimaryGroup;
}

alias TOKEN_PRIMARY_GROUP _TOKEN_PRIMARY_GROUP;
alias TOKEN_PRIMARY_GROUP TTOKENPRIMARYGROUP;
alias TOKEN_PRIMARY_GROUP* PTOKENPRIMARYGROUP;

struct TOKEN_PRIVILEGES
{
    DWORD PrivilegeCount;
    LUID_AND_ATTRIBUTES[1 + ANYSIZE_ARRAY-1] Privileges;
}

alias TOKEN_PRIVILEGES* PTOKEN_PRIVILEGES;
alias TOKEN_PRIVILEGES* LPTOKEN_PRIVILEGES;
alias TOKEN_PRIVILEGES _TOKEN_PRIVILEGES;
alias TOKEN_PRIVILEGES TTOKENPRIVILEGES;
alias TOKEN_PRIVILEGES* PTOKENPRIVILEGES;

struct TOKEN_STATISTICS
{
    LUID TokenId;
    LUID AuthenticationId;
    LARGE_INTEGER ExpirationTime;
    TOKEN_TYPE TokenType;
    SECURITY_IMPERSONATION_LEVEL ImpersonationLevel;
    DWORD DynamicCharged;
    DWORD DynamicAvailable;
    DWORD GroupCount;
    DWORD PrivilegeCount;
    LUID ModifiedId;
}

alias TOKEN_STATISTICS _TOKEN_STATISTICS;
alias TOKEN_STATISTICS TTOKENSTATISTICS;
alias TOKEN_STATISTICS* PTOKENSTATISTICS;

struct TOKEN_USER
{
    SID_AND_ATTRIBUTES User;
}

alias TOKEN_USER _TOKEN_USER;
alias TOKEN_USER TTOKENUSER;
alias TOKEN_USER* PTOKENUSER;

struct TOOLINFO
{
    UINT cbSize;
    UINT uFlags;
    HWND hwnd;
    UINT uId;
    RECT rect;
    HINST hinst;
    LPTSTR lpszText;
}

alias TOOLINFO* LPTOOLINFO;
alias TOOLINFO TTOOLINFO;
alias TOOLINFO* PTOOLINFO;

struct TOOLTIPTEXT
{
    NMHDR hdr;
    LPTSTR lpszText;
    char[1 + 79] szText;
    HINST hinst;
    UINT uFlags;
}

alias TOOLTIPTEXT* LPTOOLTIPTEXT;
alias TOOLTIPTEXT TTOOLTIPTEXT;
alias TOOLTIPTEXT* PTOOLTIPTEXT;

struct TPMPARAMS
{
    UINT cbSize;
    RECT rcExclude;
}

alias TPMPARAMS* LPTPMPARAMS;
alias TPMPARAMS TAGTPMPARAMS;
alias TPMPARAMS TTPMPARAMS;
alias TPMPARAMS* PTPMPARAMS;

struct TRANSMIT_FILE_BUFFERS
{
    PVOID Head;
    DWORD HeadLength;
    PVOID Tail;
    DWORD TailLength;
}

alias TRANSMIT_FILE_BUFFERS _TRANSMIT_FILE_BUFFERS;
alias TRANSMIT_FILE_BUFFERS TTRANSMITFILEBUFFERS;
alias TRANSMIT_FILE_BUFFERS* PTRANSMITFILEBUFFERS;

struct TTHITTESTINFO
{
    HWND hwnd;
    POINT pt;
    TOOLINFO ti;
}

alias TTHITTESTINFO* LPHITTESTINFO;
alias TTHITTESTINFO _TT_HITTESTINFO;
alias TTHITTESTINFO TTTHITTESTINFO;
alias TTHITTESTINFO* PTTHITTESTINFO;

struct TTPOLYCURVE
{
    ushort wType;
    ushort cpfx;
    POINTFX[1 + 0] apfx;
}

alias TTPOLYCURVE* LPTTPOLYCURVE;
alias TTPOLYCURVE TAGTTPOLYCURVE;
alias TTPOLYCURVE TTTPOLYCURVE;
alias TTPOLYCURVE* PTTPOLYCURVE;

struct TTPOLYGONHEADER
{
    DWORD cb;
    DWORD dwType;
    POINTFX pfxStart;
}

alias TTPOLYGONHEADER* LPTTPOLYGONHEADER;
alias TTPOLYGONHEADER _TTPOLYGONHEADER;
alias TTPOLYGONHEADER TTTPOLYGONHEADER;
alias TTPOLYGONHEADER* PTTPOLYGONHEADER;

struct TV_DISPINFO
{
    NMHDR hdr;
    TV_ITEM item;
}

alias TV_DISPINFO _TV_DISPINFO;
alias TV_DISPINFO TTVDISPINFO;
alias TV_DISPINFO* PTVDISPINFO;

struct TV_HITTESTINFO
{
    POINT pt;
    UINT flags;
    HTREEITEM hItem;
}

alias TV_HITTESTINFO* LPTV_HITTESTINFO;
alias TV_HITTESTINFO _TVHITTESTINFO;
alias TV_HITTESTINFO TTVHITTESTINFO;
alias TV_HITTESTINFO* PTVHITTESTINFO;

struct TV_INSERTSTRUCT
{
    HTREEITEM hParent;
    HTREEITEM hInsertAfter;
    TV_ITEM item;
}

alias TV_INSERTSTRUCT* LPTV_INSERTSTRUCT;
alias TV_INSERTSTRUCT _TV_INSERTSTRUCT;
alias TV_INSERTSTRUCT TTVINSERTSTRUCT;
alias TV_INSERTSTRUCT* PTVINSERTSTRUCT;

struct TV_KEYDOWN
{
    NMHDR hdr;
    ushort wVKey;
    UINT flags;
}

alias TV_KEYDOWN _TV_KEYDOWN;
alias TV_KEYDOWN TTVKEYDOWN;
alias TV_KEYDOWN* PTVKEYDOWN;

struct TV_SORTCB
{
    HTREEITEM hParent;
    PFNTVCOMPARE lpfnCompare;
    LPARAM lParam;
}

alias TV_SORTCB* LPTV_SORTCB;
alias TV_SORTCB _TV_SORTCB;
alias TV_SORTCB TTVSORTCB;
alias TV_SORTCB* PTVSORTCB;

struct UDACCEL
{
    UINT nSec;
    UINT nInc;
}

alias UDACCEL TUDACCEL;
alias UDACCEL* PUDACCEL;

struct ULARGE_INTEGER
{
    DWORD LowPart;
    DWORD HighPart;
}

alias ULARGE_INTEGER* PULARGE_INTEGER;
alias ULARGE_INTEGER _ULARGE_INTEGER;
alias ULARGE_INTEGER TULARGEINTEGER;
alias ULARGE_INTEGER* PULARGEINTEGER;

struct UNIVERSAL_NAME_INFO
{
    LPTSTR lpUniversalName;
}

alias UNIVERSAL_NAME_INFO _UNIVERSAL_NAME_INFO;
alias UNIVERSAL_NAME_INFO TUNIVERSALNAMEINFO;
alias UNIVERSAL_NAME_INFO* PUNIVERSALNAMEINFO;

struct USEROBJECTFLAGS
{
    BOOL fInherit;
    BOOL fReserved;
    DWORD dwFlags;
}

alias USEROBJECTFLAGS TAGUSEROBJECTFLAGS;
alias USEROBJECTFLAGS TUSEROBJECTFLAGS;
alias USEROBJECTFLAGS* PUSEROBJECTFLAGS;

struct VALENT
{
    LPTSTR ve_valuename;
    DWORD ve_valuelen;
    DWORD ve_valueptr;
    DWORD ve_type;
}

alias VALENT TVALENT;
alias VALENT* PVALENT;
alias VALENT VALUE_ENT;
alias VALENT TVALUE_ENT;
alias VALENT* PVALUE_ENT;

struct VERIFY_INFORMATION
{
    LARGE_INTEGER StartingOffset;
    DWORD Length;
}

alias VERIFY_INFORMATION _VERIFY_INFORMATION;
alias VERIFY_INFORMATION TVERIFYINFORMATION;
alias VERIFY_INFORMATION* PVERIFYINFORMATION;

struct VS_FIXEDFILEINFO
{
    DWORD dwSignature;
    DWORD dwStrucVersion;
    DWORD dwFileVersionMS;
    DWORD dwFileVersionLS;
    DWORD dwProductVersionMS;
    DWORD dwProductVersionLS;
    DWORD dwFileFlagsMask;
    DWORD dwFileFlags;
    DWORD dwFileOS;
    DWORD dwFileType;
    DWORD dwFileSubtype;
    DWORD dwFileDateMS;
    DWORD dwFileDateLS;
}

alias VS_FIXEDFILEINFO _VS_FIXEDFILEINFO;
alias VS_FIXEDFILEINFO TVSFIXEDFILEINFO;
alias VS_FIXEDFILEINFO* PVSFIXEDFILEINFO;

extern(Windows) struct WIN32_FIND_DATA {
    DWORD dwFileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    DWORD nFileSizeHigh;
    DWORD nFileSizeLow;
    DWORD dwReserved0;
    DWORD dwReserved1;
    char cFileName[MAX_PATH];
    char cAlternateFileName[14];
}

// alias WIN32_FIND_DATA* LPWIN32_FIND_DATA;
// alias WIN32_FIND_DATA* PWIN32_FIND_DATA;
// alias WIN32_FIND_DATA _WIN32_FIND_DATA;
// alias WIN32_FIND_DATA TWIN32FINDDATA;
// alias WIN32_FIND_DATA TWIN32FINDDATAA;
// alias WIN32_FIND_DATA* PWIN32FINDDATA;

struct WIN32_STREAM_ID
{
    DWORD dwStreamId;
    DWORD dwStreamAttributes;
    LARGE_INTEGER Size;
    DWORD dwStreamNameSize;
    WCHAR* cStreamName;
}

alias WIN32_STREAM_ID _WIN32_STREAM_ID;
alias WIN32_STREAM_ID TWIN32STREAMID;
alias WIN32_STREAM_ID* PWIN32STREAMID;

struct WINDOWPLACEMENT
{
    UINT length;
    UINT flags;
    UINT showCmd;
    POINT ptMinPosition;
    POINT ptMaxPosition;
    RECT rcNormalPosition;
}

alias WINDOWPLACEMENT _WINDOWPLACEMENT;
alias WINDOWPLACEMENT TWINDOWPLACEMENT;
alias WINDOWPLACEMENT* PWINDOWPLACEMENT;

struct WNDCLASS
{
    UINT style;
    WNDPROC lpfnWndProc;
    int cbClsExtra;
    int cbWndExtra;
    HANDLE hInstance;
    HICON hIcon;
    HCURSOR hCursor;
    HBRUSH hbrBackground;
    LPCTSTR lpszMenuName;
    LPCTSTR lpszClassName;
}

alias WNDCLASS* LPWNDCLASS;
alias WNDCLASS _WNDCLASS;
alias WNDCLASS TWNDCLASS;
alias WNDCLASS TWNDCLASSA;
alias WNDCLASS* PWNDCLASS;

struct WNDCLASSEX
{
    UINT cbSize;
    UINT style;
    WNDPROC lpfnWndProc;
    int cbClsExtra;
    int cbWndExtra;
    HANDLE hInstance;
    HICON hIcon;
    HCURSOR hCursor;
    HBRUSH hbrBackground;
    LPCTSTR lpszMenuName;
    LPCTSTR lpszClassName;
    HANDLE hIconSm;
}

alias WNDCLASSEX* LPWNDCLASSEX;
alias WNDCLASSEX _WNDCLASSEX;
alias WNDCLASSEX TWNDCLASSEX;
alias WNDCLASSEX TWNDCLASSEXA;
alias WNDCLASSEX* PWNDCLASSEX;

struct CONNECTDLGSTRUCT
{
    DWORD cbStructure;
    HWND hwndOwner;
    LPNETRESOURCE lpConnRes;
    DWORD dwFlags;
    DWORD dwDevNum;
}

alias CONNECTDLGSTRUCT* LPCONNECTDLGSTRUCT;
alias CONNECTDLGSTRUCT _CONNECTDLGSTRUCT;
alias CONNECTDLGSTRUCT TCONNECTDLGSTRUCT;
alias CONNECTDLGSTRUCT* PCONNECTDLGSTRUCT;

struct DISCDLGSTRUCT
{
    DWORD cbStructure;
    HWND hwndOwner;
    LPTSTR lpLocalName;
    LPTSTR lpRemoteName;
    DWORD dwFlags;
}

alias DISCDLGSTRUCT* LPDISCDLGSTRUCT;
alias DISCDLGSTRUCT _DISCDLGSTRUCT;
alias DISCDLGSTRUCT TDISCDLGSTRUCT;
alias DISCDLGSTRUCT TDISCDLGSTRUCTA;
alias DISCDLGSTRUCT* PDISCDLGSTRUCT;

struct NETINFOSTRUCT
{
    DWORD cbStructure;
    DWORD dwProviderVersion;
    DWORD dwStatus;
    DWORD dwCharacteristics;
    DWORD dwHandle;
    ushort wNetType;
    DWORD dwPrinters;
    DWORD dwDrives;
}

alias NETINFOSTRUCT* LPNETINFOSTRUCT;
alias NETINFOSTRUCT _NETINFOSTRUCT;
alias NETINFOSTRUCT TNETINFOSTRUCT;
alias NETINFOSTRUCT* PNETINFOSTRUCT;

struct NETCONNECTINFOSTRUCT
{
    DWORD cbStructure;
    DWORD dwFlags;
    DWORD dwSpeed;
    DWORD dwDelay;
    DWORD dwOptDataSize;
}

alias NETCONNECTINFOSTRUCT* LPNETCONNECTINFOSTRUCT;
alias NETCONNECTINFOSTRUCT _NETCONNECTINFOSTRUCT;
alias NETCONNECTINFOSTRUCT TNETCONNECTINFOSTRUCT;
alias NETCONNECTINFOSTRUCT* PNETCONNECTINFOSTRUCT;
extern(Windows) alias int (*ENUMMETAFILEPROC)(HDC, HANDLETABLE, METARECORD, int, LPARAM);
extern(Windows) alias int (*ENHMETAFILEPROC)(HDC, HANDLETABLE, ENHMETARECORD, int, LPARAM);
extern(Windows) alias int (*ENUMFONTSPROC)(LPLOGFONT, LPTEXTMETRIC, DWORD, LPARAM);
extern(Windows) alias int (*FONTENUMPROC)(ENUMLOGFONT*, NEWTEXTMETRIC*, int, LPARAM);
extern(Windows) alias int (*FONTENUMEXPROC)(ENUMLOGFONTEX*, NEWTEXTMETRICEX*, int, LPARAM);
extern(Windows) alias void (*LPOVERLAPPED_COMPLETION_ROUTINE)(DWORD, DWORD);

struct POINTFLOAT
{
    FLOAT x;
    FLOAT y;
}

alias POINTFLOAT _POINTFLOAT;
alias POINTFLOAT TPOINTFLOAT;
alias POINTFLOAT* PPOINTFLOAT;

struct GLYPHMETRICSFLOAT
{
    FLOAT gmfBlackBoxX;
    FLOAT gmfBlackBoxY;
    POINTFLOAT gmfptGlyphOrigin;
    FLOAT gmfCellIncX;
    FLOAT gmfCellIncY;
}

alias GLYPHMETRICSFLOAT* LPGLYPHMETRICSFLOAT;
alias GLYPHMETRICSFLOAT _GLYPHMETRICSFLOAT;
alias GLYPHMETRICSFLOAT TGLYPHMETRICSFLOAT;
alias GLYPHMETRICSFLOAT* PGLYPHMETRICSFLOAT;

struct LAYERPLANEDESCRIPTOR
{
    ushort nSize;
    ushort nVersion;
    DWORD dwFlags;
    ubyte iPixelType;
    ubyte cColorBits;
    ubyte cRedBits;
    ubyte cRedShift;
    ubyte cGreenBits;
    ubyte cGreenShift;
    ubyte cBlueBits;
    ubyte cBlueShift;
    ubyte cAlphaBits;
    ubyte cAlphaShift;
    ubyte cAccumBits;
    ubyte cAccumRedBits;
    ubyte cAccumGreenBits;
    ubyte cAccumBlueBits;
    ubyte cAccumAlphaBits;
    ubyte cDepthBits;
    ubyte cStencilBits;
    ubyte cAuxBuffers;
    ubyte iLayerPlane;
    ubyte bReserved;
    COLORREF crTransparent;
}

alias LAYERPLANEDESCRIPTOR* LPLAYERPLANEDESCRIPTOR;
alias LAYERPLANEDESCRIPTOR TAGLAYERPLANEDESCRIPTOR;
alias LAYERPLANEDESCRIPTOR TLAYERPLANEDESCRIPTOR;
alias LAYERPLANEDESCRIPTOR* PLAYERPLANEDESCRIPTOR;

struct PIXELFORMATDESCRIPTOR
{
    ushort nSize;
    ushort nVersion;
    DWORD dwFlags;
    ubyte iPixelType;
    ubyte cColorBits;
    ubyte cRedBits;
    ubyte cRedShift;
    ubyte cGreenBits;
    ubyte cGreenShift;
    ubyte cBlueBits;
    ubyte cBlueShift;
    ubyte cAlphaBits;
    ubyte cAlphaShift;
    ubyte cAccumBits;
    ubyte cAccumRedBits;
    ubyte cAccumGreenBits;
    ubyte cAccumBlueBits;
    ubyte cAccumAlphaBits;
    ubyte cDepthBits;
    ubyte cStencilBits;
    ubyte cAuxBuffers;
    ubyte iLayerType;
    ubyte bReserved;
    DWORD dwLayerMask;
    DWORD dwVisibleMask;
    DWORD dwDamageMask;
}

alias PIXELFORMATDESCRIPTOR* LPPIXELFORMATDESCRIPTOR;
alias PIXELFORMATDESCRIPTOR TAGPIXELFORMATDESCRIPTOR;
alias PIXELFORMATDESCRIPTOR TPIXELFORMATDESCRIPTOR;
alias PIXELFORMATDESCRIPTOR* PPIXELFORMATDESCRIPTOR;

struct USER_INFO_2
{
    LPWSTR usri2_name;
    LPWSTR usri2_password;
    DWORD usri2_password_age;
    DWORD usri2_priv;
    LPWSTR usri2_home_dir;
    LPWSTR usri2_comment;
    DWORD usri2_flags;
    LPWSTR usri2_script_path;
    DWORD usri2_auth_flags;
    LPWSTR usri2_full_name;
    LPWSTR usri2_usr_comment;
    LPWSTR usri2_parms;
    LPWSTR usri2_workstations;
    DWORD usri2_last_logon;
    DWORD usri2_last_logoff;
    DWORD usri2_acct_expires;
    DWORD usri2_max_storage;
    DWORD usri2_units_per_week;
    PBYTE usri2_logon_hours;
    DWORD usri2_bad_pw_count;
    DWORD usri2_num_logons;
    LPWSTR usri2_logon_server;
    DWORD usri2_country_code;
    DWORD usri2_code_page;
}

alias USER_INFO_2* PUSER_INFO_2;
alias USER_INFO_2* LPUSER_INFO_2;
alias USER_INFO_2 TUSERINFO2;
alias USER_INFO_2* PUSERINFO2;

struct USER_INFO_0
{
    LPWSTR usri0_name;
}

alias USER_INFO_0* PUSER_INFO_0;
alias USER_INFO_0* LPUSER_INFO_0;
alias USER_INFO_0 TUSERINFO0;
alias USER_INFO_0* PUSERINFO0;

struct USER_INFO_3
{
    LPWSTR usri3_name;
    LPWSTR usri3_password;
    DWORD usri3_password_age;
    DWORD usri3_priv;
    LPWSTR usri3_home_dir;
    LPWSTR usri3_comment;
    DWORD usri3_flags;
    LPWSTR usri3_script_path;
    DWORD usri3_auth_flags;
    LPWSTR usri3_full_name;
    LPWSTR usri3_usr_comment;
    LPWSTR usri3_parms;
    LPWSTR usri3_workstations;
    DWORD usri3_last_logon;
    DWORD usri3_last_logoff;
    DWORD usri3_acct_expires;
    DWORD usri3_max_storage;
    DWORD usri3_units_per_week;
    PBYTE usri3_logon_hours;
    DWORD usri3_bad_pw_count;
    DWORD usri3_num_logons;
    LPWSTR usri3_logon_server;
    DWORD usri3_country_code;
    DWORD usri3_code_page;
    DWORD usri3_user_id;
    DWORD usri3_primary_group_id;
    LPWSTR usri3_profile;
    LPWSTR usri3_home_dir_drive;
    DWORD usri3_password_expired;
}

alias USER_INFO_3* PUSER_INFO_3;
alias USER_INFO_3* LPUSER_INFO_3;
alias USER_INFO_3 TUSERINFO3;
alias USER_INFO_3* PUSERINFO3;

struct GROUP_INFO_2
{
    LPWSTR grpi2_name;
    LPWSTR grpi2_comment;
    DWORD grpi2_group_id;
    DWORD grpi2_attributes;
}

alias GROUP_INFO_2* PGROUP_INFO_2;
alias GROUP_INFO_2 TGROUPINFO2;
alias GROUP_INFO_2* PGROUPINFO2;

struct LOCALGROUP_INFO_0
{
    LPWSTR lgrpi0_name;
}

alias LOCALGROUP_INFO_0* PLOCALGROUP_INFO_0;
alias LOCALGROUP_INFO_0* LPLOCALGROUP_INFO_0;
alias LOCALGROUP_INFO_0 TLOCALGROUPINFO0;
alias LOCALGROUP_INFO_0* PLOCALGROUPINFO0;

struct IMAGE_DOS_HEADER
{
    ushort e_magic;
    ushort e_cblp;
    ushort e_cp;
    ushort e_crlc;
    ushort e_cparhdr;
    ushort e_minalloc;
    ushort e_maxalloc;
    ushort e_ss;
    ushort e_sp;
    ushort e_csum;
    ushort e_ip;
    ushort e_cs;
    ushort e_lfarlc;
    ushort e_ovno;
    ushort[1 + 3] e_res;
    ushort e_oemid;
    ushort e_oeminfo;
    ushort[1 + 9] e_res2;
    LONG e_lfanew;
}

alias IMAGE_DOS_HEADER* PIMAGE_DOS_HEADER;
alias IMAGE_DOS_HEADER TIMAGEDOSHEADER;
alias IMAGE_DOS_HEADER* PIMAGEDOSHEADER;
alias ushort TVARTYPE;
alias TVARIANT* PVARIANT;

struct TVARIANT
{
    TVARTYPE vt;
    ushort wReserved1;
    ushort wReserved2;
    ushort wReserved3;

    union
    {
        struct
        {
            ubyte bVal;
        }
        struct
        {
            byte iVal;
        }
        struct
        {
            int lVal;
        }
        struct
        {
            float fltVal;
        }
        struct
        {
            double dblVal;
        }
        struct
        {
            ushort vbool;
        }
        struct
        {
            HRESULT scode;
        }
        struct
        {
            ubyte* pbVal;
        }
        struct
        {
            byte* piVal;
        }
        struct
        {
            int* plVal;
        }
        struct
        {
            float* pfltVal;
        }
        struct
        {
            double* pdblVal;
        }
        struct
        {
            ushort* pbool;
        }
        struct
        {
            HRESULT* pscode;
        }
        struct
        {
            POINTER byRef;
        }
    }
}

alias TVARIANT VARIANT;
alias int MMRESULT;
alias TWAVEFORMATEX* PWAVEFORMATEX;

align(1) struct TWAVEFORMATEX
{
    ushort wFormatTag;
    ushort nChannels;
    DWORD nSamplesPerSec;
    DWORD nAvgBytesPerSec;
    ushort nBlockAlign;
    ushort wBitsPerSample;
    ushort cbSize;
}

extern(Windows) BOOL GetBinaryTypeA(LPCSTR, LPDWORD);
extern(Windows) DWORD GetShortPathNameA(LPCSTR, LPSTR, DWORD);
extern(Windows) LPSTR GetEnvironmentStringsA();
extern(Windows) BOOL FreeEnvironmentStringsA(LPSTR);
extern(Windows) DWORD FormatMessageA(DWORD, LPCVOID, DWORD, DWORD, LPSTR, DWORD, VA_LIST);
extern(Windows) HANDLE CreateMailslotA(LPCSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) int lstrcmpA(LPCSTR, LPCSTR);
extern(Windows) int lstrcmpiA(LPCSTR, LPCSTR);
extern(Windows) LPSTR lstrcpynA(LPSTR, LPCSTR, int);
extern(Windows) LPSTR lstrcpyA(LPSTR, LPCSTR);
extern(Windows) LPSTR lstrcatA(LPSTR, LPCSTR);
extern(Windows) int lstrlenA(LPCSTR);
extern(Windows) HANDLE CreateMutexA(LPSECURITY_ATTRIBUTES, BOOL, LPCSTR);
extern(Windows) HANDLE OpenMutexA(DWORD, BOOL, LPCSTR);
extern(Windows) HANDLE CreateEventA(LPSECURITY_ATTRIBUTES, BOOL, BOOL, LPCSTR);
extern(Windows) HANDLE OpenEventA(DWORD, BOOL, LPCSTR);
extern(Windows) HANDLE CreateSemaphoreA(LPSECURITY_ATTRIBUTES, LONG, LONG, LPCSTR);
extern(Windows) HANDLE OpenSemaphoreA(DWORD, BOOL, LPCSTR);
extern(Windows) HANDLE CreateFileMappingA(HANDLE, LPSECURITY_ATTRIBUTES, DWORD, DWORD, DWORD, LPCSTR);
extern(Windows) HANDLE OpenFileMappingA(DWORD, BOOL, LPCSTR);
extern(Windows) DWORD GetLogicalDriveStringsA(DWORD, LPSTR);
extern(Windows) HINST LoadLibraryA(LPCSTR);
extern(Windows) HINST LoadLibraryExA(LPCSTR, HANDLE, DWORD);
extern(Windows) DWORD GetModuleFileNameA(HINST, LPSTR, DWORD);
extern(Windows) HMODULE GetModuleHandleA(LPCSTR);
extern(Windows) void FatalAppExitA(UINT);
extern(Windows) LPSTR GetCommandLineA();
extern(Windows) DWORD GetEnvironmentVariableA(LPCSTR, LPSTR, DWORD);
extern(Windows) BOOL SetEnvironmentVariableA(LPCSTR, LPCSTR);
extern(Windows) DWORD ExpandEnvironmentStringsA(LPCSTR, LPSTR, DWORD);
extern(Windows) void OutputDebugStringA(LPCSTR);
extern(Windows) HRSRC FindResourceA(HINST, LPCSTR, LPCSTR);
extern(Windows) HRSRC FindResourceExA(HINST, LPCSTR, LPCSTR, ushort);
extern(Windows) BOOL EnumResourceTypesA(HINST, ENUMRESTYPEPROC, LONG);
extern(Windows) BOOL EnumResourceNamesA(HINST, LPCSTR, ENUMRESNAMEPROC, LONG);
extern(Windows) BOOL EnumResourceLanguagesA(HINST, LPCSTR, LPCSTR, ENUMRESLANGPROC, LONG);
extern(Windows) HANDLE BeginUpdateResourceA(LPCSTR, BOOL);
extern(Windows) BOOL UpdateResourceA(HANDLE, LPCSTR, LPCSTR, ushort, LPVOID, DWORD);
extern(Windows) BOOL EndUpdateResourceA(HANDLE, BOOL);
extern(Windows) ATOM GlobalAddAtomA(LPCSTR);
extern(Windows) ATOM GlobalFindAtomA(LPCSTR);
extern(Windows) UINT GlobalGetAtomNameA(ATOM, LPSTR, int);
extern(Windows) ATOM AddAtomA(LPCSTR);
extern(Windows) ATOM FindAtomA(LPCSTR);
extern(Windows) UINT GetAtomNameA(ATOM, LPSTR, int);
extern(Windows) UINT GetProfileIntA(LPCSTR, LPCSTR, INT);
extern(Windows) DWORD GetProfileStringA(LPCSTR, LPCSTR, LPCSTR, LPSTR, DWORD);
extern(Windows) BOOL WriteProfileStringA(LPCSTR, LPCSTR, LPCSTR);
extern(Windows) DWORD GetProfileSectionA(LPCSTR, LPSTR, DWORD);
extern(Windows) BOOL WriteProfileSectionA(LPCSTR, LPCSTR);
extern(Windows) UINT GetPrivateProfileIntA(LPCSTR, LPCSTR, INT, LPCSTR);
extern(Windows) DWORD GetPrivateProfileStringA(LPCSTR, LPCSTR, LPCSTR, LPSTR, DWORD, LPCSTR);
extern(Windows) BOOL WritePrivateProfileStringA(LPCSTR, LPCSTR, LPCSTR, LPCSTR);
extern(Windows) DWORD GetPrivateProfileSectionA(LPCSTR, LPSTR, DWORD, LPCSTR);
extern(Windows) BOOL WritePrivateProfileSectionA(LPCSTR, LPCSTR, LPCSTR);
extern(Windows) UINT GetDriveTypeA(LPCSTR);
extern(Windows) UINT GetSystemDirectoryA(LPSTR, UINT);
extern(Windows) DWORD GetTempPathA(DWORD, LPSTR);
extern(Windows) UINT GetTempFileNameA(LPCSTR, LPCSTR, UINT, LPSTR);
extern(Windows) UINT GetWindowsDirectoryA(LPSTR, UINT);
extern(Windows) BOOL SetCurrentDirectoryA(LPCSTR);
extern(Windows) DWORD GetCurrentDirectoryA(DWORD, LPSTR);
extern(Windows) BOOL GetDiskFreeSpaceA(LPCSTR, LPDWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL CreateDirectoryA(LPCSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL CreateDirectoryExA(LPCSTR, LPCSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL RemoveDirectoryA(LPCSTR);
extern(Windows) DWORD GetFullPathNameA(LPCSTR, DWORD, LPSTR, LPSTR*);
extern(Windows) BOOL DefineDosDeviceA(DWORD, LPCSTR, LPCSTR);
extern(Windows) DWORD QueryDosDeviceA(LPCSTR, LPSTR, DWORD);
extern(Windows) HANDLE CreateFileA(LPCSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
extern(Windows) BOOL SetFileAttributesA(LPCSTR, DWORD);
extern(Windows) DWORD GetFileAttributesA(LPCSTR);
extern(Windows) DWORD GetCompressedFileSizeA(LPCSTR, LPDWORD);
extern(Windows) BOOL DeleteFileA(LPCSTR);
extern(Windows) DWORD SearchPathA(LPCSTR, LPCSTR, LPCSTR, DWORD, LPSTR, LPSTR);
extern(Windows) BOOL CopyFileA(LPCSTR, LPCSTR, BOOL);
extern(Windows) BOOL MoveFileA(LPCSTR, LPCSTR);
extern(Windows) BOOL MoveFileExA(LPCSTR, LPCSTR, DWORD);
extern(Windows) HANDLE CreateNamedPipeA(LPCSTR, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL GetNamedPipeHandleStateA(HANDLE, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPSTR, DWORD);
extern(Windows) BOOL CallNamedPipeA(LPCSTR, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, DWORD);
extern(Windows) BOOL WaitNamedPipeA(LPCSTR, DWORD);
extern(Windows) BOOL SetVolumeLabelA(LPCSTR, LPCSTR);
extern(Windows) BOOL GetVolumeInformationA(LPCSTR, LPSTR, DWORD, LPDWORD, LPDWORD, LPDWORD, LPSTR, DWORD);
extern(Windows) BOOL ClearEventLogA(HANDLE, LPCSTR);
extern(Windows) BOOL BackupEventLogA(HANDLE, LPCSTR);
extern(Windows) HANDLE OpenEventLogA(LPCSTR, LPCSTR);
extern(Windows) HANDLE RegisterEventSourceA(LPCSTR, LPCSTR);
extern(Windows) HANDLE OpenBackupEventLogA(LPCSTR, LPCSTR);
extern(Windows) BOOL ReadEventLogA(HANDLE, DWORD, DWORD, LPVOID, DWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL ReportEventA(HANDLE, ushort, ushort, DWORD, PSID, ushort, DWORD, LPCSTR, LPVOID);
extern(Windows) BOOL AccessCheckAndAuditAlarmA(LPCSTR, LPVOID, LPSTR, LPSTR, PSECURITY_DESCRIPTOR, DWORD, PGENERIC_MAPPING, BOOL, LPDWORD, LPBOOL, LPBOOL);
extern(Windows) BOOL ObjectOpenAuditAlarmA(LPCSTR, LPVOID, LPSTR, LPSTR, PSECURITY_DESCRIPTOR, HANDLE, DWORD, DWORD, PPRIVILEGE_SET, BOOL, BOOL, LPBOOL);
extern(Windows) BOOL ObjectPrivilegeAuditAlarmA(LPCSTR, LPVOID, HANDLE, DWORD, PPRIVILEGE_SET, BOOL);
extern(Windows) BOOL ObjectCloseAuditAlarmA(LPCSTR, LPVOID, BOOL);
extern(Windows) BOOL PrivilegedServiceAuditAlarmA(LPCSTR, LPCSTR, HANDLE, PPRIVILEGE_SET, BOOL);
extern(Windows) BOOL SetFileSecurityA(LPCSTR, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) BOOL GetFileSecurityA(LPCSTR, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
extern(Windows) HANDLE FindFirstChangeNotificationA(LPCSTR, BOOL, DWORD);
extern(Windows) BOOL IsBadStringPtrA(LPCSTR, UINT);
extern(Windows) BOOL LookupAccountSidA(LPCSTR, PSID, LPSTR, LPDWORD, LPSTR, LPDWORD, PSID_NAME_USE);
extern(Windows) BOOL LookupAccountNameA(LPCSTR, LPCSTR, PSID, LPDWORD, LPSTR, LPDWORD, PSID_NAME_USE);
extern(Windows) BOOL LookupPrivilegeValueA(LPCSTR, LPCSTR, PLUID);
extern(Windows) BOOL LookupPrivilegeNameA(LPCSTR, PLUID, LPSTR, LPDWORD);
extern(Windows) BOOL LookupPrivilegeDisplayNameA(LPCSTR, LPCSTR, LPSTR, LPDWORD, LPDWORD);
extern(Windows) BOOL BuildCommDCBA(LPCSTR, LPDCB);
extern(Windows) BOOL BuildCommDCBAndTimeoutsA(LPCSTR, LPDCB, LPCOMMTIMEOUTS);
extern(Windows) BOOL CommConfigDialogA(LPCSTR, HWND, LPCOMMCONFIG);
extern(Windows) BOOL GetDefaultCommConfigA(LPCSTR, LPCOMMCONFIG, LPDWORD);
extern(Windows) BOOL SetDefaultCommConfigA(LPCSTR, LPCOMMCONFIG, DWORD);
extern(Windows) BOOL GetComputerNameA(LPSTR, LPDWORD);
extern(Windows) BOOL SetComputerNameA(LPCSTR);
extern(Windows) BOOL GetUserNameA(LPSTR, LPDWORD);
extern(Windows) int wvsprintfA(LPSTR, LPCSTR, VA_LIST);
extern(Windows) HKL LoadKeyboardLayoutA(LPCSTR, UINT);
extern(Windows) BOOL GetKeyboardLayoutNameA(LPSTR);
extern(Windows) HDESK CreateDesktopA(LPSTR, LPSTR, LPDEVMODE, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) HDESK OpenDesktopA(LPSTR, DWORD, BOOL, DWORD);
extern(Windows) BOOL EnumDesktopsA(HWINSTA, DESKTOPENUMPROC, LPARAM);
extern(Windows) HWINSTA CreateWindowStationA(LPSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) HWINSTA OpenWindowStationA(LPSTR, BOOL, DWORD);
extern(Windows) BOOL EnumWindowStationsA(ENUMWINDOWSTATIONPROC, LPARAM);
extern(Windows) BOOL GetUserObjectInformationA(HANDLE, int, PVOID, DWORD, LPDWORD);
extern(Windows) BOOL SetUserObjectInformationA(HANDLE, int, PVOID, DWORD);
extern(Windows) UINT RegisterWindowMessageA(LPCSTR);
extern(Windows) BOOL GetMessageA(LPMSG, HWND, UINT, UINT);
extern(Windows) LONG DispatchMessageA(LPMSG);
extern(Windows) BOOL PeekMessageA(LPMSG, HWND, UINT, UINT, UINT);
extern(Windows) LRESULT SendMessageA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT SendMessageTimeoutA(HWND, UINT, WPARAM, LPARAM, UINT, UINT, LPDWORD);
extern(Windows) BOOL SendNotifyMessageA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL SendMessageCallbackA(HWND, UINT, WPARAM, LPARAM, SENDASYNCPROC, DWORD);
extern(Windows) BOOL PostMessageA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL PostThreadMessageA(DWORD, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefWindowProcA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT CallWindowProcA(WNDPROC, HWND, UINT, WPARAM, LPARAM);
extern(Windows) ATOM RegisterClassA(LPWNDCLASS);
extern(Windows) BOOL UnregisterClassA(LPCSTR, HINST);
extern(Windows) BOOL GetClassInfoA(HINST, LPCSTR, LPWNDCLASS);
extern(Windows) ATOM RegisterClassExA(LPWNDCLASSEX);
extern(Windows) BOOL GetClassInfoExA(HINST, LPCSTR, LPWNDCLASSEX);
extern(Windows) HWND CreateWindowExA(DWORD, LPCSTR, LPCSTR, DWORD, int, int, int, int, HWND, HMENU, HINST, LPVOID);
extern(Windows) HWND CreateDialogParamA(HINST, LPCSTR, HWND, DLGPROC, LPARAM);
extern(Windows) HWND CreateDialogIndirectParamA(HINST, LPCDLGTEMPLATE, HWND, DLGPROC, LPARAM);
extern(Windows) int DialogBoxParamA(HINST, LPCSTR, HWND, DLGPROC, LPARAM);
extern(Windows) int DialogBoxIndirectParamA(HINST, LPCDLGTEMPLATE, HWND, DLGPROC, LPARAM);
extern(Windows) BOOL SetDlgItemTextA(HWND, int, LPCSTR);
extern(Windows) UINT GetDlgItemTextA(HWND, int, LPSTR, int);
extern(Windows) LONG SendDlgItemMessageA(HWND, int, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefDlgProcA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL CallMsgFilterA(LPMSG, int);
extern(Windows) UINT RegisterClipboardFormatA(LPCSTR);
extern(Windows) int GetClipboardFormatNameA(UINT, LPSTR, int);
extern(Windows) BOOL CharToOemA(LPCSTR, LPSTR);
extern(Windows) BOOL OemToCharA(LPCSTR, LPSTR);
extern(Windows) BOOL CharToOemBuffA(LPCSTR, LPSTR, DWORD);
extern(Windows) BOOL OemToCharBuffA(LPCSTR, LPSTR, DWORD);
extern(Windows) LPSTR CharUpperA(LPSTR);
extern(Windows) DWORD CharUpperBuffA(LPSTR, DWORD);
extern(Windows) LPSTR CharLowerA(LPSTR);
extern(Windows) DWORD CharLowerBuffA(LPSTR, DWORD);
extern(Windows) LPSTR CharNextA(LPCSTR);
extern(Windows) LPSTR CharPrevA(LPCSTR, LPCSTR);
extern(Windows) BOOL IsCharAlphaA(char);
extern(Windows) BOOL IsCharAlphaNumericA(char);
extern(Windows) BOOL IsCharUpperA(char);
extern(Windows) BOOL IsCharLowerA(char);
extern(Windows) int GetKeyNameTextA(LONG, LPSTR, int);
extern(Windows) SHORT VkKeyScanA(char);
extern(Windows) SHORT VkKeyScanExA(char, HKL);
extern(Windows) UINT MapVirtualKeyA(UINT, UINT);
extern(Windows) UINT MapVirtualKeyExA(UINT, UINT, HKL);
extern(Windows) HACCEL LoadAcceleratorsA(HINST, LPCSTR);
extern(Windows) HACCEL CreateAcceleratorTableA(LPACCEL, int);
extern(Windows) int CopyAcceleratorTableA(HACCEL, LPACCEL, int);
extern(Windows) int TranslateAcceleratorA(HWND, HACCEL, LPMSG);
extern(Windows) HMENU LoadMenuA(HINST, LPCSTR);
extern(Windows) HMENU LoadMenuIndirectA(LPMENUTEMPLATE);
extern(Windows) BOOL ChangeMenuA(HMENU, UINT, LPCSTR, UINT, UINT);
extern(Windows) int GetMenuStringA(HMENU, UINT, LPSTR, int, UINT);
extern(Windows) BOOL InsertMenuA(HMENU, UINT, UINT, UINT, LPCSTR);
extern(Windows) BOOL AppendMenuA(HMENU, UINT, UINT, LPCSTR);
extern(Windows) BOOL ModifyMenuA(HMENU, UINT, UINT, UINT, LPCSTR);
extern(Windows) BOOL InsertMenuItemA(HMENU, UINT, BOOL, LPCMENUITEMINFO);
extern(Windows) BOOL GetMenuItemInfoA(HMENU, UINT, BOOL, LPMENUITEMINFO);
extern(Windows) BOOL SetMenuItemInfoA(HMENU, UINT, BOOL, LPCMENUITEMINFO);
extern(Windows) int DrawTextA(HDC, LPCSTR, int, LPRECT, UINT);
extern(Windows) int DrawTextExA(HDC, LPSTR, int, LPRECT, UINT, LPDRAWTEXTPARAMS);
extern(Windows) BOOL GrayStringA(HDC, HBRUSH, GRAYSTRINGPROC, LPARAM, int, int, int, int, int);
extern(Windows) BOOL DrawStateA(HDC, HBRUSH, DRAWSTATEPROC, LPARAM, WPARAM, int, int, int, int, UINT);
extern(Windows) LONG TabbedTextOutA(HDC, int, int, LPCSTR, int, int, LPINT, int);
extern(Windows) DWORD GetTabbedTextExtentA(HDC, LPCSTR, int, int, LPINT);
extern(Windows) BOOL SetPropA(HWND, LPCSTR, HANDLE);
extern(Windows) HANDLE GetPropA(HWND, LPCSTR);
extern(Windows) HANDLE RemovePropA(HWND, LPCSTR);
extern(Windows) int EnumPropsExA(HWND, PROPENUMPROCEX, LPARAM);
extern(Windows) int EnumPropsA(HWND, PROPENUMPROC);
extern(Windows) BOOL SetWindowTextA(HWND, LPCSTR);
extern(Windows) int GetWindowTextA(HWND, LPSTR, int);
extern(Windows) int GetWindowTextLengthA(HWND);
extern(Windows) int MessageBoxA(HWND, LPCSTR, LPCSTR, UINT);
extern(Windows) int MessageBoxExA(HWND, LPCSTR, LPCSTR, UINT, ushort);
extern(Windows) int MessageBoxIndirectA(LPMSGBOXPARAMS);
extern(Windows) LONG GetWindowLongA(HWND, int);
extern(Windows) LONG SetWindowLongA(HWND, int, LONG);
extern(Windows) DWORD GetClassLongA(HWND, int);
extern(Windows) DWORD SetClassLongA(HWND, int, LONG);
extern(Windows) HWND FindWindowA(LPCSTR, LPCSTR);
extern(Windows) HWND FindWindowExA(HWND, HWND, LPCSTR, LPCSTR);
extern(Windows) int GetClassNameA(HWND, LPSTR, int);
extern(Windows) HHOOK SetWindowsHookExA(int, HOOKPROC, HINST, DWORD);
extern(Windows) HBITMAP LoadBitmapA(HINST, LPCSTR);
extern(Windows) HCURSOR LoadCursorA(HINST, LPCSTR);
extern(Windows) HCURSOR LoadCursorFromFileA(LPCSTR);
extern(Windows) HICON LoadIconA(HINST, LPCSTR);
extern(Windows) HANDLE LoadImageA(HINST, LPCSTR, UINT, int, int, UINT);
extern(Windows) int LoadStringA(HINST, UINT, LPSTR, int);
extern(Windows) BOOL IsDialogMessageA(HWND, LPMSG);
extern(Windows) int DlgDirListA(HWND, LPSTR, int, int, UINT);
extern(Windows) BOOL DlgDirSelectExA(HWND, LPSTR, int, int);
extern(Windows) int DlgDirListComboBoxA(HWND, LPSTR, int, int, UINT);
extern(Windows) BOOL DlgDirSelectComboBoxExA(HWND, LPSTR, int, int);
extern(Windows) LRESULT DefFrameProcA(HWND, HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefMDIChildProcA(HWND, UINT, WPARAM, LPARAM);
extern(Windows) HWND CreateMDIWindowA(LPSTR, LPSTR, DWORD, int, int, int, int, HWND, HINST, LPARAM);
extern(Windows) BOOL WinHelpA(HWND, LPCSTR, UINT, DWORD);
extern(Windows) LONG ChangeDisplaySettingsA(LPDEVMODE, DWORD);
extern(Windows) BOOL EnumDisplaySettingsA(LPCSTR, DWORD, LPDEVMODE);
extern(Windows) BOOL SystemParametersInfoA(UINT, UINT, PVOID, UINT);
extern(Windows) int AddFontResourceA(LPCSTR);
extern(Windows) HMETAFILE CopyMetaFileA(HMETAFILE, LPCSTR);
extern(Windows) HFONT CreateFontIndirectA(LPLOGFONT);
extern(Windows) HDC CreateICA(LPCSTR, LPCSTR, LPCSTR, LPDEVMODE);
extern(Windows) HDC CreateMetaFileA(LPCSTR);
extern(Windows) BOOL CreateScalableFontResourceA(DWORD, LPCSTR, LPCSTR, LPCSTR);
extern(Windows) int EnumFontFamiliesExA(HDC, LPLOGFONT, FONTENUMEXPROC, LPARAM, DWORD);
extern(Windows) int EnumFontFamiliesA(HDC, LPCSTR, FONTENUMPROC, LPARAM);
extern(Windows) int EnumFontsA(HDC, LPCSTR, ENUMFONTSPROC, LPARAM);
extern(Windows) BOOL GetCharWidthA(HDC, UINT, UINT, LPINT);
extern(Windows) BOOL GetCharWidth32A(HDC, UINT, UINT, LPINT);
extern(Windows) BOOL GetCharWidthFloatA(HDC, UINT, UINT, PFLOAT);
extern(Windows) BOOL GetCharABCWidthsA(HDC, UINT, UINT, LPABC);
extern(Windows) BOOL GetCharABCWidthsFloatA(HDC, UINT, UINT, LPABCFLOAT);
extern(Windows) DWORD GetGlyphOutlineA(HDC, UINT, UINT, LPGLYPHMETRICS, DWORD, LPVOID, PMAT2);
extern(Windows) HMETAFILE GetMetaFileA(LPCSTR);
extern(Windows) UINT GetOutlineTextMetricsA(HDC, UINT, LPOUTLINETEXTMETRIC);
extern(Windows) BOOL GetTextExtentPointA(HDC, LPCSTR, int, LPSIZE);
extern(Windows) BOOL GetTextExtentPoint32A(HDC, LPCSTR, int, LPSIZE);
extern(Windows) BOOL GetTextExtentExPointA(HDC, LPCSTR, int, int, LPINT, LPINT, LPSIZE);
extern(Windows) DWORD GetCharacterPlacementA(HDC, LPCSTR, int, int, LPGCP_RESULTS, DWORD);
extern(Windows) HDC ResetDCA(HDC, LPDEVMODE);
extern(Windows) BOOL RemoveFontResourceA(LPCSTR);
extern(Windows) HENHMETAFILE CopyEnhMetaFileA(HENHMETAFILE, LPCSTR);
extern(Windows) HDC CreateEnhMetaFileA(HDC, LPCSTR, LPRECT, LPCSTR);
extern(Windows) HENHMETAFILE GetEnhMetaFileA(LPCSTR);
extern(Windows) UINT GetEnhMetaFileDescriptionA(HENHMETAFILE, UINT, LPSTR);
extern(Windows) BOOL GetTextMetricsA(HDC, LPTEXTMETRIC);
extern(Windows) int StartDocA(HDC, PDOCINFO);
extern(Windows) int GetObjectA(HGDIOBJ, int, LPVOID);
extern(Windows) BOOL TextOutA(HDC, int, int, LPCSTR, int);
extern(Windows) BOOL ExtTextOutA(HDC, int, int, UINT, LPRECT, LPCSTR, UINT, LPINT);
extern(Windows) BOOL PolyTextOutA(HDC, PPOLYTEXT, int);
extern(Windows) int GetTextFaceA(HDC, int, LPSTR);
extern(Windows) DWORD GetKerningPairsA(HDC, DWORD, LPKERNINGPAIR);
extern(Windows) HCOLORSPACE CreateColorSpaceA(LPLOGCOLORSPACE);
extern(Windows) BOOL GetLogColorSpaceA(HCOLORSPACE, LPLOGCOLORSPACE, DWORD);
extern(Windows) BOOL GetICMProfileA(HDC, DWORD, LPSTR);
extern(Windows) BOOL SetICMProfileA(HDC, LPSTR);
extern(Windows) BOOL UpdateICMRegKeyA(DWORD, DWORD, LPSTR, UINT);
extern(Windows) int EnumICMProfilesA(HDC, ICMENUMPROC, LPARAM);
extern(Windows) int PropertySheetA(LPCPROPSHEETHEADER);
extern(Windows) HIMAGELIST ImageList_LoadImageA(HINST, LPCSTR, int, int, COLORREF, UINT, UINT);
extern(Windows) HWND CreateStatusWindowA(LONG, LPCSTR, HWND, UINT);
extern(Windows) void DrawStatusTextA(HDC, LPRECT, LPCSTR);
extern(Windows) BOOL GetOpenFileNameA(LPOPENFILENAME);
extern(Windows) BOOL GetSaveFileNameA(LPOPENFILENAME);
extern(Windows) int GetFileTitleA(LPCSTR, LPSTR, ushort);
extern(Windows) BOOL ChooseColorA(LPCHOOSECOLOR);
extern(Windows) HWND FindTextA(LPFINDREPLACE);
extern(Windows) HWND ReplaceTextA(LPFINDREPLACE);
extern(Windows) BOOL ChooseFontA(LPCHOOSEFONT);
extern(Windows) BOOL PrintDlgA(LPPRINTDLG);
extern(Windows) BOOL PageSetupDlgA(LPPAGESETUPDLG);
extern(Windows) BOOL CreateProcessA(LPCSTR, LPSTR, LPSECURITY_ATTRIBUTES, LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCSTR, LPSTARTUPINFO, LPPROCESS_INFORMATION);
extern(Windows) void GetStartupInfoA(LPSTARTUPINFO);
extern(Windows) HANDLE FindFirstFileA(LPCSTR, WIN32_FIND_DATA *);
extern(Windows) BOOL FindNextFileA(HANDLE, WIN32_FIND_DATA *);
extern(Windows) BOOL GetVersionExA(LPOSVERSIONINFO);
extern(Windows) HDC CreateDCA(LPCSTR, LPCSTR, LPCSTR, PDEVMODE);
extern(Windows) DWORD VerInstallFileA(DWORD, LPSTR, LPSTR, LPSTR, LPSTR, LPSTR, LPSTR, PUINT);
extern(Windows) DWORD GetFileVersionInfoSizeA(LPSTR, LPDWORD);
extern(Windows) BOOL GetFileVersionInfoA(LPSTR, DWORD, DWORD, LPVOID);
extern(Windows) DWORD VerLanguageNameA(DWORD, LPSTR, DWORD);
extern(Windows) BOOL VerQueryValueA(LPVOID, LPSTR, LPVOID, PUINT);
extern(Windows) DWORD VerFindFileA(DWORD, LPSTR, LPSTR, LPSTR, LPSTR, PUINT, LPSTR, PUINT);
extern(Windows) LONG RegConnectRegistryA(LPSTR, HKEY, PHKEY);
extern(Windows) LONG RegCreateKeyA(HKEY, LPCSTR, PHKEY);
extern(Windows) LONG RegCreateKeyExA(HKEY, LPCSTR, DWORD, LPSTR, DWORD, REGSAM, LPSECURITY_ATTRIBUTES, PHKEY, LPDWORD);
extern(Windows) LONG RegDeleteKeyA(HKEY, LPCSTR);
extern(Windows) LONG RegDeleteValueA(HKEY, LPCSTR);
extern(Windows) LONG RegEnumKeyA(HKEY, DWORD, LPSTR, DWORD);
extern(Windows) LONG RegEnumKeyExA(HKEY, DWORD, LPSTR, LPDWORD, LPDWORD, LPSTR, LPDWORD, PFILETIME);
extern(Windows) LONG RegEnumValueA(HKEY, DWORD, LPSTR, LPDWORD, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
extern(Windows) LONG RegLoadKeyA(HKEY, LPCSTR, LPCSTR);
extern(Windows) LONG RegOpenKeyA(HKEY, LPCSTR, PHKEY);
extern(Windows) LONG RegOpenKeyExA(HKEY, LPCSTR, DWORD, REGSAM, PHKEY);
extern(Windows) LONG RegQueryInfoKeyA(HKEY, LPSTR, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, PFILETIME);
extern(Windows) LONG RegQueryValueA(HKEY, LPCSTR, LPSTR, PLONG);
extern(Windows) LONG RegQueryMultipleValuesA(HKEY, PVALENT, DWORD, LPSTR, LPDWORD);
extern(Windows) LONG RegQueryValueExA(HKEY, LPCSTR, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
extern(Windows) LONG RegReplaceKeyA(HKEY, LPCSTR, LPCSTR, LPCSTR);
extern(Windows) LONG RegRestoreKeyA(HKEY, LPCSTR, DWORD);
extern(Windows) LONG RegSaveKeyA(HKEY, LPCSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) LONG RegSetValueA(HKEY, LPCSTR, DWORD, LPCSTR, DWORD);
extern(Windows) LONG RegSetValueExA(HKEY, LPCSTR, DWORD, DWORD, LPBYTE, DWORD);
extern(Windows) LONG RegUnLoadKeyA(HKEY, LPCSTR);
extern(Windows) BOOL InitiateSystemShutdownA(LPSTR, LPSTR, DWORD, BOOL, BOOL);
extern(Windows) BOOL AbortSystemShutdownA(LPSTR);
extern(Windows) int CompareStringA(LCID, DWORD, LPCSTR, int, LPCSTR, int);
extern(Windows) int LCMapStringA(LCID, DWORD, LPCSTR, int, LPSTR, int);
extern(Windows) int GetLocaleInfoA(LCID, LCTYPE, LPSTR, int);
extern(Windows) BOOL SetLocaleInfoA(LCID, LCTYPE, LPCSTR);
extern(Windows) int GetTimeFormatA(LCID, DWORD, LPSYSTEMTIME, LPCSTR, LPSTR, int);
extern(Windows) int GetDateFormatA(LCID, DWORD, LPSYSTEMTIME, LPCSTR, LPSTR, int);
extern(Windows) int GetNumberFormatA(LCID, DWORD, LPCSTR, PNUMBERFMT, LPSTR, int);
extern(Windows) int GetCurrencyFormatA(LCID, DWORD, LPCSTR, PCURRENCYFMT, LPSTR, int);
extern(Windows) BOOL EnumCalendarInfoA(CALINFO_ENUMPROC, LCID, CALID, CALTYPE);
extern(Windows) BOOL EnumTimeFormatsA(TIMEFMT_ENUMPROC, LCID, DWORD);
extern(Windows) BOOL EnumDateFormatsA(DATEFMT_ENUMPROC, LCID, DWORD);
extern(Windows) BOOL GetStringTypeExA(LCID, DWORD, LPCSTR, int, LPWORD);
extern(Windows) BOOL GetStringTypeA(LCID, DWORD, LPCSTR, int, LPWORD);
extern(Windows) int FoldStringA(DWORD, LPCSTR, int, LPSTR, int);
extern(Windows) BOOL EnumSystemLocalesA(LOCALE_ENUMPROC, DWORD);
extern(Windows) BOOL EnumSystemCodePagesA(CODEPAGE_ENUMPROC, DWORD);
extern(Windows) BOOL PeekConsoleInputA(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL ReadConsoleInputA(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL WriteConsoleInputA(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL ReadConsoleOutputA(HANDLE, PCHAR_INFO, COORD, COORD, PSMALL_RECT);
extern(Windows) BOOL WriteConsoleOutputA(HANDLE, PCHAR_INFO, COORD, COORD, PSMALL_RECT);
extern(Windows) BOOL ReadConsoleOutputCharacterA(HANDLE, LPSTR, DWORD, COORD, LPDWORD);
extern(Windows) BOOL WriteConsoleOutputCharacterA(HANDLE, LPCSTR, DWORD, COORD, LPDWORD);
extern(Windows) BOOL FillConsoleOutputCharacterA(HANDLE, char, DWORD, COORD, LPDWORD);
extern(Windows) BOOL ScrollConsoleScreenBufferA(HANDLE, PSMALL_RECT, PSMALL_RECT, COORD, PCHAR_INFO);
extern(Windows) DWORD GetConsoleTitleA(LPSTR, DWORD);
extern(Windows) BOOL SetConsoleTitleA(LPCSTR);
extern(Windows) BOOL ReadConsoleA(HANDLE, LPVOID, DWORD, LPDWORD, LPVOID);
extern(Windows) BOOL WriteConsoleA(HANDLE, POINTER, DWORD, LPDWORD, LPVOID);
extern(Windows) DWORD WNetAddConnectionA(LPCSTR, LPCSTR, LPCSTR);
extern(Windows) DWORD WNetAddConnection2A(LPNETRESOURCE, LPCSTR, LPCSTR, DWORD);
extern(Windows) DWORD WNetAddConnection3A(HWND, LPNETRESOURCE, LPCSTR, LPCSTR, DWORD);
extern(Windows) DWORD WNetCancelConnectionA(LPCSTR, BOOL);
extern(Windows) DWORD WNetCancelConnection2A(LPCSTR, DWORD, BOOL);
extern(Windows) DWORD WNetGetConnectionA(LPCSTR, LPSTR, LPDWORD);
extern(Windows) DWORD WNetUseConnectionA(HWND, LPNETRESOURCE, LPCSTR, LPCSTR, DWORD, LPSTR, LPDWORD, LPDWORD);
extern(Windows) DWORD WNetSetConnectionA(LPCSTR, DWORD, LPVOID);
extern(Windows) DWORD WNetConnectionDialog1A(LPCONNECTDLGSTRUCT);
extern(Windows) DWORD WNetDisconnectDialog1A(LPDISCDLGSTRUCT);
extern(Windows) DWORD WNetOpenEnumA(DWORD, DWORD, DWORD, LPNETRESOURCE, LPHANDLE);
extern(Windows) DWORD WNetEnumResourceA(HANDLE, LPDWORD, LPVOID, LPDWORD);
extern(Windows) DWORD WNetGetUniversalNameA(LPCSTR, DWORD, LPVOID, LPDWORD);
extern(Windows) DWORD WNetGetUserA(LPCSTR, LPSTR, LPDWORD);
extern(Windows) DWORD WNetGetProviderNameA(DWORD, LPSTR, LPDWORD);
extern(Windows) DWORD WNetGetNetworkInformationA(LPCSTR, LPNETINFOSTRUCT);
extern(Windows) DWORD WNetGetLastErrorA(LPDWORD, LPSTR, DWORD, LPSTR, DWORD);
extern(Windows) DWORD MultinetGetConnectionPerformanceA(LPNETRESOURCE, LPNETCONNECTINFOSTRUCT);
extern(Windows) BOOL ChangeServiceConfigA(SC_HANDLE, DWORD, DWORD, DWORD, LPCSTR, LPCSTR, LPDWORD, LPCSTR, LPCSTR, LPCSTR, LPCSTR);
extern(Windows) SC_HANDLE CreateServiceA(SC_HANDLE, LPCSTR, LPCSTR, DWORD, DWORD, DWORD, DWORD, LPCSTR, LPCSTR, LPDWORD, LPCSTR, LPCSTR, LPCSTR);
extern(Windows) BOOL EnumDependentServicesA(SC_HANDLE, DWORD, LPENUM_SERVICE_STATUS, DWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL EnumServicesStatusA(SC_HANDLE, DWORD, DWORD, LPENUM_SERVICE_STATUS, DWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL GetServiceKeyNameA(SC_HANDLE, LPCSTR, LPSTR, LPDWORD);
extern(Windows) BOOL GetServiceDisplayNameA(SC_HANDLE, LPCSTR, LPSTR, LPDWORD);
extern(Windows) SC_HANDLE OpenSCManagerA(LPCSTR, LPCSTR, DWORD);
extern(Windows) SC_HANDLE OpenServiceA(SC_HANDLE, LPCSTR, DWORD);
extern(Windows) BOOL QueryServiceConfigA(SC_HANDLE, LPQUERY_SERVICE_CONFIG, DWORD, LPDWORD);
extern(Windows) BOOL QueryServiceLockStatusA(SC_HANDLE, LPQUERY_SERVICE_LOCK_STATUS, DWORD, LPDWORD);
extern(Windows) SERVICE_STATUS_HANDLE RegisterServiceCtrlHandlerA(LPCSTR, LPHANDLER_FUNCTION);
extern(Windows) BOOL StartServiceCtrlDispatcherA(LPSERVICE_TABLE_ENTRY);
extern(Windows) BOOL StartServiceA(SC_HANDLE, DWORD, LPCSTR);
extern(Windows) uint DragQueryFileA(HDROP, uint, PCHAR, uint);
extern(Windows) HICON ExtractAssociatedIconA(HINST, PCHAR, LPWORD);
extern(Windows) HICON ExtractIconA(HINST, PCHAR, uint);
extern(Windows) HINST FindExecutableA(PCHAR, PCHAR, PCHAR);
extern(Windows) int ShellAboutA(HWND, PCHAR, PCHAR, HICON);
extern(Windows) HINST ShellExecuteA(HWND, PCHAR, PCHAR, PCHAR, PCHAR, int);
extern(Windows) HSZ DdeCreateStringHandleA(DWORD, PCHAR, int);
extern(Windows) UINT DdeInitializeA(LPDWORD, PFNCALLBACK, DWORD, DWORD);
extern(Windows) DWORD DdeQueryStringA(DWORD, HSZ, PCHAR, DWORD, int);
extern(Windows) BOOL LogonUserA(LPSTR, LPSTR, LPSTR, DWORD, DWORD, PHANDLE);
extern(Windows) BOOL CreateProcessAsUserA(HANDLE, LPCTSTR, LPTSTR, LPSECURITY_ATTRIBUTES, LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCTSTR, LPSTARTUPINFO, LPPROCESS_INFORMATION);
extern(Windows) BOOL GetBinaryTypeW(LPCWSTR, LPDWORD);
extern(Windows) DWORD GetShortPathNameW(LPCWSTR, LPWSTR, DWORD);
extern(Windows) LPWSTR GetEnvironmentStringsW();
extern(Windows) BOOL FreeEnvironmentStringsW(LPWSTR);
extern(Windows) DWORD FormatMessageW(DWORD, LPCVOID, DWORD, DWORD, LPWSTR, DWORD, VA_LIST);
extern(Windows) HANDLE CreateMailslotW(LPCWSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) int lstrcmpW(LPCWSTR, LPCWSTR);
extern(Windows) int lstrcmpiW(LPCWSTR, LPCWSTR);
extern(Windows) LPWSTR lstrcpynW(LPWSTR, LPCWSTR, int);
extern(Windows) LPWSTR lstrcpyW(LPWSTR, LPCWSTR);
extern(Windows) LPWSTR lstrcatW(LPWSTR, LPCWSTR);
extern(Windows) int lstrlenW(LPCWSTR);
extern(Windows) HANDLE CreateMutexW(LPSECURITY_ATTRIBUTES, BOOL, LPCWSTR);
extern(Windows) HANDLE OpenMutexW(DWORD, BOOL, LPCWSTR);
extern(Windows) HANDLE CreateEventW(LPSECURITY_ATTRIBUTES, BOOL, BOOL, LPCWSTR);
extern(Windows) HANDLE OpenEventW(DWORD, BOOL, LPCWSTR);
extern(Windows) HANDLE CreateSemaphoreW(LPSECURITY_ATTRIBUTES, LONG, LONG, LPCWSTR);
extern(Windows) HANDLE OpenSemaphoreW(DWORD, BOOL, LPCWSTR);
extern(Windows) HANDLE CreateFileMappingW(HANDLE, LPSECURITY_ATTRIBUTES, DWORD, DWORD, DWORD, LPCWSTR);
extern(Windows) HANDLE OpenFileMappingW(DWORD, BOOL, LPCWSTR);
extern(Windows) DWORD GetLogicalDriveStringsW(DWORD, LPWSTR);
extern(Windows) HINST LoadLibraryW(LPCWSTR);
extern(Windows) HINST LoadLibraryExW(LPCWSTR, HANDLE, DWORD);
extern(Windows) DWORD GetModuleFileNameW(HINST, LPWSTR, DWORD);
extern(Windows) HMODULE GetModuleHandleW(LPCWSTR);
extern(Windows) void FatalAppExitW(UINT);
extern(Windows) LPWSTR GetCommandLineW();
extern(Windows) DWORD GetEnvironmentVariableW(LPCWSTR, LPWSTR, DWORD);
extern(Windows) BOOL SetEnvironmentVariableW(LPCWSTR, LPCWSTR);
extern(Windows) DWORD ExpandEnvironmentStringsW(LPCWSTR, LPWSTR, DWORD);
extern(Windows) void OutputDebugStringW(LPCWSTR);
extern(Windows) HRSRC FindResourceW(HINST, LPCWSTR, LPCWSTR);
extern(Windows) HRSRC FindResourceExW(HINST, LPCWSTR, LPCWSTR, ushort);
extern(Windows) BOOL EnumResourceTypesW(HINST, ENUMRESTYPEPROC, LONG);
extern(Windows) BOOL EnumResourceNamesW(HINST, LPCWSTR, ENUMRESNAMEPROC, LONG);
extern(Windows) BOOL EnumResourceLanguagesW(HINST, LPCWSTR, LPCWSTR, ENUMRESLANGPROC, LONG);
extern(Windows) HANDLE BeginUpdateResourceW(LPCWSTR, BOOL);
extern(Windows) BOOL UpdateResourceW(HANDLE, LPCWSTR, LPCWSTR, ushort, LPVOID, DWORD);
extern(Windows) BOOL EndUpdateResourceW(HANDLE, BOOL);
extern(Windows) ATOM GlobalAddAtomW(LPCWSTR);
extern(Windows) ATOM GlobalFindAtomW(LPCWSTR);
extern(Windows) UINT GlobalGetAtomNameW(ATOM, LPWSTR, int);
extern(Windows) ATOM AddAtomW(LPCWSTR);
extern(Windows) ATOM FindAtomW(LPCWSTR);
extern(Windows) UINT GetAtomNameW(ATOM, LPWSTR, int);
extern(Windows) UINT GetProfileIntW(LPCWSTR, LPCWSTR, INT);
extern(Windows) DWORD GetProfileStringW(LPCWSTR, LPCWSTR, LPCWSTR, LPWSTR, DWORD);
extern(Windows) BOOL WriteProfileStringW(LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) DWORD GetProfileSectionW(LPCWSTR, LPWSTR, DWORD);
extern(Windows) BOOL WriteProfileSectionW(LPCWSTR, LPCWSTR);
extern(Windows) UINT GetPrivateProfileIntW(LPCWSTR, LPCWSTR, INT, LPCWSTR);
extern(Windows) DWORD GetPrivateProfileStringW(LPCWSTR, LPCWSTR, LPCWSTR, LPWSTR, DWORD, LPCWSTR);
extern(Windows) BOOL WritePrivateProfileStringW(LPCWSTR, LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) DWORD GetPrivateProfileSectionW(LPCWSTR, LPWSTR, DWORD, LPCWSTR);
extern(Windows) BOOL WritePrivateProfileSectionW(LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) UINT GetDriveTypeW(LPCWSTR);
extern(Windows) UINT GetSystemDirectoryW(LPWSTR, UINT);
extern(Windows) DWORD GetTempPathW(DWORD, LPWSTR);
extern(Windows) UINT GetTempFileNameW(LPCWSTR, LPCWSTR, UINT, LPWSTR);
extern(Windows) UINT GetWindowsDirectoryW(LPWSTR, UINT);
extern(Windows) BOOL SetCurrentDirectoryW(LPCWSTR);
extern(Windows) DWORD GetCurrentDirectoryW(DWORD, LPWSTR);
extern(Windows) BOOL GetDiskFreeSpaceW(LPCWSTR, LPDWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL CreateDirectoryW(LPCWSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL CreateDirectoryExW(LPCWSTR, LPCWSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL RemoveDirectoryW(LPCWSTR);
extern(Windows) DWORD GetFullPathNameW(LPCWSTR, DWORD, LPWSTR, LPWSTR*);
extern(Windows) BOOL DefineDosDeviceW(DWORD, LPCWSTR, LPCWSTR);
extern(Windows) DWORD QueryDosDeviceW(LPCWSTR, LPWSTR, DWORD);
extern(Windows) HANDLE CreateFileW(LPCWSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES, DWORD, DWORD, HANDLE);
extern(Windows) BOOL SetFileAttributesW(LPCWSTR, DWORD);
extern(Windows) DWORD GetFileAttributesW(LPCWSTR);
extern(Windows) DWORD GetCompressedFileSizeW(LPCWSTR, LPDWORD);
extern(Windows) BOOL DeleteFileW(LPCWSTR);
extern(Windows) DWORD SearchPathW(LPCWSTR, LPCWSTR, LPCWSTR, DWORD, LPWSTR, LPWSTR);
extern(Windows) BOOL CopyFileW(LPCWSTR, LPCWSTR, BOOL);
extern(Windows) BOOL MoveFileW(LPCWSTR, LPCWSTR);
extern(Windows) BOOL MoveFileExW(LPCWSTR, LPCWSTR, DWORD);
extern(Windows) HANDLE CreateNamedPipeW(LPCWSTR, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) BOOL GetNamedPipeHandleStateW(HANDLE, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPWSTR, DWORD);
extern(Windows) BOOL CallNamedPipeW(LPCWSTR, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, DWORD);
extern(Windows) BOOL WaitNamedPipeW(LPCWSTR, DWORD);
extern(Windows) BOOL SetVolumeLabelW(LPCWSTR, LPCWSTR);
extern(Windows) BOOL GetVolumeInformationW(LPCWSTR, LPWSTR, DWORD, LPDWORD, LPDWORD, LPDWORD, LPWSTR, DWORD);
extern(Windows) BOOL ClearEventLogW(HANDLE, LPCWSTR);
extern(Windows) BOOL BackupEventLogW(HANDLE, LPCWSTR);
extern(Windows) HANDLE OpenEventLogW(LPCWSTR, LPCWSTR);
extern(Windows) HANDLE RegisterEventSourceW(LPCWSTR, LPCWSTR);
extern(Windows) HANDLE OpenBackupEventLogW(LPCWSTR, LPCWSTR);
extern(Windows) BOOL ReadEventLogW(HANDLE, DWORD, DWORD, LPVOID, DWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL ReportEventW(HANDLE, ushort, ushort, DWORD, PSID, ushort, DWORD, LPCWSTR, LPVOID);
extern(Windows) BOOL AccessCheckAndAuditAlarmW(LPCWSTR, LPVOID, LPWSTR, LPWSTR, PSECURITY_DESCRIPTOR, DWORD, PGENERIC_MAPPING, BOOL, LPDWORD, LPBOOL, LPBOOL);
extern(Windows) BOOL ObjectOpenAuditAlarmW(LPCWSTR, LPVOID, LPWSTR, LPWSTR, PSECURITY_DESCRIPTOR, HANDLE, DWORD, DWORD, PPRIVILEGE_SET, BOOL, BOOL, LPBOOL);
extern(Windows) BOOL ObjectPrivilegeAuditAlarmW(LPCWSTR, LPVOID, HANDLE, DWORD, PPRIVILEGE_SET, BOOL);
extern(Windows) BOOL ObjectCloseAuditAlarmW(LPCWSTR, LPVOID, BOOL);
extern(Windows) BOOL PrivilegedServiceAuditAlarmW(LPCWSTR, LPCWSTR, HANDLE, PPRIVILEGE_SET, BOOL);
extern(Windows) BOOL SetFileSecurityW(LPCWSTR, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) BOOL GetFileSecurityW(LPCWSTR, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
extern(Windows) HANDLE FindFirstChangeNotificationW(LPCWSTR, BOOL, DWORD);
extern(Windows) BOOL IsBadStringPtrW(LPCWSTR, UINT);
extern(Windows) BOOL LookupAccountSidW(LPCWSTR, PSID, LPWSTR, LPDWORD, LPWSTR, LPDWORD, PSID_NAME_USE);
extern(Windows) BOOL LookupAccountNameW(LPCWSTR, LPCWSTR, PSID, LPDWORD, LPWSTR, LPDWORD, PSID_NAME_USE);
extern(Windows) BOOL LookupPrivilegeValueW(LPCWSTR, LPCWSTR, PLUID);
extern(Windows) BOOL LookupPrivilegeNameW(LPCWSTR, PLUID, LPWSTR, LPDWORD);
extern(Windows) BOOL LookupPrivilegeDisplayNameW(LPCWSTR, LPCWSTR, LPWSTR, LPDWORD, LPDWORD);
extern(Windows) BOOL BuildCommDCBW(LPCWSTR, LPDCB);
extern(Windows) BOOL BuildCommDCBAndTimeoutsW(LPCWSTR, LPDCB, LPCOMMTIMEOUTS);
extern(Windows) BOOL CommConfigDialogW(LPCWSTR, HWND, LPCOMMCONFIG);
extern(Windows) BOOL GetDefaultCommConfigW(LPCWSTR, LPCOMMCONFIG, LPDWORD);
extern(Windows) BOOL SetDefaultCommConfigW(LPCWSTR, LPCOMMCONFIG, DWORD);
extern(Windows) BOOL GetComputerNameW(LPWSTR, LPDWORD);
extern(Windows) BOOL SetComputerNameW(LPCWSTR);
extern(Windows) BOOL GetUserNameW(LPWSTR, LPDWORD);
extern(Windows) int wvsprintfW(LPWSTR, LPCWSTR, VA_LIST);
extern(Windows) HKL LoadKeyboardLayoutW(LPCWSTR, UINT);
extern(Windows) BOOL GetKeyboardLayoutNameW(LPWSTR);
extern(Windows) HDESK CreateDesktopW(LPWSTR, LPWSTR, LPDEVMODE, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) HDESK OpenDesktopW(LPWSTR, DWORD, BOOL, DWORD);
extern(Windows) BOOL EnumDesktopsW(HWINSTA, DESKTOPENUMPROC, LPARAM);
extern(Windows) HWINSTA CreateWindowStationW(LPWSTR, DWORD, DWORD, LPSECURITY_ATTRIBUTES);
extern(Windows) HWINSTA OpenWindowStationW(LPWSTR, BOOL, DWORD);
extern(Windows) BOOL EnumWindowStationsW(ENUMWINDOWSTATIONPROC, LPARAM);
extern(Windows) BOOL GetUserObjectInformationW(HANDLE, int, PVOID, DWORD, LPDWORD);
extern(Windows) BOOL SetUserObjectInformationW(HANDLE, int, PVOID, DWORD);
extern(Windows) UINT RegisterWindowMessageW(LPCWSTR);
extern(Windows) BOOL GetMessageW(LPMSG, HWND, UINT, UINT);
extern(Windows) LONG DispatchMessageW(LPMSG);
extern(Windows) BOOL PeekMessageW(LPMSG, HWND, UINT, UINT, UINT);
extern(Windows) LRESULT SendMessageW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT SendMessageTimeoutW(HWND, UINT, WPARAM, LPARAM, UINT, UINT, LPDWORD);
extern(Windows) BOOL SendNotifyMessageW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL SendMessageCallbackW(HWND, UINT, WPARAM, LPARAM, SENDASYNCPROC, DWORD);
extern(Windows) BOOL PostMessageW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL PostThreadMessageW(DWORD, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefWindowProcW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT CallWindowProcW(WNDPROC, HWND, UINT, WPARAM, LPARAM);
extern(Windows) ATOM RegisterClassW(LPWNDCLASS);
extern(Windows) BOOL UnregisterClassW(LPCWSTR, HINST);
extern(Windows) BOOL GetClassInfoW(HINST, LPCWSTR, LPWNDCLASS);
extern(Windows) ATOM RegisterClassExW(LPWNDCLASSEX);
extern(Windows) BOOL GetClassInfoExW(HINST, LPCWSTR, LPWNDCLASSEX);
extern(Windows) HWND CreateWindowExW(DWORD, LPCWSTR, LPCWSTR, DWORD, int, int, int, int, HWND, HMENU, HINST, LPVOID);
extern(Windows) HWND CreateDialogParamW(HINST, LPCWSTR, HWND, DLGPROC, LPARAM);
extern(Windows) HWND CreateDialogIndirectParamW(HINST, LPCDLGTEMPLATE, HWND, DLGPROC, LPARAM);
extern(Windows) int DialogBoxParamW(HINST, LPCWSTR, HWND, DLGPROC, LPARAM);
extern(Windows) int DialogBoxIndirectParamW(HINST, LPCDLGTEMPLATE, HWND, DLGPROC, LPARAM);
extern(Windows) BOOL SetDlgItemTextW(HWND, int, LPCWSTR);
extern(Windows) UINT GetDlgItemTextW(HWND, int, LPWSTR, int);
extern(Windows) LONG SendDlgItemMessageW(HWND, int, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefDlgProcW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) BOOL CallMsgFilterW(LPMSG, int);
extern(Windows) UINT RegisterClipboardFormatW(LPCWSTR);
extern(Windows) int GetClipboardFormatNameW(UINT, LPWSTR, int);
extern(Windows) BOOL CharToOemW(LPCWSTR, LPSTR);
extern(Windows) BOOL OemToCharW(LPCSTR, LPWSTR);
extern(Windows) BOOL CharToOemBuffW(LPCWSTR, LPSTR, DWORD);
extern(Windows) BOOL OemToCharBuffW(LPCSTR, LPWSTR, DWORD);
extern(Windows) LPWSTR CharUpperW(LPWSTR);
extern(Windows) DWORD CharUpperBuffW(LPWSTR, DWORD);
extern(Windows) LPWSTR CharLowerW(LPWSTR);
extern(Windows) DWORD CharLowerBuffW(LPWSTR, DWORD);
extern(Windows) LPWSTR CharNextW(LPCWSTR);
extern(Windows) LPWSTR CharPrevW(LPCWSTR, LPCWSTR);
extern(Windows) BOOL IsCharAlphaW(WCHAR);
extern(Windows) BOOL IsCharAlphaNumericW(WCHAR);
extern(Windows) BOOL IsCharUpperW(WCHAR);
extern(Windows) BOOL IsCharLowerW(WCHAR);
extern(Windows) int GetKeyNameTextW(LONG, LPWSTR, int);
extern(Windows) SHORT VkKeyScanW(WCHAR);
extern(Windows) SHORT VkKeyScanExW(WCHAR, HKL);
extern(Windows) UINT MapVirtualKeyW(UINT, UINT);
extern(Windows) UINT MapVirtualKeyExW(UINT, UINT, HKL);
extern(Windows) HACCEL LoadAcceleratorsW(HINST, LPCWSTR);
extern(Windows) HACCEL CreateAcceleratorTableW(LPACCEL, int);
extern(Windows) int CopyAcceleratorTableW(HACCEL, LPACCEL, int);
extern(Windows) int TranslateAcceleratorW(HWND, HACCEL, LPMSG);
extern(Windows) HMENU LoadMenuW(HINST, LPCWSTR);
extern(Windows) HMENU LoadMenuIndirectW(LPMENUTEMPLATE);
extern(Windows) BOOL ChangeMenuW(HMENU, UINT, LPCWSTR, UINT, UINT);
extern(Windows) int GetMenuStringW(HMENU, UINT, LPWSTR, int, UINT);
extern(Windows) BOOL InsertMenuW(HMENU, UINT, UINT, UINT, LPCWSTR);
extern(Windows) BOOL AppendMenuW(HMENU, UINT, UINT, LPCWSTR);
extern(Windows) BOOL ModifyMenuW(HMENU, UINT, UINT, UINT, LPCWSTR);
extern(Windows) BOOL InsertMenuItemW(HMENU, UINT, BOOL, LPCMENUITEMINFO);
extern(Windows) BOOL GetMenuItemInfoW(HMENU, UINT, BOOL, LPMENUITEMINFO);
extern(Windows) BOOL SetMenuItemInfoW(HMENU, UINT, BOOL, LPCMENUITEMINFO);
extern(Windows) int DrawTextW(HDC, LPCWSTR, int, LPRECT, UINT);
extern(Windows) int DrawTextExW(HDC, LPWSTR, int, LPRECT, UINT, LPDRAWTEXTPARAMS);
extern(Windows) BOOL GrayStringW(HDC, HBRUSH, GRAYSTRINGPROC, LPARAM, int, int, int, int, int);
extern(Windows) BOOL DrawStateW(HDC, HBRUSH, DRAWSTATEPROC, LPARAM, WPARAM, int, int, int, int, UINT);
extern(Windows) LONG TabbedTextOutW(HDC, int, int, LPCWSTR, int, int, LPINT, int);
extern(Windows) DWORD GetTabbedTextExtentW(HDC, LPCWSTR, int, int, LPINT);
extern(Windows) BOOL SetPropW(HWND, LPCWSTR, HANDLE);
extern(Windows) HANDLE GetPropW(HWND, LPCWSTR);
extern(Windows) HANDLE RemovePropW(HWND, LPCWSTR);
extern(Windows) int EnumPropsExW(HWND, PROPENUMPROCEX, LPARAM);
extern(Windows) int EnumPropsW(HWND, PROPENUMPROC);
extern(Windows) BOOL SetWindowTextW(HWND, LPCWSTR);
extern(Windows) int GetWindowTextW(HWND, LPWSTR, int);
extern(Windows) int GetWindowTextLengthW(HWND);
extern(Windows) int MessageBoxW(HWND, LPCWSTR, LPCWSTR, UINT);
extern(Windows) int MessageBoxExW(HWND, LPCWSTR, LPCWSTR, UINT, ushort);
extern(Windows) int MessageBoxIndirectW(LPMSGBOXPARAMS);
extern(Windows) LONG GetWindowLongW(HWND, int);
extern(Windows) LONG SetWindowLongW(HWND, int, LONG);
extern(Windows) DWORD GetClassLongW(HWND, int);
extern(Windows) DWORD SetClassLongW(HWND, int, LONG);
extern(Windows) HWND FindWindowW(LPCWSTR, LPCWSTR);
extern(Windows) HWND FindWindowExW(HWND, HWND, LPCWSTR, LPCWSTR);
extern(Windows) int GetClassNameW(HWND, LPWSTR, int);
extern(Windows) HHOOK SetWindowsHookExW(int, HOOKPROC, HINST, DWORD);
extern(Windows) HBITMAP LoadBitmapW(HINST, LPCWSTR);
extern(Windows) HCURSOR LoadCursorW(HINST, LPCWSTR);
extern(Windows) HCURSOR LoadCursorFromFileW(LPCWSTR);
extern(Windows) HICON LoadIconW(HINST, LPCWSTR);
extern(Windows) HANDLE LoadImageW(HINST, LPCWSTR, UINT, int, int, UINT);
extern(Windows) int LoadStringW(HINST, UINT, LPWSTR, int);
extern(Windows) BOOL IsDialogMessageW(HWND, LPMSG);
extern(Windows) int DlgDirListW(HWND, LPWSTR, int, int, UINT);
extern(Windows) BOOL DlgDirSelectExW(HWND, LPWSTR, int, int);
extern(Windows) int DlgDirListComboBoxW(HWND, LPWSTR, int, int, UINT);
extern(Windows) BOOL DlgDirSelectComboBoxExW(HWND, LPWSTR, int, int);
extern(Windows) LRESULT DefFrameProcW(HWND, HWND, UINT, WPARAM, LPARAM);
extern(Windows) LRESULT DefMDIChildProcW(HWND, UINT, WPARAM, LPARAM);
extern(Windows) HWND CreateMDIWindowW(LPWSTR, LPWSTR, DWORD, int, int, int, int, HWND, HINST, LPARAM);
extern(Windows) BOOL WinHelpW(HWND, LPCWSTR, UINT, DWORD);
extern(Windows) LONG ChangeDisplaySettingsW(LPDEVMODE, DWORD);
extern(Windows) BOOL EnumDisplaySettingsW(LPCWSTR, DWORD, LPDEVMODE);
extern(Windows) BOOL SystemParametersInfoW(UINT, UINT, PVOID, UINT);
extern(Windows) int AddFontResourceW(LPCWSTR);
extern(Windows) HMETAFILE CopyMetaFileW(HMETAFILE, LPCWSTR);
extern(Windows) HFONT CreateFontIndirectW(PLOGFONT);
extern(Windows) HFONT CreateFontW(int, int, int, int, int, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, LPCWSTR);
extern(Windows) HDC CreateICW(LPCWSTR, LPCWSTR, LPCWSTR, LPDEVMODE);
extern(Windows) HDC CreateMetaFileW(LPCWSTR);
extern(Windows) BOOL CreateScalableFontResourceW(DWORD, LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) int EnumFontFamiliesExW(HDC, LPLOGFONT, FONTENUMEXPROC, LPARAM, DWORD);
extern(Windows) int EnumFontFamiliesW(HDC, LPCWSTR, FONTENUMPROC, LPARAM);
extern(Windows) int EnumFontsW(HDC, LPCWSTR, ENUMFONTSPROC, LPARAM);
extern(Windows) BOOL GetCharWidthW(HDC, UINT, UINT, LPINT);
extern(Windows) BOOL GetCharWidth32W(HDC, UINT, UINT, LPINT);
extern(Windows) BOOL GetCharWidthFloatW(HDC, UINT, UINT, PFLOAT);
extern(Windows) BOOL GetCharABCWidthsW(HDC, UINT, UINT, LPABC);
extern(Windows) BOOL GetCharABCWidthsFloatW(HDC, UINT, UINT, LPABCFLOAT);
extern(Windows) DWORD GetGlyphOutlineW(HDC, UINT, UINT, LPGLYPHMETRICS, DWORD, LPVOID, PMAT2);
extern(Windows) HMETAFILE GetMetaFileW(LPCWSTR);
extern(Windows) UINT GetOutlineTextMetricsW(HDC, UINT, LPOUTLINETEXTMETRIC);
extern(Windows) BOOL GetTextExtentPointW(HDC, LPCWSTR, int, LPSIZE);
extern(Windows) BOOL GetTextExtentPoint32W(HDC, LPCWSTR, int, LPSIZE);
extern(Windows) BOOL GetTextExtentExPointW(HDC, LPCWSTR, int, int, LPINT, LPINT, LPSIZE);
extern(Windows) DWORD GetCharacterPlacementW(HDC, LPCWSTR, int, int, LPGCP_RESULTS, DWORD);
extern(Windows) HDC ResetDCW(HDC, LPDEVMODE);
extern(Windows) BOOL RemoveFontResourceW(LPCWSTR);
extern(Windows) HENHMETAFILE CopyEnhMetaFileW(HENHMETAFILE, LPCWSTR);
extern(Windows) HDC CreateEnhMetaFileW(HDC, LPCWSTR, LPRECT, LPCWSTR);
extern(Windows) HENHMETAFILE GetEnhMetaFileW(LPCWSTR);
extern(Windows) UINT GetEnhMetaFileDescriptionW(HENHMETAFILE, UINT, LPWSTR);
extern(Windows) BOOL GetTextMetricsW(HDC, LPTEXTMETRIC);
extern(Windows) int StartDocW(HDC, PDOCINFO);
extern(Windows) int GetObjectW(HGDIOBJ, int, LPVOID);
extern(Windows) BOOL TextOutW(HDC, int, int, LPCWSTR, int);
extern(Windows) BOOL ExtTextOutW(HDC, int, int, UINT, LPRECT, LPCWSTR, UINT, LPINT);
extern(Windows) BOOL PolyTextOutW(HDC, PPOLYTEXT, int);
extern(Windows) int GetTextFaceW(HDC, int, LPWSTR);
extern(Windows) DWORD GetKerningPairsW(HDC, DWORD, LPKERNINGPAIR);
extern(Windows) BOOL GetLogColorSpaceW(HCOLORSPACE, LPLOGCOLORSPACE, DWORD);
extern(Windows) HCOLORSPACE CreateColorSpaceW(LPLOGCOLORSPACE);
extern(Windows) BOOL GetICMProfileW(HDC, DWORD, LPWSTR);
extern(Windows) BOOL SetICMProfileW(HDC, LPWSTR);
extern(Windows) BOOL UpdateICMRegKeyW(DWORD, DWORD, LPWSTR, UINT);
extern(Windows) int EnumICMProfilesW(HDC, ICMENUMPROC, LPARAM);
extern(Windows) HPROPSHEETPAGE CreatePropertySheetPageW(LPCPROPSHEETPAGE);
extern(Windows) int PropertySheetW(LPCPROPSHEETHEADER);
extern(Windows) HIMAGELIST ImageList_LoadImageW(HINST, LPCWSTR, int, int, COLORREF, UINT, UINT);
extern(Windows) HWND CreateStatusWindowW(LONG, LPCWSTR, HWND, UINT);
extern(Windows) void DrawStatusTextW(HDC, LPRECT, LPCWSTR);
extern(Windows) BOOL GetOpenFileNameW(LPOPENFILENAME);
extern(Windows) BOOL GetSaveFileNameW(LPOPENFILENAME);
extern(Windows) int GetFileTitleW(LPCWSTR, LPWSTR, ushort);
extern(Windows) BOOL ChooseColorW(LPCHOOSECOLOR);
extern(Windows) HWND ReplaceTextW(LPFINDREPLACE);
extern(Windows) BOOL ChooseFontW(LPCHOOSEFONT);
extern(Windows) HWND FindTextW(LPFINDREPLACE);
extern(Windows) BOOL PrintDlgW(LPPRINTDLG);
extern(Windows) BOOL PageSetupDlgW(LPPAGESETUPDLG);
extern(Windows) BOOL CreateProcessW(LPCWSTR, LPWSTR, LPSECURITY_ATTRIBUTES, LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCWSTR, LPSTARTUPINFO, LPPROCESS_INFORMATION);
extern(Windows) void GetStartupInfoW(LPSTARTUPINFO);
extern(Windows) HANDLE FindFirstFileW(LPCWSTR, WIN32_FIND_DATA *);
extern(Windows) BOOL FindNextFileW(HANDLE, WIN32_FIND_DATA *);
extern(Windows) BOOL GetVersionExW(LPOSVERSIONINFO);
extern(Windows) HDC CreateDCW(LPCWSTR, LPCWSTR, LPCWSTR, PDEVMODE);
extern(Windows) HFONT CreateFontA(int, int, int, int, int, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, LPCSTR);
extern(Windows) DWORD VerInstallFileW(DWORD, LPWSTR, LPWSTR, LPWSTR, LPWSTR, LPWSTR, LPWSTR, PUINT);
extern(Windows) DWORD GetFileVersionInfoSizeW(LPWSTR, LPDWORD);
extern(Windows) BOOL GetFileVersionInfoW(LPWSTR, DWORD, DWORD, LPVOID);
extern(Windows) DWORD VerLanguageNameW(DWORD, LPWSTR, DWORD);
extern(Windows) BOOL VerQueryValueW(LPVOID, LPWSTR, LPVOID, PUINT);
extern(Windows) DWORD VerFindFileW(DWORD, LPWSTR, LPWSTR, LPWSTR, LPWSTR, PUINT, LPWSTR, PUINT);
extern(Windows) LONG RegSetValueExW(HKEY, LPCWSTR, DWORD, DWORD, LPBYTE, DWORD);
extern(Windows) LONG RegUnLoadKeyW(HKEY, LPCWSTR);
extern(Windows) BOOL InitiateSystemShutdownW(LPWSTR, LPWSTR, DWORD, BOOL, BOOL);
extern(Windows) BOOL AbortSystemShutdownW(LPWSTR);
extern(Windows) LONG RegRestoreKeyW(HKEY, LPCWSTR, DWORD);
extern(Windows) LONG RegSaveKeyW(HKEY, LPCWSTR, LPSECURITY_ATTRIBUTES);
extern(Windows) LONG RegSetValueW(HKEY, LPCWSTR, DWORD, LPCWSTR, DWORD);
extern(Windows) LONG RegQueryValueW(HKEY, LPCWSTR, LPWSTR, PLONG);
extern(Windows) LONG RegQueryMultipleValuesW(HKEY, PVALENT, DWORD, LPWSTR, LPDWORD);
extern(Windows) LONG RegQueryValueExW(HKEY, LPCWSTR, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
extern(Windows) LONG RegReplaceKeyW(HKEY, LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) LONG RegConnectRegistryW(LPWSTR, HKEY, PHKEY);
extern(Windows) LONG RegCreateKeyW(HKEY, LPCWSTR, PHKEY);
extern(Windows) LONG RegCreateKeyExW(HKEY, LPCWSTR, DWORD, LPWSTR, DWORD, REGSAM, LPSECURITY_ATTRIBUTES, PHKEY, LPDWORD);
extern(Windows) LONG RegDeleteKeyW(HKEY, LPCWSTR);
extern(Windows) LONG RegDeleteValueW(HKEY, LPCWSTR);
extern(Windows) LONG RegEnumKeyW(HKEY, DWORD, LPWSTR, DWORD);
extern(Windows) LONG RegEnumKeyExW(HKEY, DWORD, LPWSTR, LPDWORD, LPDWORD, LPWSTR, LPDWORD, PFILETIME);
extern(Windows) LONG RegEnumValueW(HKEY, DWORD, LPWSTR, LPDWORD, LPDWORD, LPDWORD, LPBYTE, LPDWORD);
extern(Windows) LONG RegLoadKeyW(HKEY, LPCWSTR, LPCWSTR);
extern(Windows) LONG RegOpenKeyW(HKEY, LPCWSTR, PHKEY);
extern(Windows) LONG RegOpenKeyExW(HKEY, LPCWSTR, DWORD, REGSAM, PHKEY);
extern(Windows) LONG RegQueryInfoKeyW(HKEY, LPWSTR, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, LPDWORD, PFILETIME);
extern(Windows) int CompareStringW(LCID, DWORD, LPCWSTR, int, LPCWSTR, int);
extern(Windows) int LCMapStringW(LCID, DWORD, LPCWSTR, int, LPWSTR, int);
extern(Windows) int GetLocaleInfoW(LCID, LCTYPE, LPWSTR, int);
extern(Windows) BOOL SetLocaleInfoW(LCID, LCTYPE, LPCWSTR);
extern(Windows) int GetTimeFormatW(LCID, DWORD, LPSYSTEMTIME, LPCWSTR, LPWSTR, int);
extern(Windows) int GetDateFormatW(LCID, DWORD, LPSYSTEMTIME, LPCWSTR, LPWSTR, int);
extern(Windows) int GetNumberFormatW(LCID, DWORD, LPCWSTR, PNUMBERFMT, LPWSTR, int);
extern(Windows) int GetCurrencyFormatW(LCID, DWORD, LPCWSTR, PCURRENCYFMT, LPWSTR, int);
extern(Windows) BOOL EnumCalendarInfoW(CALINFO_ENUMPROC, LCID, CALID, CALTYPE);
extern(Windows) BOOL EnumTimeFormatsW(TIMEFMT_ENUMPROC, LCID, DWORD);
extern(Windows) BOOL EnumDateFormatsW(DATEFMT_ENUMPROC, LCID, DWORD);
extern(Windows) BOOL GetStringTypeExW(LCID, DWORD, LPCWSTR, int, LPWORD);
extern(Windows) BOOL GetStringTypeW(DWORD, LPCWSTR, int, LPWORD);
extern(Windows) int FoldStringW(DWORD, LPCWSTR, int, LPWSTR, int);
extern(Windows) BOOL EnumSystemLocalesW(LOCALE_ENUMPROC, DWORD);
extern(Windows) BOOL EnumSystemCodePagesW(CODEPAGE_ENUMPROC, DWORD);
extern(Windows) BOOL PeekConsoleInputW(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL ReadConsoleInputW(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL WriteConsoleInputW(HANDLE, PINPUTRECORD, DWORD, LPDWORD);
extern(Windows) BOOL ReadConsoleOutputW(HANDLE, PCHAR_INFO, COORD, COORD, PSMALL_RECT);
extern(Windows) BOOL WriteConsoleOutputW(HANDLE, PCHAR_INFO, COORD, COORD, PSMALL_RECT);
extern(Windows) BOOL ReadConsoleOutputCharacterW(HANDLE, LPWSTR, DWORD, COORD, LPDWORD);
extern(Windows) BOOL WriteConsoleOutputCharacterW(HANDLE, LPCWSTR, DWORD, COORD, LPDWORD);
extern(Windows) BOOL FillConsoleOutputCharacterW(HANDLE, WCHAR, DWORD, COORD, LPDWORD);
extern(Windows) BOOL ScrollConsoleScreenBufferW(HANDLE, PSMALL_RECT, PSMALL_RECT, COORD, PCHAR_INFO);
extern(Windows) DWORD GetConsoleTitleW(LPWSTR, DWORD);
extern(Windows) BOOL SetConsoleTitleW(LPCWSTR);
extern(Windows) BOOL ReadConsoleW(HANDLE, LPVOID, DWORD, LPDWORD, LPVOID);
extern(Windows) BOOL WriteConsoleW(HANDLE, POINTER, DWORD, LPDWORD, LPVOID);
extern(Windows) DWORD WNetAddConnectionW(LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) DWORD WNetAddConnection2W(LPNETRESOURCE, LPCWSTR, LPCWSTR, DWORD);
extern(Windows) DWORD WNetAddConnection3W(HWND, LPNETRESOURCE, LPCWSTR, LPCWSTR, DWORD);
extern(Windows) DWORD WNetCancelConnectionW(LPCWSTR, BOOL);
extern(Windows) DWORD WNetCancelConnection2W(LPCWSTR, DWORD, BOOL);
extern(Windows) DWORD WNetGetConnectionW(LPCWSTR, LPWSTR, LPDWORD);
extern(Windows) DWORD WNetUseConnectionW(HWND, LPNETRESOURCE, LPCWSTR, LPCWSTR, DWORD, LPWSTR, LPDWORD, LPDWORD);
extern(Windows) DWORD WNetSetConnectionW(LPCWSTR, DWORD, LPVOID);
extern(Windows) DWORD WNetConnectionDialog1W(LPCONNECTDLGSTRUCT);
extern(Windows) DWORD WNetDisconnectDialog1W(LPDISCDLGSTRUCT);
extern(Windows) DWORD WNetOpenEnumW(DWORD, DWORD, DWORD, LPNETRESOURCE, LPHANDLE);
extern(Windows) DWORD WNetEnumResourceW(HANDLE, LPDWORD, LPVOID, LPDWORD);
extern(Windows) DWORD WNetGetUniversalNameW(LPCWSTR, DWORD, LPVOID, LPDWORD);
extern(Windows) DWORD WNetGetUserW(LPCWSTR, LPWSTR, LPDWORD);
extern(Windows) DWORD WNetGetProviderNameW(DWORD, LPWSTR, LPDWORD);
extern(Windows) DWORD WNetGetNetworkInformationW(LPCWSTR, LPNETINFOSTRUCT);
extern(Windows) DWORD WNetGetLastErrorW(LPDWORD, LPWSTR, DWORD, LPWSTR, DWORD);
extern(Windows) DWORD MultinetGetConnectionPerformanceW(LPNETRESOURCE, LPNETCONNECTINFOSTRUCT);
extern(Windows) BOOL ChangeServiceConfigW(SC_HANDLE, DWORD, DWORD, DWORD, LPCWSTR, LPCWSTR, LPDWORD, LPCWSTR, LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) SC_HANDLE CreateServiceW(SC_HANDLE, LPCWSTR, LPCWSTR, DWORD, DWORD, DWORD, DWORD, LPCWSTR, LPCWSTR, LPDWORD, LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) BOOL EnumDependentServicesW(SC_HANDLE, DWORD, LPENUM_SERVICE_STATUS, DWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL EnumServicesStatusW(SC_HANDLE, DWORD, DWORD, LPENUM_SERVICE_STATUS, DWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL GetServiceKeyNameW(SC_HANDLE, LPCWSTR, LPWSTR, LPDWORD);
extern(Windows) BOOL GetServiceDisplayNameW(SC_HANDLE, LPCWSTR, LPWSTR, LPDWORD);
extern(Windows) SC_HANDLE OpenSCManagerW(LPCWSTR, LPCWSTR, DWORD);
extern(Windows) SC_HANDLE OpenServiceW(SC_HANDLE, LPCWSTR, DWORD);
extern(Windows) BOOL QueryServiceConfigW(SC_HANDLE, LPQUERY_SERVICE_CONFIG, DWORD, LPDWORD);
extern(Windows) BOOL QueryServiceLockStatusW(SC_HANDLE, LPQUERY_SERVICE_LOCK_STATUS, DWORD, LPDWORD);
extern(Windows) SERVICE_STATUS_HANDLE RegisterServiceCtrlHandlerW(LPCWSTR, LPHANDLER_FUNCTION);
extern(Windows) BOOL StartServiceCtrlDispatcherW(LPSERVICE_TABLE_ENTRY);
extern(Windows) BOOL StartServiceW(SC_HANDLE, DWORD, LPCWSTR);
extern(Windows) uint DragQueryFileW(HDROP, uint, LPCWSTR, uint);
extern(Windows) HICON ExtractAssociatedIconW(HINST, LPCWSTR, LPWORD);
extern(Windows) HICON ExtractIconW(HINST, LPCWSTR, uint);
extern(Windows) HINST FindExecutableW(LPCWSTR, LPCWSTR, LPCWSTR);
extern(Windows) int ShellAboutW(HWND, LPCWSTR, LPCWSTR, HICON);
extern(Windows) HINST ShellExecuteW(HWND, LPCWSTR, LPCWSTR, LPCWSTR, LPCWSTR, int);
extern(Windows) HSZ DdeCreateStringHandleW(DWORD, LPCWSTR, int);
extern(Windows) UINT DdeInitializeW(LPDWORD, PFNCALLBACK, DWORD, DWORD);
extern(Windows) DWORD DdeQueryStringW(DWORD, HSZ, LPCWSTR, DWORD, int);
extern(Windows) BOOL LogonUserW(LPWSTR, LPWSTR, LPWSTR, DWORD, DWORD, PHANDLE);
extern(Windows) BOOL CreateProcessAsUserW(HANDLE, LPCWSTR, LPWSTR, LPSECURITY_ATTRIBUTES, LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCWSTR, LPSTARTUPINFO, LPPROCESS_INFORMATION);
extern(Windows) BOOL AccessCheck(PSECURITY_DESCRIPTOR, HANDLE, DWORD, PGENERIC_MAPPING, PPRIVILEGE_SET, LPDWORD, LPDWORD, LPBOOL);
extern(Windows) LONG InterlockedIncrement(LPLONG);
extern(Windows) LONG InterlockedDecrement(LPLONG);
extern(Windows) LONG InterlockedExchange(LPLONG, LONG);
extern(Windows) BOOL FreeResource(HGLOBAL);
extern(Windows) LPVOID LockResource(HGLOBAL);
extern(Windows) BOOL FreeLibrary(HINST);
extern(Windows) void FreeLibraryAndExitThread(HMODULE);
extern(Windows) BOOL DisableThreadLibraryCalls(HMODULE);
extern(Windows) FARPROC GetProcAddress(HINST, LPCSTR);
extern(Windows) DWORD GetVersion();
extern(Windows) HGLOBAL GlobalAlloc(UINT, DWORD);
extern(Windows) HGLOBAL GlobalReAlloc(HGLOBAL, DWORD, UINT);
extern(Windows) DWORD GlobalSize(HGLOBAL);
extern(Windows) UINT GlobalFlags(HGLOBAL);
extern(Windows) LPVOID GlobalLock(HGLOBAL);
extern(Windows) HGLOBAL GlobalHandle(LPCVOID);
extern(Windows) BOOL GlobalUnlock(HGLOBAL);
extern(Windows) HGLOBAL GlobalFree(HGLOBAL);
extern(Windows) UINT GlobalCompact(DWORD);
extern(Windows) void GlobalFix(HGLOBAL);
extern(Windows) void GlobalUnfix(HGLOBAL);
extern(Windows) LPVOID GlobalWire(HGLOBAL);
extern(Windows) BOOL GlobalUnWire(HGLOBAL);
extern(Windows) void GlobalMemoryStatus(LPMEMORYSTATUS);
extern(Windows) HLOCAL LocalAlloc(UINT, UINT);
extern(Windows) HLOCAL LocalReAlloc(HLOCAL, UINT, UINT);
extern(Windows) LPVOID LocalLock(HLOCAL);
extern(Windows) HLOCAL LocalHandle(LPCVOID);
extern(Windows) BOOL LocalUnlock(HLOCAL);
extern(Windows) UINT LocalSize(HLOCAL);
extern(Windows) UINT LocalFlags(HLOCAL);
extern(Windows) HLOCAL LocalFree(HLOCAL);
extern(Windows) UINT LocalShrink(HLOCAL, UINT);
extern(Windows) UINT LocalCompact(UINT);
extern(Windows) BOOL FlushInstructionCache(HANDLE, LPCVOID, DWORD);
extern(Windows) LPVOID VirtualAlloc(LPVOID, DWORD, DWORD, DWORD);
extern(Windows) BOOL VirtualFree(LPVOID, DWORD, DWORD);
extern(Windows) BOOL VirtualProtect(LPVOID, DWORD, DWORD, PDWORD);
extern(Windows) DWORD VirtualQuery(LPCVOID, PMEMORY_BASIC_INFORMATION, DWORD);
extern(Windows) BOOL VirtualProtectEx(HANDLE, LPVOID, DWORD, DWORD, PDWORD);
extern(Windows) DWORD VirtualQueryEx(HANDLE, LPCVOID, PMEMORY_BASIC_INFORMATION, DWORD);
extern(Windows) HANDLE HeapCreate(DWORD, DWORD, DWORD);
extern(Windows) BOOL HeapDestroy(HANDLE);
extern(Windows) LPVOID HeapAlloc(HANDLE, DWORD, DWORD);
extern(Windows) LPVOID HeapReAlloc(HANDLE, DWORD, LPVOID, DWORD);
extern(Windows) BOOL HeapFree(HANDLE, DWORD, LPVOID);
extern(Windows) DWORD HeapSize(HANDLE, DWORD, LPCVOID);
extern(Windows) BOOL HeapValidate(HANDLE, DWORD, LPCVOID);
extern(Windows) UINT HeapCompact(HANDLE, DWORD);
extern(Windows) HANDLE GetProcessHeap();
extern(Windows) DWORD GetProcessHeaps(DWORD, PHANDLE);
extern(Windows) BOOL HeapLock(HANDLE);
extern(Windows) BOOL HeapUnlock(HANDLE);
extern(Windows) BOOL HeapWalk(HANDLE, LPPROCESS_HEAP_ENTRY);
extern(Windows) BOOL GetProcessAffinityMask(HANDLE, LPDWORD, LPDWORD);
extern(Windows) BOOL GetProcessTimes(HANDLE, LPFILETIME, LPFILETIME, LPFILETIME, LPFILETIME);
extern(Windows) BOOL GetProcessWorkingSetSize(HANDLE, LPDWORD, LPDWORD);
extern(Windows) BOOL SetProcessWorkingSetSize(HANDLE, DWORD, DWORD);
extern(Windows) HANDLE OpenProcess(DWORD, BOOL, DWORD);
extern(Windows) HANDLE GetCurrentProcess();
extern(Windows) DWORD GetCurrentProcessId();
extern(Windows) void ExitProcess(UINT);
extern(Windows) BOOL TerminateProcess(HANDLE, UINT);
extern(Windows) BOOL GetExitCodeProcess(HANDLE, LPDWORD);
extern(Windows) void FatalExit(int);
extern(Windows) void RaiseException(DWORD, DWORD, DWORD);
extern(Windows) LONG UnhandledExceptionFilter(EMPTYRECORD*);
extern(Windows) HANDLE CreateRemoteThread(HANDLE, LPSECURITY_ATTRIBUTES, DWORD, LPTHREAD_START_ROUTINE, LPVOID, DWORD, LPDWORD);
extern(Windows) HANDLE GetCurrentThread();
extern(Windows) DWORD GetCurrentThreadId();
extern(Windows) DWORD SetThreadAffinityMask(HANDLE, DWORD);
extern(Windows) BOOL SetThreadPriority(HANDLE, int);
extern(Windows) int GetThreadPriority(HANDLE);
extern(Windows) BOOL GetThreadTimes(HANDLE, LPFILETIME, LPFILETIME, LPFILETIME, LPFILETIME);
extern(Windows) void ExitThread(DWORD);
extern(Windows) BOOL TerminateThread(HANDLE, DWORD);
extern(Windows) BOOL GetExitCodeThread(HANDLE, LPDWORD);
extern(Windows) BOOL GetThreadSelectorEntry(HANDLE, DWORD, LPLDT_ENTRY);
extern(Windows) DWORD GetLastError();
extern(Windows) void SetLastError(DWORD);
extern(Windows) HANDLE CreateIoCompletionPort(HANDLE, HANDLE, DWORD, DWORD);
extern(Windows) UINT SetErrorMode(UINT);
extern(Windows) BOOL ReadProcessMemory(HANDLE, LPCVOID, LPVOID, DWORD, LPDWORD);
extern(Windows) BOOL WriteProcessMemory(HANDLE, LPVOID, LPVOID, DWORD, LPDWORD);
extern(Windows) BOOL GetThreadContext(HANDLE, LPCONTEXT);
extern(Windows) DWORD SuspendThread(HANDLE);
extern(Windows) DWORD ResumeThread(HANDLE);
extern(Windows) void DebugBreak();
extern(Windows) BOOL WaitForDebugEvent(LPDEBUG_EVENT, DWORD);
extern(Windows) BOOL ContinueDebugEvent(DWORD, DWORD, DWORD);
extern(Windows) BOOL DebugActiveProcess(DWORD);
extern(Windows) void InitializeCriticalSection(LPCRITICAL_SECTION);
extern(Windows) void EnterCriticalSection(LPCRITICAL_SECTION);
extern(Windows) void LeaveCriticalSection(LPCRITICAL_SECTION);
extern(Windows) void DeleteCriticalSection(LPCRITICAL_SECTION);
extern(Windows) BOOL SetEvent(HANDLE);
extern(Windows) BOOL ResetEvent(HANDLE);
extern(Windows) BOOL PulseEvent(HANDLE);
extern(Windows) BOOL ReleaseSemaphore(HANDLE, LONG, LPLONG);
extern(Windows) BOOL ReleaseMutex(HANDLE);
extern(Windows) DWORD WaitForSingleObject(HANDLE, DWORD);
extern(Windows) DWORD WaitForMultipleObjects(DWORD, HANDLE*, BOOL, DWORD);
extern(Windows) void Sleep(DWORD);
extern(Windows) HGLOBAL LoadResource(HINST, HRSRC);
extern(Windows) DWORD SizeofResource(HINST, HRSRC);
extern(Windows) ATOM GlobalDeleteAtom(ATOM);
extern(Windows) BOOL InitAtomTable(DWORD);
extern(Windows) ATOM DeleteAtom(ATOM);
extern(Windows) UINT SetHandleCount(UINT);
extern(Windows) DWORD GetLogicalDrives();
extern(Windows) BOOL LockFile(HANDLE, DWORD, DWORD, DWORD, DWORD);
extern(Windows) BOOL UnlockFile(HANDLE, DWORD, DWORD, DWORD, DWORD);
extern(Windows) BOOL LockFileEx(HANDLE, DWORD, DWORD, DWORD, DWORD, LPOVERLAPPED);
extern(Windows) BOOL UnlockFileEx(HANDLE, DWORD, DWORD, DWORD, LPOVERLAPPED);
extern(Windows) BOOL GetFileInformationByHandle(HANDLE, LPBY_HANDLE_FILE_INFORMATION);
extern(Windows) DWORD GetFileType(HANDLE);
extern(Windows) DWORD GetFileSize(HANDLE, LPDWORD);
extern(Windows) HANDLE GetStdHandle(DWORD);
extern(Windows) BOOL SetStdHandle(DWORD, HANDLE);
extern(Windows) BOOL FlushFileBuffers(HANDLE);
extern(Windows) BOOL DeviceIoControl(HANDLE, DWORD, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, LPOVERLAPPED);
extern(Windows) BOOL SetEndOfFile(HANDLE);
extern(Windows) DWORD SetFilePointer(HANDLE, LONG, PLONG, DWORD);
extern(Windows) BOOL FindClose(HANDLE);
extern(Windows) BOOL GetFileTime(HANDLE, LPFILETIME, LPFILETIME, LPFILETIME);
extern(Windows) BOOL SetFileTime(HANDLE, FILETIME*, FILETIME*, FILETIME*);
extern(Windows) BOOL CloseHandle(HANDLE);
extern(Windows) BOOL DuplicateHandle(HANDLE, HANDLE, HANDLE, LPHANDLE, DWORD, BOOL, DWORD);
extern(Windows) BOOL GetHandleInformation(HANDLE, LPDWORD);
extern(Windows) BOOL SetHandleInformation(HANDLE, DWORD, DWORD);
extern(Windows) DWORD LoadModule(LPCSTR, LPVOID);
extern(Windows) UINT WinExec(LPCSTR, UINT);
extern(Windows) BOOL ClearCommBreak(HANDLE);
extern(Windows) BOOL ClearCommError(HANDLE, LPDWORD, LPCOMSTAT);
extern(Windows) BOOL SetupComm(HANDLE, DWORD, DWORD);
extern(Windows) BOOL EscapeCommFunction(HANDLE, DWORD);
extern(Windows) BOOL GetCommConfig(HANDLE, LPCOMMCONFIG, LPDWORD);
extern(Windows) BOOL GetCommProperties(HANDLE, LPCOMMPROP);
extern(Windows) BOOL GetCommModemStatus(HANDLE, PDWORD);
extern(Windows) BOOL GetCommState(HANDLE, PDCB);
extern(Windows) BOOL GetCommTimeouts(HANDLE, PCOMMTIMEOUTS);
extern(Windows) BOOL PurgeComm(HANDLE, DWORD);
extern(Windows) BOOL SetCommBreak(HANDLE);
extern(Windows) BOOL SetCommConfig(HANDLE, LPCOMMCONFIG, DWORD);
extern(Windows) BOOL SetCommMask(HANDLE, DWORD);
extern(Windows) BOOL SetCommState(HANDLE, TDCB*);
extern(Windows) BOOL SetCommTimeouts(HANDLE, TCOMMTIMEOUTS*);
extern(Windows) BOOL TransmitCommChar(HANDLE, char);
extern(Windows) BOOL WaitCommEvent(HANDLE, LPDWORD, LPOVERLAPPED);
extern(Windows) DWORD SetTapePosition(HANDLE, DWORD, DWORD, DWORD, DWORD, BOOL);
extern(Windows) DWORD GetTapePosition(HANDLE, DWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) DWORD PrepareTape(HANDLE, DWORD, BOOL);
extern(Windows) DWORD EraseTape(HANDLE, DWORD, BOOL);
extern(Windows) DWORD CreateTapePartition(HANDLE, DWORD, DWORD, DWORD);
extern(Windows) DWORD WriteTapemark(HANDLE, DWORD, DWORD, BOOL);
extern(Windows) DWORD GetTapeStatus(HANDLE);
extern(Windows) DWORD GetTapeParameters(HANDLE, DWORD, LPDWORD, LPVOID);
extern(Windows) DWORD SetTapeParameters(HANDLE, DWORD, LPVOID);
extern(Windows) BOOL Beep(DWORD, DWORD);
extern(Windows) int MulDiv(int, int, int);
extern(Windows) void GetSystemTime(LPSYSTEMTIME);
extern(Windows) BOOL SetSystemTime(SYSTEMTIME*);
extern(Windows) void GetLocalTime(LPSYSTEMTIME);
extern(Windows) BOOL SetLocalTime(SYSTEMTIME*);
extern(Windows) void GetSystemInfo(LPSYSTEM_INFO);
extern(Windows) BOOL SystemTimeToTzSpecificLocalTime(LPTIME_ZONE_INFORMATION, LPSYSTEMTIME, LPSYSTEMTIME);
extern(Windows) DWORD GetTimeZoneInformation(LPTIME_ZONE_INFORMATION);
extern(Windows) BOOL SetTimeZoneInformation(TIME_ZONE_INFORMATION*);
extern(Windows) BOOL SystemTimeToFileTime(SYSTEMTIME*, LPFILETIME);
extern(Windows) BOOL FileTimeToLocalFileTime(FILETIME*, LPFILETIME);
extern(Windows) BOOL LocalFileTimeToFileTime(FILETIME*, LPFILETIME);
extern(Windows) BOOL FileTimeToSystemTime(FILETIME*, LPSYSTEMTIME);
extern(Windows) LONG CompareFileTime(FILETIME*, FILETIME*);
extern(Windows) BOOL FileTimeToDosDateTime(FILETIME*, LPWORD, LPWORD);
extern(Windows) BOOL DosDateTimeToFileTime(ushort, ushort, LPFILETIME);
extern(Windows) DWORD GetTickCount();
extern(Windows) BOOL SetSystemTimeAdjustment(DWORD, BOOL);
extern(Windows) BOOL GetSystemTimeAdjustment(PDWORD, PDWORD, PWINBOOL);
extern(Windows) BOOL CreatePipe(PHANDLE, PHANDLE, LPSECURITY_ATTRIBUTES, DWORD);
extern(Windows) BOOL ConnectNamedPipe(HANDLE, LPOVERLAPPED);
extern(Windows) BOOL DisconnectNamedPipe(HANDLE);
extern(Windows) BOOL SetNamedPipeHandleState(HANDLE, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL GetNamedPipeInfo(HANDLE, LPDWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL PeekNamedPipe(HANDLE, LPVOID, DWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL TransactNamedPipe(HANDLE, LPVOID, DWORD, LPVOID, DWORD, LPDWORD, LPOVERLAPPED);
extern(Windows) BOOL GetMailslotInfo(HANDLE, LPDWORD, LPDWORD, LPDWORD, LPDWORD);
extern(Windows) BOOL SetMailslotInfo(HANDLE, DWORD);
extern(Windows) LPVOID MapViewOfFile(HANDLE, DWORD, DWORD, DWORD, DWORD);
extern(Windows) BOOL FlushViewOfFile(LPCVOID, DWORD);
extern(Windows) BOOL UnmapViewOfFile(LPVOID);
extern(Windows) HFILE OpenFile(LPCSTR, LPOFSTRUCT, UINT);
extern(Windows) HFILE _lopen(LPCSTR, int);
extern(Windows) HFILE _lcreat(LPCSTR, int);
extern(Windows) UINT _lread(HFILE, LPVOID, UINT);
extern(Windows) UINT _lwrite(HFILE, LPCSTR, UINT);
extern(Windows) int _hread(HFILE, LPVOID, int);
extern(Windows) int _hwrite(HFILE, LPCSTR, int);
extern(Windows) HFILE _lclose(HFILE);
extern(Windows) LONG _llseek(HFILE, LONG, int);
extern(Windows) BOOL IsTextUnicode(LPVOID, int, LPINT);
extern(Windows) DWORD TlsAlloc();
extern(Windows) LPVOID TlsGetValue(DWORD);
extern(Windows) BOOL TlsSetValue(DWORD, LPVOID);
extern(Windows) BOOL TlsFree(DWORD);
extern(Windows) DWORD SleepEx(DWORD, BOOL);
extern(Windows) DWORD WaitForSingleObjectEx(HANDLE, DWORD, BOOL);
extern(Windows) DWORD WaitForMultipleObjectsEx(DWORD, HANDLE*, BOOL, DWORD, BOOL);
extern(Windows) BOOL ReadFileEx(HANDLE, LPVOID, DWORD, LPOVERLAPPED, LPOVERLAPPED_COMPLETION_ROUTINE);
extern(Windows) BOOL WriteFileEx(HANDLE, LPCVOID, DWORD, LPOVERLAPPED, LPOVERLAPPED_COMPLETION_ROUTINE);
extern(Windows) BOOL BackupRead(HANDLE, LPBYTE, DWORD, LPDWORD, BOOL, BOOL, LPVOID*);
extern(Windows) BOOL BackupSeek(HANDLE, DWORD, DWORD, LPDWORD, LPDWORD, LPVOID*);
extern(Windows) BOOL BackupWrite(HANDLE, LPBYTE, DWORD, LPDWORD, BOOL, BOOL, LPVOID*);
extern(Windows) BOOL SetProcessShutdownParameters(DWORD, DWORD);
extern(Windows) BOOL GetProcessShutdownParameters(LPDWORD, LPDWORD);
extern(Windows) void SetFileApisToOEM();
extern(Windows) void SetFileApisToANSI();
extern(Windows) BOOL AreFileApisANSI();
extern(Windows) BOOL CloseEventLog(HANDLE);
extern(Windows) BOOL DeregisterEventSource(HANDLE);
extern(Windows) BOOL NotifyChangeEventLog(HANDLE, HANDLE);
extern(Windows) BOOL GetNumberOfEventLogRecords(HANDLE, PDWORD);
extern(Windows) BOOL GetOldestEventLogRecord(HANDLE, PDWORD);
extern(Windows) BOOL DuplicateToken(HANDLE, SECURITY_IMPERSONATION_LEVEL, PHANDLE);
extern(Windows) BOOL GetKernelObjectSecurity(HANDLE, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
extern(Windows) BOOL ImpersonateNamedPipeClient(HANDLE);
extern(Windows) BOOL ImpersonateLoggedOnUser(HANDLE);
extern(Windows) BOOL ImpersonateSelf(SECURITY_IMPERSONATION_LEVEL);
extern(Windows) BOOL RevertToSelf();
extern(Windows) BOOL SetThreadToken(PHANDLE, HANDLE);
extern(Windows) BOOL OpenProcessToken(HANDLE, DWORD, PHANDLE);
extern(Windows) BOOL OpenThreadToken(HANDLE, DWORD, BOOL, PHANDLE);
extern(Windows) BOOL GetTokenInformation(HANDLE, TOKEN_INFORMATION_CLASS, LPVOID, DWORD, PDWORD);
extern(Windows) BOOL SetTokenInformation(HANDLE, TOKEN_INFORMATION_CLASS, LPVOID, DWORD);
extern(Windows) BOOL AdjustTokenPrivileges(HANDLE, BOOL, PTOKEN_PRIVILEGES, DWORD, PTOKEN_PRIVILEGES, PDWORD);
extern(Windows) BOOL AdjustTokenGroups(HANDLE, BOOL, PTOKEN_GROUPS, DWORD, PTOKEN_GROUPS, PDWORD);
extern(Windows) BOOL PrivilegeCheck(HANDLE, PPRIVILEGE_SET, LPBOOL);
extern(Windows) BOOL IsValidSid(PSID);
extern(Windows) BOOL EqualSid(PSID, PSID);
extern(Windows) BOOL EqualPrefixSid(PSID, PSID);
extern(Windows) DWORD GetSidLengthRequired(UCHAR);
extern(Windows) BOOL AllocateAndInitializeSid(PSID_IDENTIFIER_AUTHORITY, ubyte, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, PSID*);
extern(Windows) PVOID FreeSid(PSID);
extern(Windows) BOOL InitializeSid(PSID, PSID_IDENTIFIER_AUTHORITY, ubyte);
extern(Windows) PSID_IDENTIFIER_AUTHORITY GetSidIdentifierAuthority(PSID);
extern(Windows) PDWORD GetSidSubAuthority(PSID, DWORD);
extern(Windows) PUCHAR GetSidSubAuthorityCount(PSID);
extern(Windows) DWORD GetLengthSid(PSID);
extern(Windows) BOOL CopySid(DWORD, PSID, PSID);
extern(Windows) BOOL AreAllAccessesGranted(DWORD, DWORD);
extern(Windows) BOOL AreAnyAccessesGranted(DWORD, DWORD);
extern(Windows) void MapGenericMask(PDWORD);
extern(Windows) BOOL IsValidAcl(PACL);
extern(Windows) BOOL InitializeAcl(PACL, DWORD, DWORD);
extern(Windows) BOOL GetAclInformation(PACL, LPVOID, DWORD, ACL_INFORMATION_CLASS);
extern(Windows) BOOL SetAclInformation(PACL, LPVOID, DWORD, ACL_INFORMATION_CLASS);
extern(Windows) BOOL AddAce(PACL, DWORD, DWORD, LPVOID, DWORD);
extern(Windows) BOOL DeleteAce(PACL, DWORD);
extern(Windows) BOOL GetAce(PACL, DWORD, LPVOID*);
extern(Windows) BOOL AddAccessAllowedAce(PACL, DWORD, DWORD, PSID);
extern(Windows) BOOL AddAccessDeniedAce(PACL, DWORD, DWORD, PSID);
extern(Windows) BOOL AddAuditAccessAce(PACL, DWORD, DWORD, PSID, BOOL, BOOL);
extern(Windows) BOOL FindFirstFreeAce(PACL, LPVOID*);
extern(Windows) BOOL InitializeSecurityDescriptor(PSECURITY_DESCRIPTOR, DWORD);
extern(Windows) BOOL IsValidSecurityDescriptor(PSECURITY_DESCRIPTOR);
extern(Windows) DWORD GetSecurityDescriptorLength(PSECURITY_DESCRIPTOR);
extern(Windows) BOOL GetSecurityDescriptorControl(PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR_CONTROL, LPDWORD);
extern(Windows) BOOL SetSecurityDescriptorDacl(PSECURITY_DESCRIPTOR, BOOL, PACL, BOOL);
extern(Windows) BOOL GetSecurityDescriptorDacl(PSECURITY_DESCRIPTOR, LPBOOL, PACL*, LPBOOL);
extern(Windows) BOOL SetSecurityDescriptorSacl(PSECURITY_DESCRIPTOR, BOOL, PACL, BOOL);
extern(Windows) BOOL GetSecurityDescriptorSacl(PSECURITY_DESCRIPTOR, LPBOOL, PACL*, LPBOOL);
extern(Windows) BOOL SetSecurityDescriptorOwner(PSECURITY_DESCRIPTOR, PSID, BOOL);
extern(Windows) BOOL GetSecurityDescriptorOwner(PSECURITY_DESCRIPTOR, PSID*, LPBOOL);
extern(Windows) BOOL SetSecurityDescriptorGroup(PSECURITY_DESCRIPTOR, PSID, BOOL);
extern(Windows) BOOL GetSecurityDescriptorGroup(PSECURITY_DESCRIPTOR, PSID*, LPBOOL);
extern(Windows) BOOL CreatePrivateObjectSecurity(PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR*, BOOL, HANDLE, PGENERIC_MAPPING);
extern(Windows) BOOL SetPrivateObjectSecurity(SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR*, PGENERIC_MAPPING, HANDLE);
extern(Windows) BOOL GetPrivateObjectSecurity(PSECURITY_DESCRIPTOR, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, PDWORD);
extern(Windows) BOOL DestroyPrivateObjectSecurity(PSECURITY_DESCRIPTOR);
extern(Windows) BOOL MakeSelfRelativeSD(PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR, LPDWORD);
extern(Windows) BOOL MakeAbsoluteSD(PSECURITY_DESCRIPTOR, PSECURITY_DESCRIPTOR, LPDWORD, PACL, LPDWORD, PACL, LPDWORD, PSID, LPDWORD, PSID, LPDWORD);
extern(Windows) BOOL SetKernelObjectSecurity(HANDLE, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) BOOL FindNextChangeNotification(HANDLE);
extern(Windows) BOOL FindCloseChangeNotification(HANDLE);
extern(Windows) BOOL VirtualLock(LPVOID, DWORD);
extern(Windows) BOOL VirtualUnlock(LPVOID, DWORD);
extern(Windows) LPVOID MapViewOfFileEx(HANDLE, DWORD, DWORD, DWORD, DWORD, LPVOID);
extern(Windows) BOOL SetPriorityClass(HANDLE, DWORD);
extern(Windows) DWORD GetPriorityClass(HANDLE);
extern(Windows) BOOL IsBadReadPtr(POINTER, UINT);
extern(Windows) BOOL IsBadWritePtr(LPVOID, UINT);
extern(Windows) BOOL IsBadHugeReadPtr(POINTER, UINT);
extern(Windows) BOOL IsBadHugeWritePtr(LPVOID, UINT);
extern(Windows) BOOL IsBadCodePtr(FARPROC);
extern(Windows) BOOL AllocateLocallyUniqueId(PLUID);
extern(Windows) BOOL QueryPerformanceCounter(PLARGE_INTEGER);
extern(Windows) BOOL QueryPerformanceFrequency(PLARGE_INTEGER);
extern(Windows) BOOL ActivateKeyboardLayout(HKL, UINT);
extern(Windows) BOOL UnloadKeyboardLayout(HKL);
extern(Windows) int GetKeyboardLayoutList(int, HKL*);
extern(Windows) HKL GetKeyboardLayout(DWORD);
extern(Windows) HDESK OpenInputDesktop(DWORD, BOOL, DWORD);
extern(Windows) BOOL EnumDesktopWindows(HDESK, ENUMWINDOWSPROC, LPARAM);
extern(Windows) BOOL SwitchDesktop(HDESK);
extern(Windows) BOOL SetThreadDesktop(HDESK);
extern(Windows) BOOL CloseDesktop(HDESK);
extern(Windows) HDESK GetThreadDesktop(DWORD);
extern(Windows) BOOL CloseWindowStation(HWINSTA);
extern(Windows) BOOL SetProcessWindowStation(HWINSTA);
extern(Windows) HWINSTA GetProcessWindowStation();
extern(Windows) BOOL SetUserObjectSecurity(HANDLE, PSECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) BOOL GetUserObjectSecurity(HANDLE, PSECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
extern(Windows) BOOL TranslateMessage(LPMSG);
extern(Windows) BOOL SetMessageQueue(int);
extern(Windows) BOOL RegisterHotKey(HWND, int, UINT, UINT);
extern(Windows) BOOL UnregisterHotKey(HWND, int);
extern(Windows) BOOL ExitWindowsEx(UINT, DWORD);
extern(Windows) BOOL SwapMouseButton(BOOL);
extern(Windows) DWORD GetMessagePos();
extern(Windows) LONG GetMessageTime();
extern(Windows) LONG GetMessageExtraInfo();
extern(Windows) LPARAM SetMessageExtraInfo(LPARAM);
extern(Windows) int BroadcastSystemMessage(DWORD, LPDWORD, UINT, WPARAM, LPARAM);
extern(Windows) BOOL AttachThreadInput(DWORD, DWORD, BOOL);
extern(Windows) BOOL ReplyMessage(LRESULT);
extern(Windows) BOOL WaitMessage();
extern(Windows) DWORD WaitForInputIdle(HANDLE, DWORD);
extern(Windows) void PostQuitMessage(int);
extern(Windows) BOOL InSendMessage();
extern(Windows) UINT GetDoubleClickTime();
extern(Windows) BOOL SetDoubleClickTime(UINT);
extern(Windows) BOOL IsWindow(HWND);
extern(Windows) BOOL IsMenu(HMENU);
extern(Windows) BOOL IsChild(HWND, HWND);
extern(Windows) BOOL DestroyWindow(HWND);
extern(Windows) BOOL ShowWindow(HWND, int);
extern(Windows) BOOL ShowWindowAsync(HWND, int);
extern(Windows) BOOL FlashWindow(HWND, BOOL);
extern(Windows) BOOL ShowOwnedPopups(HWND, BOOL);
extern(Windows) BOOL OpenIcon(HWND);
extern(Windows) BOOL CloseWindow(HWND);
extern(Windows) BOOL MoveWindow(HWND, int, int, int, int, BOOL);
extern(Windows) BOOL SetWindowPos(HWND, HWND, int, int, int, int, UINT);
extern(Windows) BOOL GetWindowPlacement(HWND, WINDOWPLACEMENT*);
extern(Windows) BOOL SetWindowPlacement(HWND, WINDOWPLACEMENT*);
extern(Windows) HDWP BeginDeferWindowPos(int);
extern(Windows) HDWP DeferWindowPos(HDWP, HWND, HWND, int, int, int, int, UINT);
extern(Windows) BOOL EndDeferWindowPos(HDWP);
extern(Windows) BOOL IsWindowVisible(HWND);
extern(Windows) BOOL IsIconic(HWND);
extern(Windows) BOOL AnyPopup();
extern(Windows) BOOL BringWindowToTop(HWND);
extern(Windows) BOOL IsZoomed(HWND);
extern(Windows) BOOL EndDialog(HWND, int);
extern(Windows) HWND GetDlgItem(HWND, int);
extern(Windows) BOOL SetDlgItemInt(HWND, int, UINT, BOOL);
extern(Windows) UINT GetDlgItemInt(HWND, int, BOOL*, BOOL);
extern(Windows) BOOL CheckDlgButton(HWND, int, UINT);
extern(Windows) BOOL CheckRadioButton(HWND, int, int, int);
extern(Windows) UINT IsDlgButtonChecked(HWND, int);
extern(Windows) HWND GetNextDlgGroupItem(HWND, HWND, BOOL);
extern(Windows) HWND GetNextDlgTabItem(HWND, HWND, BOOL);
extern(Windows) int GetDlgCtrlID(HWND);
extern(Windows) int GetDialogBaseUnits();
extern(Windows) BOOL OpenClipboard(HWND);
extern(Windows) BOOL CloseClipboard();
extern(Windows) HWND GetClipboardOwner();
extern(Windows) HWND SetClipboardViewer(HWND);
extern(Windows) HWND GetClipboardViewer();
extern(Windows) BOOL ChangeClipboardChain(HWND, HWND);
extern(Windows) HANDLE SetClipboardData(UINT, HANDLE);
extern(Windows) HANDLE GetClipboardData(UINT);
extern(Windows) int CountClipboardFormats();
extern(Windows) UINT EnumClipboardFormats(UINT);
extern(Windows) BOOL EmptyClipboard();
extern(Windows) BOOL IsClipboardFormatAvailable(UINT);
extern(Windows) int GetPriorityClipboardFormat(UINT*, int);
extern(Windows) HWND GetOpenClipboardWindow();
extern(Windows) LPSTR CharNextExA(ushort, LPCSTR, DWORD);
extern(Windows) LPSTR CharPrevExA(ushort, LPCSTR, LPCSTR, DWORD);
extern(Windows) HWND SetFocus(HWND);
extern(Windows) HWND GetActiveWindow();
extern(Windows) HWND GetFocus();
extern(Windows) UINT GetKBCodePage();
extern(Windows) SHORT GetKeyState(int);
extern(Windows) SHORT GetAsyncKeyState(int);
extern(Windows) BOOL GetKeyboardState(PBYTE);
extern(Windows) BOOL SetKeyboardState(LPBYTE);
extern(Windows) int GetKeyboardType(int);
extern(Windows) int ToAscii(UINT, UINT, PBYTE, LPWORD, UINT);
extern(Windows) int ToAsciiEx(UINT, UINT, PBYTE, LPWORD, UINT, HKL);
extern(Windows) int ToUnicode(UINT, UINT, PBYTE, LPWSTR, int, UINT);
extern(Windows) DWORD OemKeyScan(ushort);
extern(Windows) void keybd_event(ubyte, ubyte, DWORD);
extern(Windows) void mouse_event(DWORD, DWORD, DWORD, DWORD);
extern(Windows) BOOL GetInputState();
extern(Windows) DWORD GetQueueStatus(UINT);
extern(Windows) HWND GetCapture();
extern(Windows) HWND SetCapture(HWND);
extern(Windows) BOOL ReleaseCapture();
extern(Windows) DWORD MsgWaitForMultipleObjects(DWORD, LPHANDLE, BOOL, DWORD, DWORD);
extern(Windows) UINT SetTimer(HWND, UINT, UINT, TIMERPROC);
extern(Windows) BOOL KillTimer(HWND, UINT);
extern(Windows) BOOL IsWindowUnicode(HWND);
extern(Windows) BOOL EnableWindow(HWND, BOOL);
extern(Windows) BOOL IsWindowEnabled(HWND);
extern(Windows) BOOL DestroyAcceleratorTable(HACCEL);
extern(Windows) int GetSystemMetrics(int);
extern(Windows) HMENU GetMenu(HWND);
extern(Windows) BOOL SetMenu(HWND, HMENU);
extern(Windows) BOOL HiliteMenuItem(HWND, HMENU, UINT, UINT);
extern(Windows) UINT GetMenuState(HMENU, UINT, UINT);
extern(Windows) BOOL DrawMenuBar(HWND);
extern(Windows) HMENU GetSystemMenu(HWND, BOOL);
extern(Windows) HMENU CreateMenu();
extern(Windows) HMENU CreatePopupMenu();
extern(Windows) BOOL DestroyMenu(HMENU);
extern(Windows) DWORD CheckMenuItem(HMENU, UINT, UINT);
extern(Windows) BOOL EnableMenuItem(HMENU, UINT, UINT);
extern(Windows) HMENU GetSubMenu(HMENU, int);
extern(Windows) UINT GetMenuItemID(HMENU, int);
extern(Windows) int GetMenuItemCount(HMENU);
extern(Windows) BOOL RemoveMenu(HMENU, UINT, UINT);
extern(Windows) BOOL DeleteMenu(HMENU, UINT, UINT);
extern(Windows) BOOL SetMenuItemBitmaps(HMENU, UINT, UINT, HBITMAP, HBITMAP);
extern(Windows) LONG GetMenuCheckMarkDimensions();
extern(Windows) BOOL TrackPopupMenu(HMENU, UINT, int, int, int, HWND, RECT*);
extern(Windows) UINT GetMenuDefaultItem(HMENU, UINT, UINT);
extern(Windows) BOOL SetMenuDefaultItem(HMENU, UINT, UINT);
extern(Windows) BOOL GetMenuItemRect(HWND, HMENU, UINT, LPRECT);
extern(Windows) int MenuItemFromPoint(HWND, HMENU, POINT);
extern(Windows) DWORD DragObject(HWND, HWND, UINT, DWORD, HCURSOR);
extern(Windows) BOOL DragDetect(HWND, POINT);
extern(Windows) BOOL DrawIcon(HDC, int, int, HICON);
extern(Windows) BOOL UpdateWindow(HWND);
extern(Windows) HWND SetActiveWindow(HWND);
extern(Windows) HWND GetForegroundWindow();
extern(Windows) BOOL PaintDesktop(HDC);
extern(Windows) BOOL SetForegroundWindow(HWND);
extern(Windows) HWND WindowFromDC(HDC);
extern(Windows) HDC GetDC(HWND);
extern(Windows) HDC GetDCEx(HWND, HRGN, DWORD);
extern(Windows) HDC GetWindowDC(HWND);
extern(Windows) int ReleaseDC(HWND, HDC);
extern(Windows) HDC BeginPaint(HWND, LPPAINTSTRUCT);
extern(Windows) BOOL EndPaint(HWND, LPPAINTSTRUCT);
extern(Windows) BOOL GetUpdateRect(HWND, LPRECT, BOOL);
extern(Windows) int GetUpdateRgn(HWND, HRGN, BOOL);
extern(Windows) int SetWindowRgn(HWND, HRGN, BOOL);
extern(Windows) int GetWindowRgn(HWND, HRGN);
extern(Windows) int ExcludeUpdateRgn(HDC, HWND);
extern(Windows) BOOL InvalidateRect(HWND, RECT*, BOOL);
extern(Windows) BOOL ValidateRect(HWND, RECT*);
extern(Windows) BOOL InvalidateRgn(HWND, HRGN, BOOL);
extern(Windows) BOOL ValidateRgn(HWND, HRGN);
extern(Windows) BOOL RedrawWindow(HWND, RECT*, HRGN, UINT);
extern(Windows) BOOL LockWindowUpdate(HWND);
extern(Windows) BOOL ScrollWindow(HWND, int, int, RECT*, RECT*);
extern(Windows) BOOL ScrollDC(HDC, int, int, RECT*, RECT*, HRGN, LPRECT);
extern(Windows) int ScrollWindowEx(HWND, int, int, RECT*, RECT*, HRGN, LPRECT, UINT);
extern(Windows) int SetScrollPos(HWND, int, int, BOOL);
extern(Windows) int GetScrollPos(HWND, int);
extern(Windows) BOOL SetScrollRange(HWND, int, int, int, BOOL);
extern(Windows) BOOL GetScrollRange(HWND, int, LPINT, LPINT);
extern(Windows) BOOL ShowScrollBar(HWND, int, BOOL);
extern(Windows) BOOL EnableScrollBar(HWND, UINT, UINT);
extern(Windows) BOOL GetClientRect(HWND, LPRECT);
extern(Windows) BOOL GetWindowRect(HWND, LPRECT);
extern(Windows) BOOL AdjustWindowRect(LPRECT, DWORD, BOOL);
extern(Windows) BOOL AdjustWindowRectEx(LPRECT, DWORD, BOOL, DWORD);
extern(Windows) BOOL SetWindowContextHelpId(HWND, DWORD);
extern(Windows) DWORD GetWindowContextHelpId(HWND);
extern(Windows) BOOL SetMenuContextHelpId(HMENU, DWORD);
extern(Windows) DWORD GetMenuContextHelpId(HMENU);
extern(Windows) BOOL MessageBeep(UINT);
extern(Windows) int ShowCursor(BOOL);
extern(Windows) BOOL SetCursorPos(int, int);
extern(Windows) HCURSOR SetCursor(HCURSOR);
extern(Windows) BOOL GetCursorPos(LPPOINT);
extern(Windows) BOOL ClipCursor(RECT*);
extern(Windows) BOOL GetClipCursor(LPRECT);
extern(Windows) HCURSOR GetCursor();
extern(Windows) BOOL CreateCaret(HWND, HBITMAP, int, int);
extern(Windows) UINT GetCaretBlinkTime();
extern(Windows) BOOL SetCaretBlinkTime(UINT);
extern(Windows) BOOL DestroyCaret();
extern(Windows) BOOL HideCaret(HWND);
extern(Windows) BOOL ShowCaret(HWND);
extern(Windows) BOOL SetCaretPos(int, int);
extern(Windows) BOOL GetCaretPos(LPPOINT);
extern(Windows) BOOL ClientToScreen(HWND, LPPOINT);
extern(Windows) BOOL ScreenToClient(HWND, LPPOINT);
extern(Windows) int MapWindowPoints(HWND, HWND, LPPOINT, UINT);
extern(Windows) HWND WindowFromPoint(POINT);
extern(Windows) HWND ChildWindowFromPoint(HWND, POINT);
extern(Windows) DWORD GetSysColor(int);
extern(Windows) HBRUSH GetSysColorBrush(int);
extern(Windows) BOOL SetSysColors(int, WINT*, COLORREF*);
extern(Windows) BOOL DrawFocusRect(HDC, RECT*);
extern(Windows) int FillRect(HDC, RECT*, HBRUSH);
extern(Windows) int FrameRect(HDC, RECT*, HBRUSH);
extern(Windows) BOOL InvertRect(HDC, RECT*);
extern(Windows) BOOL SetRect(LPRECT, int, int, int, int);
extern(Windows) BOOL SetRectEmpty(LPRECT);
extern(Windows) BOOL CopyRect(LPRECT, RECT*);
extern(Windows) BOOL InflateRect(LPRECT, int, int);
extern(Windows) BOOL IntersectRect(LPRECT, RECT*, RECT*);
extern(Windows) BOOL UnionRect(LPRECT, RECT*, RECT*);
extern(Windows) BOOL SubtractRect(LPRECT, RECT*, RECT*);
extern(Windows) BOOL OffsetRect(LPRECT, int, int);
extern(Windows) BOOL IsRectEmpty(RECT*);
extern(Windows) BOOL EqualRect(RECT*, RECT*);
extern(Windows) BOOL PtInRect(RECT*, POINT);
extern(Windows) ushort GetWindowWord(HWND, int);
extern(Windows) ushort SetWindowWord(HWND, int, ushort);
extern(Windows) ushort GetClassWord(HWND, int);
extern(Windows) ushort SetClassWord(HWND, int, ushort);
extern(Windows) HWND GetDesktopWindow();
extern(Windows) HWND GetParent(HWND);
extern(Windows) HWND SetParent(HWND, HWND);
extern(Windows) BOOL EnumChildWindows(HWND, ENUMWINDOWSPROC, LPARAM);
extern(Windows) BOOL EnumWindows(ENUMWINDOWSPROC, LPARAM);
extern(Windows) BOOL EnumThreadWindows(DWORD, ENUMWINDOWSPROC, LPARAM);
extern(Windows) HWND GetTopWindow(HWND);
extern(Windows) DWORD GetWindowThreadProcessId(HWND, LPDWORD);
extern(Windows) HWND GetLastActivePopup(HWND);
extern(Windows) HWND GetWindow(HWND, UINT);
extern(Windows) BOOL UnhookWindowsHook(int, HOOKPROC);
extern(Windows) BOOL UnhookWindowsHookEx(HHOOK);
extern(Windows) LRESULT CallNextHookEx(HHOOK, int, WPARAM, LPARAM);
extern(Windows) BOOL CheckMenuRadioItem(HMENU, UINT, UINT, UINT, UINT);
extern(Windows) HCURSOR CreateCursor(HINST, int, int, int, int, POINTER, POINTER);
extern(Windows) BOOL DestroyCursor(HCURSOR);
extern(Windows) BOOL SetSystemCursor(HCURSOR, DWORD);
extern(Windows) HICON CreateIcon(HINST, int, int, ubyte, ubyte, ubyte*, ubyte*);
extern(Windows) BOOL DestroyIcon(HICON);
extern(Windows) int LookupIconIdFromDirectory(PBYTE, BOOL);
extern(Windows) int LookupIconIdFromDirectoryEx(PBYTE, BOOL, int, int, UINT);
extern(Windows) HICON CreateIconFromResource(PBYTE, DWORD, BOOL, DWORD);
extern(Windows) HICON CreateIconFromResourceEx(PBYTE, DWORD, BOOL, DWORD, int, int, UINT);
extern(Windows) HICON CopyImage(HANDLE, UINT, int, int, UINT);
extern(Windows) HICON CreateIconIndirect(PICONINFO);
extern(Windows) HICON CopyIcon(HICON);
extern(Windows) BOOL GetIconInfo(HICON, PICONINFO);
extern(Windows) BOOL MapDialogRect(HWND, LPRECT);
extern(Windows) int SetScrollInfo(HWND, int, LPCSCROLLINFO, BOOL);
extern(Windows) BOOL GetScrollInfo(HWND, int, LPSCROLLINFO);
extern(Windows) BOOL TranslateMDISysAccel(HWND, LPMSG);
extern(Windows) UINT ArrangeIconicWindows(HWND);
extern(Windows) ushort TileWindows(HWND, UINT, RECT*, UINT, HWND*);
extern(Windows) ushort CascadeWindows(HWND, UINT, RECT*, UINT, HWND*);
extern(Windows) void SetLastErrorEx(DWORD);
extern(Windows) void SetDebugErrorLevel(DWORD);
extern(Windows) BOOL DrawEdge(HDC, LPRECT, UINT, UINT);
extern(Windows) BOOL DrawFrameControl(HDC, LPRECT, UINT, UINT);
extern(Windows) BOOL DrawCaption(HWND, HDC, RECT*, UINT);
extern(Windows) BOOL DrawAnimatedRects(HWND, int, RECT*, RECT*);
extern(Windows) BOOL TrackPopupMenuEx(HMENU, UINT, int, int, HWND, LPTPMPARAMS);
extern(Windows) HWND ChildWindowFromPointEx(HWND, POINT, UINT);
extern(Windows) BOOL DrawIconEx(HDC, int, int, HICON, int, int, UINT, HBRUSH, UINT);
extern(Windows) BOOL AnimatePalette(HPALETTE, UINT, UINT, PALETTEENTRY*);
extern(Windows) BOOL Arc(HDC, int, int, int, int, int, int, int, int);
extern(Windows) BOOL BitBlt(HDC, int, int, int, int, HDC, int, int, DWORD);
extern(Windows) BOOL CancelDC(HDC);
extern(Windows) BOOL Chord(HDC, int, int, int, int, int, int, int, int);
extern(Windows) HMETAFILE CloseMetaFile(HDC);
extern(Windows) int CombineRgn(HRGN, HRGN, HRGN, int);
extern(Windows) HBITMAP CreateBitmap(int, int, UINT, UINT, POINTER);
extern(Windows) HBITMAP CreateBitmapIndirect(BITMAP*);
extern(Windows) HBRUSH CreateBrushIndirect(LOGBRUSH*);
extern(Windows) HBITMAP CreateCompatibleBitmap(HDC, int, int);
extern(Windows) HBITMAP CreateDiscardableBitmap(HDC, int, int);
extern(Windows) HDC CreateCompatibleDC(HDC);
extern(Windows) HBITMAP CreateDIBitmap(HDC, BITMAPINFOHEADER*, DWORD, POINTER, BITMAPINFO*, UINT);
extern(Windows) HBRUSH CreateDIBPatternBrush(HGLOBAL, UINT);
extern(Windows) HBRUSH CreateDIBPatternBrushPt(POINTER, UINT);
extern(Windows) HRGN CreateEllipticRgn(int, int, int, int);
extern(Windows) HRGN CreateEllipticRgnIndirect(RECT*);
extern(Windows) HBRUSH CreateHatchBrush(int, COLORREF);
extern(Windows) HPALETTE CreatePalette(LOGPALETTE*);
extern(Windows) HPEN CreatePen(int, int, COLORREF);
extern(Windows) HPEN CreatePenIndirect(LOGPEN*);
extern(Windows) HRGN CreatePolyPolygonRgn(POINT*, WINT*, int, int);
extern(Windows) HBRUSH CreatePatternBrush(HBITMAP);
extern(Windows) HRGN CreateRectRgn(int, int, int, int);
extern(Windows) HRGN CreateRectRgnIndirect(RECT*);
extern(Windows) HRGN CreateRoundRectRgn(int, int, int, int, int, int);
extern(Windows) HBRUSH CreateSolidBrush(COLORREF);
extern(Windows) BOOL DeleteDC(HDC);
extern(Windows) BOOL DeleteMetaFile(HMETAFILE);
extern(Windows) BOOL DeleteObject(HGDIOBJ);
extern(Windows) int DrawEscape(HDC, int, int, LPCSTR);
extern(Windows) BOOL Ellipse(HDC, int, int, int, int);
extern(Windows) int EnumObjects(HDC, int, ENUMOBJECTSPROC, LPARAM);
extern(Windows) BOOL EqualRgn(HRGN, HRGN);
extern(Windows) int Escape(HDC, int, int, LPCSTR, LPVOID);
extern(Windows) int ExtEscape(HDC, int, int, LPCSTR, int, LPSTR);
extern(Windows) int ExcludeClipRect(HDC, int, int, int, int);
extern(Windows) HRGN ExtCreateRegion(XFORM*, DWORD, RGNDATA*);
extern(Windows) BOOL ExtFloodFill(HDC, int, int, COLORREF, UINT);
extern(Windows) BOOL FillRgn(HDC, HRGN, HBRUSH);
extern(Windows) BOOL FloodFill(HDC, int, int, COLORREF);
extern(Windows) BOOL FrameRgn(HDC, HRGN, HBRUSH, int, int);
extern(Windows) int GetROP2(HDC);
extern(Windows) BOOL GetAspectRatioFilterEx(HDC, LPSIZE);
extern(Windows) COLORREF GetBkColor(HDC);
extern(Windows) int GetBkMode(HDC);
extern(Windows) LONG GetBitmapBits(HBITMAP, LONG, LPVOID);
extern(Windows) BOOL GetBitmapDimensionEx(HBITMAP, LPSIZE);
extern(Windows) UINT GetBoundsRect(HDC, LPRECT, UINT);
extern(Windows) BOOL GetBrushOrgEx(HDC, LPPOINT);
extern(Windows) int GetClipBox(HDC, LPRECT);
extern(Windows) int GetClipRgn(HDC, HRGN);
extern(Windows) int GetMetaRgn(HDC, HRGN);
extern(Windows) HGDIOBJ GetCurrentObject(HDC, UINT);
extern(Windows) BOOL GetCurrentPositionEx(HDC, LPPOINT);
extern(Windows) int GetDeviceCaps(HDC, int);
extern(Windows) int GetDIBits(HDC, HBITMAP, UINT, UINT, LPVOID, LPBITMAPINFO, UINT);
extern(Windows) DWORD GetFontData(HDC, DWORD, DWORD, LPVOID, DWORD);
extern(Windows) int GetGraphicsMode(HDC);
extern(Windows) int GetMapMode(HDC);
extern(Windows) UINT GetMetaFileBitsEx(HMETAFILE, UINT, LPVOID);
extern(Windows) COLORREF GetNearestColor(HDC, COLORREF);
extern(Windows) UINT GetNearestPaletteIndex(HPALETTE, COLORREF);
extern(Windows) DWORD GetObjectType(HGDIOBJ);
extern(Windows) UINT GetPaletteEntries(HPALETTE, UINT, UINT, LPPALETTEENTRY);
extern(Windows) COLORREF GetPixel(HDC, int, int);
extern(Windows) int GetPixelFormat(HDC);
extern(Windows) int GetPolyFillMode(HDC);
extern(Windows) BOOL GetRasterizerCaps(LPRASTERIZER_STATUS, UINT);
extern(Windows) DWORD GetRegionData(HRGN, DWORD, LPRGNDATA);
extern(Windows) int GetRgnBox(HRGN, LPRECT);
extern(Windows) HGDIOBJ GetStockObject(int);
extern(Windows) int GetStretchBltMode(HDC);
extern(Windows) UINT GetSystemPaletteEntries(HDC, UINT, UINT, LPPALETTEENTRY);
extern(Windows) UINT GetSystemPaletteUse(HDC);
extern(Windows) int GetTextCharacterExtra(HDC);
extern(Windows) UINT GetTextAlign(HDC);
extern(Windows) COLORREF GetTextColor(HDC);
extern(Windows) int GetTextCharset(HDC);
extern(Windows) int GetTextCharsetInfo(HDC, LPFONTSIGNATURE, DWORD);
extern(Windows) BOOL TranslateCharsetInfo(DWORD*, LPCHARSETINFO, DWORD);
extern(Windows) DWORD GetFontLanguageInfo(HDC);
extern(Windows) BOOL GetViewportExtEx(HDC, LPSIZE);
extern(Windows) BOOL GetViewportOrgEx(HDC, LPPOINT);
extern(Windows) BOOL GetWindowExtEx(HDC, LPSIZE);
extern(Windows) BOOL GetWindowOrgEx(HDC, LPPOINT);
extern(Windows) int IntersectClipRect(HDC, int, int, int, int);
extern(Windows) BOOL InvertRgn(HDC, HRGN);
extern(Windows) BOOL LineDDA(int, int, int, int, LINEDDAPROC, LPARAM);
extern(Windows) BOOL LineTo(HDC, int, int);
extern(Windows) BOOL MaskBlt(HDC, int, int, int, int, HDC, int, int, HBITMAP, int, int, DWORD);
extern(Windows) BOOL PlgBlt(HDC, POINT*, HDC, int, int, int, int, HBITMAP, int, int);
extern(Windows) int OffsetClipRgn(HDC, int, int);
extern(Windows) int OffsetRgn(HRGN, int, int);
extern(Windows) BOOL PatBlt(HDC, int, int, int, int, DWORD);
extern(Windows) BOOL Pie(HDC, int, int, int, int, int, int, int, int);
extern(Windows) BOOL PlayMetaFile(HDC, HMETAFILE);
extern(Windows) BOOL PaintRgn(HDC, HRGN);
extern(Windows) BOOL PolyPolygon(HDC, POINT*, WINT*, int);
extern(Windows) BOOL PtInRegion(HRGN, int, int);
extern(Windows) BOOL PtVisible(HDC, int, int);
extern(Windows) BOOL RectInRegion(HRGN, RECT*);
extern(Windows) BOOL RectVisible(HDC, RECT*);
extern(Windows) BOOL Rectangle(HDC, int, int, int, int);
extern(Windows) BOOL RestoreDC(HDC, int);
extern(Windows) UINT RealizePalette(HDC);
extern(Windows) BOOL RoundRect(HDC, int, int, int, int, int, int);
extern(Windows) BOOL ResizePalette(HPALETTE, UINT);
extern(Windows) int SaveDC(HDC);
extern(Windows) int SelectClipRgn(HDC, HRGN);
extern(Windows) int ExtSelectClipRgn(HDC, HRGN, int);
extern(Windows) int SetMetaRgn(HDC);
extern(Windows) HGDIOBJ SelectObject(HDC, HGDIOBJ);
extern(Windows) HPALETTE SelectPalette(HDC, HPALETTE, BOOL);
extern(Windows) COLORREF SetBkColor(HDC, COLORREF);
extern(Windows) int SetBkMode(HDC, int);
extern(Windows) LONG SetBitmapBits(HBITMAP, DWORD, POINTER);
extern(Windows) UINT SetBoundsRect(HDC, RECT*, UINT);
extern(Windows) int SetDIBits(HDC, HBITMAP, UINT, UINT, POINTER, PBITMAPINFO, UINT);
extern(Windows) int SetDIBitsToDevice(HDC, int, int, DWORD, DWORD, int, int, UINT, UINT, POINTER, BITMAPINFO*, UINT);
extern(Windows) DWORD SetMapperFlags(HDC, DWORD);
extern(Windows) int SetGraphicsMode(HDC, int);
extern(Windows) int SetMapMode(HDC, int);
extern(Windows) HMETAFILE SetMetaFileBitsEx(UINT, ubyte*);
extern(Windows) UINT SetPaletteEntries(HPALETTE, UINT, UINT, PALETTEENTRY*);
extern(Windows) COLORREF SetPixel(HDC, int, int, COLORREF);
extern(Windows) BOOL SetPixelV(HDC, int, int, COLORREF);
extern(Windows) int SetPolyFillMode(HDC, int);
extern(Windows) BOOL StretchBlt(HDC, int, int, int, int, HDC, int, int, int, int, DWORD);
extern(Windows) BOOL SetRectRgn(HRGN, int, int, int, int);
extern(Windows) int StretchDIBits(HDC, int, int, int, int, int, int, int, int, POINTER, BITMAPINFO*, UINT, DWORD);
extern(Windows) int SetROP2(HDC, int);
extern(Windows) int SetStretchBltMode(HDC, int);
extern(Windows) UINT SetSystemPaletteUse(HDC, UINT);
extern(Windows) int SetTextCharacterExtra(HDC, int);
extern(Windows) COLORREF SetTextColor(HDC, COLORREF);
extern(Windows) UINT SetTextAlign(HDC, UINT);
extern(Windows) BOOL SetTextJustification(HDC, int, int);
extern(Windows) BOOL UpdateColors(HDC);
extern(Windows) BOOL PlayMetaFileRecord(HDC, LPHANDLETABLE, LPMETARECORD, UINT);
extern(Windows) BOOL EnumMetaFile(HDC, HMETAFILE, ENUMMETAFILEPROC, LPARAM);
extern(Windows) HENHMETAFILE CloseEnhMetaFile(HDC);
extern(Windows) BOOL DeleteEnhMetaFile(HENHMETAFILE);
extern(Windows) BOOL EnumEnhMetaFile(HDC, HENHMETAFILE, ENHMETAFILEPROC, LPVOID, RECT*);
extern(Windows) UINT GetEnhMetaFileHeader(HENHMETAFILE, UINT, LPENHMETAHEADER);
extern(Windows) UINT GetEnhMetaFilePaletteEntries(HENHMETAFILE, UINT, LPPALETTEENTRY);
extern(Windows) UINT GetWinMetaFileBits(HENHMETAFILE, UINT, LPBYTE, WINT, HDC);
extern(Windows) BOOL PlayEnhMetaFile(HDC, HENHMETAFILE, RECT*);
extern(Windows) BOOL PlayEnhMetaFileRecord(HDC, LPHANDLETABLE, ENHMETARECORD*, UINT);
extern(Windows) HENHMETAFILE SetEnhMetaFileBits(UINT, ubyte*);
extern(Windows) HENHMETAFILE SetWinMetaFileBits(UINT, ubyte*, HDC, METAFILEPICT*);
extern(Windows) BOOL GdiComment(HDC, UINT, ubyte*);
extern(Windows) BOOL AngleArc(HDC, int, int, DWORD, FLOAT, FLOAT);
extern(Windows) BOOL PolyPolyline(HDC, POINT*, DWORD*, DWORD);
extern(Windows) BOOL GetWorldTransform(HDC, LPXFORM);
extern(Windows) BOOL SetWorldTransform(HDC, XFORM*);
extern(Windows) BOOL ModifyWorldTransform(HDC, XFORM*, DWORD);
extern(Windows) BOOL CombineTransform(LPXFORM, XFORM*, XFORM*);
extern(Windows) HBITMAP CreateDIBSection(HDC, BITMAPINFO*, UINT, POINTER*, HANDLE, DWORD);
extern(Windows) UINT GetDIBColorTable(HDC, UINT, UINT, RGBQUAD*);
extern(Windows) UINT SetDIBColorTable(HDC, UINT, UINT, RGBQUAD*);
extern(Windows) BOOL SetColorAdjustment(HDC, COLORADJUSTMENT*);
extern(Windows) BOOL GetColorAdjustment(HDC, LPCOLORADJUSTMENT);
extern(Windows) HPALETTE CreateHalftonePalette(HDC);
extern(Windows) int EndDoc(HDC);
extern(Windows) int StartPage(HDC);
extern(Windows) int EndPage(HDC);
extern(Windows) int AbortDoc(HDC);
extern(Windows) int SetAbortProc(HDC, TABORTPROC);
extern(Windows) BOOL ArcTo(HDC, int, int, int, int, int, int, int, int);
extern(Windows) BOOL BeginPath(HDC);
extern(Windows) BOOL CloseFigure(HDC);
extern(Windows) BOOL EndPath(HDC);
extern(Windows) BOOL FillPath(HDC);
extern(Windows) BOOL FlattenPath(HDC);
extern(Windows) int GetPath(HDC, LPPOINT, LPBYTE, int);
extern(Windows) HRGN PathToRegion(HDC);
extern(Windows) BOOL PolyDraw(HDC, POINT*, ubyte*, int);
extern(Windows) BOOL SelectClipPath(HDC, int);
extern(Windows) int SetArcDirection(HDC, int);
extern(Windows) BOOL SetMiterLimit(HDC, FLOAT, PFLOAT);
extern(Windows) BOOL StrokeAndFillPath(HDC);
extern(Windows) BOOL StrokePath(HDC);
extern(Windows) BOOL WidenPath(HDC);
extern(Windows) HPEN ExtCreatePen(DWORD, DWORD, LOGBRUSH*, DWORD, DWORD*);
extern(Windows) BOOL GetMiterLimit(HDC, PFLOAT);
extern(Windows) int GetArcDirection(HDC);
extern(Windows) BOOL MoveToEx(HDC, int, int, LPPOINT);
extern(Windows) HRGN CreatePolygonRgn(POINT*, int, int);
extern(Windows) BOOL DPtoLP(HDC, LPPOINT, int);
extern(Windows) BOOL LPtoDP(HDC, LPPOINT, int);
extern(Windows) BOOL Polygon(HDC, POINT*, int);
extern(Windows) BOOL Polyline(HDC, POINT*, int);
extern(Windows) BOOL PolyBezier(HDC, POINT*, DWORD);
extern(Windows) BOOL PolyBezierTo(HDC, POINT*, DWORD);
extern(Windows) BOOL PolylineTo(HDC, POINT*, DWORD);
extern(Windows) BOOL SetViewportExtEx(HDC, int, int, LPSIZE);
extern(Windows) BOOL SetViewportOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL SetWindowExtEx(HDC, int, int, LPSIZE);
extern(Windows) BOOL SetWindowOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL OffsetViewportOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL OffsetWindowOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL ScaleViewportExtEx(HDC, int, int, int, int, LPSIZE);
extern(Windows) BOOL ScaleWindowExtEx(HDC, int, int, int, int, LPSIZE);
extern(Windows) BOOL SetBitmapDimensionEx(HBITMAP, int, int, LPSIZE);
extern(Windows) BOOL SetBrushOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL GetDCOrgEx(HDC, LPPOINT);
extern(Windows) BOOL FixBrushOrgEx(HDC, int, int, LPPOINT);
extern(Windows) BOOL UnrealizeObject(HGDIOBJ);
extern(Windows) BOOL GdiFlush();
extern(Windows) DWORD GdiSetBatchLimit(DWORD);
extern(Windows) DWORD GdiGetBatchLimit();
extern(Windows) int SetICMMode(HDC, int);
extern(Windows) BOOL CheckColorsInGamut(HDC, LPVOID, LPVOID, DWORD);
extern(Windows) HANDLE GetColorSpace(HDC);
extern(Windows) BOOL SetColorSpace(HDC, HCOLORSPACE);
extern(Windows) BOOL DeleteColorSpace(HCOLORSPACE);
extern(Windows) BOOL GetDeviceGammaRamp(HDC, LPVOID);
extern(Windows) BOOL SetDeviceGammaRamp(HDC, LPVOID);
extern(Windows) BOOL ColorMatchToTarget(HDC, HDC, DWORD);
extern(Windows) HPROPSHEETPAGE CreatePropertySheetPageA(LPCPROPSHEETPAGE);
extern(Windows) BOOL DestroyPropertySheetPage(HPROPSHEETPAGE);
extern(Windows) void InitCommonControls();
extern(Windows) HIMAGELIST ImageList_Create(int, int, UINT, int, int);
extern(Windows) BOOL ImageList_Destroy(HIMAGELIST);
extern(Windows) int ImageList_GetImageCount(HIMAGELIST);
extern(Windows) int ImageList_Add(HIMAGELIST, HBITMAP, HBITMAP);
extern(Windows) int ImageList_ReplaceIcon(HIMAGELIST, int, HICON);
extern(Windows) COLORREF ImageList_SetBkColor(HIMAGELIST, COLORREF);
extern(Windows) COLORREF ImageList_GetBkColor(HIMAGELIST);
extern(Windows) BOOL ImageList_SetOverlayImage(HIMAGELIST, int, int);
extern(Windows) BOOL ImageList_Draw(HIMAGELIST, int, HDC, int, int, UINT);
extern(Windows) BOOL ImageList_Replace(HIMAGELIST, int, HBITMAP, HBITMAP);
extern(Windows) int ImageList_AddMasked(HIMAGELIST, HBITMAP, COLORREF);
extern(Windows) BOOL ImageList_DrawEx(HIMAGELIST, int, HDC, int, int, int, int, COLORREF, COLORREF, UINT);
extern(Windows) BOOL ImageList_Remove(HIMAGELIST, int);
extern(Windows) HICON ImageList_GetIcon(HIMAGELIST, int, UINT);
extern(Windows) BOOL ImageList_BeginDrag(HIMAGELIST, int, int, int);
extern(Windows) void ImageList_EndDrag();
extern(Windows) BOOL ImageList_DragEnter(HWND, int, int);
extern(Windows) BOOL ImageList_DragLeave(HWND);
extern(Windows) BOOL ImageList_DragMove(int, int);
extern(Windows) BOOL ImageList_SetDragCursorImage(HIMAGELIST, int, int, int);
extern(Windows) BOOL ImageList_DragShowNolock(BOOL);
extern(Windows) HIMAGELIST ImageList_GetDragImage(POINT*, POINT*);
extern(Windows) BOOL ImageList_GetIconSize(HIMAGELIST, int*, int*);
extern(Windows) BOOL ImageList_SetIconSize(HIMAGELIST, int, int);
extern(Windows) BOOL ImageList_GetImageInfo(HIMAGELIST, int, IMAGEINFO*);
extern(Windows) HIMAGELIST ImageList_Merge(HIMAGELIST, int, HIMAGELIST, int, int, int);
extern(Windows) HWND CreateToolbarEx(HWND, DWORD, UINT, int, HINST, UINT, LPCTBBUTTON, int, int, int, int, int, UINT);
extern(Windows) HBITMAP CreateMappedBitmap(HINST, int, UINT, LPCOLORMAP, int);
extern(Windows) void MenuHelp(UINT, WPARAM, LPARAM, HMENU, HINST, HWND);
extern(Windows) BOOL ShowHideMenuCtl(HWND, UINT, LPINT);
extern(Windows) void GetEffectiveClientRect(HWND, LPRECT);
extern(Windows) BOOL MakeDragList(HWND);
extern(Windows) void DrawInsert(HWND, HWND);
extern(Windows) int LBItemFromPt(HWND, POINT, BOOL);
extern(Windows) HWND CreateUpDownControl(DWORD, int, int, int, int, HWND, int, HINST, HWND, int, int, int);
extern(Windows) LONG RegCloseKey(HKEY);
extern(Windows) LONG RegSetKeySecurity(HKEY, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) LONG RegFlushKey(HKEY);
extern(Windows) LONG RegGetKeySecurity(HKEY, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, LPDWORD);
extern(Windows) LONG RegNotifyChangeKeyValue(HKEY, BOOL, DWORD, HANDLE, BOOL);
extern(Windows) BOOL IsValidCodePage(UINT);
extern(Windows) UINT GetACP();
extern(Windows) UINT GetOEMCP();
extern(Windows) BOOL GetCPInfo(UINT, LPCPINFO);
extern(Windows) BOOL IsDBCSLeadByte(ubyte);
extern(Windows) BOOL IsDBCSLeadByteEx(UINT, ubyte);
extern(Windows) int MultiByteToWideChar(UINT, DWORD, LPCSTR, int, LPWSTR, int);
extern(Windows) int WideCharToMultiByte(UINT, DWORD, LPCWSTR, int, LPSTR, int, LPCSTR, LPBOOL);
extern(Windows) BOOL IsValidLocale(LCID, DWORD);
extern(Windows) LCID ConvertDefaultLocale(LCID);
extern(Windows) LCID GetThreadLocale();
extern(Windows) BOOL SetThreadLocale(LCID);
extern(Windows) LANGID GetSystemDefaultLangID();
extern(Windows) LANGID GetUserDefaultLangID();
extern(Windows) LCID GetSystemDefaultLCID();
extern(Windows) LCID GetUserDefaultLCID();
extern(Windows) BOOL ReadConsoleOutputAttribute(HANDLE, LPWORD, DWORD, COORD, LPDWORD);
extern(Windows) BOOL WriteConsoleOutputAttribute(HANDLE, ushort*, DWORD, COORD, LPDWORD);
extern(Windows) BOOL FillConsoleOutputAttribute(HANDLE, ushort, DWORD, COORD, LPDWORD);
extern(Windows) BOOL GetConsoleMode(HANDLE, LPDWORD);
extern(Windows) BOOL GetNumberOfConsoleInputEvents(HANDLE, PDWORD);
extern(Windows) BOOL GetConsoleScreenBufferInfo(HANDLE, PCONSOLE_SCREEN_BUFFER_INFO);
extern(Windows) COORD GetLargestConsoleWindowSize(HANDLE);
extern(Windows) BOOL GetConsoleCursorInfo(HANDLE, PCONSOLE_CURSOR_INFO);
extern(Windows) BOOL GetNumberOfConsoleMouseButtons(LPDWORD);
extern(Windows) BOOL SetConsoleMode(HANDLE, DWORD);
extern(Windows) BOOL SetConsoleActiveScreenBuffer(HANDLE);
extern(Windows) BOOL FlushConsoleInputBuffer(HANDLE);
extern(Windows) BOOL SetConsoleScreenBufferSize(HANDLE, COORD);
extern(Windows) BOOL SetConsoleCursorPosition(HANDLE, COORD);
extern(Windows) BOOL SetConsoleCursorInfo(HANDLE, PCONSOLE_CURSOR_INFO);
extern(Windows) BOOL SetConsoleWindowInfo(HANDLE, BOOL, SMALL_RECT*);
extern(Windows) BOOL SetConsoleTextAttribute(HANDLE, ushort);
extern(Windows) BOOL SetConsoleCtrlHandler(PHANDLER_ROUTINE, BOOL);
extern(Windows) BOOL GenerateConsoleCtrlEvent(DWORD, DWORD);
extern(Windows) BOOL AllocConsole();
extern(Windows) BOOL FreeConsole();
extern(Windows) HANDLE CreateConsoleScreenBuffer(DWORD, DWORD, SECURITY_ATTRIBUTES*, DWORD, LPVOID);
extern(Windows) UINT GetConsoleCP();
extern(Windows) BOOL SetConsoleCP(UINT);
extern(Windows) UINT GetConsoleOutputCP();
extern(Windows) BOOL SetConsoleOutputCP(UINT);
extern(Windows) DWORD WNetConnectionDialog(HWND, DWORD);
extern(Windows) DWORD WNetDisconnectDialog(HWND, DWORD);
extern(Windows) DWORD WNetCloseEnum(HANDLE);
extern(Windows) BOOL CloseServiceHandle(SC_HANDLE);
extern(Windows) BOOL ControlService(SC_HANDLE, DWORD, LPSERVICE_STATUS);
extern(Windows) BOOL DeleteService(SC_HANDLE);
extern(Windows) SC_LOCK LockServiceDatabase(SC_HANDLE);
extern(Windows) BOOL NotifyBootConfigStatus(BOOL);
extern(Windows) BOOL QueryServiceObjectSecurity(SC_HANDLE, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR, DWORD, LPDWORD);
extern(Windows) BOOL QueryServiceStatus(SC_HANDLE, LPSERVICE_STATUS);
extern(Windows) BOOL SetServiceObjectSecurity(SC_HANDLE, SECURITY_INFORMATION, PSECURITY_DESCRIPTOR);
extern(Windows) BOOL SetServiceStatus(SERVICE_STATUS_HANDLE, LPSERVICE_STATUS);
extern(Windows) BOOL UnlockServiceDatabase(SC_LOCK);
extern(Windows) int ChoosePixelFormat(HDC, PIXELFORMATDESCRIPTOR*);
extern(Windows) int DescribePixelFormat(HDC, int, UINT, LPPIXELFORMATDESCRIPTOR);
extern(Windows) BOOL SetPixelFormat(HDC, int, PPIXELFORMATDESCRIPTOR);
extern(Windows) BOOL SwapBuffers(HDC);
extern(Windows) BOOL DragQueryPoint(HDROP, LPPOINT);
extern(Windows) void DragFinish(HDROP);
extern(Windows) void DragAcceptFiles(HWND);
extern(Windows) HICON DuplicateIcon(HINST, HICON);
extern(Windows) BOOL DdeAbandonTransaction(DWORD, HCONV, DWORD);
extern(Windows) PBYTE DdeAccessData(HDDEDATA, PDWORD);
extern(Windows) HDDEDATA DdeAddData(HDDEDATA, PBYTE, DWORD, DWORD);
extern(Windows) HDDEDATA DdeClientTransaction(PBYTE, DWORD, HCONV, HSZ, UINT, UINT, DWORD, PDWORD);
extern(Windows) int DdeCmpStringHandles(HSZ, HSZ);
extern(Windows) HCONV DdeConnect(DWORD, HSZ, HSZ, CONVCONTEXT*);
extern(Windows) HCONVLIST DdeConnectList(DWORD, HSZ, HSZ, HCONVLIST, PCONVCONTEXT);
extern(Windows) HDDEDATA DdeCreateDataHandle(DWORD, LPBYTE, DWORD, DWORD, HSZ, UINT, UINT);
extern(Windows) BOOL DdeDisconnect(HCONV);
extern(Windows) BOOL DdeDisconnectList(HCONVLIST);
extern(Windows) BOOL DdeEnableCallback(DWORD, HCONV, UINT);
extern(Windows) BOOL DdeFreeDataHandle(HDDEDATA);
extern(Windows) BOOL DdeFreeStringHandle(DWORD, HSZ);
extern(Windows) DWORD DdeGetData(HDDEDATA, ubyte*, DWORD, DWORD);
extern(Windows) UINT DdeGetLastError(DWORD);
extern(Windows) BOOL DdeImpersonateClient(HCONV);
extern(Windows) BOOL DdeKeepStringHandle(DWORD, HSZ);
extern(Windows) HDDEDATA DdeNameService(DWORD, HSZ, HSZ, UINT);
extern(Windows) BOOL DdePostAdvise(DWORD, HSZ, HSZ);
extern(Windows) UINT DdeQueryConvInfo(HCONV, DWORD, PCONVINFO);
extern(Windows) HCONV DdeQueryNextServer(HCONVLIST, HCONV);
extern(Windows) HCONV DdeReconnect(HCONV);
extern(Windows) BOOL DdeSetUserHandle(HCONV, DWORD, DWORD);
extern(Windows) BOOL DdeUnaccessData(HDDEDATA);
extern(Windows) BOOL DdeUninitialize(DWORD);
extern(Windows) void SHAddToRecentDocs(UINT);
extern(Windows) LPITEMIDLIST SHBrowseForFolder(LPBROWSEINFO);
extern(Windows) void SHChangeNotify(LONG, UINT, LPCVOID);
extern(Windows) int SHFileOperation(LPSHFILEOPSTRUCT);
extern(Windows) void SHFreeNameMappings(HANDLE);
extern(Windows) DWORD SHGetFileInfo(LPCTSTR, DWORD, SHFILEINFO*, UINT, UINT);
extern(Windows) BOOL SHGetPathFromIDList(LPCITEMIDLIST, LPTSTR);
extern(Windows) HRESULT SHGetSpecialFolderLocation(HWND, int, LPITEMIDLIST*);
alias CRITICAL_SECTION TRTLCRITICALSECTION;
alias PCRITICAL_SECTION PRTLCRITICALSECTION;
alias PGUID PIID;
alias TGUID TIID;
alias HANDLE THANDLE;
alias TSMALLRECT* PSMALLRECT;
alias SMALL_RECT TSMALLRECT;
alias TCHARINFO* PCHARINFO;
alias _CHAR_INFO TCHARINFO;
alias POINTER TFARPROC;
alias POINTER TFNDLGPROC;
alias POINTER TFNTHREADSTARTROUTINE;

struct _OBJECT_TYPE_LIST
{
    ushort Level;
    ushort Sbz;
    PGUID ObjectType;
}

alias _OBJECT_TYPE_LIST TOBJECTTYPELIST;
alias TOBJECTTYPELIST* POBJECTTYPELIST;
alias _OBJECT_TYPE_LIST OBJECT_TYPE_LIST;
alias DWORD AUDIT_EVENT_TYPE;

align(1) struct _BLENDFUNCTION
{
    ubyte BlendOp;
    ubyte BlendFlags;
    ubyte SourceConstantAlpha;
    ubyte AlphaFormat;
}

alias _BLENDFUNCTION TBLENDFUNCTION;
alias TBLENDFUNCTION* PBLENDFUNCTION;
alias _BLENDFUNCTION BLENDFUNCTION;
/*
const int S_OK = (0x00000000);
const int S_FALSE = (0x00000001);
const int NOERROR = (0);
const int E_UNEXPECTED = (DWORD)((0x8000FFFF));
const int E_NOTIMPL = (DWORD)((0x80004001));
const int E_OUTOFMEMORY = (DWORD)((0x8007000E));
const int E_INVALIDARG = (DWORD)((0x80070057));
const int E_NOINTERFACE = (DWORD)((0x80004002));
const int E_POINTER = (DWORD)((0x80004003));
const int E_HANDLE = (DWORD)((0x80070006));
const int E_ABORT = (DWORD)((0x80004004));
const int E_FAIL = (DWORD)((0x80004005));
const int E_ACCESSDENIED = (DWORD)((0x80070005));
const int E_PENDING = (DWORD)((0x8000000A));
const int CO_E_INIT_TLS = (DWORD)((0x80004006));
const int CO_E_INIT_MEMORY_ALLOCATOR = (DWORD)((0x80004008));
const int CO_E_INIT_CLASS_CACHE = (DWORD)((0x80004009));
const int CO_E_INIT_RPC_CHANNEL = (DWORD)((0x8000400A));
const int CO_E_INIT_TLS_SET_CHANNEL_CONTROL = (DWORD)((0x8000400B));
const int CO_E_INIT_TLS_CHANNEL_CONTROL = (DWORD)((0x8000400C));
const int CO_E_INIT_UNACCEPTED_USER_ALLOCATOR = (DWORD)((0x8000400D));
const int CO_E_INIT_SCM_MUTEX_EXISTS = (DWORD)((0x8000400E));
const int CO_E_INIT_SCM_FILE_MAPPING_EXISTS = (DWORD)((0x8000400F));
const int CO_E_INIT_SCM_MAP_VIEW_OF_FILE = (DWORD)((0x80004010));
const int CO_E_INIT_SCM_EXEC_FAILURE = (DWORD)((0x80004011));
const int CO_E_INIT_ONLY_SINGLE_THREADED = (DWORD)((0x80004012));
const int CO_E_CANT_REMOTE = (DWORD)((0x80004013));
const int CO_E_BAD_SERVER_NAME = (DWORD)((0x80004014));
const int CO_E_WRONG_SERVER_IDENTITY = (DWORD)((0x80004015));
const int CO_E_OLE1DDE_DISABLED = (DWORD)((0x80004016));
const int CO_E_RUNAS_SYNTAX = (DWORD)((0x80004017));
const int CO_E_CREATEPROCESS_FAILURE = (DWORD)((0x80004018));
const int CO_E_RUNAS_CREATEPROCESS_FAILURE = (DWORD)((0x80004019));
const int CO_E_RUNAS_LOGON_FAILURE = (DWORD)((0x8000401A));
const int CO_E_LAUNCH_PERMSSION_DENIED = (DWORD)((0x8000401B));
const int CO_E_START_SERVICE_FAILURE = (DWORD)((0x8000401C));
const int CO_E_REMOTE_COMMUNICATION_FAILURE = (DWORD)((0x8000401D));
const int CO_E_SERVER_START_TIMEOUT = (DWORD)((0x8000401E));
const int CO_E_CLSREG_INCONSISTENT = (DWORD)((0x8000401F));
const int CO_E_IIDREG_INCONSISTENT = (DWORD)((0x80004020));
const int CO_E_NOT_SUPPORTED = (DWORD)((0x80004021));
const int CO_E_FIRST = (DWORD)((0x800401F0));
const int CO_E_LAST = (DWORD)((0x800401FF));
const int CO_S_FIRST = (0x401F0);
const int CO_E_NOTINITIALIZED = (DWORD)((0x800401F0));
const int CO_E_ALREADYINITIALIZED = (DWORD)((0x800401F1));
const int CO_E_CANTDETERMINECLASS = (DWORD)((0x800401F2));
const int CO_E_CLASSSTRING = (DWORD)((0x800401F3));
const int CO_E_IIDSTRING = (DWORD)((0x800401F4));
const int CO_E_APPNOTFOUND = (DWORD)((0x800401F5));
const int CO_E_APPSINGLEUSE = (DWORD)((0x800401F6));
const int CO_E_ERRORINAPP = (DWORD)((0x800401F7));
const int CO_E_DLLNOTFOUND = (DWORD)((0x800401F8));
const int CO_E_ERRORINDLL = (DWORD)((0x800401F9));
const int CO_E_WRONGOSFORAPP = (DWORD)((0x800401FA));
const int CO_E_OBJNOTREG = (DWORD)((0x800401FB));
const int CO_E_OBJISREG = (DWORD)((0x800401FC));
const int CO_E_OBJNOTCONNECTED = (DWORD)((0x800401FD));
const int CO_E_APPDIDNTREG = (DWORD)((0x800401FE));
const int CO_E_RELEASED = (DWORD)((0x800401FF));
*/
extern(Windows) THANDLE CreateThread(POINTER, DWORD, TFNTHREADSTARTROUTINE, POINTER, DWORD, DWORD*);
extern(Windows) BOOL DdeSetQualityOfService(HWND, TSECURITYQUALITYOFSERVICE*, PSECURITYQUALITYOFSERVICE);
extern(Windows) BOOL GetCommMask(THANDLE, DWORD*);
extern(Windows) BOOL GetDiskFreeSpaceExA(LPCSTR, void*, void*, PLARGEINTEGER);
extern(Windows) BOOL GetDiskFreeSpaceExW(LPWSTR, void*, void*, PLARGEINTEGER);
extern(Windows) DWORD GetKerningPairs(HDC, DWORD, void*);
extern(Windows) BOOL GetOverlappedResult(THANDLE, TOVERLAPPED*, DWORD*, BOOL);
extern(Windows) BOOL GetQueuedCompletionStatus(THANDLE, DWORD*, DWORD*, POVERLAPPED*, DWORD);
extern(Windows) BOOL GetSystemPowerStatus(TSYSTEMPOWERSTATUS*);
extern(Windows) BOOL ReadFile(THANDLE, void*, DWORD, DWORD*, POVERLAPPED);
extern(Windows) BOOL SetThreadContext(THANDLE, TCONTEXT*);
extern(Windows) BOOL wglDescribeLayerPlane(HDC, int, int, uint, TLAYERPLANEDESCRIPTOR*);
extern(Windows) int wglGetLayerPaletteEntries(HDC, int, int, int, void*);
extern(Windows) int wglSetLayerPaletteEntries(HDC, int, int, int, void*);
extern(Windows) DWORD WNetGetResourceParentA(PNETRESOURCEA, POINTER, DWORD*);
extern(Windows) BOOL WriteFile(THANDLE, void*, DWORD, DWORD*, POVERLAPPED);

int bool_test ()
{
   BOOL b=true;
   return 0;
}